//////////////////////////////////////////////////////////////////////////////
//	FILE NAME : DataManager.cpp
//	ABSTRACT  : CDataManager NX̃Cve[V
//	
//	CREATE    : T.Isogai	2006.9.21
//	UPDATE    : 
//	
//										(C)Copyright : Noritsu Koki CO.,LTD.
//////////////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "DataManager.h"

//////////////////////////////////////////////////////////////////////////////
// UTC[J^C
//////////////////////////////////////////////////////////////////////////////
SYSTEMTIME	NpsUPCToLocalTime( USHORT * a )
{
	// ̕ϊ
	SYSTEMTIME	utc;

	utc.wYear			= a[0];	// N
	utc.wMonth			= a[1];	// 
	utc.wDay			= a[2];	// 

	utc.wDayOfWeek		= a[7];	// j

//	utc.wDayOfWeek		= NkcComApi::GetDayofweek(
//													utc.wYear,
//													utc.wMonth,
//													utc.wDay
//													);	// j	0ijj-6iyjj

	utc.wHour			= a[3];	// 
	utc.wMinute			= a[4];	// 
	utc.wSecond			= a[5];	// b
	utc.wMilliseconds	= a[6];	// ~b

	// UTC[J^C
	SYSTEMTIME	localtime	= NkcComApi::MyUTCToLocalTime( utc );

	return localtime;
}

//////////////////////////////////////////////////////////////////////////////
// jbgԏϊ(NPS)
//////////////////////////////////////////////////////////////////////////////

// v^S̏
//////////////////////////////////////////////////////////////////////////////
//	MODULE   : TransUnitInfo_dwPrinterStatus()
//  UPDATE	 : J.Fukumori(AVASYS) 2008.07.17 VS2005Ή
//////////////////////////////////////////////////////////////////////////////
DWORD TransUnitInfo_dwPrinterStatus( UCHAR State, UCHAR PrinterStatus )
{
	DWORD	dwPrinterStatus	= 0;

	switch ( State )
	{
	case CDataManager::STATE_OFFLINE:

		// ItC̏ꍇ
		dwPrinterStatus = INFO_SALLOFFLN;		// 6FItC
		break;

	default:

		// IC̏ꍇ
		switch( PrinterStatus )
		{
		case 1:	dwPrinterStatus = INFO_SALLBOOT;	break;	//   0Fv^
		case 2: dwPrinterStatus = INFO_SALLIDLE;	break;	// 101FACh
		case 3: dwPrinterStatus = INFO_SALLPRINT;	break;	// 102Fvg
		case 4: dwPrinterStatus = INFO_SALLEND;		break;	//   7FI
		case 5: dwPrinterStatus = INFO_SALLPRGTM;	break;	// 103FvO^C}[
		case 6: dwPrinterStatus = INFO_SALLINST;	break;	// 104FCXg[
		}
		break;
	}

	return dwPrinterStatus;
}

// t
DWORD TransUnitInfo_dwAcceptStatus( UCHAR AcceptStatus )
{
	DWORD	dwAcceptStatus	= 0;
	switch( AcceptStatus )
	{
	case 1:	{ dwAcceptStatus	= INFO_SACDISABLE;		} break;	// 0Fts\
	case 2:	{ dwAcceptStatus	= INFO_SACENABLE;		} break;	// 1Ft\
	}
	return dwAcceptStatus;
}

// v^L
DWORD TransUnitInfo_dwPrinterPossession( UCHAR PrinterPossession )
{
	DWORD	dwPrinterPossession	= 0;
	switch( PrinterPossession )
	{
	case 1:	{ dwPrinterPossession	= INFO_SPPNOUSE;		} break;	// 1FL
	case 2:	{ dwPrinterPossession	= INFO_SPPUSENORMAL;	} break;	// 3FʏL
	case 3:	{ dwPrinterPossession	= INFO_SPPRESTART;		} break;	// 2FLiĊJ҂j
	case 4:	{ dwPrinterPossession	= INFO_SPPUSEEXPRESS;	} break;	// 4F}Lix1j
	case 5:	{ dwPrinterPossession	= INFO_SPPUSEEXPRESS;	} break;	// 4F}Lix2j
	case 6:	{ dwPrinterPossession	= INFO_SPPUSEEXPRESS;	} break;	// 4F}Lix2j
	case 7:
	case 8:
	case 9:
	case 10:
	case 11:
	case 12:
	case 13: { dwPrinterPossession	= INFO_SPPUSEEXPRESS;	} break;	// 4F}L
	}
	return dwPrinterPossession;
}

// nS
DWORD TransUnitInfo_dwAdvanceStatus( UCHAR AdvanceStatus )
{
	DWORD	dwAdvanceStatus	= 0;
	switch( AdvanceStatus )
	{
	case 0:	{ dwAdvanceStatus	= INFO_SMCALLMOTNONE;	} break;	// 0FԎ擾s\
	case 1:	{ dwAdvanceStatus	= INFO_SMCALLMOTNG;		} break;	// 1F̗vts
	case 2:	{ dwAdvanceStatus	= INFO_SMCALLMOTOK;		} break;	// 2F̗vt\
	case 3:	{ dwAdvanceStatus	= INFO_SMCALLMOTACT;	} break;	// 3F쒆
	}
	return dwAdvanceStatus;
}

// w[U[
DWORD TransUnitInfo_dwLaserStatus( UCHAR LaserStatus )
{
	DWORD	dwLaserStatus	= 0;
	switch( LaserStatus )
	{
	case 0:	{ dwLaserStatus	= INFO_SLDLZNONE;	} break;	// 0FԎ擾s\
	case 1:	{ dwLaserStatus	= INFO_SLDLZSTOP;	} break;	// 1F
	case 2:	{ dwLaserStatus	= INFO_SLDLZSTART;	} break;	// 2FJnij
	case 3:	{ dwLaserStatus	= INFO_SLDLZEND;	} break;	// 3F
	}
	return dwLaserStatus;
}

// S
DWORD TransUnitInfo_dwDevelopmentStatus( UCHAR DevelopmentStatus )
{
	DWORD	dwDevelopmentStatus	= 0;
	switch( DevelopmentStatus )
	{
	case 0:	{ dwDevelopmentStatus	= INFO_SPRALLMTNONE;	} break;	// 0FԎ擾s\
	case 1:	{ dwDevelopmentStatus	= INFO_SPRALLMTNG;		} break;	// 1F̗vts\
	case 2:	{ dwDevelopmentStatus	= INFO_SPRALLMTOK;		} break;	// 2F̗vt\
	case 3:	{ dwDevelopmentStatus	= INFO_SPRALLMTDO;		} break;	// 3F쒆
	}
	return dwDevelopmentStatus;
}

// 
DWORD TransUnitInfo_dwProcessorStatus( UCHAR ProcessorStatus )
{
	DWORD	dwProcessorStatus	= 0;
	switch( ProcessorStatus )
	{
	case 0:	{ dwProcessorStatus	= INFO_SPRBTHNONE;		} break;	// 0FԎ擾s\
	case 1:	{ dwProcessorStatus	= INFO_SPRBTHTPNO;		} break;	// 1F
	case 2:	{ dwProcessorStatus	= INFO_SPRBTHHTUP;		} break;	// 2Fq[gAbv
	case 3:	{ dwProcessorStatus	= INFO_SPRBTHPRTP;		} break;	// 3F
	case 4:	{ dwProcessorStatus	= INFO_SPRBTHTPNG;		} break;	// 4Fs
	}
	return dwProcessorStatus;
}

// [
DWORD TransUnitInfo_dwReplenisherStatus( UCHAR ReplenisherStatus )
{
	DWORD	dwReplenisherStatus	= 0;
	switch( ReplenisherStatus )
	{
	case 0:	{ dwReplenisherStatus	= INFO_SPRSPNONE;	} break;	// 0FԎ擾s\
	case 1:	{ dwReplenisherStatus	= INFO_SPRSPAAL;	} break;	// 1Fʏ^]
	case 2:	{ dwReplenisherStatus	= INFO_SPRSPASA;	} break;	// 2F[
	case 3:	{ dwReplenisherStatus	= INFO_SPRSPADO;	} break;	// 3FՎU
	case 4:	{ dwReplenisherStatus	= INFO_SPRSPAKT;	} break;	// 4FLbg[
	}
	return dwReplenisherStatus;
}

// [J[gbWύX
DWORD TransUnitInfo_dwReplaceCartridgeStatus( UCHAR ReplaceCartridgeStatus )
{
	DWORD	dwReplaceCartridgeStatus	= 0;
	switch( ReplaceCartridgeStatus )
	{
	case 0:	{ dwReplaceCartridgeStatus	= INFO_SPRKITNONE;	} break;	// 0FԎ擾s\
	case 1:	{ dwReplaceCartridgeStatus	= INFO_SPRKITCG;	} break;	// 1F\
	case 2:	{ dwReplaceCartridgeStatus	= INFO_SPRKITLY;	} break;	// 2F[ҋ@
	case 3:	{ dwReplaceCartridgeStatus	= INFO_SPRKITOP;	} break;	// 3FJ
	}
	return dwReplaceCartridgeStatus;
}

// nƓ_̎{
DWORD TransUnitInfo_dwStartUpChecksStatus( UCHAR StartUpChecksStatus )
{
	DWORD	dwStartUpChecksStatus	= 0;
	switch( StartUpChecksStatus )
	{
	case 0:	{ dwStartUpChecksStatus	= INFO_SUCSNONE;	} break;	// 0FԎ擾s\
	case 1:	{ dwStartUpChecksStatus	= INFO_SUCSNO;		} break;	// 1F{
	case 2:	{ dwStartUpChecksStatus	= INFO_SUCSOK;		} break;	// 2F{ς
	}
	return dwStartUpChecksStatus;
}

// I[gZbgAbvł̕␅̎{
DWORD TransUnitInfo_dwRefillWaterStatus( UCHAR RefillWaterStatus )
{
	DWORD	dwRefillWaterStatus	= 0;
	switch( RefillWaterStatus )
	{
	case 0:	{ dwRefillWaterStatus	= INFO_RWSNONE;		} break;	// 0FԎ擾s\
	case 1:	{ dwRefillWaterStatus	= INFO_RWSNO;		} break;	// 1F{
	case 2:	{ dwRefillWaterStatus	= INFO_RWSOK;		} break;	// 2F{ς
	}
	return dwRefillWaterStatus;
}

// I[gZbgAbvł̃fC[ZbgAbv̎{
DWORD TransUnitInfo_dwDailySetupStatus( UCHAR DailySetupStatus )
{
	DWORD	dwDailySetupStatus	= 0;
	switch( DailySetupStatus )
	{
	case 0:	{ dwDailySetupStatus	= INFO_DSSNONE;		} break;	// 0FԎ擾s\
	case 1:	{ dwDailySetupStatus	= INFO_DSSNO;		} break;	// 1F{
	case 2:	{ dwDailySetupStatus	= INFO_DSSOK;		} break;	// 2F{ς
	}
	return dwDailySetupStatus;
}

// I[gZbgAbvł̃Rg[Xgbv̎{
DWORD TransUnitInfo_dwControlStripStatus( UCHAR ControlStripStatus )
{
	DWORD	dwControlStripStatus	= 0;
	switch( ControlStripStatus )
	{
	case 0:	{ dwControlStripStatus	= INFO_CSSNONE;		} break;	// 0FԎ擾s\
	case 1:	{ dwControlStripStatus	= INFO_CSSNO;		} break;	// 1F{
	case 2:	{ dwControlStripStatus	= INFO_CSSOK;		} break;	// 2F{ς
	case 3:	{ dwControlStripStatus	= INFO_CSSNONE;		} break;	// 3Fjbg
	}
	return dwControlStripStatus;
}

// eiX\tg̐L
DWORD TransUnitInfo_dwMaintenanceStatus( UCHAR InMaintenance )
{
	DWORD	dwMaintenanceStatus	= 0;
	switch( InMaintenance )
	{
	case 0:	{ dwMaintenanceStatus	= INFO_MNTNONE;		} break;	// 0FԎ擾s\
	case 1:	{ dwMaintenanceStatus	= INFO_MNTNOTUSE;	} break;	// 1FeAvLĂȂ
	case 2:	{ dwMaintenanceStatus	= INFO_MNTUSE;		} break;	// 2FeAvLĂ
	}
	return dwMaintenanceStatus;
}

// FAD̏
DWORD TransUnitInfo_dwFadStatus( UCHAR FadStatus )
{
	DWORD	dwFadStatus	= INFO_FADNONE;
	switch( FadStatus )
	{
	case 0:	{ dwFadStatus	= INFO_FADNONE;		} break;	// 0FԎ擾s\
	case 1:	{ dwFadStatus	= INFO_FADOFFLN;	} break;	// 1FItC
	case 2:	{ dwFadStatus	= INFO_FADUNWK;		} break;	// 2FN
	case 3: { dwFadStatus	= INFO_FADIDLE;		} break;	// 3FACh
	case 4:	{ dwFadStatus	= INFO_FADWRRNG;	} break;	// 4Fx
	case 5:	{ dwFadStatus	= INFO_FADMNT;		} break;	// 5FeiX
	default:{ dwFadStatus	= (DWORD)FadStatus;	} break;	// ̑:v^Ml̂܂܃Zbgilgꂽꍇ̑΍j
	}
	return dwFadStatus;
}

//////////////////////////////////////////////////////////////////////
// \z/
//////////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////////////////////
//	MODULE   :CDataManager::CDataManager()
//	ABSTRACT : RXgN^
//	FUNCTION : RXgN^
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : T.Isogai	2006.9.21
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
CDataManager::CDataManager()
{
	InitializeCriticalSection( &m_CS );

	NkcComApi::CCSScopeLock CSScopeLock( &m_CS );

	m_eState	= STATE_OFFLINE;
	SetDefault();

	m_bFirstConnect = TRUE;				// ڑǂi TRUE:ڑ, FALSE:ڑłȂ j
	m_bEnableOfflineEvent = TRUE;		// ItCCxgʒm邩ǂi TRUE:ʒm, FALSE:ʒmȂ j

	m_bRestartNormal = FALSE;			// }[x1]荞ݏ̐LĊJ̏ԁi TRUE:L[ĊJ҂], FALSE:L j
	m_bRestartExpress= FALSE;			// }[x2]荞ݏ̐LĊJ̏ԁi TRUE:L[ĊJ҂], FALSE:L j

	m_OccupyState = OCCUPY_STATE_NONE;	// L		2006.11.07 T.Mizushima

	::ZeroMemory( &m_Nps6002H_7305H, sizeof(T_Nps6002H_7305H) );

	::ZeroMemory( &m_Nps6002H_732BH, sizeof(T_Nps6002H_732BH) );

	::GetLocalTime( &m_stSendLastTime );

	::ZeroMemory( &m_stLastImgTransmitTime, sizeof(T_TransmitTimeInfo) );

#if defined(NKC_CMS_PROC)
	m_bExistGProProc = FALSE;
#endif // defined(NKC_CMS_PROC)
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   :CDataManager::~CDataManager()
//	ABSTRACT : fXgN^
//	FUNCTION : fXgN^
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : T.Isogai	2006.9.21
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
CDataManager::~CDataManager()
{
	{
		NkcComApi::CCSScopeLock CSScopeLock( &m_CS );
		ClearMagInfo();
		ClearAllMagInfo();
		ClearEventInfo();
	}

	DeleteCriticalSection( &m_CS );
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CDataManager::Init()
//	ABSTRACT : 
//	FUNCTION : 
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : T.Isogai	2006.10.3
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
void CDataManager::Init(
		DWORD						dwIPAddress,			// v^IPAhX
		USHORT						wNpsPortNo,				// v^NPSp|[gԍ
		HPRINTER					hPrinter,				// v^nh
		CNpsCallbackUnit *			pCallbackUnit,			// jbgԕωCxgʒmNX
		void*						pFuncSetEvent,			// vg쓮֐|C^
		LPVOID						pParam					// eNX̃|C^
		)
{
	NkcComApi::CCSScopeLock CSScopeLock( &m_CS );

	m_dwIPAddress		= dwIPAddress;		// v^IPAhX
	m_wNpsPortNo		= wNpsPortNo;		// v^NPSp|[gԍ
	m_hPrinter			= hPrinter;			// v^nh
	m_pCallbackUnit		= pCallbackUnit;	// jbgԕωCxgʒmNX
	m_pFuncSetEvent		= pFuncSetEvent;	// vg쓮֐|C^
	m_pParam			= pParam;			// eNX̃|C^
}


//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CallbackUnit()
//	ABSTRACT : jbgԕωʒm
//	FUNCTION : jbgԕωʒmAvɒʒm
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : T.Isogai	2006.10.5
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
void CDataManager::CallbackUnit( long lUnitId, short iNewStatus, short iOldStatus )
{
		NPSUNITNOTIFYINFO	UnitInfo;	// jbgԕω

		ZeroMemory( &UnitInfo, sizeof( NPSUNITNOTIFYINFO ) );

		UnitInfo.hPrinter		= m_hPrinter;		// Cxg̔v^̃nh
		UnitInfo.dwIPAddress	= m_dwIPAddress;	// Cxg̔v^IPAhX

		UnitInfo.lUnitId	= lUnitId;		// ω̐jbgID
		UnitInfo.iNewStatus	= iNewStatus;	// V
		UnitInfo.iOldStatus	= iOldStatus;	// 

		UnitInfo.wPortNo	= m_wNpsPortNo;	// Cxg̔v^NPSp|[gԍ

		m_pCallbackUnit->AddNpsCALLBACKDATA( UnitInfo );
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CallbackUnitNps()
//	UPDATE   : J.Fukumori(AVASYS) 2008.07.17 VS2005Ή
//////////////////////////////////////////////////////////////////////////////
void CDataManager::CallbackUnitNps( const T_Nps6000H_0301H& PrinterStateNew, E_State eStateNew, const T_Nps6000H_0301H& PrinterStateOld, E_State eStateOld )
{
	DWORD dwNew;
	DWORD dwOld;

	// v^Ŝ̏ iv^S̏ԁj
	dwNew = TransUnitInfo_dwPrinterStatus( eStateNew, PrinterStateNew.PrinterStatus );
	dwOld = TransUnitInfo_dwPrinterStatus( eStateOld, PrinterStateOld.PrinterStatus );
	if( dwNew != dwOld )
	{
		CallbackUnit( INFO_PRINTER,
						(short)dwNew,
						(short)dwOld
						);
	}

	// t
	dwNew = TransUnitInfo_dwAcceptStatus( PrinterStateNew.AcceptStatus );
	dwOld = TransUnitInfo_dwAcceptStatus( PrinterStateOld.AcceptStatus );
	if( dwNew != dwOld )
	{
		CallbackUnit( INFO_ACCEPT,
						(short)dwNew,
						(short)dwOld
						);
	}

	// v^L̏
	dwNew	= TransUnitInfo_dwPrinterPossession( PrinterStateNew.PrinterPossession );
	dwOld	= TransUnitInfo_dwPrinterPossession( PrinterStateOld.PrinterPossession );

	if( dwNew != dwOld )
	{
		CallbackUnit( INFO_POSSESSION,
						(short)dwNew,
						(short)dwOld
						);
	}

	// v^Ŝ̏ inŚj
	dwNew	= TransUnitInfo_dwAdvanceStatus( PrinterStateNew.AdvanceStatus );
	dwOld	= TransUnitInfo_dwAdvanceStatus( PrinterStateOld.AdvanceStatus );

	if( dwNew != dwOld )
	{
		CallbackUnit( INFO_ADVANCE,
						(short)dwNew,
						(short)dwOld
						);
	}

	// w[U[̏ iw[U[j
	dwNew	= TransUnitInfo_dwLaserStatus( PrinterStateNew.LaserStatus );
	dwOld	= TransUnitInfo_dwLaserStatus( PrinterStateOld.LaserStatus );

	if( dwNew != dwOld )
	{
		CallbackUnit( INFO_LASER,
						(short)dwNew,
						(short)dwOld
						);
	}

	// vZT[Ŝ̏ inŚj
	dwNew	= TransUnitInfo_dwDevelopmentStatus( PrinterStateNew.DevelopmentStatus );
	dwOld	= TransUnitInfo_dwDevelopmentStatus( PrinterStateOld.DevelopmentStatus );

	if( dwNew != dwOld )
	{
		CallbackUnit( INFO_DEVELOPMENT,
						(short)dwNew,
						(short)dwOld
						);
	}

	// ̏ ij
	dwNew	= TransUnitInfo_dwProcessorStatus( PrinterStateNew.ProcessorStatus );
	dwOld	= TransUnitInfo_dwProcessorStatus( PrinterStateOld.ProcessorStatus );

	if( dwNew != dwOld )
	{
		CallbackUnit( INFO_PROCESSOR,
						(short)dwNew,
						(short)dwOld
						);
	}

	// [Ŝ̏ i[j
	dwNew	= TransUnitInfo_dwReplenisherStatus( PrinterStateNew.ReplenisherStatus );
	dwOld	= TransUnitInfo_dwReplenisherStatus( PrinterStateOld.ReplenisherStatus );

	if( dwNew != dwOld )
	{
		CallbackUnit( INFO_REPLENISHER,
						(short)dwNew,
						(short)dwOld
						);
	}

	// [J[gbW̌̉ i[J[gbWj
	dwNew	= TransUnitInfo_dwReplaceCartridgeStatus( PrinterStateNew.ReplaceCartridgeStatus );
	dwOld	= TransUnitInfo_dwReplaceCartridgeStatus( PrinterStateOld.ReplaceCartridgeStatus );

	if( dwNew != dwOld )
	{
		CallbackUnit( INFO_REPLACECARTRIDGE,
						(short)dwNew,
						(short)dwOld
						);
	}

	// nƓ_̎{
	dwNew	= TransUnitInfo_dwStartUpChecksStatus( PrinterStateNew.StartUpChecksStatus );
	dwOld	= TransUnitInfo_dwStartUpChecksStatus( PrinterStateOld.StartUpChecksStatus );

	if( dwNew != dwOld )
	{
		CallbackUnit( INFO_STARTCHECK,
						(short)dwNew,
						(short)dwOld
						);
	}

	// I[gZbgAbvł̕␅̎{
	dwNew	= TransUnitInfo_dwRefillWaterStatus( PrinterStateNew.RefillWaterStatus );
	dwOld	= TransUnitInfo_dwRefillWaterStatus( PrinterStateOld.RefillWaterStatus );

	if( dwNew != dwOld )
	{
		CallbackUnit( INFO_REFILLWATER,
						(short)dwNew,
						(short)dwOld
						);
	}

	// I[gZbgAbvł̃fC[ZbgAbv̎{
	dwNew	= TransUnitInfo_dwDailySetupStatus( PrinterStateNew.DailySetupStatus );
	dwOld	= TransUnitInfo_dwDailySetupStatus( PrinterStateOld.DailySetupStatus );

	if( dwNew != dwOld )
	{
		CallbackUnit( INFO_DAILYSETUP,
						(short)dwNew,
						(short)dwOld
						);
	}

	// I[gZbgAbvł̃Rg[Xgbv̎{
	dwNew	= TransUnitInfo_dwControlStripStatus( PrinterStateNew.ControlStripStatus );
	dwOld	= TransUnitInfo_dwControlStripStatus( PrinterStateOld.ControlStripStatus );

	if( dwNew != dwOld )
	{
		CallbackUnit( INFO_CNTRSTRP,
						(short)dwNew,
						(short)dwOld
						);
	}

	// eiX\tg̐L
	dwNew	= TransUnitInfo_dwMaintenanceStatus( PrinterStateNew.InMaintenance );
	dwOld	= TransUnitInfo_dwMaintenanceStatus( PrinterStateOld.InMaintenance );

	if( dwNew != dwOld )
	{
		CallbackUnit( INFO_MNTNNC,
						(short)dwNew,
						(short)dwOld
						);
	}

	// FAD̏
	dwNew	= TransUnitInfo_dwFadStatus( PrinterStateNew.FadStatus );
	dwOld	= TransUnitInfo_dwFadStatus( PrinterStateOld.FadStatus );

	if( dwNew != dwOld )
	{
		CallbackUnit( INFO_FAD,
						(short)dwNew,
						(short)dwOld
						);
	}
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CDataManager::ClearMagInfo()
//	ABSTRACT : }KW񃊃Xg̃NA
//	FUNCTION : }KW񃊃XgNA
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : T.Isogai	2006.9.22
//	UPDATE   : J.Fukumori(AVASYS) 2008.0717 VS2005Ή@for̔rŃLXg{
//////////////////////////////////////////////////////////////////////////////
void CDataManager::ClearMagInfo()
{
	for( int i =0; i < (int)m_vMagInfo.size(); i++ )
	{
		T_NpsMagInfo* ptmpMagInfo	= ( T_NpsMagInfo* ) m_vMagInfo[i];
		delete ptmpMagInfo;
	}

	m_vMagInfo.erase( m_vMagInfo.begin(), m_vMagInfo.end() );
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CDataManager::ClearAllMagInfo()
//	ABSTRACT : S}KW񃊃Xg̃NA
//	FUNCTION : S}KW񃊃XgNA
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : T.Isogai	2006.9.22
//	UPDATE   : J.Fukumori(AVASYS) 2008.0717 VS2005Ή@for̔rŃLXg{
//////////////////////////////////////////////////////////////////////////////
void CDataManager::ClearAllMagInfo()
{
	for( int i =0; i < (int)m_vAllMagInfo.size(); i++ )
	{
		T_NpsRegMagInfo* ptmpRegMagInfo	= ( T_NpsRegMagInfo* ) m_vAllMagInfo[i];
		delete ptmpRegMagInfo;
	}

	m_vAllMagInfo.erase( m_vAllMagInfo.begin(), m_vAllMagInfo.end() );
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CDataManager::ClearEventInfo()
//	ABSTRACT : Cxg񃊃Xg̃NA
//	FUNCTION : Cxg񃊃XgNA
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : T.Isogai	2006.10.2
//	UPDATE   : J.Fukumori(AVASYS) 2008.0717 VS2005Ή@for̔rŃLXg{
//////////////////////////////////////////////////////////////////////////////
void CDataManager::ClearEventInfo()
{
	for( int idx =0; idx < (int)m_vEventInfo.size(); idx++ )
	{
		T_Nps6000H_F202H* ptmpEventInfo	= ( T_Nps6000H_F202H* ) m_vEventInfo[idx];
		delete ptmpEventInfo;
	}

	m_vEventInfo.erase( m_vEventInfo.begin(), m_vEventInfo.end() );
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CDataManager::SetDefaultNpsVersion()
//	ABSTRACT : NPS I/F ̃o[W̃ftHgݒ
//	FUNCTION : NPS I/F ̃o[W̃ftHgݒ
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : T.Isogai	2006.9.21
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
void CDataManager::SetDefaultNpsVersion()
{
	m_NpsVersion	= 0;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CDataManager::SetDefaultPrinterBasic()
//	ABSTRACT : v^{̃ftHgݒ
//	FUNCTION : v^{̃ftHgݒ
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : T.Isogai	2006.9.21
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
void CDataManager::SetDefaultPrinterBasic()
{
	::ZeroMemory( &m_Nps6000H_0101H, sizeof(T_Nps6000H_0101H) );

	m_Nps6000H_0101H.Result					= NPS_SUCCESS;	// 
	strcpy( m_Nps6000H_0101H.MachineTypeName, "" );	// @햼
	strcpy( m_Nps6000H_0101H.SerialNumber, "" );	// VAԍ
	m_Nps6000H_0101H.SupportResolutions[0]	= 0;	// 𑜓x iPʁF0.1 dpij
	m_Nps6000H_0101H.SupportResolutions[1]	= 0;	// 𑜓x iPʁF0.1 dpij
	m_Nps6000H_0101H.SupportResolutions[2]	= 0;	// 𑜓x iPʁF0.1 dpij
	m_Nps6000H_0101H.SupportResolutions[3]	= 0;	// 𑜓x iPʁF0.1 dpij
	m_Nps6000H_0101H.SupportResolutions[4]	= 0;	// 𑜓x iPʁF0.1 dpij
	m_Nps6000H_0101H.SupportResolutions[5]	= 0;	// 𑜓x iPʁF0.1 dpij
	m_Nps6000H_0101H.SupportResolutions[6]	= 0;	// 𑜓x iPʁF0.1 dpij
	m_Nps6000H_0101H.SupportResolutions[7]	= 0;	// 𑜓x iPʁF0.1 dpij
	m_Nps6000H_0101H.MachineTypeID			= 0;	// @敪
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CDataManager::SetDefaultPrinterSetup()
//	ABSTRACT : v^ݒ̃ftHgݒ
//	FUNCTION : v^ݒ̃ftHgݒ
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : T.Isogai	2006.9.21
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
void CDataManager::SetDefaultPrinterSetup()
{
	::ZeroMemory( &m_Nps6000H_0201H, sizeof(T_Nps6000H_0201H) );

	m_Nps6000H_0201H.Result					= NPS_SUCCESS;	// 
	m_Nps6000H_0201H.TotalMemory			= 0;	// v^̃e (PʁFByte)
	m_Nps6000H_0201H.ImageSizeMinWidth		= 0;	// t摜̍̕ŏTCY iPʁFPixelj
	m_Nps6000H_0201H.ImageSizeMinHeight		= 0;	// t摜̍̍ŏTCY iPʁFPixelj
	m_Nps6000H_0201H.ImageSizeMaxWidth		= 0;	// t摜̍̕őTCY iPʁFPixelj
	m_Nps6000H_0201H.ImageSizeMaxHeight		= 0;	// t摜̍̍őTCY iPʁFPixelj
	m_Nps6000H_0201H.NumberOfMagazine		= 1;	// U\ȃ}KW

	// v^̓
	m_Nps6000H_0201H.PrinterTime[0]	= 0;			// z[0] N
	m_Nps6000H_0201H.PrinterTime[1]	= 0;			// z[1] 
	m_Nps6000H_0201H.PrinterTime[2]	= 0;			// z[2] 
	m_Nps6000H_0201H.PrinterTime[3]	= 0;			// z[3] 
	m_Nps6000H_0201H.PrinterTime[4]	= 0;			// z[4] 
	m_Nps6000H_0201H.PrinterTime[5]	= 0;			// z[5] b
	m_Nps6000H_0201H.PrinterTime[6]	= 0;			// z[6] ~b
	m_Nps6000H_0201H.PrinterTime[7]	= 0;			// z[7] j

	m_Nps6000H_0201H.RepeatCountMax	= 0;			// ő僊s[g

	//T|[g摜
	ZeroMemory( m_Nps6000H_0201H.SupportImageFormat, sizeof( m_Nps6000H_0201H.SupportImageFormat ) );
	m_Nps6000H_0201H.SupportImageFormat[0]	= 0;	// z[ 0] JPEG
	m_Nps6000H_0201H.SupportImageFormat[1]	= 0;	// z[ 1] Bitmap
	m_Nps6000H_0201H.SupportImageFormat[2]	= 0;	// z[ 2] RGB24rbg J[_
	m_Nps6000H_0201H.SupportImageFormat[3]	= 0;	// z[ 3] RGB48rbg J[_(12rbgL,LSB) 
	m_Nps6000H_0201H.SupportImageFormat[4]	= 0;	// z[ 4] RGB48rbg J[_(12rbgL,LSB)
	m_Nps6000H_0201H.SupportImageFormat[5]	= 0;	// z[ 5] BGR48rbg J[_(12rbgL,LSB)
	m_Nps6000H_0201H.SupportImageFormat[6]	= 0;	// z[ 6] BGR48rbg J[_(12rbgL,LSB)
	m_Nps6000H_0201H.SupportImageFormat[7]	= 0;	// z[ 7] RGB48rbg J[_(12rbgL,MSB)
	m_Nps6000H_0201H.SupportImageFormat[8]	= 0;	// z[ 8] RGB48rbg J[_(12rbgL,MSB)
	m_Nps6000H_0201H.SupportImageFormat[9]	= 0;	// z[ 9] BGR48rbg J[_(12rbgL,MSB)
	m_Nps6000H_0201H.SupportImageFormat[10]	= 0;	// z[10] BGR48rbg J[_(12rbgL,MSB)
													// z[11-31] gp

	m_Nps6000H_0201H.LaminatorUnitAttach	= 0;	// ~l[^[jbg̑

	// ݒu
	m_Nps6000H_0201H.InstallationDate[0]	= 0;	// z[0] N
	m_Nps6000H_0201H.InstallationDate[1]	= 0;	// z[1] 
	m_Nps6000H_0201H.InstallationDate[2]	= 0;	// z[2] 

	// ғJn
	m_Nps6000H_0201H.OperationStartDate[0]	= 0;	// z[0] N
	m_Nps6000H_0201H.OperationStartDate[1]	= 0;	// z[1] 
	m_Nps6000H_0201H.OperationStartDate[2]	= 0;	// z[2] 

	m_Nps6000H_0201H.ProcessorType		= 0;		// vZT[ ivZT[ʁj
	m_Nps6000H_0201H.EmulsionNumber		= 0;		// [ ij
	strcpy( m_Nps6000H_0201H.PrinterNickname, "" );	// [U[`̃v^
	m_Nps6000H_0201H.SupportAngle		= 0;		// T|[g]px iPʁF0.1pxj
	m_Nps6000H_0201H.SupportIntoPrinter	= 0;		// L
	m_Nps6000H_0201H.SupportLongPaper	= 0;		// ڃvgΉ
	m_Nps6000H_0201H.SorterStatus		= 0;		// \[^[̃gC̐
	m_Nps6000H_0201H.CvpStatus			= 0;		// CVP󎚍s

	m_Nps6000H_0201H.SupportInterrupt	= INFO_SUPPORTINTNO;	// f		2011.11.21 A.Nagamatsu (D703/WG)
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CDataManager::SetDefaultPrinterState()
//	ABSTRACT : v^Ԃ̃ftHgݒ
//	FUNCTION : v^Ԃ̃ftHgݒ
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : T.Isogai	2006.9.21
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
void CDataManager::SetDefaultPrinterState()
{
	::ZeroMemory( &m_Nps6000H_0301H, sizeof(T_Nps6000H_0301H) );

	m_Nps6000H_0301H.Result					= NPS_SUCCESS;	// 
	m_Nps6000H_0301H.PrinterStatus			= 0;	// 2:v^Ŝ̏ iv^S̏ԁj
	m_Nps6000H_0301H.AcceptStatus			= 0;	// 3:t
	m_Nps6000H_0301H.PrinterPossession		= 0;	// 4:v^L̏
	m_Nps6000H_0301H.AdvanceStatus			= 0;	// 5:v^Ŝ̏ inŚj
	m_Nps6000H_0301H.LaserStatus			= 0;	// 6:w[U[̏ iw[U[j
	m_Nps6000H_0301H.DevelopmentStatus		= 0;	// 7:vZT[Ŝ̏ inŚj
	m_Nps6000H_0301H.ProcessorStatus		= 0;	// 8:̏ ij
	m_Nps6000H_0301H.ReplenisherStatus		= 0;	// 9:[Ŝ̏ i[j
	m_Nps6000H_0301H.ReplaceCartridgeStatus	= 0;	// 10:[J[gbW̌̉ i[J[gbWj
	m_Nps6000H_0301H.StartUpChecksStatus	= 0;	// 11:nƓ_̎{
	m_Nps6000H_0301H.RefillWaterStatus		= 0;	// 12:I[gZbgAbvł̕␅̎{
	m_Nps6000H_0301H.DailySetupStatus		= 0;	// 13:I[gZbgAbvł̃fC[ZbgAbv̎{
	m_Nps6000H_0301H.ControlStripStatus		= 0;	// 14:I[gZbgAbvł̃Rg[Xgbv̎{
	m_Nps6000H_0301H.InMaintenance			= 0;	// 15:eiX\tg̐L
	m_Nps6000H_0301H.FadStatus				= 0;	// 16:FAD̏

	// LɂȂ̂œ}荞ݏ̐LĊJ̏Ԃɂ
	m_bRestartNormal = FALSE;
	m_bRestartExpress = FALSE;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CDataManager::SetDefaultMagInfo()
//	ABSTRACT : }KW񃊃Xg̃ftHgݒ
//	FUNCTION : 
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : Y.Yoshinobu 2006.09.24
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
void CDataManager::SetDefaultMagInfo()
{
	ClearMagInfo();

}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CDataManager::SetDefaultAllMagInfo()
//	ABSTRACT : S}KW񃊃Xg̃ftHgݒ
//	FUNCTION : 
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : Y.Yoshinobu 2006.09.24
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
void CDataManager::SetDefaultAllMagInfo()
{
	ClearAllMagInfo();

}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CDataManager::SelectMagInfo()
//	ABSTRACT : y[p[̎擾
//	FUNCTION : y[p[̎擾
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : T.Isogai	2006.9.22
//	UPDATE   : J.Fukumori(AVASYS) 2008.0717 VS2005Ή@for̔rŃLXg{
//////////////////////////////////////////////////////////////////////////////
T_NpsRegMagInfo* CDataManager::SelectMagInfo( USHORT PaperWidth, USHORT PaperId, UCHAR PaperFeed, CHAR* pPaperName )
{
	T_NpsRegMagInfo*	pRegMagInfo	= NULL;

	for( int i =0; i < (int)m_vAllMagInfo.size(); i++ )
	{
		T_NpsRegMagInfo* ptmpRegMagInfo	= ( T_NpsRegMagInfo* ) m_vAllMagInfo[i];

		if ( PAPER_SHEET == PaperFeed )
		{
			// SHEET
			if( ( ptmpRegMagInfo->PaperWidth == PaperWidth )	&&
				( ptmpRegMagInfo->PaperId == PaperId )		&&
				( ptmpRegMagInfo->PaperFeed == PaperFeed )	&&
				( 0 == strcmp( ptmpRegMagInfo->PaperName, pPaperName ) )
				)
			{
				pRegMagInfo	= ptmpRegMagInfo;
				break;
			}
		}
		else
		{
			// ROLL
			if( ( ptmpRegMagInfo->PaperWidth == PaperWidth )	&&
				( ptmpRegMagInfo->PaperId == PaperId )		&&
				( ptmpRegMagInfo->PaperFeed == PaperFeed )
				)
			{
				pRegMagInfo	= ptmpRegMagInfo;
				break;
			}
		}
	}	

	return pRegMagInfo;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CDataManager::IsSetupPaper()
//	ABSTRACT : ZbgAbvĂy[p[ǂmF
//	FUNCTION : y[p[̎擾
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : Y.Yoshinobu 2007.07.17
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
BOOL CDataManager::IsSetupPaper( UCHAR PaperFeed, USHORT Resolution, USHORT PaperWidth, USHORT PaperLength, USHORT PaperId, CHAR* pPaperName )
{
	NkcComApi::CCSScopeLock CSScopeLock( &m_CS );

	std::vector<T_NpsRegMagInfo*>::iterator itMagInfo;

	for ( itMagInfo=m_vAllMagInfo.begin() ; m_vAllMagInfo.end() != itMagInfo ; itMagInfo++ )
	{
		if ( 0 == (*itMagInfo)->SetupStatus )
		{	// ZbgAbv
			continue;
		}

		if ((( Resolution != (*itMagInfo)->PaperResolution[0] ) &&
			 ( Resolution != (*itMagInfo)->PaperResolution[1] ) &&
			 ( Resolution != (*itMagInfo)->PaperResolution[2] ) &&
			 ( Resolution != (*itMagInfo)->PaperResolution[3] ) &&
			 ( Resolution != (*itMagInfo)->PaperResolution[4] ) &&
			 ( Resolution != (*itMagInfo)->PaperResolution[5] ) &&
			 ( Resolution != (*itMagInfo)->PaperResolution[6] ) &&
			 ( Resolution != (*itMagInfo)->PaperResolution[7] )) ||
			( PaperId != (*itMagInfo)->PaperId ) ||
			( PaperFeed != (*itMagInfo)->PaperFeed ))
		{
			continue;
		}

		if ( PAPER_SHEET == PaperFeed )
		{
			// SHEET
			if (( PaperWidth == (*itMagInfo)->PaperWidth ) &&
				(( PaperLength >= (*itMagInfo)->PaperLengthMin ) &&
				 ( PaperLength <= (*itMagInfo)->PaperLengthMax )) &&
				( 0 == strcmp( pPaperName, (*itMagInfo)->PaperName ) ))
			{
				return TRUE;
			}
		}
		else
		{
			// ROLL
			if (( PaperWidth == (*itMagInfo)->PaperWidth ) &&
				(( PaperLength >= (*itMagInfo)->PaperLengthMin ) &&
				 ( PaperLength <= (*itMagInfo)->PaperLengthMax )))
			{
				return TRUE;
			}
		}
	}	

	return FALSE;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CDataManager::GetPaperWBAdjust()
//	ABSTRACT : WB␳l̎擾
//	FUNCTION : 
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : Y.Yoshinobu 2007.07.30
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
BOOL CDataManager::GetPaperWBAdjust( UCHAR PaperFeed, USHORT Resolution, USHORT PaperWidth, USHORT PaperLength, USHORT PaperId, CHAR* pPaperName, SHORT* pWBAdjustLeft, SHORT* pWBAdjustRight )
{
	NkcComApi::CCSScopeLock CSScopeLock( &m_CS );

	std::vector<T_NpsRegMagInfo*>::iterator itMagInfo;

	for ( itMagInfo=m_vAllMagInfo.begin() ; m_vAllMagInfo.end() != itMagInfo ; itMagInfo++ )
	{

		if ((( Resolution != (*itMagInfo)->PaperResolution[0] ) &&
			 ( Resolution != (*itMagInfo)->PaperResolution[1] ) &&
			 ( Resolution != (*itMagInfo)->PaperResolution[2] ) &&
			 ( Resolution != (*itMagInfo)->PaperResolution[3] ) &&
			 ( Resolution != (*itMagInfo)->PaperResolution[4] ) &&
			 ( Resolution != (*itMagInfo)->PaperResolution[5] ) &&
			 ( Resolution != (*itMagInfo)->PaperResolution[6] ) &&
			 ( Resolution != (*itMagInfo)->PaperResolution[7] )) ||
			( PaperId != (*itMagInfo)->PaperId ) ||
			( PaperFeed != (*itMagInfo)->PaperFeed ))
		{
			continue;
		}

		if ( PAPER_SHEET == PaperFeed )
		{
			// SHEET
			if (( PaperWidth == (*itMagInfo)->PaperWidth ) &&
				(( PaperLength >= (*itMagInfo)->PaperLengthMin ) &&
				 ( PaperLength <= (*itMagInfo)->PaperLengthMax )) &&
				( 0 == strcmp( pPaperName, (*itMagInfo)->PaperName ) ))
			{
				*pWBAdjustLeft	= (*itMagInfo)->WBAdjustLeft;
				*pWBAdjustRight	= (*itMagInfo)->WBAdjustRight;
				return TRUE;
			}
		}
		else
		{
			// ROLL
			if (( PaperWidth == (*itMagInfo)->PaperWidth ) &&
				(( PaperLength >= (*itMagInfo)->PaperLengthMin ) &&
				 ( PaperLength <= (*itMagInfo)->PaperLengthMax )))
			{
				*pWBAdjustLeft	= (*itMagInfo)->WBAdjustLeft;
				*pWBAdjustRight	= (*itMagInfo)->WBAdjustRight;
				return TRUE;
			}
		}
	}

	*pWBAdjustLeft	= 0;
	*pWBAdjustRight	= 0;

	return FALSE;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CDataManager::GetMagInfo()
//	ABSTRACT : y[p[̎擾
//	FUNCTION : Yy[p[擾
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : Y.Yoshinobu 2008.01.28
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
BOOL CDataManager::GetMagInfo( UCHAR PaperFeed, USHORT Resolution, USHORT PaperWidth, USHORT PaperLength, USHORT PaperId, CHAR* pPaperName, T_NpsRegMagInfo* pMagInfo )
{
	NkcComApi::CCSScopeLock CSScopeLock( &m_CS );

	std::vector<T_NpsRegMagInfo*>::iterator itMagInfo;

	for ( itMagInfo=m_vAllMagInfo.begin() ; m_vAllMagInfo.end() != itMagInfo ; itMagInfo++ )
	{

		if ((( Resolution != (*itMagInfo)->PaperResolution[0] ) &&
			 ( Resolution != (*itMagInfo)->PaperResolution[1] ) &&
			 ( Resolution != (*itMagInfo)->PaperResolution[2] ) &&
			 ( Resolution != (*itMagInfo)->PaperResolution[3] ) &&
			 ( Resolution != (*itMagInfo)->PaperResolution[4] ) &&
			 ( Resolution != (*itMagInfo)->PaperResolution[5] ) &&
			 ( Resolution != (*itMagInfo)->PaperResolution[6] ) &&
			 ( Resolution != (*itMagInfo)->PaperResolution[7] )) ||
			( PaperId != (*itMagInfo)->PaperId ) ||
			( PaperFeed != (*itMagInfo)->PaperFeed ))
		{
			continue;
		}

		if ( PAPER_SHEET == PaperFeed )
		{
			// SHEET
			if (( PaperWidth == (*itMagInfo)->PaperWidth ) &&
				(( PaperLength >= (*itMagInfo)->PaperLengthMin ) &&
				 ( PaperLength <= (*itMagInfo)->PaperLengthMax )) &&
				( 0 == strcmp( pPaperName, (*itMagInfo)->PaperName ) ))
			{
				*pMagInfo = **itMagInfo;
				return TRUE;
			}
		}
		else
		{
			// ROLL
			if (( PaperWidth == (*itMagInfo)->PaperWidth ) &&
				(( PaperLength >= (*itMagInfo)->PaperLengthMin ) &&
				 ( PaperLength <= (*itMagInfo)->PaperLengthMax )))
			{
				*pMagInfo = **itMagInfo;
				return TRUE;
			}
		}
	}

	::ZeroMemory( pMagInfo, sizeof(T_NpsRegMagInfo) );

	return FALSE;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CDataManager::UpdateState()
//	ABSTRACT : v^̏Ԃ̍XV
//	FUNCTION : ͂ăv^̏ԂXV
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : T.Isogai	2006.10.3
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
void CDataManager::UpdateState( BOOL bIsOnline )
{
	//////////////////////////////////////////////////////////////////////////////
	//v^̏
	//
	//    - PC̃CXg[ [STATE_SELFINST]
	//        EPC̃CXg[
	//
	//    -  => f[^NAiL[J_ʒmvj[STATE_INITNG]
	//                       => ftHglԂ
	//        Ev^
	//        EItC
	//        EI       -> v^Ƃ̒ʐMؒf
	//
	//    - ҂ [STATE_IDLNG]
	//        EAChEts
	//
	//    -  [STATE_IDLOK]
	//        EAChEt
	//        EvgEts
	//        EvgEt

	E_State	oldState		= m_eState;
	BOOL	boldSELFINST	= IsStateSELFINST();	// PC̃CXg[
	BOOL	boldINITNG		= IsStateINITNG();		// 
	BOOL	boldIDLNG		= IsStateIDLNG();		// ҂
	BOOL	boldIDLOK		= IsStateIDLOK();		// 	
	
	//////////////////////////////////////////////////////////////////////////////
	// Ԃ̍XV
	if( TRUE == bIsOnline )
	{
		//////////////////////////////////////////////////////////////////////////////
		// PrinterStatus
		// 1Fv^ieiXj
		// 2FACh
		// 3Fvg
		// 4FI
		// 5FPC̃CXg[
		//
		// AcceptStatus
		// 1Fts\
		// 2Ft\

		if( 1 == m_Nps6000H_0301H.PrinterStatus )
		{	// v^(1)
			m_eState	= STATE_NOTREADY;
		}
		else if( ( 5 == m_Nps6000H_0301H.PrinterStatus ) ||
				 ( 6 == m_Nps6000H_0301H.PrinterStatus ) )
		{	 // vO^C}[(5) or CXg[(6)
			 m_eState	= STATE_NOTREADY;
		}
		else if( 4 == m_Nps6000H_0301H.PrinterStatus )
		{
			// I iv^Ƃ̒ʐMؒfj
			m_eState	= STATE_END;
		}
		else if( ( 3 == m_Nps6000H_0301H.PrinterStatus ) && ( 2 == m_Nps6000H_0301H.AcceptStatus ) )
		{
			// vgEt
			m_eState	= STATE_PRNOK;
		}
		else if( ( 3 == m_Nps6000H_0301H.PrinterStatus ) && ( 1 == m_Nps6000H_0301H.AcceptStatus ) )
		{
			// vgEts
			m_eState	= STATE_IDLENG;
		}
		else if( ( 2 == m_Nps6000H_0301H.PrinterStatus ) && ( 2 == m_Nps6000H_0301H.AcceptStatus ) )
		{
			// QSS̏ꍇ͉ԂmFāAdDP̏ꍇ͏Ԏ擾s\ɂȂ̂ŉԂ͌Ȃ
			if (( ( 3 == m_Nps6000H_0301H.LaserStatus ) && ( 3 == m_Nps6000H_0301H.ProcessorStatus ) ) ||
				( ( 0 == m_Nps6000H_0301H.LaserStatus ) && ( 0 == m_Nps6000H_0301H.ProcessorStatus ) ))
			{
				// AChEt
				m_eState	= STATE_IDLEOK;
			}
			else
			{
				// 
				m_eState	= STATE_IDLENG;
			}
		}
		else
		{
			// 
			m_eState	= STATE_IDLENG;
		}
	}
	else
	{
		m_eState	= STATE_OFFLINE;

		SetDefault();
	}

	//////////////////////////////////////////////////////////////////////////////
	// Ԃ̍XVɔ

	if( oldState == m_eState )
	{	// XVOƏԂł邽ߏKvȂ
		return;
	}

}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CDataManager::GetState()
//	ABSTRACT : 
//	FUNCTION : 
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : T.Isogai	2006.10.3
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
CDataManager::E_State CDataManager::GetState()
{
	NkcComApi::CCSScopeLock CSScopeLock( &m_CS );

	return m_eState;
}

// PC̃CXg[
BOOL CDataManager::IsStateSELFINST()
{
	NkcComApi::CCSScopeLock CSScopeLock( &m_CS );

	switch( m_eState )
	{
	case STATE_SELFINST:	// - PC̃CXg[
		return TRUE;break;

	default:break;
	}

	return FALSE;
}

// 
BOOL CDataManager::IsStateINITNG()
{
	NkcComApi::CCSScopeLock CSScopeLock( &m_CS );

	switch( m_eState )
	{
	case STATE_NOTREADY:// Ev^
	case STATE_OFFLINE:	// EItC
	case STATE_END:		// EI       -> v^Ƃ̒ʐMؒf
		return TRUE;break;

	default:break;
	}

	return FALSE;
}

// ҂
BOOL CDataManager::IsStateIDLNG()
{
	NkcComApi::CCSScopeLock CSScopeLock( &m_CS );

	switch( m_eState )
	{
	case STATE_IDLENG:	// - ҂
		return TRUE;break;

	default:break;
	}

	return FALSE;
}

// 
BOOL CDataManager::IsStateIDLOK()
{
	switch( m_eState )
	{
	case STATE_IDLEOK:	// EAChEt
	case STATE_PRNNG:	// EvgEts
	case STATE_PRNOK:	// EvgEt
		return TRUE;break;

	default:break;
	}

	return FALSE;
}

// ts܂܂Ȃ̂쐬	2007.01.20 T.Mizushima
BOOL CDataManager::IsStateIDLOK2()
{
	switch( m_eState )
	{
	case STATE_IDLEOK:	// EAChEt
	case STATE_PRNOK:	// EvgEt
		return TRUE;break;

	default:break;
	}

	return FALSE;
}

// rcCḦ˗ŎtEsł̊mFŝ쐬	2007.05.07	Y.Yoshinobu
BOOL CDataManager::IsStateIDLOK3()
{
	switch ( m_eState )
	{
	case STATE_OFFLINE:		// ItC
	case STATE_END:			// I iv^Ƃ̒ʐMؒfj
	case STATE_SELFINST:	// PC̃CXg[
		break;
	default:
		if ( 2 == m_Nps6000H_0301H.AcceptStatus )		// 2Ft\
		{
			return TRUE;
		}
		break;
	}

	return FALSE;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CDataManager::SetStateOffline()
//	ABSTRACT : 
//	FUNCTION : 
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : T.Isogai	2006.10.3
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
void CDataManager::SetStateOffline()
{
	NkcComApi::CCSScopeLock CSScopeLock( &m_CS );

	SetOccupyState( CDataManager::OCCUPY_STATE_NONE );

	E_State eStateOld = m_eState;
	T_Nps6000H_0301H	PrinterStateOld	= m_Nps6000H_0301H;

	UpdateState( FALSE );

	CallbackUnitNps( m_Nps6000H_0301H, m_eState, PrinterStateOld, eStateOld );
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CDataManager::RecvEventUnit()
//	ABSTRACT : v^ԕύXʒmM
//	FUNCTION : v^v^ԕύXʒm󂯂s
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : T.Isogai	2006.10.3
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
void CDataManager::RecvEventUnit( T_Nps6000H_F102H *pInfo )
{
	NkcComApi::CCSScopeLock CSScopeLock( &m_CS );

	// }KW̑^
	if( 0 != pInfo->MagagineChange )
	{
			NPSUNITNOTIFYINFO	UnitInfo;
			ZeroMemory( &UnitInfo, sizeof( NPSUNITNOTIFYINFO ) );
			m_pCallbackUnit->AddNpsCALLBACKDATA( UnitInfo, TRUE, FALSE );
	}

	// Sy[p[̏
	if( 0 != pInfo->PaperInfoChange )
	{
			NPSUNITNOTIFYINFO	UnitInfo;
			ZeroMemory( &UnitInfo, sizeof( NPSUNITNOTIFYINFO ) );
			m_pCallbackUnit->AddNpsCALLBACKDATA( UnitInfo, FALSE, TRUE );
	}

	E_State eStateOld = m_eState;
	T_Nps6000H_0301H	PrinterStateOld	= m_Nps6000H_0301H;

	// v^Ŝ̏ iv^S̏ԁj
	if( 0 != pInfo->PrinterStatus )
	{
		m_Nps6000H_0301H.PrinterStatus			= pInfo->PrinterStatus;
	}

	// t
	if( 0 != pInfo->AcceptStatus )
	{
		m_Nps6000H_0301H.AcceptStatus			= pInfo->AcceptStatus;
	}

	// v^L̏
	if( 0 != pInfo->PrinterPossession )
	{
		m_Nps6000H_0301H.PrinterPossession		= pInfo->PrinterPossession;

		switch ( m_Nps6000H_0301H.PrinterPossession )
		{
			case 1:		// L
				// LɂȂ̂œ}荞ݏ̐LĊJ̏Ԃɂ
				m_bRestartNormal	= FALSE;
				m_bRestartExpress	= FALSE;
				break;
			case 2:		// ʏL
			case 3:		// LiʏĊJ҂j
				m_bRestartExpress	= FALSE;
				break;
			case 4:		// }[x1]L
			case 5:		// Li}[x1]ĊJ҂j
			case 6:		// }[x2]L
				break;
		}
	}

	// v^Ŝ̏ inŚj
	if( 0 != pInfo->AdvanceStatus )
	{
		m_Nps6000H_0301H.AdvanceStatus			= pInfo->AdvanceStatus;
	}

	// w[U[̏ iw[U[j
	if( 0 != pInfo->LaserStatus )
	{
		m_Nps6000H_0301H.LaserStatus			= pInfo->LaserStatus;
	}

	// vZT[Ŝ̏ inŚj
	if( 0 != pInfo->DevelopmentStatus )
	{
		m_Nps6000H_0301H.DevelopmentStatus		= pInfo->DevelopmentStatus;
	}

	// ̏ ij
	if( 0 != pInfo->ProcessorStatus )
	{
		m_Nps6000H_0301H.ProcessorStatus		= pInfo->ProcessorStatus;
	}

	// [Ŝ̏ i[j
	if( 0 != pInfo->ReplenisherStatus )
	{
		m_Nps6000H_0301H.ReplenisherStatus		= pInfo->ReplenisherStatus;
	}

	// [J[gbW̌̉ i[J[gbWj
	if( 0 != pInfo->ReplaceCartridgeStatus )
	{
		m_Nps6000H_0301H.ReplaceCartridgeStatus	= pInfo->ReplaceCartridgeStatus;
	}

	// nƓ_̎{
	if( 0 != pInfo->StartUpChecksStatus )
	{
		m_Nps6000H_0301H.StartUpChecksStatus = pInfo->StartUpChecksStatus;
	}

	// I[gZbgAbvł̕␅̎{
	if( 0 != pInfo->RefillWaterStatus )
	{
		m_Nps6000H_0301H.RefillWaterStatus = pInfo->RefillWaterStatus;
	}

	// I[gZbgAbvł̃fC[ZbgAbv̎{
	if( 0 != pInfo->DailySetupStatus )
	{
		m_Nps6000H_0301H.DailySetupStatus = pInfo->DailySetupStatus;
	}

	// I[gZbgAbvł̃Rg[Xgbv̎{
	if( 0 != pInfo->ControlStripStatus )
	{
		m_Nps6000H_0301H.ControlStripStatus = pInfo->ControlStripStatus;
	}

	// eiX\tg̐L
	if( 0 != pInfo->InMaintenance )
	{
		m_Nps6000H_0301H.InMaintenance = pInfo->InMaintenance;
	}

	// FAD̏
	if( 0 != pInfo->FadStatus )
	{
		m_Nps6000H_0301H.FadStatus = pInfo->FadStatus;
	}

	UpdateState();

	CallbackUnitNps( m_Nps6000H_0301H, m_eState, PrinterStateOld, eStateOld );
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CDataManager::IsPrintEnable()
//	ABSTRACT : vg\ȏԂǂ̊mF
//	FUNCTION : 
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : Y.Yoshinobu 2006.10.17
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
BOOL CDataManager::IsPrintEnable( T_NextCmd* pNextCmd )
{
	// e[h̏ꍇ̓v^̏ԂɊ֌WȂTRUEԂ
	if ( QUE_MAINTENANCE == pNextCmd->eQueModeM )
	{
		return TRUE;
	}

	// >>> Y.Yoshinobu	2008.04.30
	// vg̏ꍇv^̏ԂɊ֌WȂTRUEԂ
	// R:QSS̏ꍇɒ[hŏƁAe\tgƌɂȂAv^̏ԂŎtsɂȂ邽
	if ( pNextCmd->dwOption & OPTION_SETTING_PRN )
	{
		return TRUE;
	}
	// <<< Y.Yoshinobu	2008.04.30

	// v^Ă邩
	if ( FALSE == IsStateIDLOK3() )
	{
		return FALSE;
	}

	return TRUE;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CDataManager::IsEnableOccupy()
//	ABSTRACT : v^L\ǂ̊mF
//	FUNCTION : 
//	
//	NOTE     : < QSS System > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : Y.Yoshinobu	2006.10.19
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
BOOL CDataManager::IsEnableOccupy( T_NextCmd* pNextCmd, BOOL* pResume )
{
	*pResume = FALSE;

	CString str;
	str.Format( " --IsEnableOccupy ( dwOrderId=%d, eQueModeP=%d, PrinterPossession=%d, m_bRestartNormal=%d, m_bRestartExpress=%d )",
					pNextCmd->dwOrderId,
					pNextCmd->eQueModeP,
					m_Nps6000H_0301H.PrinterPossession,
					m_bRestartNormal,
					m_bRestartExpress );
	NPS_LOGOUT( str );

	// v^L
	if ( CMD_ORDER_START == pNextCmd->eCmdType )
	{
		switch ( pNextCmd->eQueModeP )
		{
		case QUE_NORMAL:
			// ʏ
			switch ( m_Nps6000H_0301H.PrinterPossession )
			{
			case 1:		// L
				break;
			case 3:		// LiʏĊJ҂j
				if ( FALSE == m_bRestartNormal )
				{
					return FALSE;
				}
				else
				{
					*pResume = TRUE;
				}
				break;
			case 2:		// ʏL
			case 4:		// }[x1]L
			case 5:		// Li}[x1]ĊJ҂j
			case 6:		// }[x2]L
				return FALSE;
				break;
			}
			break;
		case QUE_EXPRESS1:
			// }(Level1)
			switch ( m_Nps6000H_0301H.PrinterPossession )
			{
			case 1:		// L
			case 2:		// ʏL
			case 3:		// LiʏĊJ҂j
				break;
			case 5:		// Li}[x1]ĊJ҂j
				if ( FALSE == m_bRestartExpress )
				{
					return FALSE;
				}
				else
				{
					*pResume = TRUE;
				}
				break;
			case 4:		// }[x1]L
			case 6:		// }[x2]L
				return FALSE;
				break;
			}
			break;
		case QUE_EXPRESS2:
			// }(Level2)
			switch ( m_Nps6000H_0301H.PrinterPossession )
			{
			case 1:		// L
			case 2:		// ʏL
			case 3:		// LiʏĊJ҂j
			case 4:		// }[x1]L
			case 5:		// Li}[x1]ĊJ҂j
				break;
			case 6:		// }[x2]L
				return FALSE;
				break;
			}
			break;
		}

	}

	return TRUE;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CDataManager::SetDefault()
//	ABSTRACT : v^ꎮ
//	FUNCTION : v^ftHgɂ
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : T.Isogai	2006.9.21
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
void CDataManager::SetDefault()
{
	SetDefaultNpsVersion();		// NPS I/F ̃o[W̃ftHgݒ
	SetDefaultPrinterBasic();	// v^{̃ftHgݒ
	SetDefaultPrinterSetup();	// v^ݒ̃ftHgݒ
	SetDefaultPrinterState();	// v^Ԃ̃ftHgݒ
	SetDefaultMagInfo();		// }KW񃊃Xg̃ftHgݒ
	SetDefaultAllMagInfo();		// o^}KW񃊃Xg̃ftHgݒ
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CDataManager::SetNpsVersion()
//	ABSTRACT : NPS I/F ̃o[W̐ݒ
//	FUNCTION : NPS I/F ̃o[W̐ݒ
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : T.Isogai	2006.9.21
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
void CDataManager::SetNpsVersion( USHORT NpsVersion )
{
	NkcComApi::CCSScopeLock CSScopeLock( &m_CS );

	m_NpsVersion	= NpsVersion;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CDataManager::GetNpsVersion()
//	ABSTRACT : NPS I/F ̃o[W̎擾
//	FUNCTION : NPS I/F ̃o[W̎擾
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : T.Isogai	2006.9.21
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
USHORT CDataManager::GetNpsVersion()
{
	NkcComApi::CCSScopeLock CSScopeLock( &m_CS );

	return m_NpsVersion;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CDataManager::SetPrinterBasic()
//	ABSTRACT : v^{̐ݒ
//	FUNCTION : v^{̐ݒ
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : T.Isogai	2006.9.21
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
void CDataManager::SetPrinterBasic( T_Nps6000H_0101H* pNps6000H_0101H )
{
	NkcComApi::CCSScopeLock CSScopeLock( &m_CS );
	m_Nps6000H_0101H = *pNps6000H_0101H;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CDataManager::GetPrinterBasic()
//	ABSTRACT : v^{̎擾
//	FUNCTION : v^{̎擾
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : T.Isogai	2006.9.21
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
void CDataManager::GetPrinterBasic( T_Nps6000H_0101H* pNps6000H_0101H )
{
	NkcComApi::CCSScopeLock CSScopeLock( &m_CS );

	*pNps6000H_0101H = m_Nps6000H_0101H;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CDataManager::GetPrinterBasicSoftName()
//	ABSTRACT : v^{̎擾
//	FUNCTION : v^{̎擾
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : T.Isogai	2006.9.21
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
void CDataManager::GetPrinterBasicSoftName( CHAR* pSoftName )
{
	NkcComApi::CCSScopeLock CSScopeLock( &m_CS );

	::MoveMemory( pSoftName, m_Nps6000H_0101H.SoftName, sizeof(m_Nps6000H_0101H.SoftName) );
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CDataManager::SetPrinterSetup()
//	ABSTRACT : v^ݒ̐ݒ
//	FUNCTION : v^ݒ̐ݒ
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : T.Isogai	2006.9.21
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
void CDataManager::SetPrinterSetup( T_Nps6000H_0201H* pNps6000H_0201H )
{
	NkcComApi::CCSScopeLock CSScopeLock( &m_CS );
	m_Nps6000H_0201H = *pNps6000H_0201H;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CDataManager::GetPrinterSetup()
//	ABSTRACT : v^ݒ̎擾
//	FUNCTION : v^ݒ̎擾
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : T.Isogai	2006.9.21
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
void CDataManager::GetPrinterSetup( T_Nps6000H_0201H* pNps6000H_0201H )
{
	NkcComApi::CCSScopeLock CSScopeLock( &m_CS );

	*pNps6000H_0201H = m_Nps6000H_0201H;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CDataManager::GetPrinterSetupRepeatCountMax()
//	ABSTRACT : ő僊s[g̎擾
//	FUNCTION : 
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : Y.Yoshinobu 2006.9.24
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
ULONG CDataManager::GetPrinterSetupRepeatCountMax()
{
	NkcComApi::CCSScopeLock CSScopeLock( &m_CS );

	return m_Nps6000H_0201H.RepeatCountMax;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CDataManager::GetPrinterSetupRepeatCountMax()
//	ABSTRACT : L݂̃T|[gԂ̎擾
//	FUNCTION : 
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : Y.Yoshinobu 2006.10.25
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
USHORT CDataManager::GetPrinterSetupSupportIntoPrinter()
{
	NkcComApi::CCSScopeLock CSScopeLock( &m_CS );

	return m_Nps6000H_0201H.SupportIntoPrinter;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CDataManager::GetPrinterSetupRepeatCountMax()
//	ABSTRACT : \[^[̃gC̐̎擾
//	FUNCTION : 
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : Y.Yoshinobu 2006.10.25
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
UCHAR CDataManager::GetPrinterSetupSorterStatus()
{
	NkcComApi::CCSScopeLock CSScopeLock( &m_CS );

	return m_Nps6000H_0201H.SorterStatus;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CDataManager::SetPrinterState()
//	ABSTRACT : v^Ԃ̐ݒ
//	FUNCTION : v^Ԃ̐ݒ
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : T.Isogai	2006.9.21
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
void CDataManager::SetPrinterState( T_Nps6000H_0301H* pNps6000H_0301H )
{
	NkcComApi::CCSScopeLock CSScopeLock( &m_CS );

	E_State eStateOld = m_eState;
	T_Nps6000H_0301H PrinterStateOld = m_Nps6000H_0301H;
	m_Nps6000H_0301H = *pNps6000H_0301H;
	UpdateState();

	CallbackUnitNps( m_Nps6000H_0301H, m_eState, PrinterStateOld, eStateOld );
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CDataManager::GetPrinterState()
//	ABSTRACT : v^Ԃ̎擾
//	FUNCTION : v^Ԃ̎擾
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : T.Isogai	2006.9.21
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
void CDataManager::GetPrinterState( T_Nps6000H_0301H* pNps6000H_0301H )
{
	NkcComApi::CCSScopeLock CSScopeLock( &m_CS );

	*pNps6000H_0301H = m_Nps6000H_0301H;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CDataManager::SetMagInfo()
//	ABSTRACT : }KW񃊃Xg̐ݒ
//	FUNCTION : }KW񃊃Xg̐ݒ
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : T.Isogai	2006.9.22
//	UPDATE   : Y.Yoshinobu 2006.11.27 NPS̎ɖCallbackUnitR[Ă̂C
//	UPDATE   : J.Fukumori(AVASYS) 2008.0717 VS2005Ή
//////////////////////////////////////////////////////////////////////////////
typedef VOID  (CALLBACK*  PRINTREQUEST_SETEVENT)( void * pParam );
void CDataManager::SetMagInfo( T_Nps6000H_0401H* pNps6000H_0401H )
{
	long	lResult	= NPSERR_NORMAL;
	
	NkcComApi::CCSScopeLock CSScopeLock( &m_CS );

	UCHAR	oldMag1	= GetMagazineID( 1 );
	UCHAR	oldMag2	= GetMagazineID( 2 );
	UCHAR	oldMag3	= GetMagazineID( 3 );
	UCHAR	oldMag4	= GetMagazineID( 4 );

	int nIdx;
	std::vector<T_NpsMagInfo> vMagInfoOld;

	for ( nIdx=0 ; (int)m_vMagInfo.size() > nIdx ; nIdx++ )
	{
		vMagInfoOld.push_back( *((T_NpsMagInfo*)m_vMagInfo[nIdx]) );
	}

	ClearMagInfo();

	for( nIdx=0 ; nIdx < pNps6000H_0401H->NumberOfPaper ; nIdx++ )
	{
		T_NpsMagInfo* pNpsPaperInfo;

		try
		{
			pNpsPaperInfo = new T_NpsMagInfo;
		}
		catch (CMemoryException* e)
		{
			{
				CString str;
				str.Format( "===Memory allocation error [%d]", sizeof(T_NpsMagInfo) );
				NPS_LOGOUT_FATAL( str );
			}
			e->Delete();
			break;
		}

		pNpsPaperInfo->PaperWidth			= pNps6000H_0401H->PaperWidth[nIdx];			// y[p[̕ iPʁF0.1mmj
		pNpsPaperInfo->PaperId				= pNps6000H_0401H->PaperId[nIdx];				// y[p[ID iʎj
		pNpsPaperInfo->PaperRemaind			= pNps6000H_0401H->PaperRemaind[nIdx];			// y[p[c iPʁF0.1mmj
		pNpsPaperInfo->PaperFeed			= pNps6000H_0401H->PaperFeed[nIdx];				// @
		pNpsPaperInfo->PaperPresence		= pNps6000H_0401H->PaperPresence[nIdx];			// U
		strncpy( pNpsPaperInfo->PaperName, pNps6000H_0401H->PaperName[nIdx], sizeof(pNpsPaperInfo->PaperName) );

		m_vMagInfo.push_back( pNpsPaperInfo );
	}

	// Avւ̃jbgԕύXʒm
	UCHAR	newMag1	= GetMagazineID( 1 );
	UCHAR	newMag2	= GetMagazineID( 2 );
	UCHAR	newMag3	= GetMagazineID( 3 );
	UCHAR	newMag4	= GetMagazineID( 4 );	

		if ( vMagInfoOld.size() == m_vMagInfo.size() )
		{
			for ( nIdx=0 ; (int)m_vMagInfo.size() > nIdx ; nIdx++ )
			{
				if (( ((T_NpsMagInfo*)m_vMagInfo[nIdx])->PaperFeed != vMagInfoOld[nIdx].PaperFeed ) ||
					( ((T_NpsMagInfo*)m_vMagInfo[nIdx])->PaperWidth != vMagInfoOld[nIdx].PaperWidth ) ||
					( ((T_NpsMagInfo*)m_vMagInfo[nIdx])->PaperId != vMagInfoOld[nIdx].PaperId ) ||
					( 0 != ::lstrcmp(( (T_NpsMagInfo*)m_vMagInfo[nIdx])->PaperName, vMagInfoOld[nIdx].PaperName ) ))
				{
					CallbackUnit( INFO_INSTMAG, INFO_MAGINFOCHANGE, INFO_MAGINFOCHANGE );
					break;
				}
			}
		}
		else
		{
			CallbackUnit( INFO_INSTMAG, INFO_MAGINFOCHANGE, INFO_MAGINFOCHANGE );
		}

	vMagInfoOld.clear();

	( ( PRINTREQUEST_SETEVENT ) m_pFuncSetEvent )( m_pParam );
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CDataManager::SetRegMagInfo()
//	ABSTRACT : o^}KW񃊃Xg̐ݒ
//	FUNCTION : o^}KW񃊃Xg̐ݒ
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : T.Isogai	2006.9.22
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
void CDataManager::SetRegMagInfo( T_Nps6000H_1301H* pNps6000H_1301H )
{
	long	lResult	= NPSERR_NORMAL;

	NkcComApi::CCSScopeLock CSScopeLock( &m_CS );

	int nIdx1;
	int nIdx2;

	ClearAllMagInfo();

	for( nIdx1=0 ; pNps6000H_1301H->NumberOfPaper > nIdx1 ; nIdx1++ )
	{
		T_NpsRegMagInfo* pNpsPaperInfo;

		try
		{
			pNpsPaperInfo = new T_NpsRegMagInfo;
		}
		catch (CMemoryException* e)
		{
			{
				CString str;
				str.Format( "===Memory allocation error [%d]", sizeof(T_NpsRegMagInfo) );
				NPS_LOGOUT_FATAL( str );
			}
			e->Delete();
		}

		pNpsPaperInfo->PaperWidth			= pNps6000H_1301H->PaperWidth[nIdx1];			// y[p[̕ iPʁF0.1mmj
		pNpsPaperInfo->PaperLengthMin		= pNps6000H_1301H->PaperLengthMin[nIdx1];		// y[p[̑蒷̍ŏl iPʁF0.1mmj
		pNpsPaperInfo->PaperLengthMax		= pNps6000H_1301H->PaperLengthMax[nIdx1];		// y[p[̑蒷̍ől iPʁF0.1mmj
		pNpsPaperInfo->PaperId				= pNps6000H_1301H->PaperId[nIdx1];				// y[p[ID iʎj

		for( nIdx2=0 ; 8 > nIdx2 ; nIdx2++ )
		{
			pNpsPaperInfo->PaperResolution[nIdx2] = pNps6000H_1301H->PaperResolution[nIdx1][nIdx2];	// ͉𑜓x iPʁF0.1dpij
		}

		pNpsPaperInfo->PaperAllocationTop	= pNps6000H_1301H->PaperAllocationTop[nIdx1];	// t㕔 iPʁF0.1mmj
		pNpsPaperInfo->PaperAllocationBottom= pNps6000H_1301H->PaperAllocationBottom[nIdx1];// t iPʁF0.1mmj
		pNpsPaperInfo->PaperAllocationLeft	= pNps6000H_1301H->PaperAllocationLeft[nIdx1];	// t iPʁF0.1mmj
		pNpsPaperInfo->PaperAllocationRight	= pNps6000H_1301H->PaperAllocationRight[nIdx1];	// tE iPʁF0.1mmj
		pNpsPaperInfo->SetupStatus			= pNps6000H_1301H->SetupStatus[nIdx1];			// ZbgAbv
		pNpsPaperInfo->PaperFeed			= pNps6000H_1301H->PaperFeed[nIdx1];			// @
		pNpsPaperInfo->PaperTypeCode		= pNps6000H_1301H->PaperTypeCode[nIdx1];		// y[p[^CvR[h
		pNpsPaperInfo->PaperKind			= pNps6000H_1301H->PaperKind[nIdx1];			// y[p[ʎ
		pNpsPaperInfo->MagazineID			= pNps6000H_1301H->MagazineID[nIdx1];			// }KWID
		pNpsPaperInfo->WBAdjustLeft			= pNps6000H_1301H->WBAdjustLeft[nIdx1];			// WB␳l iPʁF0.1mmj
		pNpsPaperInfo->WBAdjustRight		= pNps6000H_1301H->WBAdjustRight[nIdx1];		// WB␳lE iPʁF0.1mmj
																							// y[p[
		strncpy( pNpsPaperInfo->PaperName, pNps6000H_1301H->PaperName[nIdx1], sizeof(pNpsPaperInfo->PaperName) );
		pNpsPaperInfo->PaperType			= pNps6000H_1301H->PaperType[nIdx1];			// y[p[^Cvi܎j
		pNpsPaperInfo->Direction			= pNps6000H_1301H->Direction[nIdx1];			// fBNV
		pNpsPaperInfo->PrintQuality			= pNps6000H_1301H->PrintQuality[nIdx1];			// i
		pNpsPaperInfo->PaperTypeValid		= pNps6000H_1301H->PaperTypeValid[nIdx1];		// y[p[^CvuL/v	(2011.8.4 A.Nagamatsu)

		// S}KW񃊃Xg
		m_vAllMagInfo.push_back( pNpsPaperInfo );

	}

	// Avւ̃jbgԕύXʒmiɑj
	CallbackUnit( INFO_INFOMAG, INFO_MAGINFOCHANGE, INFO_MAGINFOCHANGE );
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CDataManager::GetMagInfo ()
//	ABSTRACT : 
//	FUNCTION : 
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : T.Isogai	2006.9.22
//	UPDATE   : J.Fukumori(AVASYS) 2008.0717 VS2005Ή
//////////////////////////////////////////////////////////////////////////////
long CDataManager::GetMagInfo (
	PNPS_MagInfo	pMagInfo,	// }KW󂯎obt@
	DWORD*			pdwSize		// obt@̃TCY
)
{
	NkcComApi::CCSScopeLock CSScopeLock( &m_CS );

	if( NULL == pdwSize )
	{
		return NPSERR_SYSERR;
	}

	if( NULL == pMagInfo )
	{	// TCŶݕԂ
		*pdwSize	= (DWORD)m_vMagInfo.size() * (DWORD)sizeof( NPS_MagInfo );
		return NPSERR_NORMAL;
	}

	if( *pdwSize < ( (DWORD)m_vMagInfo.size() * (DWORD)sizeof( NPS_MagInfo ) ) )
	{	// obt@̃TCYȂ
		*pdwSize	= (DWORD)m_vMagInfo.size() * (DWORD)sizeof( NPS_MagInfo );
		return NPSERR_BADPARAM;
	}

	for( int i = 0; i < (int)m_vMagInfo.size(); i++ )
	{
		T_NpsMagInfo * pNpsPaperInfo	= ( T_NpsMagInfo * ) m_vMagInfo[i];
		T_NpsRegMagInfo * pNpsRegPaperInfo	= SelectMagInfo( pNpsPaperInfo->PaperWidth, pNpsPaperInfo->PaperId, pNpsPaperInfo->PaperFeed, pNpsPaperInfo->PaperName );

		pMagInfo[i].dwWidth				= pNpsPaperInfo->PaperWidth;			// y[p[iPʁF0.1mmj
		pMagInfo[i].dwSurface			= pNpsPaperInfo->PaperId;				// ʎ
		pMagInfo[i].dwRemain			= pNpsPaperInfo->PaperRemaind;			// y[p[cʁiPʁF0.1mmj
		pMagInfo[i].dwFeed				= pNpsPaperInfo->PaperFeed;				// @
		pMagInfo[i].dwPresence			= pNpsPaperInfo->PaperPresence;			// U
		strncpy( pMagInfo[i].szName, pNpsPaperInfo->PaperName, 32 );			// y[p[
	}

	*pdwSize	= (DWORD)m_vMagInfo.size() * (DWORD)sizeof( NPS_MagInfo );

	return NPSERR_NORMAL;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CDataManager::SetVersionInfo()
//	ABSTRACT : v^o[W̐ݒ
//	FUNCTION : v^o[W̐ݒ
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : T.Mizushima	2006.12.01
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
void CDataManager::SetVersionInfo( T_Nps6002H_7305H* pNps6002H_7305H )
{
	memcpy( &m_Nps6002H_7305H, pNps6002H_7305H, sizeof(T_Nps6002H_7305H) );
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CDataManager::GetVersionInfo()
//	ABSTRACT : v^o[W̎擾
//	FUNCTION : v^o[W̎擾
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : T.Mizushima	2006.12.01
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
void CDataManager::GetVersionInfo( T_Nps6002H_7305H* pNps6002H_7305H )
{
	memcpy( pNps6002H_7305H, &m_Nps6002H_7305H, sizeof(T_Nps6002H_7305H) );
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CDataManager::SetMachineSpecInfo()
//	ABSTRACT : @Bdl̐ݒ
//	FUNCTION : @Bdl̐ݒ
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : Y.Yoshinobu	2008.01.23
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
void CDataManager::SetMachineSpecInfo( T_Nps6002H_732BH* pNps6002H_732BH )
{
	memcpy( &m_Nps6002H_732BH, pNps6002H_732BH, sizeof(T_Nps6002H_732BH) );
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CDataManager::GetMachineSpecInfo()
//	ABSTRACT : @Bdl̎擾
//	FUNCTION : @Bdl̎擾
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : Y.Yoshinobu	2008.01.23
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
void CDataManager::GetMachineSpecInfo( T_Nps6002H_732BH* pNps6002H_732BH )
{
	memcpy( pNps6002H_732BH, &m_Nps6002H_732BH, sizeof(T_Nps6002H_732BH) );
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CDataManager::GetAllMagInfo ()
//	ABSTRACT : 
//	FUNCTION : 
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : T.Isogai	2006.9.22
//	UPDATE   : J.Fukumori(AVASYS) 2008.0717 VS2005Ή
//////////////////////////////////////////////////////////////////////////////
long CDataManager::GetAllMagInfo(
		PNPS_MagDetailInfo	pMagDetailInfo,	// o^}KW󂯎obt@
		DWORD*				pdwSize			// obt@̃TCY
)
{
	NkcComApi::CCSScopeLock CSScopeLock( &m_CS );

	if( NULL == pdwSize )
	{
		return NPSERR_SYSERR;
	}

	if( NULL == pMagDetailInfo )
	{	// TCŶݕԂ
		*pdwSize	= (DWORD)m_vAllMagInfo.size() * (DWORD)sizeof( NPS_MagDetailInfo );
		return NPSERR_NORMAL;
	}

	if( *pdwSize < m_vAllMagInfo.size() * sizeof( NPS_MagDetailInfo ) )
	{	// obt@̃TCYȂ
		*pdwSize	= (DWORD)m_vAllMagInfo.size() * (DWORD)sizeof( NPS_MagDetailInfo );
		return NPSERR_BADPARAM;
	}

	for( int i = 0; i < (int)m_vAllMagInfo.size(); i++ )
	{
		T_NpsRegMagInfo * pNpsPaperInfo	= ( T_NpsRegMagInfo * ) m_vAllMagInfo[i];

		pMagDetailInfo[i].dwWidth				= pNpsPaperInfo->PaperWidth;			// y[p[iPʁF0.1mmj
		pMagDetailInfo[i].dwLengthMin			= pNpsPaperInfo->PaperLengthMin;		// y[p[蒷̍ŏiPʁF0.1mmj
		pMagDetailInfo[i].dwLengthMax			= pNpsPaperInfo->PaperLengthMax;		// y[p[蒷̍őiPʁF0.1mmj
		pMagDetailInfo[i].dwSurface				= pNpsPaperInfo->PaperId;				// ʎ

		for( int j = 0; j < 8; j++ )
		{
			pMagDetailInfo[i].dwResolution[j]	= pNpsPaperInfo->PaperResolution[j];	// ͉𑜓xiPʁF0.1dpij
		}

		pMagDetailInfo[i].nAllocationTop		= pNpsPaperInfo->PaperAllocationTop;	// t㕔iPʁF0.1mmj
		pMagDetailInfo[i].nAllocationBottom		= pNpsPaperInfo->PaperAllocationBottom;	// tiPʁF0.1mmj
		pMagDetailInfo[i].nAllocationLeft		= pNpsPaperInfo->PaperAllocationLeft;	// tiPʁF0.1mmj
		pMagDetailInfo[i].nAllocationRight		= pNpsPaperInfo->PaperAllocationRight;	// tEiPʁF0.1mmj
		pMagDetailInfo[i].dwSetupStatus			= pNpsPaperInfo->SetupStatus;			// Setup status
		pMagDetailInfo[i].dwFeed				= pNpsPaperInfo->PaperFeed;				// @
		pMagDetailInfo[i].nWBAdjustLeft			= pNpsPaperInfo->WBAdjustLeft;			// WB␳l
		pMagDetailInfo[i].nWBAdjustRight		= pNpsPaperInfo->WBAdjustRight;			// WB␳lE
		strncpy( pMagDetailInfo[i].szPaperName, pNpsPaperInfo->PaperName, sizeof(pMagDetailInfo[i].szPaperName) );	// y[p[
		pMagDetailInfo[i].wPaperTypeCode		= pNpsPaperInfo->PaperTypeCode;			// y[p[^CvR[h
		pMagDetailInfo[i].wDirection			= pNpsPaperInfo->Direction;				// fBNV
		pMagDetailInfo[i].wPrintQuality			= pNpsPaperInfo->PrintQuality;			// i
		pMagDetailInfo[i].PaperType				= pNpsPaperInfo->PaperType;				// y[p[^Cv					(2011.8.4 A.Nagamatsu)
		pMagDetailInfo[i].PaperTypeValid		= pNpsPaperInfo->PaperTypeValid;		// y[p[^CvuL/v	(2011.8.4 A.Nagamatsu)

	}

	*pdwSize	= (DWORD)m_vAllMagInfo.size() * (DWORD)sizeof( NPS_MagDetailInfo );

	return NPSERR_NORMAL;
}



//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CDataManager::GetMagazineID()
//	ABSTRACT : Ԃɂ}KWID̎擾
//	FUNCTION : Ԃɂ}KWID̎擾
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : T.Isogai	2006.9.22
//	UPDATE   : J.Fukumori(AVASYS) 2008.0717 VS2005Ή
//////////////////////////////////////////////////////////////////////////////
UCHAR CDataManager::GetMagazineID( UCHAR PaperPresence )
{
	NkcComApi::CCSScopeLock CSScopeLock( &m_CS );

	UCHAR	MagazineID	= 0;

	for( int i = 0; i < (int)m_vMagInfo.size(); i++ )
	{
		T_NpsMagInfo * pPaperInfo	= ( T_NpsMagInfo * ) m_vMagInfo[i];
		
		if( PaperPresence == pPaperInfo->PaperPresence )
		{
			T_NpsRegMagInfo* pRegMagInfo	= SelectMagInfo( pPaperInfo->PaperWidth, pPaperInfo->PaperId, pPaperInfo->PaperFeed, pPaperInfo->PaperName );

			if( pRegMagInfo )
			{
				MagazineID	= pRegMagInfo->MagazineID;
			}
			break;
		}
	}

	return MagazineID;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CDataManager::GetNumberOfMagazine()
//	ABSTRACT : U\ȃ}KW
//	FUNCTION : U\ȃ}KW
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : T.Isogai	2006.9.22
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
USHORT CDataManager::GetNumberOfMagazine()
{
	NkcComApi::CCSScopeLock CSScopeLock( &m_CS );

	return m_Nps6000H_0201H.NumberOfMagazine;
}



//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CDataManager::GetMagSizeToImgSize()
//	ABSTRACT : y[p[TCYiPʁF0.1mmjvgTCYiPʁFPixelj
//	FUNCTION : 
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : Y.Yoshinobu	2006.10.13
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
BOOL CDataManager::GetMagSizeToImgSize( DWORD dwPaperWidth, DWORD dwPaperLength, DWORD dwPaperResolution, DWORD* pWidth, DWORD* pHeight )
{
	BOOL bResult=FALSE;
	std::vector<T_NpsRegMagInfo*>::iterator	itMagInfo;

	for ( itMagInfo=m_vAllMagInfo.begin() ; m_vAllMagInfo.end() != itMagInfo ; itMagInfo++ )
	{
		if ((( (*itMagInfo)->PaperResolution[0] == dwPaperResolution ) ||
			 ( (*itMagInfo)->PaperResolution[1] == dwPaperResolution ) ||
			 ( (*itMagInfo)->PaperResolution[2] == dwPaperResolution ) ||
			 ( (*itMagInfo)->PaperResolution[3] == dwPaperResolution ) ||
			 ( (*itMagInfo)->PaperResolution[4] == dwPaperResolution ) ||
			 ( (*itMagInfo)->PaperResolution[5] == dwPaperResolution ) ||
			 ( (*itMagInfo)->PaperResolution[6] == dwPaperResolution ) ||
			 ( (*itMagInfo)->PaperResolution[7] == dwPaperResolution )) &&
			( (*itMagInfo)->PaperWidth == dwPaperWidth ) &&
			( (*itMagInfo)->PaperLengthMin <= dwPaperLength ) &&
			( (*itMagInfo)->PaperLengthMax >= dwPaperLength ))
		{
			*pWidth = ( dwPaperWidth * dwPaperResolution / 254 + 5 ) / 10
						+ ( (*itMagInfo)->PaperAllocationLeft * dwPaperResolution / 254 + 5 ) / 10
						+ ( (*itMagInfo)->PaperAllocationRight * dwPaperResolution / 254 + 5 ) / 10;

			*pHeight = ( dwPaperLength * dwPaperResolution / 254 + 5 ) / 10
						+ ( (*itMagInfo)->PaperAllocationTop * dwPaperResolution / 254 + 5 ) / 10
						+ ( (*itMagInfo)->PaperAllocationBottom * dwPaperResolution / 254 + 5 ) / 10;

			bResult = TRUE;
			break;
		}
	}

	return bResult;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CDataManager::IsEnableMagazineID()
//	ABSTRACT : v^ΉĂ}KWIdmF
//	FUNCTION : 
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : Y.Yoshinobu 2006.9.26
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
BOOL CDataManager::IsEnableMagazineID( DWORD dwMagId )
{
	NkcComApi::CCSScopeLock CSScopeLock( &m_CS );

	BOOL bResult=FALSE;
	std::vector<T_NpsRegMagInfo*>::iterator	itMagInfo;

	for ( itMagInfo=m_vAllMagInfo.begin() ; m_vAllMagInfo.end() != itMagInfo ; itMagInfo++ )
	{
		if ( (*itMagInfo)->MagazineID == dwMagId )
		{
			bResult = TRUE;		// }KWID݂͑
			break;
		}
	}

	return bResult;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CDataManager::GetPaperTypeCode()
//	ABSTRACT : y[p[^CvR[h擾
//	FUNCTION : 
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : Y.Yoshinobu 2006.12.18
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
BOOL CDataManager::GetPaperTypeCode( DWORD dwWidth, DWORD dwPaperId, DWORD dwFeed, char* pPaperName, DWORD* pPaperTypeCode )
{
	NkcComApi::CCSScopeLock CSScopeLock( &m_CS );

	BOOL bResult=FALSE;
	std::vector<T_NpsRegMagInfo*>::iterator	itMagInfo;

	for ( itMagInfo=m_vAllMagInfo.begin() ; m_vAllMagInfo.end() != itMagInfo ; itMagInfo++ )
	{
		if ( PAPER_SHEET == dwFeed )
		{
			// SHEET
			if (( (*itMagInfo)->PaperWidth == dwWidth ) &&
				( (*itMagInfo)->PaperId == dwPaperId ) &&
				( (*itMagInfo)->PaperFeed == dwFeed ) &&
				( 0 == ::lstrcmp( (*itMagInfo)->PaperName, pPaperName ) ))
			{
				// Yy[p[݂̂ŁAy[p[^CvR[hZbg
				*pPaperTypeCode = (*itMagInfo)->PaperTypeCode;
				bResult = TRUE;
				break;
			}
		}
		else
		{
			// ROLL
			if (( (*itMagInfo)->PaperWidth == dwWidth ) &&
				( (*itMagInfo)->PaperId == dwPaperId ) &&
				( (*itMagInfo)->PaperFeed == dwFeed ) )
			{
				// Yy[p[݂̂ŁAy[p[^CvR[hZbg
				*pPaperTypeCode = (*itMagInfo)->PaperTypeCode;
				bResult = TRUE;
				break;
			}
		}
	}

	return bResult;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CDataManager::ChkRegistPaperNo()
//	ABSTRACT : o^y[p[No`FbN (dDPp)
//	FUNCTION : 
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : Y.Yoshinobu 2006.12.18
//	UPDATE   : Y.Atoji		2011.06.28	JX^vt@C̓`FbNΏۊOƂ
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
BOOL CDataManager::ChkRegistPaperNo( int nMaxCnt )
{
	NkcComApi::CCSScopeLock CSScopeLock( &m_CS );

	std::vector<T_NpsRegMagInfo*>::iterator	itMagInfo;

	for ( itMagInfo=m_vAllMagInfo.begin() ; m_vAllMagInfo.end() != itMagInfo ; itMagInfo++ )
	{
		// JX^vt@C̓`FbNΏۊOƂ	2011.06.28 Y.Atoji
		if ( CUSTOM_CODE_MIN <= (*itMagInfo)->PaperTypeCode &&
			 (*itMagInfo)->PaperTypeCode <= CUSTOM_CODE_MAX )
		{	// JX^vt@C
			continue;
		}

		if ( nMaxCnt < (*itMagInfo)->PaperTypeCode )
		{
			// vt@Co[WvȂ
			return FALSE;
		}
	}

	return TRUE;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CDataManager::UpdateEventInfoList()
//	ABSTRACT : Cxgǉ
//	FUNCTION : CxgXgɒǉiCxgj
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : T.Isogai	2006.10.2
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
BOOL CDataManager::InsertEventInfo( T_Nps6000H_F202H* pEventInfo )
{
	NkcComApi::CCSScopeLock CSScopeLock( &m_CS );

	T_Nps6000H_F202H* ptmpEventInfo;

	try
	{
		ptmpEventInfo = new T_Nps6000H_F202H;
	}
	catch (CMemoryException* e)
	{
		{
			CString str;
			str.Format( "===Memory allocation error [%d]", sizeof(T_Nps6000H_F202H) );
			NPS_LOGOUT_FATAL( str );
		}
		e->Delete();
	}

	memcpy( ptmpEventInfo, pEventInfo, sizeof( T_Nps6000H_F202H ) );
	m_vEventInfo.push_back( ptmpEventInfo );

	return TRUE;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CDataManager::DeleteEventInfo()
//	ABSTRACT : Cxg폜
//	FUNCTION : CxgXg폜iCxgj
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : T.Isogai	2006.10.2
//	UPDATE   : J.Fukumori(AVASYS) 2008.0717 VS2005Ή
//////////////////////////////////////////////////////////////////////////////
BOOL CDataManager::DeleteEventInfo( DWORD dwErrHandle )
{
	NkcComApi::CCSScopeLock CSScopeLock( &m_CS );

	BOOL	bRet	= FALSE;

	for( int idx = 0; idx < (int)m_vEventInfo.size(); idx++ )
	{
		T_Nps6000H_F202H * ptmpEventInfo	= ( T_Nps6000H_F202H * ) m_vEventInfo[idx];
		
		if( dwErrHandle == ptmpEventInfo->EventId )
		{
			m_vEventInfo.erase( m_vEventInfo.begin() + idx );
			delete ptmpEventInfo;
			bRet	= TRUE;
			break;
		}
	}

	return bRet;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CDataManager::DeleteEventInfo2()
//	ABSTRACT : Cxg폜
//	FUNCTION : CxgXg폜iCxgj
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : T.Mizushima	2006.11.27
//	UPDATE   : J.Fukumori(AVASYS) 2008.0717 VS2005Ή
//////////////////////////////////////////////////////////////////////////////
BOOL CDataManager::DeleteEventInfo2( T_Nps6000H_F202H* pEventInfo, LONG* pSubCode, DWORD* pdwErrHandle )
{
	NkcComApi::CCSScopeLock CSScopeLock( &m_CS );

	BOOL	bRet	= FALSE;

	// v^͉F202ʒmĂꍇAȂʎqݒ肵ĂȂ̂
	// ԂL[Ɍ
	for( int idx = 0; idx < (int)m_vEventInfo.size(); idx++ )
	{
		T_Nps6000H_F202H * ptmpEventInfo	= ( T_Nps6000H_F202H * ) m_vEventInfo[idx];
		
		if( pEventInfo->EventCode == ptmpEventInfo->EventCode )
		{
			*pSubCode = ptmpEventInfo->EventParam[0];
			*pdwErrHandle = ptmpEventInfo->EventId;
			m_vEventInfo.erase( m_vEventInfo.begin() + idx );
			delete ptmpEventInfo;
			bRet	= TRUE;
			break;
		}
	}

	return bRet;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CDataManager::SelectEventInfo()
//	ABSTRACT : nhCxg擾
//	FUNCTION : nhCxg擾
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : T.Isogai	2006.10.2
//	UPDATE   : J.Fukumori(AVASYS) 2008.0717 VS2005Ή
//////////////////////////////////////////////////////////////////////////////
BOOL CDataManager::SelectEventInfo( DWORD dwErrHandle, T_Nps6000H_F202H* pEventInfo )
{
	NkcComApi::CCSScopeLock CSScopeLock( &m_CS );

	BOOL	bRet	= FALSE;

	for( int idx = 0; idx < (int)m_vEventInfo.size(); idx++ )
	{
		T_Nps6000H_F202H * ptmpEventInfo	= ( T_Nps6000H_F202H * ) m_vEventInfo[idx];
		
		if( dwErrHandle == ptmpEventInfo->EventId )
		{
			memcpy( pEventInfo, ptmpEventInfo, sizeof( T_Nps6000H_F202H ) );
			bRet	= TRUE;
			break;
		}
	}

	return bRet;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CDataManager::SelectEventinfoByPos()
//	ABSTRACT : CfbNXCxg擾
//	FUNCTION : 
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : Y.Yoshinobu 2007.07.05
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
BOOL CDataManager::SelectEventinfoByPos( DWORD dwPos, T_Nps6000H_F202H* pEventInfo )
{
	NkcComApi::CCSScopeLock CSScopeLock( &m_CS );

	BOOL bRet = FALSE;

	if (( 0 <= dwPos ) && ( m_vEventInfo.size() > dwPos ))
	{
		T_Nps6000H_F202H * ptmpEventInfo = (T_Nps6000H_F202H*)m_vEventInfo[dwPos];
		memcpy( pEventInfo, ptmpEventInfo, sizeof( T_Nps6000H_F202H ) );
		bRet = TRUE;
	}

	return bRet;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CDataManager::IsFirstConnect()
//	ABSTRACT : Nǂ
//	FUNCTION : 
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : Y.Yoshinobu	2006.10.15
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
BOOL CDataManager::IsFirstConnect()
{
	NkcComApi::CCSScopeLock CSScopeLock( &m_CS );

	return m_bFirstConnect;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CDataManager::SetFirstConnect()
//	ABSTRACT : N̐ݒ
//	FUNCTION : 
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : Y.Yoshinobu	2006.10.15
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
void CDataManager::SetFirstConnect( BOOL bFirstConnect )
{
	NkcComApi::CCSScopeLock CSScopeLock( &m_CS );

	m_bFirstConnect = bFirstConnect;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CDataManager::IsEnableOfflineEvent()
//	ABSTRACT : ItCCxgʒm邩ǂ
//	FUNCTION : 
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : Y.Yoshinobu	2006.10.15
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
BOOL CDataManager::IsEnableOfflineEvent()
{
	NkcComApi::CCSScopeLock CSScopeLock( &m_CS );

	return m_bEnableOfflineEvent;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CDataManager::SetEnableOfflineEvent()
//	ABSTRACT : ItCCxgʒm邩ǂ
//	FUNCTION : 
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : Y.Yoshinobu	2006.10.15
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
void CDataManager::SetEnableOfflineEvent( BOOL bEnable )
{
	NkcComApi::CCSScopeLock CSScopeLock( &m_CS );

	m_bEnableOfflineEvent = bEnable;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CDataManager::SetRestartNormal()
//	ABSTRACT : }[Level1]荞ݏ̐LĊJ̏Ԃo^
//	FUNCTION : 
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : Y.Yoshinobu	2006.10.17
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
void CDataManager::SetRestartNormal( BOOL bRestartNormal )
{
	NkcComApi::CCSScopeLock CSScopeLock( &m_CS );

	m_bRestartNormal = bRestartNormal;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CDataManager::SetRestartExpress()
//	ABSTRACT : }[Level2]荞ݏ̐LĊJ̏Ԃo^
//	FUNCTION : 
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : Y.Yoshinobu	2006.11.23
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
void CDataManager::SetRestartExpress( BOOL bRestartExpress )
{
	NkcComApi::CCSScopeLock CSScopeLock( &m_CS );

	m_bRestartExpress = bRestartExpress;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CDataManager::UpdateSendLastTime()
//	ABSTRACT : ŏIMԂXV
//	FUNCTION : 
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : Y.Yoshinobu	2006.12.21
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
void CDataManager::UpdateSendLastTime()
{
	NkcComApi::CCSScopeLock CSScopeLock( &m_CS );

	::GetLocalTime( &m_stSendLastTime );
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CDataManager::IsSendConnectCheck()
//	ABSTRACT : ڑmFv𔭍s邩ǂmF
//	FUNCTION : 
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : Y.Yoshinobu	2006.12.21
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
BOOL CDataManager::IsSendConnectCheck()
{
	NkcComApi::CCSScopeLock CSScopeLock( &m_CS );

	COleDateTimeSpan objDiff;
	SYSTEMTIME stLocalTime;

	::GetLocalTime( &stLocalTime );

	objDiff = COleDateTime( stLocalTime ) - COleDateTime( m_stSendLastTime );

	if ( 30 <= objDiff.GetTotalSeconds() )
	{
		return TRUE;
	}

	return FALSE;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CDataManager::SetLastImgTransmitTime()
//	ABSTRACT : ԍŋ߂ɉ摜𑗐MԂZbg
//	FUNCTION : 
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : Y.Yoshinobu	2006.12.21
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
void CDataManager::SetLastImgTransmitTime( T_TransmitTimeInfo *pstLastImgTransmitTime )
{
	NkcComApi::CCSScopeLock CSScopeLock( &m_CS );

	::MoveMemory( &m_stLastImgTransmitTime, pstLastImgTransmitTime, sizeof(T_TransmitTimeInfo) );
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CDataManager::GetLastImgTransmitTime()
//	ABSTRACT : ԍŋ߂ɉ摜𑗐MԂ擾
//	FUNCTION : 
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : Y.Yoshinobu	2006.12.21
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
void CDataManager::GetLastImgTransmitTime( T_TransmitTimeInfo *pstLastImgTransmitTime )
{
	NkcComApi::CCSScopeLock CSScopeLock( &m_CS );

	::MoveMemory( pstLastImgTransmitTime, &m_stLastImgTransmitTime, sizeof(T_TransmitTimeInfo) );
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CDataManager::GetUnitInfo ()
//	ABSTRACT : jbgԎ擾
//	FUNCTION : v^̃jbgԏ擾
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//				NPSERR_NORMAL		I
//				NPSERR_BADPARAM	wp[^ł͎słȂ
//				NPSERR_PRNERR		v^G[
//				NPSERR_SYSERR		\[XsȂǂɂsłȂ
//	
//	CREATE	 : T.Isogai	2006.7.13
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
long CDataManager::GetUnitInfo (
	PNPS_UnitInfo	pUnitInfo	// jbgԍ\̂ւ̃AhX
)
{
	NkcComApi::CCSScopeLock CSScopeLock( &m_CS );

	long	lResult;

	lResult	= NPSERR_NORMAL;

	if (( STATE_OFFLINE  != GetState() ) &&		// ItC 
		( STATE_SELFINST != GetState() ))		// PC̃CXg[ ȊO
	{
		// v^S̏
		pUnitInfo->dwPrinterStatus			= TransUnitInfo_dwPrinterStatus( m_eState, m_Nps6000H_0301H.PrinterStatus );

		// t
		pUnitInfo->dwAcceptStatus			= TransUnitInfo_dwAcceptStatus( m_Nps6000H_0301H.AcceptStatus );

		// v^L
		pUnitInfo->dwPrinterPossession		= TransUnitInfo_dwPrinterPossession( m_Nps6000H_0301H.PrinterPossession );

		// nS
		pUnitInfo->dwAdvanceStatus			= TransUnitInfo_dwAdvanceStatus( m_Nps6000H_0301H.AdvanceStatus );
		
		// w[U[
		pUnitInfo->dwLaserStatus			= TransUnitInfo_dwLaserStatus( m_Nps6000H_0301H.LaserStatus );

		// S
		pUnitInfo->dwDevelopmentStatus		= TransUnitInfo_dwDevelopmentStatus( m_Nps6000H_0301H.DevelopmentStatus );

		// 
		pUnitInfo->dwProcessorStatus		= TransUnitInfo_dwProcessorStatus( m_Nps6000H_0301H.ProcessorStatus );

		// [
		pUnitInfo->dwReplenisherStatus		= TransUnitInfo_dwReplenisherStatus( m_Nps6000H_0301H.ReplenisherStatus );

		// [J[gbWύX
		pUnitInfo->dwReplaceCartridgeStatus	= TransUnitInfo_dwReplaceCartridgeStatus( m_Nps6000H_0301H.ReplaceCartridgeStatus );

		// nƓ_̎{
		pUnitInfo->dwStartUpChecksStatus	= TransUnitInfo_dwStartUpChecksStatus( m_Nps6000H_0301H.StartUpChecksStatus );

		// I[gZbgAbvł̕␅̎{
		pUnitInfo->dwRefillWaterStatus		= TransUnitInfo_dwRefillWaterStatus( m_Nps6000H_0301H.RefillWaterStatus );

		// I[gZbgAbvł̃fC[ZbgAbv̎{
		pUnitInfo->dwDailySetupStatus		= TransUnitInfo_dwDailySetupStatus( m_Nps6000H_0301H.DailySetupStatus );

		// I[gZbgAbvł̃Rg[Xgbv̎{
		pUnitInfo->dwControlStripStatus		= TransUnitInfo_dwControlStripStatus( m_Nps6000H_0301H.ControlStripStatus );

		// eiX\tg̐L
		pUnitInfo->dwMaintenanceStatus		= TransUnitInfo_dwMaintenanceStatus( m_Nps6000H_0301H.InMaintenance );

		// FAD̏
		pUnitInfo->dwFadStatus				= TransUnitInfo_dwFadStatus( m_Nps6000H_0301H.FadStatus );
	}
	else
	{
		//----------------------------------------
		// ftHgݒ
		//----------------------------------------
		pUnitInfo->dwPrinterStatus			= INFO_SALLOFFLN;		// v^S̏
		pUnitInfo->dwAcceptStatus			= INFO_SACDISABLE;		// t
		pUnitInfo->dwPrinterPossession		= INFO_SPPNOUSE;		// v^L
		pUnitInfo->dwAdvanceStatus			= INFO_SMCALLMOTNONE;	// nS
		pUnitInfo->dwLaserStatus			= INFO_SLDLZNONE;		// w[U[
		pUnitInfo->dwDevelopmentStatus		= INFO_SPRALLMTNONE;	// S
		pUnitInfo->dwProcessorStatus		= INFO_SPRBTHNONE;		// 
		pUnitInfo->dwReplenisherStatus		= INFO_SPRSPNONE;		// [
		pUnitInfo->dwReplaceCartridgeStatus	= INFO_SPRKITNONE;		// [J[gbWύX
		pUnitInfo->dwStartUpChecksStatus	= INFO_SUCSNONE;		// nƓ_̎{
		pUnitInfo->dwRefillWaterStatus		= INFO_RWSNONE;			// I[gZbgAbvł̕␅̎{
		pUnitInfo->dwDailySetupStatus		= INFO_DSSNONE;			// I[gZbgAbvł̃fC[ZbgAbv̎{
		pUnitInfo->dwControlStripStatus		= INFO_CSSNONE;			// I[gZbgAbvł̃Rg[Xgbv̎{
		pUnitInfo->dwMaintenanceStatus		= INFO_MNTNONE;			// eiX\tg̐L
		pUnitInfo->dwFadStatus				= INFO_FADNONE;			// FAD̏
	}

	return lResult;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CDataManager::GetSetUpInfo ()
//	ABSTRACT : ݒu擾
//	FUNCTION : v^̐ݒu擾
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//				NPSERR_NORMAL		I
//				NPSERR_BADPARAM	wp[^ł͎słȂ
//				NPSERR_PRNERR		v^G[
//				NPSERR_SYSERR		\[XsȂǂɂsłȂ
//	
//	CREATE	 : T.Isogai	2006.7.13
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
long CDataManager::GetSetUpInfo (
	PNPS_SetUpInfo	pSetUpInfo	// ݒu\̂ւ̃AhX
)
{
	NkcComApi::CCSScopeLock CSScopeLock( &m_CS );

	long	lResult	= NPSERR_NORMAL;

	if (( STATE_OFFLINE  != GetState() ) &&		// ItC 
		( STATE_SELFINST != GetState() ))		// PC̃CXg[ ȊO
	{
		// ̕ϊ
		strcpy( pSetUpInfo->szMachineTypeName, m_Nps6000H_0101H.MachineTypeName );	// @햼
		strcpy( pSetUpInfo->szSoftName, m_Nps6000H_0101H.SoftName );				// \tgEFA
		strcpy( pSetUpInfo->szSerialNumber, m_Nps6000H_0101H.SerialNumber );		// VAԍ

		for( int i = 0; i < 8; i++ )
		{
			pSetUpInfo->wSupportResolutions[i]	= m_Nps6000H_0101H.SupportResolutions[i];	// 𑜓xiPʁF0.1 dpij
		}

		pSetUpInfo->wNpsVersion				= GetNpsVersion();		// NPS I/F ̃o[W

		pSetUpInfo->wMachineTypeID			= m_Nps6000H_0101H.MachineTypeID;		// @敪
		pSetUpInfo->dwTotalMemory			= m_Nps6000H_0201H.TotalMemory;			// v^̃e(PʁFByte)
		pSetUpInfo->dwImageSizeMinWidth		= m_Nps6000H_0201H.ImageSizeMinWidth;	// t摜̍̕ŏTCYiPʁFPixelj
		pSetUpInfo->dwImageSizeMinHeight	= m_Nps6000H_0201H.ImageSizeMinHeight;	// t摜̍̍ŏTCYiPʁFPixelj
		pSetUpInfo->dwImageSizeMaxWidth		= m_Nps6000H_0201H.ImageSizeMaxWidth;	// t摜̍̕őTCYiPʁFPixelj
		pSetUpInfo->dwImageSizeMaxHeight	= m_Nps6000H_0201H.ImageSizeMaxHeight;	// t摜̍̍őTCYiPʁFPixelj
		pSetUpInfo->dwNumberOfMagazine		= m_Nps6000H_0201H.NumberOfMagazine;		// U\ȃ}KW

		// v^̓
		pSetUpInfo->PrinterTime.tDate.dwYear		= m_Nps6000H_0201H.PrinterTime[0];		// N
		pSetUpInfo->PrinterTime.tDate.dwMonth		= m_Nps6000H_0201H.PrinterTime[1];		// 
		pSetUpInfo->PrinterTime.tDate.dwDay			= m_Nps6000H_0201H.PrinterTime[2];		// 
		pSetUpInfo->PrinterTime.tTime.dwHour		= m_Nps6000H_0201H.PrinterTime[3];		// 
		pSetUpInfo->PrinterTime.tTime.dwMinute		= m_Nps6000H_0201H.PrinterTime[4];		// 
		pSetUpInfo->PrinterTime.tTime.dwSecond		= m_Nps6000H_0201H.PrinterTime[5];		// b
		pSetUpInfo->PrinterTime.tDate.dwDayofweek	= m_Nps6000H_0201H.PrinterTime[7];		// j	0ijj-6iyjj

		pSetUpInfo->dwRepeatCountMax		= m_Nps6000H_0201H.RepeatCountMax;		// ő僊s[g

#if defined(NKC_CMS_PROC)
		for( i = 0; i < 32; i++ )
		{
			pSetUpInfo->SupportImageFormat[i]	= INFO_IMGNO;	// T|[g摜
		}
		pSetUpInfo->SupportImageFormat[0]	= INFO_IMGOK;			// JPEG TYPE1
		pSetUpInfo->SupportImageFormat[1]	= INFO_IMGOK;			// BMP TYPE1
		pSetUpInfo->SupportImageFormat[11]	= INFO_IMGOK;			// JPEG TYPE2
		pSetUpInfo->SupportImageFormat[12]	= INFO_IMGOK;			// BMP TYPE2
		pSetUpInfo->SupportImageFormat[13]	= INFO_IMGOK;			// TIFF TYPE1
#else  // defined(NKC_CMS_PROC)
		for( i = 0; i < 32; i++ )
		{
			pSetUpInfo->SupportImageFormat[i]	= m_Nps6000H_0201H.SupportImageFormat[i];	// T|[g摜
		}
		if ( INFO_IMGOK == pSetUpInfo->SupportImageFormat[2] )
		{
			// RAWT|[gĂABMPT|[g
			pSetUpInfo->SupportImageFormat[1] = INFO_IMGOK;				// T|[g摜 BMP
		}
		if ( INFO_IMGOK == pSetUpInfo->SupportImageFormat[1] )
		{
			// BMPT|[gĂARAWT|[g
			pSetUpInfo->SupportImageFormat[2] = INFO_IMGOK;				// T|[g摜 BMP
		}
#endif // defined(NKC_CMS_PROC)

		pSetUpInfo->wLaminatorUnitAttach	= m_Nps6000H_0201H.LaminatorUnitAttach;	// ~l[^[jbg̑

		// ݒu
		pSetUpInfo->InstallationDate.dwYear			= m_Nps6000H_0201H.InstallationDate[0];	// N
		pSetUpInfo->InstallationDate.dwMonth		= m_Nps6000H_0201H.InstallationDate[1];	// 
		pSetUpInfo->InstallationDate.dwDay			= m_Nps6000H_0201H.InstallationDate[2];	// 
		pSetUpInfo->InstallationDate.dwDayofweek	= NkcComApi::GetDayofweek(
														pSetUpInfo->InstallationDate.dwYear,
														pSetUpInfo->InstallationDate.dwMonth,
														pSetUpInfo->InstallationDate.dwDay
														);	// j	0ijj-6iyjj

		// ғJn
		pSetUpInfo->OperationStartDate.dwYear		= m_Nps6000H_0201H.OperationStartDate[0];	// N
		pSetUpInfo->OperationStartDate.dwMonth		= m_Nps6000H_0201H.OperationStartDate[1];	// 
		pSetUpInfo->OperationStartDate.dwDay		= m_Nps6000H_0201H.OperationStartDate[2];	// 
		pSetUpInfo->OperationStartDate.dwDayofweek	= NkcComApi::GetDayofweek(
														pSetUpInfo->OperationStartDate.dwYear,
														pSetUpInfo->OperationStartDate.dwMonth,
														pSetUpInfo->OperationStartDate.dwDay
														);	// j	0ijj-6iyjj

		// vZT[
		switch( m_Nps6000H_0201H.ProcessorType )
		{
		case 0:	{ pSetUpInfo->wProcessorType	= INFO_PRIDNONE;		} break;	// 0FȂ
		case 1:	{ pSetUpInfo->wProcessorType	= INFO_PRIDGPRO1;		} break;	// 1FLPP600(iBEAM600)
		case 2:	{ pSetUpInfo->wProcessorType	= INFO_PRIDGPRO2;		} break;	// 2FLPP600(Laser600)
		case 3:	{ pSetUpInfo->wProcessorType	= INFO_PRIDGPRO3;		} break;	// 3FLPP1000(Laser1000)
		case 4:	{ pSetUpInfo->wProcessorType	= INFO_PRIDGPRO4;		} break;	// 4FLP1700(900)
		case 5:	{ pSetUpInfo->wProcessorType	= INFO_PRIDGPRO5;		} break;	// 5FLP1700(1300)
		case 6:	{ pSetUpInfo->wProcessorType	= INFO_PRIDGPRO6;		} break;	// 6FLP1700(1700)
		case 7:	{ pSetUpInfo->wProcessorType	= INFO_PRIDGPRO7;		} break;	// 7FLP2500(2300)
		case 8:	{ pSetUpInfo->wProcessorType	= INFO_PRIDGPRO8;		} break;	// 8FLP2500(2500)
		}

		pSetUpInfo->wEmulsionNumber			= m_Nps6000H_0201H.EmulsionNumber;		// 
		strcpy( pSetUpInfo->szPrinterNickname, m_Nps6000H_0201H.PrinterNickname );	// [U[`̃v^
		pSetUpInfo->wSupportAngle			= m_Nps6000H_0201H.SupportAngle;		// T|[g]px
		pSetUpInfo->wSupportIntoPrinter		= m_Nps6000H_0201H.SupportIntoPrinter;	// L

		pSetUpInfo->wSorterStatus			= m_Nps6000H_0201H.SorterStatus;				// \[^[̃gC̐
		pSetUpInfo->wCvpStatus				= m_Nps6000H_0201H.CvpStatus;				// CVP󎚍s
		pSetUpInfo->wSupportPaperFitting	= m_Nps6000H_0201H.SupportPaperFitting;		// T|[gy[p[tBbeBO
		pSetUpInfo->wSupportEdgeEnhancement	= m_Nps6000H_0201H.SupportEdgeEnhancement;	// T|[gGbW
		pSetUpInfo->wSupportWithBorder		= m_Nps6000H_0201H.SupportWithBorder;		// T|[g쐬
		pSetUpInfo->wMachinTypeForProfile	= m_Nps6000H_0201H.MachinTypeForProfile;	// vt@Cp@R[h
		for( i = 0; i < 6; i++ )
		{
			pSetUpInfo->wPaperTypeCode[i]	= m_Nps6000H_0201H.PaperTypeCode[i];		// y[p[^CvR[h
		}
		pSetUpInfo->wSupportCMS				= m_Nps6000H_0201H.SupportCMS;				// T|[gCMS
		pSetUpInfo->wSetupAlgorithm			= m_Nps6000H_0201H.SetupAlgorithm;			// ZbgAbvASY
		pSetUpInfo->wSupportDuplex			= m_Nps6000H_0201H.SupportDoubleSided;		// T|[gʈ
		pSetUpInfo->dwFadAttachNo			= m_Nps6000H_0201H.FadAttachNo;				// FADT|[g
		pSetUpInfo->wSupportInterrupt		= m_Nps6000H_0201H.SupportInterrupt;		// f		2011.11.08 A.Nagamatsu (D703/WG)

#if defined(NKC_CMS_PROC)
		if ( TRUE == m_bExistGProProc )
		{
			pSetUpInfo->wSupportAngle			= INFO_ROTATIONOK;	// T|[g Angle
			pSetUpInfo->wSupportPaperFitting	= INFO_PFOK;		// T|[g PaperFitting
			pSetUpInfo->wSupportEdgeEnhancement	= INFO_EEOK;		// T|[g EdgeEnhancement
			pSetUpInfo->wSupportCMS				= INFO_CMSOK;		// T|[g CMS
		}
#endif  // defined(NKC_CMS_PROC)

	}
	else
	{
		//----------------------------------------
		// ftHgݒ
		//----------------------------------------
		strcpy( pSetUpInfo->szMachineTypeName, "" );		// @햼
		strcpy( pSetUpInfo->szSoftName, "" );				// \tgEFA
		strcpy( pSetUpInfo->szSerialNumber, "" );			// VAԍ

		for( int i = 0; i < 8; i++ )
		{
			pSetUpInfo->wSupportResolutions[i]	= 0;		// 𑜓xiPʁF0.1 dpij
		}

		pSetUpInfo->wNpsVersion				= GetNpsVersion();	// NPS I/F ̃o[W

		pSetUpInfo->wMachineTypeID			= INFO_TYPEEXP;	// @敪
		pSetUpInfo->dwTotalMemory			= 0;			// v^̃e(PʁFByte)
		pSetUpInfo->dwImageSizeMinWidth		= 0;			// t摜̍̕ŏTCYiPʁFPixelj
		pSetUpInfo->dwImageSizeMinHeight	= 0;			// t摜̍̍ŏTCYiPʁFPixelj
		pSetUpInfo->dwImageSizeMaxWidth		= 0;			// t摜̍̕őTCYiPʁFPixelj
		pSetUpInfo->dwImageSizeMaxHeight	= 0;			// t摜̍̍őTCYiPʁFPixelj
		pSetUpInfo->dwNumberOfMagazine		= 0;			// U\ȃ}KW

		// v^̓
		pSetUpInfo->PrinterTime.tDate.dwYear		= 0;	// N
		pSetUpInfo->PrinterTime.tDate.dwMonth		= 0;	// 
		pSetUpInfo->PrinterTime.tDate.dwDay			= 0;	// 
		pSetUpInfo->PrinterTime.tDate.dwDayofweek	= 0;	// j	0ijj-6iyjj
		pSetUpInfo->PrinterTime.tTime.dwHour		= 0;	// 
		pSetUpInfo->PrinterTime.tTime.dwMinute		= 0;	// 
		pSetUpInfo->PrinterTime.tTime.dwSecond		= 0;	// b

		pSetUpInfo->dwRepeatCountMax		= 0;		// ő僊s[g

		for( i = 0; i < 32; i++ )
		{
			pSetUpInfo->SupportImageFormat[i]	= INFO_IMGNO;	// T|[g摜
		}

		pSetUpInfo->wLaminatorUnitAttach	= INFO_LAMIDISABLE;	// ~l[^[jbg̑

		// ݒu
		pSetUpInfo->InstallationDate.dwYear			= 0;	// N
		pSetUpInfo->InstallationDate.dwMonth		= 0;	// 
		pSetUpInfo->InstallationDate.dwDay			= 0;	// 
		pSetUpInfo->InstallationDate.dwDayofweek	= 0;	// j	0ijj-6iyjj

		// ғJn
		pSetUpInfo->OperationStartDate.dwYear		= 0;	// N
		pSetUpInfo->OperationStartDate.dwMonth		= 0;	// 
		pSetUpInfo->OperationStartDate.dwDay		= 0;	// 
		pSetUpInfo->OperationStartDate.dwDayofweek	= 0;	// j	0ijj-6iyjj
		
		pSetUpInfo->wProcessorType	= INFO_PRIDNONE;		// vZT[

		pSetUpInfo->wEmulsionNumber			= 0;			// 
		strcpy( pSetUpInfo->szPrinterNickname, "" );		// [U[`̃v^
		pSetUpInfo->wSupportAngle			= INFO_ROTATIONNO;	// T|[g]px
		pSetUpInfo->wSupportIntoPrinter		= INFO_EXPRESSNO;	// L

		pSetUpInfo->wSorterStatus			= 0;					// \[^[̃gC̐
		pSetUpInfo->wCvpStatus				= INFO_SMCMT1BPUNSET;	// CVP󎚍s
		pSetUpInfo->wSupportPaperFitting	= INFO_PFNO;			// T|[gy[p[tBbeBO
		pSetUpInfo->wSupportEdgeEnhancement	= INFO_EENO;			// T|[gGbW
		pSetUpInfo->wSupportWithBorder		= INFO_WBNO;			// T|[g쐬
		pSetUpInfo->wMachinTypeForProfile	= 0;					// vt@Cp@R[h
		for( i = 0; i < 6; i++ )
		{
			pSetUpInfo->wPaperTypeCode[i]	= 0;					// y[p[^CvR[h
		}
		pSetUpInfo->wSupportCMS				= INFO_CMSNO;			// T|[gCMS
		pSetUpInfo->wSupportDuplex			= INFO_DUPLEXNO;		// T|[gʈ
		pSetUpInfo->dwFadAttachNo			= 0;					// FADT|[g
		pSetUpInfo->wSupportInterrupt		= INFO_SUPPORTINTNO;	// f		2011.11.08 A.Nagamatsu (D703/WG)
	}

	return lResult;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CDataManager::GetTime ()
//	ABSTRACT : 擾
//	FUNCTION : 擾
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//				NPSERR_NORMAL		I
//				NPSERR_BADPARAM	wp[^ł͎słȂ
//				NPSERR_PRNERR		v^G[
//				NPSERR_SYSERR		\[XsȂǂɂsłȂ
//	
//	CREATE	 : T.Isogai	2006.7.13
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
long CDataManager::GetTime (
	PNPS_DateTime	pTime		// 擾̊i[
)
{
	NkcComApi::CCSScopeLock CSScopeLock( &m_CS );

	long	lResult	= NPSERR_NORMAL;

	if (( STATE_OFFLINE  != GetState() ) &&		// ItC 
		( STATE_SELFINST != GetState() ))		// PC̃CXg[ ȊO
	{
		// ̐ݒ
		pTime->tDate.dwYear			= m_Nps6000H_0201H.PrinterTime[0];
		pTime->tDate.dwMonth		= m_Nps6000H_0201H.PrinterTime[1];
		pTime->tDate.dwDay			= m_Nps6000H_0201H.PrinterTime[2];
		pTime->tDate.dwDayofweek	= m_Nps6000H_0201H.PrinterTime[7];
		pTime->tTime.dwHour			= m_Nps6000H_0201H.PrinterTime[3];
		pTime->tTime.dwMinute		= m_Nps6000H_0201H.PrinterTime[4];
		pTime->tTime.dwSecond		= m_Nps6000H_0201H.PrinterTime[5];
	}
	else
	{
		//----------------------------------------
		// ftHgݒ
		//----------------------------------------
		pTime->tDate.dwYear			= 0;
		pTime->tDate.dwMonth		= 0;
		pTime->tDate.dwDay			= 0;
		pTime->tDate.dwDayofweek	= 0;
		pTime->tTime.dwHour			= 0;
		pTime->tTime.dwMinute		= 0;
		pTime->tTime.dwSecond		= 0;
	}

	return lResult;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CDataManager::GetPrinterSetupSupportInterrupt()
//	ABSTRACT : f݂̃T|[gԂ̎擾
//	FUNCTION : 
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : T.Mizushima 2012.02.09	@@@RD-151Ή
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
USHORT CDataManager::GetPrinterSetupSupportInterrupt()
{
	NkcComApi::CCSScopeLock CSScopeLock( &m_CS );

	return m_Nps6000H_0201H.SupportInterrupt;
}




#if defined(NKC_CMS_PROC)
//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CDataManager::SetExistGProProc()
//	ABSTRACT : GProp摜W[CXg[Ă邩Zbg
//	FUNCTION : 
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : Y.Yoshinobu	2008.1.30
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
void CDataManager::SetExistGProProc( BOOL bExistGProProc )
{
	m_bExistGProProc = bExistGProProc;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CDataManager::IsEnableGProProc()
//	ABSTRACT : CMSpW[CXg[Ă邩Zbg
//	FUNCTION : 
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : Y.Yoshinobu	2008.1.30
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
BOOL CDataManager::IsEnableGProProc()
{
	return m_bExistGProProc;
}

#endif // defined(NKC_CMS_PROC)
