//////////////////////////////////////////////////////////////////////////////
//	FILE NAME : DrawObjImage.h
//	ABSTRACT  : CDrawObjImage NX̃C^[tFCX
//	
//	CREATE    : T.Isogai	2009.11.25
//	UPDATE    : 
//	
//										(C)Copyright : Noritsu Koki CO.,LTD.
//////////////////////////////////////////////////////////////////////////////

#if !defined(AFX_DRAWOBJIMAGE_H__78868A6B_E053_4BCF_8B72_757EA651FA85__INCLUDED_)
#define AFX_DRAWOBJIMAGE_H__78868A6B_E053_4BCF_8B72_757EA651FA85__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "DrawObj.h"

//////////////////////////////////////////////////////////////////////////////
//	CLASS    : CDrawObjImage
//	ABSTRACT : `IuWFNg [摜\t]
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	CREATE	 : T.Isogai	2009.11.25	EZ Controller 6x6C` tHgubNΉ
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
class CDrawObjImage : public CDrawObj  
{
public:

	// RXgN^
	CDrawObjImage();

	// fXgN^
	virtual ~CDrawObjImage();

	// 񕶎擾
	virtual CString GetInformation()
	{
		CString str;
		str.Format("DrawObjImage : Trim1 (%d, %d, %d, %d) Trim2 (%d, %d, %d, %d)",
			m_Trim1.left, m_Trim1.top, m_Trim1.right, m_Trim1.bottom,
			m_Trim2.left, m_Trim2.top, m_Trim2.right, m_Trim2.bottom
			);
		return str;
	}

	// I
	virtual void End();

	// `揈
	virtual ECODE Draw(unsigned char* pData, RECT rect);

public:

	RECT m_Trim1;					// ؂oʒuiP:1sNZj
	RECT m_Trim2;					// ؂oꂽ̂̓\tʒuiP:1sNZj
	CString m_strFilePath;			// rbg}bvt@CpX

private:

	BOOL m_bBmpAccess;				// rbg}bvt@CANZXtO
	unsigned char* m_pData;			// f[^obt@|C^

	CFile m_File;					// t@CNX
	BITMAPFILEHEADER m_FileHeader;	// rbg}bvt@Cwb_[
	BITMAPINFOHEADER m_InfoHeader;	// rbg}bvCtHwb_[

	int m_DataSize;					// mۂĂobt@̃TCYioCgj

	// rbg}bvt@Cւ̃ANZXJn
	BOOL OpenBmpFile();

	// rbg}bvt@C̃f[^̓ǂݍ
	BOOL LoadBmpFile(RECT rect);

	// rbg}bvt@Cւ̃ANZXI
	BOOL CloseBmpFile();
};

#endif // !defined(AFX_DRAWOBJIMAGE_H__78868A6B_E053_4BCF_8B72_757EA651FA85__INCLUDED_)
