#include	"stdafx.h"
#include	"ImgProcMmf.h"	//ImgProcNX`萔`wb_t@C

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/**
 *
 * MMFr[擪AhX擾
 *
 */
HANDLE	CImgProcMmf::pView(int start, int size )
{
	if( m_pView!=NULL && start==0 && size==0)return m_pView+m_offset;

	BOOL	ErrFlg=FALSE;
	LPVOID	lpMsgBuf;
    DWORD	dwDesiredAccess=0;
	int		i;

	m_offset = start%m_dwAllocationGranularity;
	start = start-m_offset;
	size+=m_offset;

//	try
	{
		if( m_pView!=NULL ){
			UnmapViewOfFile(m_pView);
			m_pView=NULL;
		}
		do{
			dwDesiredAccess=FILE_MAP_READ;
			if( m_Access&WRITE )dwDesiredAccess=FILE_MAP_ALL_ACCESS;
	
			for( i=0 ; i<100 ; i++ ){
				m_pView = (char*)MapViewOfFile(
					m_hMap,
					dwDesiredAccess,
					0,
					start,
					size
				);
				if( NULL != m_pView )break;
				Sleep(10);
			}
			if( NULL == m_pView ){
				m_LastErr=GetLastError();
				FormatMessage(FORMAT_MESSAGE_ALLOCATE_BUFFER |FORMAT_MESSAGE_FROM_SYSTEM |FORMAT_MESSAGE_IGNORE_INSERTS,NULL,m_LastErr,MAKELANGID(LANG_NEUTRAL, SUBLANG_DEFAULT), (LPTSTR) &lpMsgBuf,0,NULL);
				TRACE( "CImgProcMmf::CreateMMF MapViewOfFile\n%s",lpMsgBuf );
				LocalFree(lpMsgBuf);
				ErrFlg=TRUE;
				break;
			}
		}while(0);

		if( ErrFlg==TRUE ){
			Free();
		}
	}
//	CATCH_SE{}CATCH_END
//	CATCH_AE{}CATCH_END
	return m_pView + m_offset;
}

/**
 *
 * t@CMMFr[擾
 *
 */
BOOL	CImgProcMmf::CreateMMF( const char* str, int size, int Access )
{
	m_Access = Access;
	BOOL	ErrFlg=FALSE;
	LPVOID	lpMsgBuf;
    DWORD	dwDesiredAccess=0;

//	try
	{
		do{
			Free();

			dwDesiredAccess=0;
			if( m_Access&READ )dwDesiredAccess|=GENERIC_READ;
			if( m_Access&WRITE )dwDesiredAccess|=GENERIC_WRITE;

			if( strlen(str)!=0 ){
				m_hFile = CreateFileA(
					str,
					dwDesiredAccess,
					FILE_SHARE_READ,
					NULL,
					m_dwCreationDisposition,
					NULL,
					NULL
				);
				if( INVALID_HANDLE_VALUE == m_hFile ){
					m_LastErr=GetLastError();
					FormatMessage(FORMAT_MESSAGE_ALLOCATE_BUFFER |FORMAT_MESSAGE_FROM_SYSTEM |FORMAT_MESSAGE_IGNORE_INSERTS,NULL,m_LastErr,MAKELANGID(LANG_NEUTRAL, SUBLANG_DEFAULT), (LPTSTR) &lpMsgBuf,0,NULL);
					TRACE( "CImgProcMmf::CreateMMF CreateFile\n%s\n%s",str,lpMsgBuf );
					LocalFree(lpMsgBuf);
					ErrFlg=TRUE;
					break;
				}
			}

			dwDesiredAccess=PAGE_READONLY;
			if( m_Access&WRITE )dwDesiredAccess=PAGE_READWRITE;

			m_hMap = ::CreateFileMapping( m_hFile, NULL,
										 dwDesiredAccess,
										 0, 
										 size,
										 NULL
			);
			if( NULL == m_hMap ){
				m_LastErr=GetLastError();
				FormatMessage(FORMAT_MESSAGE_ALLOCATE_BUFFER |FORMAT_MESSAGE_FROM_SYSTEM |FORMAT_MESSAGE_IGNORE_INSERTS,NULL,m_LastErr,MAKELANGID(LANG_NEUTRAL, SUBLANG_DEFAULT), (LPTSTR) &lpMsgBuf,0,NULL);
				TRACE( "CImgProcMmf::CreateMMF CreateFileMapping\n%s\n%s",str,lpMsgBuf );
				LocalFree(lpMsgBuf);
				ErrFlg=TRUE;
				break;
			}
		}while(0);

		if( ErrFlg==TRUE ){
			Free();
		}
	}
//	CATCH_SE{}CATCH_END
//	CATCH_AE{}CATCH_END

	return !ErrFlg;
}

/**
 *
 * IuWFNgMMFr[擾
 *
 */
BOOL	CImgProcMmf::AttachMMF( const char* str, int size, int Access )
{
	m_Access = Access;
	BOOL	ErrFlg=FALSE;
	LPVOID	lpMsgBuf;
    DWORD dwDesiredAccess=0;

//	try
	{
		Free();

		do{
			dwDesiredAccess=FILE_MAP_READ;
			if( m_Access&WRITE )dwDesiredAccess=FILE_MAP_ALL_ACCESS;

			m_hMap = OpenFileMappingA(
				dwDesiredAccess,	// ANZX[h
				FALSE,			// ptO
				str		// IuWFNg
			);
			if( NULL == m_hMap ){
				m_LastErr=GetLastError();
				FormatMessage(FORMAT_MESSAGE_ALLOCATE_BUFFER |FORMAT_MESSAGE_FROM_SYSTEM |FORMAT_MESSAGE_IGNORE_INSERTS,NULL,m_LastErr,MAKELANGID(LANG_NEUTRAL, SUBLANG_DEFAULT), (LPTSTR) &lpMsgBuf,0,NULL);
				TRACE( "CImgProcMmf::CreateMMF OpenFileMapping\n%s\n%s",str,lpMsgBuf );
				LocalFree(lpMsgBuf);
				ErrFlg=TRUE;
				break;
			}
		}while(0);

		if( ErrFlg==TRUE ){
			Free();
		}
	}
//	CATCH_SE{ Free(); }CATCH_END
//	CATCH_AE{ Free(); }CATCH_END

	return !ErrFlg;
}

/**
 *
 * nhSJ
 *
 */
void CImgProcMmf::Free()
{
	if( m_pView!=NULL ){
		UnmapViewOfFile(m_pView);
		m_pView=NULL;
	}
	if( m_hMap!=NULL ){
		CloseHandle(m_hMap);
		m_hMap=NULL;
	}
	if( m_hFile!=INVALID_HANDLE_VALUE ){
		CloseHandle(m_hFile);
		m_hFile=INVALID_HANDLE_VALUE;
	}
}
