#pragma once

#pragma pack( push , 8 )

class	CImgProcMmf
{

private:
	HANDLE	m_hFile;
	HANDLE	m_hMap;
	char*	m_pView;
	int		m_Access;
	DWORD m_dwCreationDisposition;
	DWORD m_dwAllocationGranularity;
	DWORD m_offset;
	DWORD m_LastErr;
public:
	DWORD GetLastError(){
		return m_LastErr;
	}
	enum{
		READ=1,
		WRITE
	} ACCESSTYPE;
	
	CImgProcMmf(  DWORD dwCreationDisposition  )
	{
		m_LastErr=0;
		m_dwCreationDisposition = dwCreationDisposition;
		m_hFile=INVALID_HANDLE_VALUE;
		m_hMap=NULL;
		m_pView=NULL;
		m_Access=READ|WRITE;

		SYSTEM_INFO SysInfo;
		GetSystemInfo(&SysInfo);
		m_dwAllocationGranularity = SysInfo.dwAllocationGranularity;
		m_offset=0;
	};
	CImgProcMmf()
	{
		m_LastErr=0;
		m_dwCreationDisposition = OPEN_ALWAYS;
		m_hFile=INVALID_HANDLE_VALUE;
		m_hMap=NULL;
		m_pView=NULL;
		m_Access=READ|WRITE;

		SYSTEM_INFO SysInfo;
		GetSystemInfo(&SysInfo);
		m_dwAllocationGranularity = SysInfo.dwAllocationGranularity;
		m_offset=0;
	};
	virtual ~CImgProcMmf()
	{
		Free();
	};

/**
 *
 * MMFr[擪AhX擾
 *
 * @author K.Kishi
 * @date 2006/08/02
 * @note VK쐬
 * @attention ŕێĂMFFr[|C^Ԃ
 *				
 * @return	FMMFr[擪AhX
 *			sFNULL	
 */
	void*	pView(int start=0, int size=0 );
/**
 *
 * t@CMMFIuWFNg쐬Ar[J
 *
 * @param[in] type		IuWFNg/t@C̐ݒ^Cv	0:MMFOBJECT	1:FILENAME
 * @param[in] str		IuWFNg/t@C
 * @param[in] Access	1:Read 2:Write 3:ReadWrite
 * @param[in] size		TCYi0w肷ƑS̃̕TCYj
 * @return	FTRUE
 *			sFFALSE	
 *
 * @author K.Kishi
 * @date 2006/08/02
 * @note VK쐬
 * @attention ɂȂ
 *
 */
	BOOL	CreateMMF( const char* str, int size=0, int Access = CImgProcMmf::READ|CImgProcMmf::WRITE );
/**
 *
 * MMFIuWFNgMMFɃA^b`Ar[J
 *
 * @param[in] type		IuWFNg/t@C̐ݒ^Cv	0:MMFOBJECT	1:FILENAME
 * @param[in] str		IuWFNg/t@C
 * @param[in] Access	1:Read 2:Write 3:ReadWrite
 * @param[in] size		TCYi0w肷ƑS̃̕TCYj
 * @return	FTRUE
 *			sFFALSE	
 *
 * @author K.Kishi
 * @date 2006/08/02
 * @note VK쐬
 * @attention ɂȂ
 *
 */
	BOOL	AttachMMF( const char* str, int size=0, int Access = CImgProcMmf::READ|CImgProcMmf::WRITE );
/**
 *
 * nhSJ
 *
 * @author K.Kishi
 * @date 2006/08/02
 * @note VK쐬
 * @attention ɂȂ
 *
 */
	void Free();
};

#pragma pack( pop )
