//////////////////////////////////////////////////////////////////////////////
//	FILE NAME : NpsCallbackCompletion.h
//	ABSTRACT  : CNpsCallbackCompletion NX̃C^[tFCX
//	
//	CREATE    : T.Isogai	2006.7.10
//	UPDATE    : 
//	
//										(C)Copyright : Noritsu Koki CO.,LTD.
//////////////////////////////////////////////////////////////////////////////

#if !defined(AFX_NPSCALLBACKCOMPLETION_H__46AD7FA9_543A_4080_99F8_F5FC673C24EC__INCLUDED_)
#define AFX_NPSCALLBACKCOMPLETION_H__46AD7FA9_543A_4080_99F8_F5FC673C24EC__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "NpsCallback.h"

//////////////////////////////////////////////////////////////////////////////
#define	NPS_CALLBACKCOMPLETION		(0)		// 0: ʒm
#define	NPS_CALLBACKEVENTPROCEX		(1)		// 1: v^Cxggʒm

class CNpsCALLBACKDATA_Completion : public CNpsCALLBACKDATA
{
public:
	void *			m_pFunc;
	DWORD			m_dwCompletionCode;
	NPSPRINTINFO	m_PrintInfo;
	NPSORDERINFO	m_OrderInfo;

	WORD			m_wCallCallback;		// R[obNďo			2011.11.18 A.Nagamatsu
											//	NPS_CALLBACKCOMPLETION		: v^󋵒ʒm
											//	NPS_CALLBACKEVENTPROCEX		: v^Cxggʒm
	NPSEVENTINFOEX	m_EventInfoEx;			// v^Cxgg		2011.11.18 A.Nagamatsu
};

//////////////////////////////////////////////////////////////////////////////
//	CLASS    : CNpsCallbackCompletion
//	ABSTRACT : R[obNvg󋵒ʒmNX
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	CREATE	 : T.Isogai	2006.8.9
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
class CNpsCallbackCompletion : public CNpsCallback  
{
public:
	CNpsCallbackCompletion();			// RXgN^
	virtual ~CNpsCallbackCompletion();	// fXgN^

	void	AddNpsCALLBACKDATA( void*			pFunc,
								DWORD			dwCompletionCode,
								NPSPRINTINFO	PrintInfo,
								NPSORDERINFO	OrderInfo );

	////////////////////////////////////
	// v^Cxggʒm
	void	AddNpsCALLBACKDATA( void*			pFunc,
								NPSEVENTINFOEX	EventInfoEx );

protected:

	virtual void	CallCallback( CNpsCALLBACKDATA* pCALLBACKDATA );// R[obNďo

};



#endif // !defined(AFX_NPSCALLBACKCOMPLETION_H__46AD7FA9_543A_4080_99F8_F5FC673C24EC__INCLUDED_)
