//////////////////////////////////////////////////////////////////////////////
//	FILE NAME : NpsCmd.h
//	ABSTRACT  : CNpsCmd NX̃C^[tFCX
//	
//	CREATE    : T.Isogai	2006.7.6
//	UPDATE    : 
//	
//										(C)Copyright : Noritsu Koki CO.,LTD.
//////////////////////////////////////////////////////////////////////////////

#if !defined(AFX_NPSCMD_H__039EF4A2_CA48_4575_B38F_0382572373D2__INCLUDED_)
#define AFX_NPSCMD_H__039EF4A2_CA48_4575_B38F_0382572373D2__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "Nps.h"
#include "NkcComApi.h"
#include "WS2Tcp.h"
#include "NpsRecvRequestControl.h"
#include "NpsNoticeRequestControl.h"
#include "NpsCommand.h"
#include "DataManager.h"

// NPSvR}hɑ΂鉞ʃR[h
//---------------------------------------------------------------------------------------
#define	NPS_SUCCESS		(0)		// 0 
#define	NPS_ERROR_01	(1)		// 1 `G[
//#define NPS_ERROR_02	(2)		// 2 w肳ꂽR}hID̓T|[gĂ܂	(gp)
#define	NPS_ERROR_03	(3)		// 3 R}h̃TCYw肪sł
//#define NPS_ERROR_04	(4)		// 4 Tagw肳Ă܂				(gp)
#define	NPS_ERROR_05	(5)		// 5 f[^擾s
#define	NPS_ERROR_06	(6)		// 6 vg̎Ɏs܂
#define	NPS_ERROR_07	(7)		// 7 Ytԍ܂
#define	NPS_ERROR_08	(8)		// 8 v^͑̃AvLĂ܂
#define	NPS_ERROR_09	(9)		// 9 v^̐LsĂ܂
//#define NPS_ERROR_10	(10)	// 10 摜Mp|[gƂ̐ڑĂ܂	(gp)
#define	NPS_ERROR_11	(11)	// 11 摜tH[}bg̓T|[gĂ܂
#define	NPS_ERROR_12	(12)	// 12 s[gsł
#define	NPS_ERROR_13	(13)	// 13 Xv[̈̋󂫗eʂ܂
#define	NPS_ERROR_14	(14)	// 14 摜TCY܂
#define	NPS_ERROR_15	(15)	// 15 摜TCY܂
#define	NPS_ERROR_16	(16)	// 16 w肵y[p[͎gpł܂
#define	NPS_ERROR_17	(17)	// 17 y[p[̑蒷sł
#define	NPS_ERROR_18	(18)	// 18 tsԂł
#define	NPS_ERROR_19	(19)	// 19 摜̎MɎs܂
#define	NPS_ERROR_20	(20)	// 20 摜Mp|[gƂ̐ڑmłĂ܂
#define	NPS_ERROR_21	(21)	// 21 摜f[^sł
#define	NPS_ERROR_22	(22)	// 22 摜f[^M^CAEg
#define	NPS_ERROR_23	(23)	// 23 p[^̎w肪sł
#define	NPS_ERROR_24	(24)	// 24 YCxgʎq܂
#define	NPS_ERROR_25	(25)	// 25 gCύX̗vɎ󂯕tĂ܂
#define	NPS_ERROR_26	(26)	// 26 gCύXł܂
#define	NPS_ERROR_27	(27)	// 27 v^Lf܂
#define	NPS_ERROR_28	(28)	// 28 ڑJnv󂯕tĂ܂
#define	NPS_ERROR_29	(29)	// 29 摜̃f[^Ă܂B
#define	NPS_ERROR_30	(30)	// 30 f[^o^s
#define	NPS_ERROR_31	(31)	// 31 w肳ꂽL[h̓T|[gĂ܂
#define	NPS_ERROR_32	(32)	// 32 CPULZ܂

#define	NPS_ERROR_34	(34)	// 34 NWbgJnv󂯕tĂ܂
#define	NPS_ERROR_35	(35)	// 35 vg~Ɏs܂
#define	NPS_ERROR_36	(36)	// 36 tLZ܂
#define	NPS_ERROR_37	(37)	// 37 ʈɑΉĂ܂
#define	NPS_ERROR_38	(38)	// 38 ʈJnv󂯕tĂ܂
#define	NPS_ERROR_39	(39)	// 39 ʈJnvɎ󂯕tĂ܂
#define	NPS_ERROR_40	(40)	// 40 ʈŕ\ʂƗʂ̃p[p[񂪈قȂ܂
#define	NPS_ERROR_41	(41)	// 41 ʈŕ\ʂƗʂ̃s[gقȂ܂
#define	NPS_ERROR_42	(42)	// 42 OEMR[hs
#define	NPS_ERROR_43	(43)	// 43 FADG[Ԃ܂
#define	NPS_ERROR_44	(44)	// 44 ɍđJnĂ܂							2011.11.1 A.Nagamatsu (D703/WG)
#define	NPS_ERROR_45	(45)	// 45 ܂đJnĂ܂						2011.11.1 A.Nagamatsu (D703/WG)

//---------------------------------------------------------------------------------------

class CDataManager;

//////////////////////////////////////////////////////////////////////////////
//	CLASS    : CNpsCmd
//	ABSTRACT : \PbgʐMNXiTCPj
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	CREATE	 : T.Isogai	2006.8.9
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
class CNpsCmd : public CWS2Tcp  
{
public:

	CNpsCmd();														// RXgN^
	virtual ~CNpsCmd();												// fXgN^

	void SetDataManager( CDataManager * pDataManager );				// v^Ǘ̓o^ { m_pDataManager	= pDataManager; }	// f[^ǗNX̐ݒ

	BOOL SetCallbackFuncSocketClose( void * pFunc, LPVOID pParam );	// lbg[NؒfʒmR[obNݒ
	BOOL SetCallbackFuncUnit( void * pFunc, LPVOID pParam );		// v^ԕύXʒmR[obNݒ
	BOOL SetCallbackFuncEvent( void * pFunc, LPVOID pParam );		// v^CxgʒmR[obNݒ
	BOOL SetCallbackFuncCompletion( void * pFunc, LPVOID pParam );	// vg󋵒ʒmR[obNݒ
	BOOL SetCallbackFuncFunction( void * pFunc, LPVOID pParam );	// ㏈sʒmR[obNݒ
	BOOL SetCallbackFuncEventEx( void * pFunc, LPVOID pParam );		// v^CxggʒmR[obNݒ

	BOOL SetTimeout( ULONG TimeOut );								// ^CAEgݒ
	long Open( LPCTSTR lpszHostAddress, USHORT wNpsPortNo );		// R}hM\PbgI[v
	long Close();													// R}hM\PbgN[Y

	void OfflineProc();												// ItCɂȂƂɒʐM̃^CAEgIɃZbg

	long NpsCommand1(												// NPSʐMi^Cv1j
					WORD	wIfId,			// C^[tFCXID
					WORD	wSendCmdId,		// vp̃R}hID
					WORD	wSendBufLen,	// vp̃R}h̃obt@TCY
					LPVOID	lpSendBuf,		// vp̃R}h̃obt@
					WORD	wRecvCmdId,		// p̃R}hID
					LPWORD	pwRecvBufLen,	// p̃R}h̃obt@TCY
					LPVOID	lpRecvBuf,		// p̃R}h̃obt@
					DWORD	dwTimeOut		// ^CAEg(~b)
					);

	long NpsCommand2(												// NPSʐMi^Cv2j
					WORD	wIfId,			// C^[tFCXID
					WORD	wSendCmdId,		// vp̃R}hID
					WORD	wSendBufLen,	// vp̃R}h̃obt@TCY
					LPVOID	lpSendBuf,		// vp̃R}h̃obt@
					WORD	wRecvCmdId,		// p̃R}hID
					LPWORD	pwRecvBufLen,	// p̃R}h̃obt@TCY
					void *	pFunc,			// ɌĂяo֐
					DWORD	dwTimeOut		// ^CAEg(~b)
					);

	long NpsNotice(													// NPS񓯊ʐM
					HPRINTER	hPrinter,		// v^̃nh
					DWORD		dwIPAddress,	// v^IPAhX
					WORD		wIfId,			// C^[tFCXID
					WORD		wCmdId,			// R}hID
					NOTICEPROC	pNoticeProc		// ɌĂяo֐
					);

	long GetPrinterBasic		( T_Nps6000H_0100H * pInBuf, T_Nps6000H_0101H * pOutBuf );	// v^{̎擾
	long GetPrinterSetup		( T_Nps6000H_0200H * pInBuf, T_Nps6000H_0201H * pOutBuf );	// v^ݒ̎擾
	long GetPrinterState		( T_Nps6000H_0300H * pInBuf, T_Nps6000H_0301H * pOutBuf );	// v^Ԃ̎擾
	long GetPaper				( T_Nps6000H_0400H * pInBuf, T_Nps6000H_0401H * pOutBuf );	// y[p[̎擾
	long OccupyStart			( T_Nps6000H_0500H * pInBuf, T_Nps6000H_0501H * pOutBuf );	// v^LJn
	long OccupyEnd				( T_Nps6000H_0600H * pInBuf, T_Nps6000H_0601H * pOutBuf );	// v^LI
	long PrintRequest			( T_Nps6000H_0700H * pInBuf, T_Nps6000H_0701H * pOutBuf );	// tJn
	long CheckSendImage			( T_Nps6000H_0800H * pInBuf, T_Nps6000H_0801H * pOutBuf );	// 摜MmF
	long PrintCancel			( T_Nps6000H_0900H * pInBuf, T_Nps6000H_0901H * pOutBuf );	// vg
	long OrderCancel			( T_Nps6000H_1900H * pInBuf, T_Nps6000H_1901H * pOutBuf );	// I[_[LZ	@@@RD-151Ή	2012.04.12	T.Mizushima
	long EventCancel			( T_Nps6000H_0A00H * pInBuf, T_Nps6000H_0A01H * pOutBuf );	// v^Cxg
	long ChangeTray				( T_Nps6000H_0B00H * pInBuf, T_Nps6000H_0B01H * pOutBuf );	// gCύX
	long GetPrintCount			( T_Nps6000H_0C00H * pInBuf, T_Nps6000H_0C01H * pOutBuf );	// vg擾
	long PrintCtrl				( T_Nps6000H_0D00H * pInBuf, T_Nps6000H_0D01H * pOutBuf );	// vg~
	long Login					( T_Nps6000H_0E00H * pInBuf, T_Nps6000H_0E01H * pOutBuf );	// ڑJn
	long SetPrintOption			( T_Nps6000H_1200H * pInBuf, T_Nps6000H_1201H * pOutBuf );	// vgIvVݒ
	long GetAllPaper			( T_Nps6000H_1300H * pInBuf, T_Nps6000H_1301H * pOutBuf );	// Sy[p[̎擾
	long UpdateDateTime			( T_Nps6001H_0100H * pInBuf, T_Nps6001H_0101H * pOutBuf );	// XV
	long BuzzerControl			( T_Nps6000H_0F00H * pInBuf, T_Nps6000H_0F01H * pOutBuf );	// uU[
	long SignalLampControl		( T_Nps6000H_1000H * pInBuf, T_Nps6000H_1001H * pOutBuf );	// \
	long GetVersion				( T_Nps6002H_7304H * pInBuf, T_Nps6002H_7305H * pOutBuf );	// o[W̎擾
	long GetMachineSpec			( T_Nps6002H_732AH * pInBuf, T_Nps6002H_732BH * pOutBuf );	// @Bdl̎擾
	long DuplexStart			( T_Nps6000H_1600H * pInBuf, T_Nps6000H_1601H * pOutBuf );	// ʈJn
	long DuplexEnd				( T_Nps6000H_1700H * pInBuf, T_Nps6000H_1701H * pOutBuf );	// ʈI
	long BlankPrintRequest		( T_Nps6000H_1800H * pInBuf, T_Nps6000H_1801H * pOutBuf );	// 󔒈tJn
	long NpsCmd_6000_1500_1501	( T_Nps6000H_1500H * pInBuf, T_Nps6000H_1501H * pOutBuf );	// ڑmF
	long NpsCmd_6001_0700_0701	( T_Nps6001H_0700H * pInBuf, T_Nps6001H_0701H * pOutBuf );	// ^[Qbg擾
	long NpsCmd_6001_0800_0801	( T_Nps6001H_0800H * pInBuf, T_Nps6001H_0801H * pOutBuf );	// ^[Qbgf[^XVv
	long NpsCmd_6001_0900_0901	( T_Nps6001H_0900H * pInBuf, T_Nps6001H_0901H * pOutBuf );	// vt@Co[WXVv
	long NpsCmd_6001_0A00_0A01	( T_Nps6001H_0A00H * pInBuf, T_Nps6001H_0A01H * pOutBuf );	// FADgpJnv
	long NpsCmd_6001_0B00_0B01	( T_Nps6001H_0B00H * pInBuf, T_Nps6001H_0B01H * pOutBuf );	// vgJn
	long NpsCmd_6001_B006_B007	( T_Nps6001H_B006H * pInBuf, T_Nps6001H_B007H * pOutBuf );	// NWbgJn
	long NpsCmd_6001_B008_B009	( T_Nps6001H_B008H * pInBuf, T_Nps6001H_B009H * pOutBuf );	// NWbgI
	long NpsCmd_6002_7300_7301	( T_Nps6002H_7300H * pInBuf, T_Nps6002H_7301H * pOutBuf );	// [hύXv

	long NpsCmd_6001_0C00_0C01	( T_Nps6001H_0C00H * pInBuf, T_Nps6001H_0C01H * pOutBuf );	// đJn
	long NpsCmd_6001_0D00_0D01	( T_Nps6001H_0D00H * pInBuf, T_Nps6001H_0D01H * pOutBuf );	// đI
	long NpsCmd_6001_0E00_0E01	( T_Nps6001H_0E00H * pInBuf, T_Nps6001H_0E01H * pOutBuf );	// fLZ

	BOOL Send( const void* lpBuf, int nBufLen, DWORD dwFlags = 0 );

	virtual void OnReceive( int nErrorCode );	// Receive 󂯎Ƃ
	virtual void OnClose( int nErrorCode );		// Close   󂯎Ƃ

protected:

	CDataManager*				m_pDataManager;			// f[^ǗNX

	ULONG	m_TimeOut;									// ^CAEg
	CNpsRecvRequestControl		m_RecvRequestControl;	// {XbhAMXbhANZX
	CNpsNoticeRequestControl	m_NoticeRequestControl;	// {XbhAMXbhANZX

	void	SetSndBuf( BYTE* pSendBuf, USHORT TagNo, BYTE* pData, enum NpsType Type ,ULONG* pCounter );	// ^ɂ鑗Mf[^̐ݒ
	USHORT				GetTypeSize( enum NpsType Type );												// ^ɂ鑗Mf[^TCY̎擾
	BOOL				SetDataNtoH( void * pIn, void * pOut, enum NpsType Type, int Array = 0 );		// lbg[NoCgI[_[zXgoCgI[_[
	BOOL				SetDataHtoN( void * pIn, void * pOut, enum NpsType Type );						// zXgoCgI[_[lbg[NoCgI[_[

	long NpsCommand(									// NPSʐM
					WORD	wIfId,			// C^[tFCXID
					WORD	wSendCmdId,		// vp̃R}hID
					WORD	wSendBufLen,	// vp̃R}h̃obt@TCY
					LPVOID	lpSendBuf,		// vp̃R}h̃obt@
					WORD	wRecvCmdId,		// p̃R}hID
					LPWORD	pwRecvBufLen,	// p̃R}h̃obt@TCY
					LPVOID	lpRecvBuf,		// p̃R}h̃obt@
					DWORD	dwTimeOut,		// ^CAEg(~b)
					BOOL	bSendHeader	= FALSE	// vMŃwb_[ݒ肷邩Ȃ
					);

private:
	BYTE	m_byBuffer[65535];	// R}h̍őTCY1024Byte + R}hwb_4Byte
	WORD	m_wWritePoint;		// 擾ς݃|Cg
	WORD	m_wHeaderRemain;	// wb_[擾TCY
	WORD	m_wTagRemain;		// wb_[^O擾TCY
	WORD	m_wTagValue;		// Value擾TCY

	BOOL	ReadCmdHdr( LPBYTE lpBuffer, WORD &wInterfaceId, WORD &wCommandId );		// NPSR}h̃wb_[擾
	BOOL	RecvEndFunc( LPBYTE lpBuffer, unsigned long AttSize );						// R}hI[M
	BOOL	Read6000H_FFFFH( LPBYTE lpBuffer, WORD &wInterfaceId, WORD &wCommandId );	// R}hT|[gʒmM

	BYTE	m_bySendBuffer[65535];	// Mpf[^i[̈  bSendHeader=TRUE ̂ƂɎgp
	WORD	m_wSendSize;			// Mpf[^(m_bySendBuffer)e (P:Byte)  bSendHeader=TRUE ̂ƂɎgp
	//////////////////////////////////////////////////////////////////////////////
	// R[obNĂяo

	// lbg[NؒfʒmR[obNݒ
	void *	m_pCallbackFuncSocketClose;
	LPVOID	m_pCallbackFuncSocketCloseParam;

	// v^ԕύXʒmR[obNݒ
	void *	m_pCallbackFuncUnit;
	LPVOID	m_pCallbackFuncUnitParam;
	void	CallCallbackFuncUnit( BYTE * lpBuff, unsigned long AttSize );

	// v^CxgʒmR[obNݒ
	void *	m_pCallbackFuncEvent;
	LPVOID	m_pCallbackFuncEventParam;
	void	CallCallbackFuncEvent( BYTE * lpBuff, unsigned long AttSize );

	// vg󋵒ʒmR[obNݒ
	void *	m_pCallbackFuncCompletion;
	LPVOID	m_pCallbackFuncCompletionParam;
	void	CallCallbackFuncCompletion( BYTE * lpBuff, unsigned long AttSize );

	// ㏈sʒmR[obNݒ
	void *	m_pCallbackFuncFunction;
	LPVOID	m_pCallbackFuncFunctionParam;
	void	CallCallbackFuncFunction( BYTE * lpBuff, unsigned long AttSize );

	// v^CxggʒmR[obNݒ
	void *	m_pCallbackFuncEventEx;
	LPVOID	m_pCallbackFuncEventExParam;
	void	CallCallbackFuncEventEx( BYTE * lpBuff, unsigned long AttSize );

	CRITICAL_SECTION	m_CS;	// NeBJZNV
	CRITICAL_SECTION	m_csSend;	// sendp̃NeBJZNV 2006.12.25 Y.Yoshinobu
};

#endif // !defined(AFX_NPSCMD_H__039EF4A2_CA48_4575_B38F_0382572373D2__INCLUDED_)
