//////////////////////////////////////////////////////////////////////////////
//	FILE NAME : NpsRecvRequest2.cpp
//	ABSTRACT  : CNpsRecvRequest2 NX̃Cve[V
//	
//	CREATE    : T.Isogai	2006.7.18
//	UPDATE    : 
//	
//										(C)Copyright : Noritsu Koki CO.,LTD.
//////////////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "NpsRecvRequest2.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

extern BOOL g_bDetatch;

//////////////////////////////////////////////////////////////////////
// \z/
//////////////////////////////////////////////////////////////////////


//////////////////////////////////////////////////////////////////////////////
//	MODULE   :CNpsRecvRequest1::CNpsRecvRequest2()
//	ABSTRACT : RXgN^
//	FUNCTION : RXgN^
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : T.Isogai	2006.7.18
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
CNpsRecvRequest2::CNpsRecvRequest2(
					WORD	IfId,		// C^[tFCXID
					WORD	CmdId,		// Mp̃R}hID
					WORD	wBufLen,	// Mp̃R}h̃obt@TCY
					WORD	SendCmdId,	// Mp̃R}hID
					void *	pFunc,		// R[obN֐̃|C^
					DWORD	dwTimeOut	// ^CAEg(~b)
					)
:CNpsRecvRequest( IfId, CmdId, SendCmdId )
{
	// p[^ݒ
	m_wBufLen	= wBufLen;
	m_pFunc		= pFunc;
	m_dwTimeOut	= dwTimeOut;

	// ̊m
	try
	{
		m_lpBuf	= new char[ wBufLen ];
	}
	catch (CMemoryException* e)
	{
		{
			CString str;
			str.Format( "===Memory allocation error [%d]", wBufLen );
			NPS_LOGOUT_FATAL( str );
		}
		e->Delete();
		return;
	}

	// Xbh̐
	int nPriority;
	#if defined(NPS_THREAD_PRIORITY_BELOW)
	nPriority = THREAD_PRIORITY_BELOW_NORMAL;
	#else  // defined(NPS_THREAD_PRIORITY_BELOW)
	nPriority = THREAD_PRIORITY_NORMAL;
	#endif // defined(NPS_THREAD_PRIORITY_BELOW)

	m_hExitEvent    = CreateEvent( 0, FALSE, FALSE, 0 );		// IpCxg
	m_hEvent		= CreateEvent( 0, FALSE, FALSE, 0 );		// MmpCxg
	m_pWinThread	= AfxBeginThread( RecvRequest2Thread, this, nPriority,	0, CREATE_SUSPENDED, NULL );
	m_pWinThread->m_bAutoDelete = FALSE;	// 폜Ȃ
	m_pWinThread->ResumeThread();			// Xbh̏Jn
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   :CNpsRecvRequest2::~CNpsRecvRequest2()
//	ABSTRACT : fXgN^
//	FUNCTION : fXgN^
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : T.Isogai	2006.7.18
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
CNpsRecvRequest2::~CNpsRecvRequest2()
{
	// Ip̃Cxgݒ肵܂
	::SetEvent( m_hExitEvent );
	// XbhI҂
	if( g_bDetatch )
	{
		delete m_pWinThread;
	}
	else if( GetCurrentThreadId() != m_pWinThread->m_nThreadID )
	{
		// Xbhł͂ȂƂ
		HANDLE hThread;

		hThread = m_pWinThread->m_hThread;

#if defined(NPS_SINGLE_WAIT)
		::WaitForSingleObject( hThread, INFINITE );
#else  // NPS_SINGLE_WAIT
		while ( WAIT_OBJECT_0 != ::MsgWaitForMultipleObjects( 1, &hThread, FALSE, INFINITE, QS_ALLEVENTS ) )
		{
			MSG msg;
			CWinThread* pWinThread;
			while( PeekMessage( &msg , NULL , 0 , 0 , PM_NOREMOVE ) )
			{
				pWinThread = AfxGetThread();
				if ( NULL != pWinThread )
				{
					pWinThread->PumpMessage();
				}
				else
				{
					// ݎs̃XbhȂ̂ PeekMessage ̃[v𔲂
					NPS_LOGOUT_WARN( "---CNpsRecvRequest2::~CNpsRecvRequest2() AfxGetThread() is NULL" );
					break;
				}
			}
		}
#endif // NPS_SINGLE_WAIT

		delete m_pWinThread;			// XbhpNX̍폜
		m_pWinThread = NULL;
	}else{
		// XbhĝƂ
		m_pWinThread->m_bAutoDelete = TRUE;		// 폜
	}

	// e㏈
	CloseHandle( m_hExitEvent );
	CloseHandle( m_hEvent );

	// ̊J
	delete [] m_lpBuf;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CNpsRecvRequest2::EndFunc()
//	ABSTRACT : Ōɍs
//	FUNCTION : Ōɍs
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : T.Isogai	2006.7.18
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
BOOL CNpsRecvRequest2::EndFunc()
{
	::SetEvent( m_hEvent );

	return TRUE;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CNpsRecvRequest2::RecvRequest2Thread()
//	ABSTRACT : XbhiX^eBbNj
//	FUNCTION : XbhiX^eBbNj
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : T.Isogai	2006.7.18
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
UINT CNpsRecvRequest2::RecvRequest2Thread( LPVOID pParam )
{
	return ((CNpsRecvRequest2*)pParam)->RecvRequest2();
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CNpsRecvRequest2::RecvRequest2()
//	ABSTRACT : Xbh
//	FUNCTION : Xbh
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : T.Isogai	2006.7.18
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
UINT CNpsRecvRequest2::RecvRequest2()
{
	HANDLE		evt[2] = { m_hExitEvent, m_hEvent };

	DWORD	dwState;

	//while( WAIT_OBJECT_0 + 1 == ( dwState = WaitForMultipleObjects(
	//	COUNTOF( evt ) , evt , FALSE , m_dwTimeOut ) ) )

	dwState = ::WaitForMultipleObjects( COUNTOF( evt ), evt, FALSE, m_dwTimeOut );
	DWORD	dwThreadID = GetCurrentThreadId();

	// 
	long	Result;

	if( WAIT_TIMEOUT == dwState )
	{
		Result	= NPSERR_TIMEOUT;
	}
	else if ( TRUE == m_bOffline )
	{
		Result	= NPSERR_TIMEOUT;
	}
	else if( m_bNotSupport )
	{
		Result	= NPSERR_BADPARAM;
	}
	else if( m_bShortage )
	{
		Result	= NPSERR_REMAINING_DATA;
	}
	else
	{
		Result	= NPSERR_NORMAL;
	}

	( ( RECVPROC )( m_pFunc ) )(
			m_IfId,			// C^[tFCXID
			m_CmdId,		// p̃R}hID
			m_lpBuf,		// p̃R}h̃obt@
			m_wBufLen,		// p̃R}h̃obt@TCY
			Result			// 	
		);

	// I
	//delete this;

	return 0;
}
