#include "StdAfx.h"
#include "RecvCmdBuffer.h"
#include "Winsock2.h"
//////////////////////////////////////////////////////////////////////////////
//	FILE NAME : RecvCmdBuffer.cpp
//	ABSTRACT  : NPSMR}h̓NX
//	
//	CREATE    : Y.Yoshinobu   2008.6.9
//	UPDATE    : 
//										(C)Copyright : Noritsu Koki CO.,LTD.
//////////////////////////////////////////////////////////////////////////////


//////////////////////////////////////////////////////////////////////////////
//	FUNCTION : CAnalysisTag::CAnalysisTag()
//	ABSTRACT : RXgN^
//	
//	NOTE     : < RD-123 > 
//             < Note > 
//	
//	ARGUMENT : Ȃ
//	
//	RETURN   : Ȃ
//	
//	CREATE	 : Y.Yoshinobu	2008.6.9
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
CAnalysisTag::CAnalysisTag(void)
{
	m_wTag			= 0;			// ^Oԍ
	m_wType			= 0;			// ^Ǒ^ (NPS_TYPE_*)
	m_wArrayCntMax	= 0;			// z̍ő吔

	m_wVauleCnt		= 0;			// lZbgĂ鐔
	m_lpVaule		= NULL;			// li[邽߂̐擪|C^
}

//////////////////////////////////////////////////////////////////////////////
//	FUNCTION : CAnalysisTag::~CAnalysisTag()
//	ABSTRACT : fXgN^
//	
//	NOTE     : < RD-123 > 
//             < Note > 
//	
//	ARGUMENT : Ȃ
//	
//	RETURN   : Ȃ
//	
//	CREATE	 : Y.Yoshinobu	2008.6.9
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
CAnalysisTag::~CAnalysisTag(void)
{
	if ( NULL != m_lpVaule )
	{
		delete m_lpVaule;
	}
}

//////////////////////////////////////////////////////////////////////////////
//	FUNCTION : CRecvCmdBuffer::CRecvCmdBuffer()
//	ABSTRACT : RXgN^
//	
//	NOTE     : < RD-123 > 
//             < Note > 
//	
//	ARGUMENT : Ȃ
//	
//	RETURN   : Ȃ
//	
//	CREATE	 : Y.Yoshinobu	2008.6.9
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
CRecvCmdBuffer::CRecvCmdBuffer(void)
{
	EmptyTagList();
}

//////////////////////////////////////////////////////////////////////////////
//	FUNCTION : CRecvCmdBuffer::~CRecvCmdBuffer()
//	ABSTRACT : fXgN^
//	
//	NOTE     : < RD-123 > 
//             < Note > 
//	
//	ARGUMENT : Ȃ
//	
//	RETURN   : Ȃ
//	
//	CREATE	 : Y.Yoshinobu	2008.6.9
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
CRecvCmdBuffer::~CRecvCmdBuffer(void)
{
	EmptyTagList();
}

//////////////////////////////////////////////////////////////////////////////
//	FUNCTION : CRecvCmdBuffer::ResetTagValue()
//	ABSTRACT : ͌ʂ̒lZbg
//	
//	NOTE     : < RD-123 > 
//             < Note > 
//	
//	ARGUMENT : Ȃ
//	
//	RETURN   : Ȃ
//	
//	CREATE	 : Y.Yoshinobu	2008.6.9
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
void CRecvCmdBuffer::ResetTagValue(void)
{
	std::vector<CAnalysisTag*>::iterator itTag;

	m_wIfId = 0;
	m_wCmdId = 0;

	for ( itTag=m_vTag.begin() ; m_vTag.end() != itTag ; itTag++ )
	{
		// ž0ɃZbg
		(*itTag)->m_wVauleCnt = 0;
		// f[^i[̈
		switch ( (*itTag)->m_wType )
		{
		case NPS_TYPE_CHAR:		::ZeroMemory( (*itTag)->m_lpVaule, (*itTag)->m_wArrayCntMax*1 );	break;
		case NPS_TYPE_SHORT:	::ZeroMemory( (*itTag)->m_lpVaule, (*itTag)->m_wArrayCntMax*2 );	break;
		case NPS_TYPE_LONG:		::ZeroMemory( (*itTag)->m_lpVaule, (*itTag)->m_wArrayCntMax*4 );	break;
		case NPS_TYPE_FLOAT:	::ZeroMemory( (*itTag)->m_lpVaule, (*itTag)->m_wArrayCntMax*4 );	break;
		case NPS_TYPE_LONGLONG:	::ZeroMemory( (*itTag)->m_lpVaule, (*itTag)->m_wArrayCntMax*8 );	break;
		}
	}
}

//////////////////////////////////////////////////////////////////////////////
//	FUNCTION : CRecvCmdBuffer::EmptyTagList()
//	ABSTRACT : ̓^ÕXgJ
//	
//	NOTE     : < RD-123 > 
//             < Note > 
//	
//	ARGUMENT : Ȃ
//	
//	RETURN   : Ȃ
//	
//	CREATE	 : Y.Yoshinobu	2008.6.9
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
void CRecvCmdBuffer::EmptyTagList(void)
{
	m_wIfId = 0;
	m_wCmdId = 0;

	CAnalysisTag* pobjAnalysisTag;
	std::vector<CAnalysisTag*>::iterator itTag;

	for ( itTag=m_vTag.begin() ; m_vTag.end() != itTag ; itTag++ )
	{
		pobjAnalysisTag = (*itTag);
		delete [] pobjAnalysisTag->m_lpVaule;
		pobjAnalysisTag->m_lpVaule = NULL;
		delete pobjAnalysisTag;
	}

	m_vTag.clear();
}

//////////////////////////////////////////////////////////////////////////////
//	FUNCTION : CRecvCmdBuffer::AddTagList()
//	ABSTRACT : ͂^Oo^
//	
//	NOTE     : < RD-123 > 
//             < Note > 
//	
//	ARGUMENT : wTag     ͂^Oԍ
//	           wType    ͂^Ǒ^
//	           wMaxCnt  ͂^O̔z̍ő吔 [default=1]
//	
//	RETURN   : Ȃ
//	
//	CREATE	 : Y.Yoshinobu	2008.6.9
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
void CRecvCmdBuffer::AddTagList( const WORD wTag, const WORD wType, const WORD wMaxCnt )
{
	WORD dwBufferSixe;
	CAnalysisTag* pobjAnalysisTag;

	try
	{
		pobjAnalysisTag = new CAnalysisTag;
	}
	catch (CMemoryException* e)
	{
		e->Delete();
		return;
	}

	pobjAnalysisTag->m_wTag			= wTag;
	pobjAnalysisTag->m_wType		= wType;
	pobjAnalysisTag->m_wArrayCntMax	= wMaxCnt;

	switch ( wType )
	{
	case NPS_TYPE_CHAR:		dwBufferSixe = wMaxCnt * 1;	break;
	case NPS_TYPE_SHORT:	dwBufferSixe = wMaxCnt * 2;	break;
	case NPS_TYPE_LONG:		dwBufferSixe = wMaxCnt * 4;	break;
	case NPS_TYPE_FLOAT:	dwBufferSixe = wMaxCnt * 4;	break;
	case NPS_TYPE_LONGLONG:	dwBufferSixe = wMaxCnt * 8;	break;
	default:				delete pobjAnalysisTag;		return;
	}

	try
	{
		pobjAnalysisTag->m_lpVaule = new BYTE[dwBufferSixe];
	}
	catch (CMemoryException* e)
	{
		delete pobjAnalysisTag;
		e->Delete();
		return;
	}

	::ZeroMemory( pobjAnalysisTag->m_lpVaule, dwBufferSixe );

	m_vTag.push_back( pobjAnalysisTag );
}

//////////////////////////////////////////////////////////////////////////////
//	FUNCTION : CRecvCmdBuffer::Analysis()
//	ABSTRACT : w肵obt@͂āAo^^Oԍ̏擾
//	
//	NOTE     : < RD-123 > 
//             < Note > 
//	
//	ARGUMENT : lpBuffer    ͂obt@̐擪|C^
//	           dwBufferLen ͂obt@̃TCY [default=4294967295(0xFFFFFFFF)]
//	
//	RETURN   : true        ͐
//	           false       ͎s
//	
//	CREATE	 : Y.Yoshinobu	2008.6.9
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
bool CRecvCmdBuffer::Analysis( const LPBYTE lpBuffer, const DWORD dwBufferLen )
{
	WORD wIdx1;
	WORD wIdx2;
	WORD wTypeSize = 0;
	WORD wTagNo = 0;
	WORD wLength = 0;
	DWORD dwPos = 0;
	NpsDataType eDataType = NPS_DATATYPE_TAG_NO;
	std::vector<CAnalysisTag*>::iterator itTag;

	// Ô߂ɒlZbg
	ResetTagValue();

	// R}hobt@̒`FbN
	if ( 8 > dwBufferLen )
	{
		return false;
	}

	// C^[tFCXIDƃR}hID̉ (擪4Byte)
	::CopyMemory( &m_wIfId, lpBuffer + dwPos, sizeof(SHORT) );
	m_wIfId = ntohs( m_wIfId );
	dwPos += sizeof(SHORT);
	::CopyMemory( &m_wCmdId, lpBuffer + dwPos, sizeof(SHORT) );
	m_wCmdId = ntohs( m_wCmdId );
	dwPos += sizeof(SHORT);

	// Tag
	while( 1 )
	{
		// ----------------------------------------
		// Tag̔ԍ (2Byte)
		// ----------------------------------------
		if ( eDataType == NPS_DATATYPE_TAG_NO )
		{
			// obt@`FbN
			if (max ( dwBufferLen, ( dwBufferLen + 2 )) < dwPos )
			{
				return false;
			}
			// Tagԍ擾
			::CopyMemory( &wTagNo, lpBuffer + dwPos, sizeof(SHORT) );
			wTagNo = ntohs( wTagNo );
			dwPos += sizeof(SHORT);
			eDataType = NPS_DATATYPE_TAG_LENGTH;
		}
		// ----------------------------------------
		// Valuẽf[^  (2Byte)
		// ----------------------------------------
		else if ( eDataType == NPS_DATATYPE_TAG_LENGTH )
		{
			// obt@`FbN
			if (max ( dwBufferLen, ( dwBufferLen + 2 )) < dwPos )
			{
				return false;
			}
			// Valuẽf[^擾
			::CopyMemory( &wLength, lpBuffer + dwPos, sizeof(SHORT) );
			wLength = ntohs( wLength );
			dwPos += sizeof( SHORT );
			eDataType = NPS_DATATYPE_TAG_VALUE;

			if(( 0 == wTagNo ) && ( 0 == wLength ))
			{
				// I^OȂ̂ŉ͂I
				break;
			}
		}
		// ----------------------------------------
		// Tagɑ΂lf[^
		// ----------------------------------------
		else if ( eDataType == NPS_DATATYPE_TAG_VALUE )
		{
			// obt@`FbN
			if (max ( dwBufferLen, ( dwBufferLen + 2 )) < dwPos )
			{
				return false;
			}
			// Value擾
			for ( itTag=m_vTag.begin() ; m_vTag.end() != itTag ; itTag++ )
			{
				if ( wTagNo == (*itTag)->m_wTag )
				{
					switch ( (*itTag)->m_wType )
					{
					case NPS_TYPE_CHAR:		wTypeSize = 1;	break;
					case NPS_TYPE_SHORT:	wTypeSize = 2;	break;
					case NPS_TYPE_LONG:		wTypeSize = 4;	break;
					case NPS_TYPE_FLOAT:	wTypeSize = 4;	break;
					case NPS_TYPE_LONGLONG:	wTypeSize = 8;	break;
					}
					(*itTag)->m_wVauleCnt = wLength / wTypeSize;

					for ( wIdx1=0 ; min ( (*itTag)->m_wVauleCnt, (*itTag)->m_wArrayCntMax ) > wIdx1 ; wIdx1++ )
					{
						for ( wIdx2=0 ; wTypeSize > wIdx2 ; wIdx2++ )
						{
							*((*itTag)->m_lpVaule + (wIdx1*wTypeSize) + wIdx2) = *(lpBuffer + dwPos + (wIdx1*wTypeSize) + (wTypeSize-wIdx2-1));
						}
					}
					break;
				}
			}

			dwPos += wLength;
			eDataType = NPS_DATATYPE_TAG_NO;
		}
	}

	return true;
}

//////////////////////////////////////////////////////////////////////////////
//	FUNCTION : CRecvCmdBuffer::GetIfIdAndCmdId()
//	ABSTRACT : ͌̃C^[tFCXIDƃR}hID擾
//	
//	NOTE     : < RD-123 > 
//             < Note > 
//	
//	ARGUMENT : lpwIfId     C^[tFCXID
//	           lpwCmdId    R}hID
//	
//	RETURN   : zɒlZbg
//	
//	CREATE	 : Y.Yoshinobu	2008.6.17
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
void CRecvCmdBuffer::GetIfIdAndCmdId( LPWORD lpwIfId, LPWORD lpwCmdId )
{
	*lpwIfId = m_wIfId;
	*lpwCmdId = m_wCmdId;
}

//////////////////////////////////////////////////////////////////////////////
//	FUNCTION : CRecvCmdBuffer::GetTagValue()
//	ABSTRACT : ͌Tag擾
//	
//	NOTE     : < RD-123 > 
//             < Note > 
//	
//	ARGUMENT : wType       Tagԍ
//	           lpVariable  l󂯎邽߂̃obt@̐擪|C^
//	           wCnt        lpVariableɃZbgz̐ [default=1]
//	
//	RETURN   : zɒlZbg
//	
//	CREATE	 : Y.Yoshinobu	2008.6.9
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
int CRecvCmdBuffer::GetTagValue( const WORD wTag, LPBYTE lpVariable, const WORD wCnt )
{
	WORD wArrayCnt = 0;
	std::vector<CAnalysisTag*>::iterator itTag;

	for ( itTag=m_vTag.begin() ; m_vTag.end() != itTag ; itTag++ )
	{
		if ( wTag == (*itTag)->m_wTag )
		{
			wArrayCnt = min( wCnt, (*itTag)->m_wVauleCnt );
			switch ( (*itTag)->m_wType )
			{
			case NPS_TYPE_CHAR:		::CopyMemory( lpVariable, (*itTag)->m_lpVaule, wArrayCnt * sizeof(char) );		break;
			case NPS_TYPE_SHORT:	::CopyMemory( lpVariable, (*itTag)->m_lpVaule, wArrayCnt * sizeof(short) );		break;
			case NPS_TYPE_LONG:		::CopyMemory( lpVariable, (*itTag)->m_lpVaule, wArrayCnt * sizeof(long) );		break;
			case NPS_TYPE_FLOAT:	::CopyMemory( lpVariable, (*itTag)->m_lpVaule, wArrayCnt * sizeof(float) );		break;
			case NPS_TYPE_LONGLONG:	::CopyMemory( lpVariable, (*itTag)->m_lpVaule, wArrayCnt * sizeof(LONGLONG) );	break;
			}
			return wArrayCnt;
		}
	}

	return wArrayCnt;
}
