//////////////////////////////////////////////////////////////////////////////
//   FILE NAME   : WS2Tcp2.cpp
//   ABSTRACT    : \PbgʐMNX (WinSock2.0Ή)
//
//                                     (C)Copyright : Noritsu Koki CO.,LTD.
//////////////////////////////////////////////////////////////////////////////
#include "stdafx.h"

#include "WS2Tcp.h"
//#include "ServerTcp.h"

#pragma comment( lib , "Ws2_32.lib"  )			// WinSock 2.0 gp
#pragma comment( lib , "Mswsock.lib" )


//////////////////////////////////////////////////////////////////////////////
//   MODULE   : CWS2Tcp::CWS2Tcp
//   ABSTRACT : RXgN^
//   FUNCTION : \PbgǗNX̐s܂
//////////////////////////////////////////////////////////////////////////////
CWS2Tcp2::CWS2Tcp2()
{
	m_Socket      = INVALID_SOCKET;			// \Pbgnh𖳌ɂ܂
	m_bAutoDelete = FALSE;					// \PbgN[YɎIɍ폜Ȃ
}

//////////////////////////////////////////////////////////////////////////////
//   MODULE   : CWS2Tcp2::~CWS2Tcp2
//   ABSTRACT : fXgN^
//   FUNCTION : \PbgǗNX̊Js܂
//////////////////////////////////////////////////////////////////////////////
CWS2Tcp2::~CWS2Tcp2()
{
	// \PbgJĂꍇAJ܂
	if( m_Socket != INVALID_SOCKET )
		Close();		// ؒf

	// Ǘ̈悩J
	//gServerTcp.RemoveServerSock( this );
}

//////////////////////////////////////////////////////////////////////////////
//   MODULE   : CWS2Tcp2::Create
//   ABSTRACT : \Pbg̍쐬
//   FUNCTION : \Pbg̍쐬(`1)
//////////////////////////////////////////////////////////////////////////////
BOOL CWS2Tcp2::Create( int nAddressFamily , int nSocketType , int nProtocol )
{
	// \Pbg̍쐬s܂
	return Create( NULL , nAddressFamily , nSocketType , nProtocol );
}

//////////////////////////////////////////////////////////////////////////////
//   MODULE   : CWS2Tcp2::Create
//   ABSTRACT : \Pbg̍쐬
//   FUNCTION : \Pbg̍쐬(`2)
//////////////////////////////////////////////////////////////////////////////
BOOL CWS2Tcp2::Create(
				LPWSAPROTOCOL_INFO lpProtocolInfo ,
  				int nAddressFamily ,
				int nSocketType    ,
				int nProtocol      )
{
	m_nAddressFamily = nAddressFamily;

	// \Pbg̍쐬s܂
	m_Socket = WSASocket(
					nAddressFamily ,
					nSocketType ,
					nProtocol ,
					lpProtocolInfo ,
					0 ,
					WSA_FLAG_OVERLAPPED );

	if( m_Socket == INVALID_SOCKET )
	{
		return FALSE;		// \Pbg̍쐬G[
	}

	return TRUE;
}

//////////////////////////////////////////////////////////////////////////////
//   MODULE   : CWS2Udp::GetSocketPortNo
//   ABSTRACT : |[gԍ擾܂
//   FUNCTION : |[gԍ擾܂
//////////////////////////////////////////////////////////////////////////////
UINT CWS2Tcp2::GetSocketPortNo()
{
	UINT		SocketPort;
	SOCKADDR	SockAddr;
	int			size;

	size	= sizeof( SockAddr );
	ZeroMemory( &SockAddr , size );
	getsockname( m_Socket, &SockAddr, &size );
	SocketPort	= (USHORT)( SockAddr.sa_data[0]<<8 ) + (UCHAR)SockAddr.sa_data[1];

	return SocketPort;
}

//////////////////////////////////////////////////////////////////////////////
//   MODULE   : CWS2Tcp2::Bind
//   ABSTRACT : \PbgɖOt܂
//   FUNCTION : \PbgɖOt܂(`1)
//////////////////////////////////////////////////////////////////////////////
BOOL CWS2Tcp2::Bind( UINT nSocketPort , LPCTSTR lpszSocketAddress )
{
	USES_CONVERSION;

	SOCKADDR_IN		SockAddr;ZeroMemory( &SockAddr , sizeof( SockAddr ) );

	// \Pbg̐ݒ
	SockAddr.sin_family		= m_nAddressFamily;		// AhXt@~[
	// \PbgAhX
	LPSTR lpszAscii = T2A((LPTSTR)lpszSocketAddress);
	if( lpszAscii == NULL )
	{
		// AhXwȂ
		SockAddr.sin_addr.s_addr = htonl( INADDR_ANY );
	}else{
		// AhXw
		DWORD lResult = inet_addr(lpszAscii);
		if (lResult == INADDR_NONE)
		{
			WSASetLastError(WSAEINVAL);
			return FALSE;
		}
		SockAddr.sin_addr.s_addr = lResult;
	}
	// |[gԍݒ
	SockAddr.sin_port = htons((u_short)nSocketPort);

	// 
	return Bind( (SOCKADDR*)&SockAddr , sizeof( SockAddr ) );
}

//////////////////////////////////////////////////////////////////////////////
//   MODULE   : CWS2Tcp2::Bind
//   ABSTRACT : \PbgɖOt܂
//   FUNCTION : \PbgɖOt܂(`2)
//////////////////////////////////////////////////////////////////////////////
BOOL CWS2Tcp2::Bind( const SOCKADDR* lpSockAddr, int nSockAddrLen )
{
	return bind( m_Socket , lpSockAddr , nSockAddrLen ) == 0;
}

//////////////////////////////////////////////////////////////////////////////
//   MODULE   : CWS2Tcp2::Connect
//   ABSTRACT : T[o[ɐڑvs܂(1)
//   FUNCTION : T[o[ɐڑvs܂(1)
//////////////////////////////////////////////////////////////////////////////
BOOL CWS2Tcp2::Connect( LPCTSTR lpszHostAddress, UINT nHostPort )
{
	USES_CONVERSION;

	ASSERT(lpszHostAddress != NULL);

	// ݒp\̍\z&
	SOCKADDR_IN SockAddr;
	ZeroMemory( &SockAddr , sizeof( SockAddr ) );

	// \Pbg̐ݒ
	SockAddr.sin_family		= m_nAddressFamily;		// AhXt@~[
	LPSTR lpszAscii = T2A((LPTSTR)lpszHostAddress);	// T[o[AhXݒ
	SockAddr.sin_addr.s_addr = inet_addr(lpszAscii);
	if (SockAddr.sin_addr.s_addr == INADDR_NONE)
	{
		// zXgAIP AhX܂
		LPHOSTENT lphost;
		lphost = gethostbyname( lpszAscii );
		if (lphost != NULL)
		{
			SockAddr.sin_addr.s_addr = ((LPIN_ADDR)lphost->h_addr)->s_addr;
		}else{
			WSASetLastError(WSAEINVAL);
			return FALSE;
		}
	}
	SockAddr.sin_port = htons((u_short)nHostPort);	// |[gԍݒ

	return Connect((SOCKADDR*)&SockAddr, sizeof(SockAddr));
}

//////////////////////////////////////////////////////////////////////////////
//   MODULE   : CWS2Tcp2::Connect
//   ABSTRACT : T[o[ɐڑvs܂(2)
//   FUNCTION : T[o[ɐڑvs܂(2)
//////////////////////////////////////////////////////////////////////////////
BOOL CWS2Tcp2::Connect( const SOCKADDR* lpSockAddr, int nSockAddrLen )
{
	if( WSAConnect( m_Socket , lpSockAddr , nSockAddrLen ,
						NULL , NULL , NULL , NULL ) )
	{
		int nErr = GetLastError();
		if( WSAEISCONN == nErr )	// 2006.11.07 T.Mizushima ǉ
		{	// The socket is already connected.
			return TRUE;
		}

		{	// Oo
			CString str;
			str.Format( "CWS2Tcp2::Connect Failed ( WSAGetLastError() = %d, SocketPortNo = %d )", nErr, GetSocketPortNo() );
			NPS_LOGOUT_WARN( str );
		}

		return FALSE;		// WSAEWOULDBLOCK ȊÔƂ̓G[
	}
	return TRUE;
}

//////////////////////////////////////////////////////////////////////////////
//   MODULE   : CWS2Tcp2::Send
//   ABSTRACT : f[^̑Ms܂(1)
//   FUNCTION : f[^̑Ms܂(1)
//////////////////////////////////////////////////////////////////////////////
BOOL CWS2Tcp2::Send( const void* lpBuf , int nBufLen , DWORD dwFlags )
{
	// Mf[^ݒpobt@
	WSABUF			WSABuf;
	WSABuf.buf		= (char*)lpBuf;		// obt@ւ̃|C^[
	WSABuf.len		= nBufLen;			// f[^̒

	// Mv
	return Send( &WSABuf , 1 , dwFlags );
}

//////////////////////////////////////////////////////////////////////////////
//   MODULE   : CWS2Tcp2::Send
//   ABSTRACT : f[^̑Ms܂(2)
//   FUNCTION : f[^̑Ms܂(2)
//////////////////////////////////////////////////////////////////////////////
BOOL CWS2Tcp2::Send( WSABUF* pBuf , int nCount , DWORD dwFlags )
{
	// Mpf[^낢낢̂ŁAf[^̃Rs[s܂
	WSABUF*		pCopyBuf = (WSABUF*)malloc( sizeof( WSABUF ) * nCount );
	CopyMemory( pCopyBuf , pBuf , sizeof( WSABUF ) * nCount );

	//I[o[bv̂߂̏s܂
	WSAOVERLAPPED	WSAov;					// OVERLPPED \
	WSAov.hEvent	= WSACreateEvent();		// Cxg쐬

	WSABUF*		pSendBuf = pCopyBuf;		// |C^[Rs[܂
	while( nCount > 0 )
	{
		// f[^̑Ms܂
		DWORD		dwSend;
		if( SOCKET_ERROR == WSASend( m_Socket , pSendBuf , nCount ,
									 &dwSend , dwFlags , &WSAov , NULL ) )
		{
			DWORD dwErr = GetLastError();
			if( WSA_IO_PENDING == dwErr )
			{
				// OVERLAPPED Ȃ̂ŏI܂ő҂܂
				WSAGetOverlappedResult( m_Socket , &WSAov , &dwSend ,
										TRUE , &dwFlags );
			}
			else
			{
				free( pCopyBuf );
				CString str;
				str.Format( "===WSASend ERROR ( %d )", dwErr );
				NPS_LOGOUT_FATAL( str );
				return FALSE;		// ȊO̗\ʃG[
			}
		}
		// MTCYf
		while( dwSend > 0 && nCount > 0 )
		{
			DWORD	dwSendLength = min( pSendBuf->len , dwSend );
			pSendBuf->len -= dwSendLength;
			if( pSendBuf->len == 0 )
			{
				pSendBuf++;
				nCount--;
			}else{
				pSendBuf->buf += dwSendLength;
			}
			dwSend -= dwSendLength;
		}
	}
	
	// M㏈
	free( pCopyBuf );
	WSACloseEvent( WSAov.hEvent );

	return TRUE;
}

//////////////////////////////////////////////////////////////////////////////
//   MODULE   : CWS2Tcp2::SendDisconnect
//   ABSTRACT : MI錾
//   FUNCTION : MI錾
//////////////////////////////////////////////////////////////////////////////
BOOL CWS2Tcp2::SendDisconnect()
{
	WSABUF		WSABuf[1];

	WSABuf[0].buf	= NULL;
	WSABuf[0].len	= 0;

	return WSASendDisconnect( m_Socket , WSABuf ) != SOCKET_ERROR;
}

//////////////////////////////////////////////////////////////////////////////
//   MODULE   : CWS2Tcp2::ReceiveDisconnect
//   ABSTRACT : MI錾
//   FUNCTION : MI錾
//////////////////////////////////////////////////////////////////////////////
BOOL CWS2Tcp2::ReceiveDisconnect()
{
	WSABUF		WSABuf[1];

	WSABuf[0].buf	= NULL;
	WSABuf[0].len	= 0;

	return WSARecvDisconnect( m_Socket , WSABuf ) != SOCKET_ERROR;
}

//////////////////////////////////////////////////////////////////////////////
//   MODULE   : CWS2Tcp2::Close
//   ABSTRACT : ܂
//   FUNCTION : ܂
//////////////////////////////////////////////////////////////////////////////
BOOL CWS2Tcp2::Close()
{
	if ( INVALID_SOCKET != m_Socket )
	{
		shutdown( m_Socket, SD_SEND );
		closesocket( m_Socket );
		m_Socket = INVALID_SOCKET;
	}
	return TRUE;
}

//////////////////////////////////////////////////////////////////////////////
//   MODULE   : CWS2Tcp2::GetLastError
//   ABSTRACT : G[擾܂
//   FUNCTION : G[擾܂
//////////////////////////////////////////////////////////////////////////////
int CWS2Tcp2::GetLastError()
{
	return WSAGetLastError();
}

//////////////////////////////////////////////////////////////////////////////
//   MODULE   : CWS2Tcp2::SetAutoDelete
//   ABSTRACT : \PbgؒfꂽƂɎIɃNX̍폜邩ǂݒ肵܂
//   FUNCTION : \PbgؒfꂽƂɎIɃNX̍폜邩ǂݒ肵܂
//////////////////////////////////////////////////////////////////////////////
void CWS2Tcp2::SetAutoDelete( BOOL bAutoDelete )
{
	m_bAutoDelete = bAutoDelete;
}

//////////////////////////////////////////////////////////////////////////////
//   MODULE   : CWS2Tcp2::SetReUsePort
//   ABSTRACT : |[gԍ̍Ďgpݒ肵܂
//   FUNCTION : |[gԍ̍Ďgpݒ肵܂
//////////////////////////////////////////////////////////////////////////////
BOOL CWS2Tcp2::SetReUsePort()
{
	BOOL	opt = TRUE;

	if( ::setsockopt( m_Socket, SOL_SOCKET, SO_REUSEADDR, ( const char FAR* )&opt, sizeof( opt ) ) == 0 )
	{
		return TRUE;
	}

	return FALSE;
}

//////////////////////////////////////////////////////////////////////////////
//   MODULE   : CWS2Tcp2::GetSendBufSize
//   ABSTRACT : f[^Mp̃obt@̃TCYݒ肵܂
//   FUNCTION : f[^Mp̃obt@̃TCYݒ肵܂
//////////////////////////////////////////////////////////////////////////////
BOOL CWS2Tcp2::GetSendBufSize( int* pSendBufSize )
{
	int nValue=0;
	int nLen;

	nLen = sizeof(nValue);

	// Mobt@̃TCYύXꂽmF
	if ( 0 != ::getsockopt( m_Socket, SOL_SOCKET, SO_SNDBUF, ( char FAR* )&nValue, ( int FAR* )&nLen ) )
	{
		return FALSE;
	}

	*pSendBufSize = nValue;

	return TRUE;
}

//////////////////////////////////////////////////////////////////////////////
//   MODULE   : CWS2Tcp2::SetSendBufSize
//   ABSTRACT : f[^Mp̃obt@̃TCYݒ肵܂
//   FUNCTION : f[^Mp̃obt@̃TCYݒ肵܂
//////////////////////////////////////////////////////////////////////////////
BOOL CWS2Tcp2::SetSendBufSize( const int nSendBufSize )
{
	int nValue=0;
	int nLen;

	nLen = sizeof(nValue);

	// Mobt@̃TCYύX
	if ( 0 != ::setsockopt( m_Socket, SOL_SOCKET, SO_SNDBUF, ( const char FAR* )&nSendBufSize, sizeof( nSendBufSize ) ) )
	{
		return FALSE;
	}

	// Mobt@̃TCYύXꂽmF
	if ( 0 != ::getsockopt( m_Socket, SOL_SOCKET, SO_SNDBUF, ( char FAR* )&nValue, ( int FAR* )&nLen ) )
	{
		return FALSE;
	}

	if ( nSendBufSize != nValue )
	{
		return FALSE;
	}

	return TRUE;
}

//////////////////////////////////////////////////////////////////////////////
//   MODULE   : CWS2Tcp2::GetNoDelay
//   ABSTRACT : NagleASY̗L擾܂
//   FUNCTION : NagleASY̗L擾܂
//////////////////////////////////////////////////////////////////////////////
BOOL CWS2Tcp2::GetNoDelay( BOOL* pEnable )
{
	BOOL bValue=FALSE;
	int nLen;

	nLen = sizeof(bValue);

	// Mobt@̃TCYύXꂽmF
	if ( 0 != ::getsockopt( m_Socket, IPPROTO_TCP, TCP_NODELAY, ( char FAR* )&bValue, ( int FAR* )&nLen ) )
	{
		return FALSE;
	}

	*pEnable = bValue;

	return TRUE;
}

//////////////////////////////////////////////////////////////////////////////
//   MODULE   : CWS2Tcp2::SetNoDelay
//   ABSTRACT : NagleASY̗Lݒ肵܂
//   FUNCTION : NagleASY̗Lݒ肵܂
//////////////////////////////////////////////////////////////////////////////
BOOL CWS2Tcp2::SetNoDelay( const BOOL bEnable )
{
	BOOL bValue=FALSE;
	int nLen;

	nLen = sizeof(bValue);

	//  NagleASY̗LύX
	if ( 0 != ::setsockopt( m_Socket, IPPROTO_TCP, TCP_NODELAY, ( const char FAR* )&bEnable, sizeof( bEnable ) ) )
	{
		return FALSE;
	}

	// NagleASYύXꂽmF
	if ( 0 != ::getsockopt( m_Socket, IPPROTO_TCP, TCP_NODELAY, ( char FAR* )&bValue, ( int FAR* )&nLen ) )
	{
		return FALSE;
	}

	if ( bEnable != bValue )
	{
		return FALSE;
	}

	return TRUE;
}
