// NpsLib.cpp: CNpsLib NX̃Cve[V
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "NpsAutoTester.h"
#include "NpsLib.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

// NPS_UnitInfo\̂̃oϐ̒l𕶎ɕϊ
CString GetString_UnitInfo_dwPrinterStatus( DWORD dwStatus )
{
	CString str;

	switch ( dwStatus )
	{
	case INFO_SALLBOOT:		str.Format( "v^(%d)", dwStatus );		break;
	case INFO_SALLOFFLN:	str.Format( "ItC(%d)", dwStatus );			break;
	case INFO_SALLEND:		str.Format( "I(%d)", dwStatus );					break;
	case INFO_SALLSELFINST:	str.Format( "INFO_SALLSELFINST(%d)", dwStatus );	break;
	case INFO_SALLIDLE:		str.Format( "ACh(%d)", dwStatus );				break;
	case INFO_SALLPRINT:	str.Format( "vg(%d)", dwStatus );			break;
	case INFO_SALLPRGTM:	str.Format( "vO^C}[(%d)", dwStatus );	break;
	case INFO_SALLINST:		str.Format( "CXg[(%d)", dwStatus );		break;
	}

	return str;
}

CString ConvIPAddress2Str( DWORD dwIPAddress )
{
	CString strIPAddress;
	union _IPADDRESS_VAR {
		unsigned char	IP_CHAR[4];
		DWORD			IP_DWORD;
	};

	union _IPADDRESS_VAR var;

	var.IP_DWORD = dwIPAddress;

	strIPAddress.Format( "%03u.%03u.%03u.%03u", var.IP_CHAR[0], var.IP_CHAR[1], var.IP_CHAR[2], var.IP_CHAR[3] );

	return strIPAddress;
}

CString ConvSupportImageFormat2Str( char* pFormatList )
{
	CString strFormatList;

	if ( 0 != *(pFormatList+ 0) ) { strFormatList += "JPEG[TYPE1], "; }
	if ( 0 != *(pFormatList+ 1) ) { strFormatList += "Bitmap[TYPE1], "; }
	if ( 0 != *(pFormatList+ 2) ) { strFormatList += "RAW[RGB24bit], "; }
	if ( 0 != *(pFormatList+ 3) ) { strFormatList += "RGB48bit[J[_ 12bit LSB], "; }
	if ( 0 != *(pFormatList+ 4) ) { strFormatList += "RGB48bit[J[_ 12bit LSB], "; }
	if ( 0 != *(pFormatList+ 5) ) { strFormatList += "BGR48bit[J[_ 12bit LSB], "; }
	if ( 0 != *(pFormatList+ 6) ) { strFormatList += "BGR48bit[J[_ 12bit LSB], "; }
	if ( 0 != *(pFormatList+ 7) ) { strFormatList += "RGB48bit[J[_ 12bit MSB], "; }
	if ( 0 != *(pFormatList+ 8) ) { strFormatList += "RGB48bit[J[_ 12bit MSB], "; }
	if ( 0 != *(pFormatList+ 9) ) { strFormatList += "BGR48bit[J[_ 12bit MSB], "; }
	if ( 0 != *(pFormatList+10) ) { strFormatList += "BGR48bit[J[_ 12bit MSB], "; }
	if ( 0 != *(pFormatList+11) ) { strFormatList += "JPEG[TYPE2], "; }
	if ( 0 != *(pFormatList+12) ) { strFormatList += "Bitmap[TYPE2], "; }
	if ( 0 != *(pFormatList+13) ) { strFormatList += "TIFF[TYPE1], "; }
	if ( 0 != *(pFormatList+14) ) { strFormatList += "Bitmap[TYPE1-FILE], "; }

	return strFormatList;
}

CString GetString_UnitInfo_dwAcceptStatus( DWORD dwStatus )
{
	CString str;

	switch ( dwStatus )
	{
	case INFO_SACDISABLE:	str.Format( "ts\(%d)", dwStatus );	break;
	case INFO_SACENABLE:	str.Format( "t\(%d)", dwStatus );		break;
	}

	return str;
}

CString GetString_UnitInfo_dwPrinterPossession( DWORD dwStatus )
{
	CString str;

	switch ( dwStatus )
	{
	case INFO_SPPNOUSE:		str.Format( "L(%d)", dwStatus );				break;
	case INFO_SPPRESTART:	str.Format( "L (ĊJ҂)(%d)", dwStatus );	break;
	case INFO_SPPUSENORMAL:	str.Format( "ʏL(%d)", dwStatus );			break;
	case INFO_SPPUSEEXPRESS:str.Format( "}L(%d)", dwStatus );			break;
	}

	return str;
}

CString GetString_UnitInfo_dwAdvanceStatus( DWORD dwStatus )
{
	CString str;

	switch ( dwStatus )
	{
	case INFO_SMCALLMOTNG:	str.Format( "̗vts(%d)", dwStatus );	break;
	case INFO_SMCALLMOTOK:	str.Format( "̗vt\(%d)", dwStatus );	break;
	case INFO_SMCALLMOTACT:	str.Format( "쒆(%d)", dwStatus );				break;
	case INFO_SMCALLMOTNONE:str.Format( "擾s\(%d)", dwStatus );					break;
	}

	return str;
}

CString GetString_UnitInfo_dwLaserStatus( DWORD dwStatus )
{
	CString str;

	switch ( dwStatus )
	{
	case INFO_SLDLZSTOP:	str.Format( "(%d)", dwStatus );				break;
	case INFO_SLDLZSTART:	str.Format( "Jn ()(%d)", dwStatus );	break;
	case INFO_SLDLZEND:		str.Format( "(%d)", dwStatus );				break;
	case INFO_SLDLZNONE:	str.Format( "擾s\(%d)", dwStatus );			break;
	}

	return str;
}

CString GetString_UnitInfo_dwDevelopmentStatus( DWORD dwStatus )
{
	CString str;

	switch ( dwStatus )
	{
	case INFO_SPRALLMTNG:	str.Format( "̗vts\(%d)", dwStatus );	break;
	case INFO_SPRALLMTOK:	str.Format( "̗vt\(%d)", dwStatus );	break;
	case INFO_SPRALLMTDO:	str.Format( "쒆(%d)", dwStatus );				break;
	case INFO_SPRALLMTNONE:	str.Format( "擾s\(%d)", dwStatus );					break;
	}

	return str;
}

CString GetString_UnitInfo_dwProcessorStatus( DWORD dwStatus )
{
	CString str;

	switch ( dwStatus )
	{
	case INFO_SPRBTHTPNO:	str.Format( "(%d)", dwStatus );			break;
	case INFO_SPRBTHHTUP:	str.Format( "q[gAbv(%d)", dwStatus );	break;
	case INFO_SPRBTHPRTP:	str.Format( "(%d)", dwStatus );			break;
	case INFO_SPRBTHTPNG:	str.Format( "s(%d)", dwStatus );			break;
	case INFO_SPRBTHNONE:	str.Format( "擾s\(%d)", dwStatus );		break;
	}

	return str;
}

CString GetString_UnitInfo_dwReplenisherStatus( DWORD dwStatus )
{
	CString str;

	switch ( dwStatus )
	{
	case INFO_SPRSPAAL:		str.Format( "ʏ^](%d)", dwStatus );		break;
	case INFO_SPRSPASA:		str.Format( "[(%d)", dwStatus );	break;
	case INFO_SPRSPADO:		str.Format( "ՎU(%d)", dwStatus );	break;
	case INFO_SPRSPAKT:		str.Format( "Lbg[(%d)", dwStatus );	break;
	case INFO_SPRSPNONE:	str.Format( "擾s\(%d)", dwStatus );	break;
	}

	return str;
}

CString GetString_UnitInfo_dwReplaceCartridgeStatus( DWORD dwStatus )
{
	CString str;

	switch ( dwStatus )
	{
	case INFO_SPRKITCG:		str.Format( "\(%d)", dwStatus );		break;
	case INFO_SPRKITLY:		str.Format( "[ҋ@(%d)", dwStatus );	break;
	case INFO_SPRKITOP:		str.Format( "J(%d)", dwStatus );		break;
	case INFO_SPRKITNONE:	str.Format( "擾s\(%d)", dwStatus );	break;
	}

	return str;
}

CString GetString_UnitInfo_dwStartUpChecksStatus( DWORD dwStatus )
{
	CString str;

	switch ( dwStatus )
	{
	case INFO_SUCSNO:		str.Format( "{(%d)", dwStatus );		break;
	case INFO_SUCSOK:		str.Format( "{ς(%d)", dwStatus );		break;
	case INFO_SUCSNONE:		str.Format( "擾s\(%d)", dwStatus );	break;
	}

	return str;
}

CString GetString_UnitInfo_dwRefillWaterStatus( DWORD dwStatus )
{
	CString str;

	switch ( dwStatus )
	{
	case INFO_RWSNO:		str.Format( "{(%d)", dwStatus );		break;
	case INFO_RWSOK:		str.Format( "{ς(%d)", dwStatus );		break;
	case INFO_RWSNONE:		str.Format( "擾s\(%d)", dwStatus );	break;
	}

	return str;
}

CString GetString_UnitInfo_dwDailySetupStatus( DWORD dwStatus )
{
	CString str;

	switch ( dwStatus )
	{
	case INFO_DSSNO:		str.Format( "{(%d)", dwStatus );		break;
	case INFO_DSSOK:		str.Format( "{ς(%d)", dwStatus );		break;
	case INFO_DSSNONE:		str.Format( "擾s\(%d)", dwStatus );	break;
	}

	return str;
}

CString GetString_UnitInfo_dwControlStripStatus( DWORD dwStatus )
{
	CString str;

	switch ( dwStatus )
	{
	case INFO_CSSNO:		str.Format( "{(%d)", dwStatus );		break;
	case INFO_CSSOK:		str.Format( "{ς(%d)", dwStatus );		break;
	case INFO_CSSNONE:		str.Format( "擾s\(%d)", dwStatus );	break;
	}

	return str;
}

CString GetString_UnitInfo_dwMaintenanceStatus( DWORD dwStatus )
{
	CString str;

	switch ( dwStatus )
	{
	case INFO_MNTNOTUSE:	str.Format( "L(%d)", dwStatus );		break;
	case INFO_MNTUSE:		str.Format( "L(%d)", dwStatus );		break;
	case INFO_MNTNONE:		str.Format( "擾s\(%d)", dwStatus );	break;
	}

	return str;
}

CString GetString_UnitInfo_dwFadStatus( DWORD dwStatus )
{
	CString str;

	switch ( dwStatus )
	{
	case INFO_FADOFFLN:		str.Format( "ItC(%d)", dwStatus );		break;
	case INFO_FADUNWK:		str.Format( "ғ(%d)", dwStatus );			break;
	case INFO_FADWRRNG:		str.Format( "x(%d)", dwStatus );		break;
	case INFO_FADMNT:		str.Format( "eiX(%d)", dwStatus );	break;
	case INFO_FADIDLE:		str.Format( "ACh(%d)", dwStatus );		break;
	case INFO_FADNONE:		str.Format( "擾s\(%d)", dwStatus );		break;
	}

	return str;
}

CString GetString_UnitProc( long lUnitId, short iNewStatus, short iOldStatus )
{
	CString str;
	CString strUnitId;
	CString strNewStatus;
	CString strOldStatus;

	switch ( lUnitId )
	{
	case INFO_PRINTER:			// v^S
		strUnitId.Format( "v^S(%d)", lUnitId );
		strNewStatus = GetString_UnitInfo_dwPrinterStatus( iNewStatus );
		strOldStatus = GetString_UnitInfo_dwPrinterStatus( iOldStatus );
		break;
	case INFO_ADVANCE:			// nS
		strUnitId.Format( "nS(%d)", lUnitId );
		strNewStatus = GetString_UnitInfo_dwAdvanceStatus( iNewStatus );
		strOldStatus = GetString_UnitInfo_dwAdvanceStatus( iOldStatus );
		break;
	case INFO_LASER:			// w[U[
		strUnitId.Format( "w[U[(%d)", lUnitId );
		strNewStatus = GetString_UnitInfo_dwLaserStatus( iNewStatus );
		strOldStatus = GetString_UnitInfo_dwLaserStatus( iOldStatus );
		break;
	case INFO_DEVELOPMENT:		// nS
		strUnitId.Format( "nS(%d)", lUnitId );
		strNewStatus = GetString_UnitInfo_dwDevelopmentStatus( iNewStatus );
		strOldStatus = GetString_UnitInfo_dwDevelopmentStatus( iOldStatus );
		break;
	case INFO_PROCESSOR:		// 
		strUnitId.Format( "(%d)", lUnitId );
		strNewStatus = GetString_UnitInfo_dwProcessorStatus( iNewStatus );
		strOldStatus = GetString_UnitInfo_dwProcessorStatus( iOldStatus );
		break;
	case INFO_REPLENISHER:		// [
		strUnitId.Format( "[(%d)", lUnitId );
		strNewStatus = GetString_UnitInfo_dwReplenisherStatus( iNewStatus );
		strOldStatus = GetString_UnitInfo_dwReplenisherStatus( iOldStatus );
		break;
	case INFO_REPLACECARTRIDGE:	// [J[gbW
		strUnitId.Format( "[J[gbW(%d)", lUnitId );
		strNewStatus = GetString_UnitInfo_dwReplaceCartridgeStatus( iNewStatus );
		strOldStatus = GetString_UnitInfo_dwReplaceCartridgeStatus( iOldStatus );
		break;
	case INFO_ACCEPT:			// t
		strUnitId.Format( "t(%d)", lUnitId );
		strNewStatus = GetString_UnitInfo_dwAcceptStatus( iNewStatus );
		strOldStatus = GetString_UnitInfo_dwAcceptStatus( iOldStatus );
		break;
	case INFO_POSSESSION:		// v^L
		strUnitId.Format( "v^L(%d)", lUnitId );
		strNewStatus = GetString_UnitInfo_dwPrinterPossession( iNewStatus );
		strOldStatus = GetString_UnitInfo_dwPrinterPossession( iOldStatus );
		break;
	case INFO_STARTCHECK:		// I[gZbgAbvł̎nƓ_
		strUnitId.Format( "nƓ_(%d)", lUnitId );
		strNewStatus = GetString_UnitInfo_dwStartUpChecksStatus( iNewStatus );
		strOldStatus = GetString_UnitInfo_dwStartUpChecksStatus( iOldStatus );
		break;
	case INFO_REFILLWATER:		// I[gZbgAbvł̕␅
		strUnitId.Format( "␅(%d)", lUnitId );
		strNewStatus = GetString_UnitInfo_dwRefillWaterStatus( iNewStatus );
		strOldStatus = GetString_UnitInfo_dwRefillWaterStatus( iOldStatus );
		break;
	case INFO_DAILYSETUP:		// I[gZbgAbvł̃fC[ZbgAbv
		strUnitId.Format( "fC[(%d)", lUnitId );
		strNewStatus = GetString_UnitInfo_dwDailySetupStatus( iNewStatus );
		strOldStatus = GetString_UnitInfo_dwDailySetupStatus( iOldStatus );
		break;
	case INFO_CNTRSTRP:			// I[gZbgAbvł̃Rg[Xgbv
		strUnitId.Format( "Xgbv(%d)", lUnitId );
		strNewStatus = GetString_UnitInfo_dwControlStripStatus( iNewStatus );
		strOldStatus = GetString_UnitInfo_dwControlStripStatus( iOldStatus );
		break;
	case INFO_MNTNNC:			// eiX\tg̐L
		strUnitId.Format( "eL(%d)", lUnitId );
		strNewStatus = GetString_UnitInfo_dwMaintenanceStatus( iNewStatus );
		strOldStatus = GetString_UnitInfo_dwMaintenanceStatus( iOldStatus );
		break;
	case INFO_FAD:				// FAD̏
		strUnitId.Format( "FAD(%d)", lUnitId );
		strNewStatus = GetString_UnitInfo_dwFadStatus( iNewStatus );
		strOldStatus = GetString_UnitInfo_dwFadStatus( iOldStatus );
		break;
	case INFO_INSTMAG:			// }KW
		strUnitId.Format( "}KW(%d)", lUnitId );
		strNewStatus.Format( "%d", iNewStatus );
		strOldStatus.Format( "%d", iOldStatus );
		break;
	case INFO_INFOMAG:			// }KW
		strUnitId.Format( "}KW(%d)", lUnitId );
		strNewStatus.Format( "%d", iNewStatus );
		strOldStatus.Format( "%d", iOldStatus );
		break;
	}

	str.Format( "lUnitId=%s, iNewStatus=%s, iOldStatus=%s", strUnitId, strNewStatus, strOldStatus );

	return str;
}

CString GetString_CtrlPrint( DWORD dwCtrl )
{
	CString str;

	switch ( dwCtrl )
	{
	case CTRL_STOP_FEED:	str.Format( "~(%d)", dwCtrl );	break;
	case CTRL_RESTART_FEED:	str.Format( "ĊJ(%d)", dwCtrl );	break;
	}

	return str;
}

CString GetString_Feed( DWORD dwFeed )
{
	CString str;

	switch ( dwFeed )
	{
	case INFO_ROLL:		str.Format( "ROLL" );	break;
	case INFO_SHEET:	str.Format( "SHEET" );	break;
	}

	return str;
}

// R[obN֐
// --------------------------------------------------
VOID __stdcall CallBack_npsEventProc( PNPSEVENTINFO pEventInfo )
{
	CMNAPI::WriteLog( "  <CALLBACK> NPSEVENTPROC ( hPrinter=0x%08X, dwIPAddress=%s, dwErrHandle=%u, sysTime=%04d/%02d/%02d %02d:%02d:%02d'%03d, dwErrCode=%u, dwOnOff=%u, alParams={ %d, %d, %d, %d }, szStrings={ \"%s\", \"%s\", \"%s\", \"%s\" }",
						pEventInfo->hPrinter,
						ConvIPAddress2Str( pEventInfo->dwIPAddress ),
						pEventInfo->dwErrHandle,
						pEventInfo->sysTime.wYear, pEventInfo->sysTime.wMonth, pEventInfo->sysTime.wDay,
						pEventInfo->sysTime.wHour, pEventInfo->sysTime.wMinute, pEventInfo->sysTime.wSecond, pEventInfo->sysTime.wMilliseconds,
						pEventInfo->dwErrCode,
						pEventInfo->dwOnOff,
						pEventInfo->alParams[0], pEventInfo->alParams[1], pEventInfo->alParams[2], pEventInfo->alParams[3],
						pEventInfo->szStrings[0], pEventInfo->szStrings[1], pEventInfo->szStrings[2], pEventInfo->szStrings[3] );
}

// --------------------------------------------------
VOID __stdcall CallBack_npsUnitProc( PNPSUNITNOTIFYINFO pUnitInfo )
{
	CMNAPI::WriteLog( "  <CALLBACK> NPSUNITPROC ( hPrinter=0x%08X, dwIPAddress=%s, %s",
						pUnitInfo->hPrinter,
						ConvIPAddress2Str( pUnitInfo->dwIPAddress ),
						GetString_UnitProc( pUnitInfo->lUnitId, pUnitInfo->iNewStatus, pUnitInfo->iOldStatus ) );
}

// --------------------------------------------------
VOID __stdcall CallBack_npsCompletionProc( DWORD dwCompletionCode, PVOID pCompletionInfo )
{
}

//////////////////////////////////////////////////////////////////////
// \z/
//////////////////////////////////////////////////////////////////////

//--------------------------------------------------------------------
CNpsLib::CNpsLib( DWORD dwSeqNo )
{
	m_dwOrderId = 0;
	m_dwSeqNo = dwSeqNo;
	m_hPrinter = NULL;
}

//--------------------------------------------------------------------
CNpsLib::~CNpsLib()
{

}

//--------------------------------------------------------------------
CString CNpsLib::ConvResultNum2Str( long nResultNum )
{
	CString strResult;

	switch ( nResultNum )
	{
	case NPSERR_NORMAL:			strResult.Format( "NPSERR_NORMAL(%d)", nResultNum );				break;
	case NPSERR_REJECT2:		strResult.Format( "NPSERR_REJECT2(%d)", nResultNum );			break;
	case NPSERR_BADPARAM:		strResult.Format( "NPSERR_BADPARAM(%d)", nResultNum );			break;
	case NPSERR_SYSERR:			strResult.Format( "NPSERR_SYSERR(%d)", nResultNum );			break;
	case NPSERR_PRNERR:			strResult.Format( "NPSERR_PRNERR(%d)", nResultNum );			break;
	case NPSERR_REJECT3:		strResult.Format( "NPSERR_REJECT3(%d)", nResultNum );				break;
	case NPSERR_REMAINING_DATA:	strResult.Format( "NPSERR_REMAINING_DATA(%d)", nResultNum );	break;
	case NPSERR_TIMEOUT:		strResult.Format( "NPSERR_TIMEOUT(%d)", nResultNum );			break;
	default:					strResult.Format( "error(%d)", nResultNum );					break;
	}

	return strResult;
}

//--------------------------------------------------------------------
bool CNpsLib::npsLibOpen( bool bEnableLogOut )
{
	long nResult = 0;
	bool bResult = true;

	if ( true == bEnableLogOut )
	{
		// Oo͐ݒt@C̍쐬
		CString strLogIniFile = CMNAPI::GetModuleFolder() + _T("NpsAutoTester_NpsLog.ini");
		CString strLogFile = CMNAPI::GetModuleFolder() + _T("NpsAutoTester_NpsLog.log");
		::WritePrivateProfileString( "log", "logger", "NoritsuPrinter.dll", strLogIniFile );
		::WritePrivateProfileString( "log", "memorysize", "1", strLogIniFile );
		::WritePrivateProfileString( "log", "filename", strLogFile, strLogIniFile );
		::WritePrivateProfileString( "log", "levelfatal", "0", strLogIniFile );
		::WritePrivateProfileString( "log", "levelwarn", "0", strLogIniFile );
		::WritePrivateProfileString( "log", "levelinfo", "0", strLogIniFile );
		::WritePrivateProfileString( "log", "leveldebug", "0", strLogIniFile );

		nResult = ::npsLibOpen( strLogIniFile );
		CMNAPI::WriteLog( "  <API CALL> npsLibOpen( lpLogFileName=\"%s\" ) = %s", strLogIniFile, ConvResultNum2Str(nResult) );
	}
	else
	{
		nResult = ::npsLibOpen( NULL );
		CMNAPI::WriteLog( "  <API CALL> npsLibOpen( NULL ) = %s", ConvResultNum2Str(nResult) );
	}

	return bResult;
}

//--------------------------------------------------------------------
bool CNpsLib::npsLibClose()
{
	long nResult = 0;
	bool bResult = true;

	nResult = ::npsLibClose();
	CMNAPI::WriteLog( "  <API CALL> npsLibClose() = %s", ConvResultNum2Str(nResult) );

	return bResult;
}

//--------------------------------------------------------------------
bool CNpsLib::npsGetNpsVersion()
{
	long nResult = 0;
	bool bResult = true;
	WORD wNpsVersion = 0;

	// a. npsGetNpsVersion֐̌ĂяomF
	CMNAPI::WriteLog( "a. npsGetNpsVersion֐̌ĂяomF" );
	nResult = ::npsGetNpsVersion( &wNpsVersion );
	CMNAPI::WriteLog( "  <API CALL> npsGetNpsVersion( *pNpsVersion=0x%04X(%d) ) = %s", wNpsVersion, wNpsVersion, ConvResultNum2Str(nResult) );

	return bResult;
}

//--------------------------------------------------------------------
bool CNpsLib::npsSearchPrinter()
{
	long nResult = 0;
	bool bResult = true;
	WORD wPrinterNum = 0;
	DWORD dwWaitTime = 0;
	WORD wBufferNum = 0;
	WORD wIdx = 0;
	PNPS_PRINTER_ENUM pPrinterInfo = NULL;

	// a. npsSearchPrinter֐̌ĂяomF(dwWaitTimewȂ=>6b)
	CMNAPI::WriteLog( "a. npsSearchPrinter֐̌ĂяomF(dwWaitTimewȂ=>6b)" );
	nResult = ::npsSearchPrinter( &wPrinterNum );
	CMNAPI::WriteLog( "  <API CALL> npsSearchPrinter( *pPrinterNum=%u ) = %s", wPrinterNum, ConvResultNum2Str(nResult) );

	wBufferNum = wPrinterNum;
	pPrinterInfo = new NPS_PRINTER_ENUM[ wBufferNum ];
	nResult = ::npsGetPrinter( wBufferNum, pPrinterInfo );
	CMNAPI::WriteLog( "  <API CALL> npsGetPrinter( wBufferNum=%u, pPrinterInfo<ȉQ> ) = %s", wPrinterNum, ConvResultNum2Str(nResult) );
	for ( wIdx=0 ; wBufferNum > wIdx ; wIdx++ )
	{
		CMNAPI::WriteLog( "                pPrinterInfo[%d] = { dwIPAddress=%s, szMachineTypeName=\"%s\", szSoftName=\"%s\", szSerialNumber=\"%s\", wSupportResolutions={ %u, %u, %u, %u, %u, %u, %u, %u }, wNpsVersion=0x%04X(%d), MacAddress=%02X-%02X-%02X-%02X-%02X-%02X }",
							wIdx,
							ConvIPAddress2Str( (pPrinterInfo+wIdx)->dwIPAddress ),
							(pPrinterInfo+wIdx)->szMachineTypeName,
							(pPrinterInfo+wIdx)->szSoftName,
							(pPrinterInfo+wIdx)->szSerialNumber,
							(pPrinterInfo+wIdx)->wSupportResolutions[0], (pPrinterInfo+wIdx)->wSupportResolutions[1], (pPrinterInfo+wIdx)->wSupportResolutions[2], (pPrinterInfo+wIdx)->wSupportResolutions[3],
							(pPrinterInfo+wIdx)->wSupportResolutions[4], (pPrinterInfo+wIdx)->wSupportResolutions[5], (pPrinterInfo+wIdx)->wSupportResolutions[6], (pPrinterInfo+wIdx)->wSupportResolutions[7],
							(pPrinterInfo+wIdx)->wNpsVersion, (pPrinterInfo+wIdx)->wNpsVersion,
							(pPrinterInfo+wIdx)->MacAddress[0], (pPrinterInfo+wIdx)->MacAddress[1], (pPrinterInfo+wIdx)->MacAddress[2], (pPrinterInfo+wIdx)->MacAddress[3], (pPrinterInfo+wIdx)->MacAddress[4], (pPrinterInfo+wIdx)->MacAddress[5] );
	}
	delete [] pPrinterInfo;

	// b. npsSearchPrinter֐̌ĂяomF(dwWaitTime3bw)
	CMNAPI::WriteLog( "b. npsSearchPrinter֐̌ĂяomF(dwWaitTime3bw)" );
	dwWaitTime = 3000;
	nResult = ::npsSearchPrinter( &wPrinterNum, dwWaitTime );
	CMNAPI::WriteLog( "  <API CALL> npsSearchPrinter( *pPrinterNum=%u, dwWaitTime=%u ) = %s", wPrinterNum, dwWaitTime, ConvResultNum2Str(nResult) );

	wBufferNum = wPrinterNum;
	pPrinterInfo = new NPS_PRINTER_ENUM[ wBufferNum ];
	nResult = ::npsGetPrinter( wBufferNum, pPrinterInfo );
	CMNAPI::WriteLog( "  <API CALL> npsGetPrinter( wBufferNum=%u, pPrinterInfo<ȉQ> ) = %s", wPrinterNum, ConvResultNum2Str(nResult) );
	for ( wIdx=0 ; wBufferNum > wIdx ; wIdx++ )
	{
		CMNAPI::WriteLog( "                pPrinterInfo[%d] = { dwIPAddress=%s, szMachineTypeName=\"%s\", szSoftName=\"%s\", szSerialNumber=\"%s\", wSupportResolutions={ %u, %u, %u, %u, %u, %u, %u, %u }, wNpsVersion=0x%04X(%d), MacAddress=%02X-%02X-%02X-%02X-%02X-%02X }",
							wIdx,
							ConvIPAddress2Str( (pPrinterInfo+wIdx)->dwIPAddress ),
							(pPrinterInfo+wIdx)->szMachineTypeName,
							(pPrinterInfo+wIdx)->szSoftName,
							(pPrinterInfo+wIdx)->szSerialNumber,
							(pPrinterInfo+wIdx)->wSupportResolutions[0], (pPrinterInfo+wIdx)->wSupportResolutions[1], (pPrinterInfo+wIdx)->wSupportResolutions[2], (pPrinterInfo+wIdx)->wSupportResolutions[3],
							(pPrinterInfo+wIdx)->wSupportResolutions[4], (pPrinterInfo+wIdx)->wSupportResolutions[5], (pPrinterInfo+wIdx)->wSupportResolutions[6], (pPrinterInfo+wIdx)->wSupportResolutions[7],
							(pPrinterInfo+wIdx)->wNpsVersion, (pPrinterInfo+wIdx)->wNpsVersion,
							(pPrinterInfo+wIdx)->MacAddress[0], (pPrinterInfo+wIdx)->MacAddress[1], (pPrinterInfo+wIdx)->MacAddress[2], (pPrinterInfo+wIdx)->MacAddress[3], (pPrinterInfo+wIdx)->MacAddress[4], (pPrinterInfo+wIdx)->MacAddress[5] );
	}
	delete [] pPrinterInfo;

	// c. npsSearchPrinter2֐̌ĂяomF(dwWaitTimewȂ=>6b)
	CMNAPI::WriteLog( "c. npsSearchPrinter2֐̌ĂяomF(dwWaitTimewȂ=>6b)" );
	nResult = ::npsSearchPrinter2( &wPrinterNum );
	CMNAPI::WriteLog( "  <API CALL> npsSearchPrinter2( *pPrinterNum=%u ) = %s", wPrinterNum, ConvResultNum2Str(nResult) );

	wBufferNum = wPrinterNum;
	pPrinterInfo = new NPS_PRINTER_ENUM[ wBufferNum ];
	nResult = ::npsGetPrinter( wBufferNum, pPrinterInfo );
	CMNAPI::WriteLog( "  <API CALL> npsGetPrinter( wBufferNum=%u, pPrinterInfo<ȉQ> ) = %s", wPrinterNum, ConvResultNum2Str(nResult) );
	for ( wIdx=0 ; wBufferNum > wIdx ; wIdx++ )
	{
		CMNAPI::WriteLog( "                pPrinterInfo[%d] = { dwIPAddress=%s, szMachineTypeName=\"%s\", szSoftName=\"%s\", szSerialNumber=\"%s\", wSupportResolutions={ %u, %u, %u, %u, %u, %u, %u, %u }, wNpsVersion=0x%04X(%d), MacAddress=%02X-%02X-%02X-%02X-%02X-%02X }",
							wIdx,
							ConvIPAddress2Str( (pPrinterInfo+wIdx)->dwIPAddress ),
							(pPrinterInfo+wIdx)->szMachineTypeName,
							(pPrinterInfo+wIdx)->szSoftName,
							(pPrinterInfo+wIdx)->szSerialNumber,
							(pPrinterInfo+wIdx)->wSupportResolutions[0], (pPrinterInfo+wIdx)->wSupportResolutions[1], (pPrinterInfo+wIdx)->wSupportResolutions[2], (pPrinterInfo+wIdx)->wSupportResolutions[3],
							(pPrinterInfo+wIdx)->wSupportResolutions[4], (pPrinterInfo+wIdx)->wSupportResolutions[5], (pPrinterInfo+wIdx)->wSupportResolutions[6], (pPrinterInfo+wIdx)->wSupportResolutions[7],
							(pPrinterInfo+wIdx)->wNpsVersion, (pPrinterInfo+wIdx)->wNpsVersion,
							(pPrinterInfo+wIdx)->MacAddress[0], (pPrinterInfo+wIdx)->MacAddress[1], (pPrinterInfo+wIdx)->MacAddress[2], (pPrinterInfo+wIdx)->MacAddress[3], (pPrinterInfo+wIdx)->MacAddress[4], (pPrinterInfo+wIdx)->MacAddress[5] );
	}
	delete [] pPrinterInfo;

	// d. npsSearchPrinter֐̌ĂяomF(dwWaitTime3bw)
	CMNAPI::WriteLog( "d. npsSearchPrinter2֐̌ĂяomF(dwWaitTime3bw)" );
	dwWaitTime = 3000;
	nResult = ::npsSearchPrinter2( &wPrinterNum, dwWaitTime );
	CMNAPI::WriteLog( "  <API CALL> npsSearchPrinter2( *pPrinterNum=%u, dwWaitTime=%u ) = %s", wPrinterNum, dwWaitTime, ConvResultNum2Str(nResult) );

	wBufferNum = wPrinterNum;
	pPrinterInfo = new NPS_PRINTER_ENUM[ wBufferNum ];
	nResult = ::npsGetPrinter( wBufferNum, pPrinterInfo );
	CMNAPI::WriteLog( "  <API CALL> npsGetPrinter( wBufferNum=%u, pPrinterInfo<ȉQ> ) = %s", wPrinterNum, ConvResultNum2Str(nResult) );
	for ( wIdx=0 ; wBufferNum > wIdx ; wIdx++ )
	{
		CMNAPI::WriteLog( "                pPrinterInfo[%d] = { dwIPAddress=%s, szMachineTypeName=\"%s\", szSoftName=\"%s\", szSerialNumber=\"%s\", wSupportResolutions={ %u, %u, %u, %u, %u, %u, %u, %u }, wNpsVersion=0x%04X(%d), MacAddress=%02X-%02X-%02X-%02X-%02X-%02X }",
							wIdx,
							ConvIPAddress2Str( (pPrinterInfo+wIdx)->dwIPAddress ),
							(pPrinterInfo+wIdx)->szMachineTypeName,
							(pPrinterInfo+wIdx)->szSoftName,
							(pPrinterInfo+wIdx)->szSerialNumber,
							(pPrinterInfo+wIdx)->wSupportResolutions[0], (pPrinterInfo+wIdx)->wSupportResolutions[1], (pPrinterInfo+wIdx)->wSupportResolutions[2], (pPrinterInfo+wIdx)->wSupportResolutions[3],
							(pPrinterInfo+wIdx)->wSupportResolutions[4], (pPrinterInfo+wIdx)->wSupportResolutions[5], (pPrinterInfo+wIdx)->wSupportResolutions[6], (pPrinterInfo+wIdx)->wSupportResolutions[7],
							(pPrinterInfo+wIdx)->wNpsVersion, (pPrinterInfo+wIdx)->wNpsVersion,
							(pPrinterInfo+wIdx)->MacAddress[0], (pPrinterInfo+wIdx)->MacAddress[1], (pPrinterInfo+wIdx)->MacAddress[2], (pPrinterInfo+wIdx)->MacAddress[3], (pPrinterInfo+wIdx)->MacAddress[4], (pPrinterInfo+wIdx)->MacAddress[5] );
	}
	delete [] pPrinterInfo;

	return bResult;
}

//--------------------------------------------------------------------
bool CNpsLib::npsDevOpen( DWORD dwIPAddress )
{
	long nResult = 0;
	bool bResult = true;

	CMNAPI::WriteLog( "a. npsDevOpen֐̌ĂяomF" );
	nResult = ::npsDevOpen( dwIPAddress, &m_hPrinter, &CallBack_npsEventProc, &CallBack_npsUnitProc );
	CMNAPI::WriteLog( "  <API CALL> npsDevOpen( dwIPAddress=\"%s\", *phPrinter=0x%08X, pEventProc=0x%08X, pUnitProc=0x%08X ) = %s",
						ConvIPAddress2Str(dwIPAddress), m_hPrinter, &CallBack_npsEventProc, &CallBack_npsUnitProc, ConvResultNum2Str(nResult) );

	if ( NPSERR_NORMAL == nResult )
	{
		m_dwOrderId = 0;
	}

	return bResult;
}

//--------------------------------------------------------------------
bool CNpsLib::npsDevClose()
{
	long nResult = 0;
	bool bResult = true;

	CMNAPI::WriteLog( "a. npsDevClose֐̌ĂяomF" );
	nResult = ::npsDevClose( m_hPrinter );
	CMNAPI::WriteLog( "  <API CALL> npsDevClose( hPrinter=0x%08X ) = %s", m_hPrinter, ConvResultNum2Str(nResult) );

	return bResult;
}

//--------------------------------------------------------------------
bool CNpsLib::npsDevGetUnitInfo()
{
	long nResult = 0;
	bool bResult = true;
	NPS_UnitInfo tUnitInfo = { 0 };

	CMNAPI::WriteLog( "a. npsDevGetUnitInfo֐̌ĂяomF" );
	nResult = ::npsDevGetUnitInfo( m_hPrinter, &tUnitInfo );
	CMNAPI::WriteLog( "  <API CALL> npsDevGetUnitInfo( hPrinter=0x%08X, pUnitInfo<ȉQ> ) = %s", m_hPrinter, ConvResultNum2Str(nResult) );
	CMNAPI::WriteLog( "                pUnitInfo->dwPrinterStatus          (v^S)     = %s", GetString_UnitInfo_dwPrinterStatus(tUnitInfo.dwPrinterStatus) );
	CMNAPI::WriteLog( "                pUnitInfo->dwAcceptStatus           (t)         = %s", GetString_UnitInfo_dwAcceptStatus(tUnitInfo.dwAcceptStatus) );
	CMNAPI::WriteLog( "                pUnitInfo->dwPrinterPossession      (v^L)     = %s", GetString_UnitInfo_dwPrinterPossession(tUnitInfo.dwPrinterPossession) );
	CMNAPI::WriteLog( "                pUnitInfo->dwAdvanceStatus          (nS)       = %s", GetString_UnitInfo_dwAdvanceStatus(tUnitInfo.dwAdvanceStatus) );
	CMNAPI::WriteLog( "                pUnitInfo->dwLaserStatus            (w[U[)     = %s", GetString_UnitInfo_dwLaserStatus(tUnitInfo.dwLaserStatus) );
	CMNAPI::WriteLog( "                pUnitInfo->dwDevelopmentStatus      (nS)       = %s", GetString_UnitInfo_dwDevelopmentStatus(tUnitInfo.dwDevelopmentStatus) );
	CMNAPI::WriteLog( "                pUnitInfo->dwProcessorStatus        ()           = %s", GetString_UnitInfo_dwProcessorStatus(tUnitInfo.dwProcessorStatus) );
	CMNAPI::WriteLog( "                pUnitInfo->dwReplenisherStatus      ([)           = %s", GetString_UnitInfo_dwReplenisherStatus(tUnitInfo.dwReplenisherStatus) );
	CMNAPI::WriteLog( "                pUnitInfo->dwReplaceCartridgeStatus ([J[gbW) = %s", GetString_UnitInfo_dwReplaceCartridgeStatus(tUnitInfo.dwReplaceCartridgeStatus) );
	CMNAPI::WriteLog( "                pUnitInfo->dwStartUpChecksStatus    (nƓ_)         = %s", GetString_UnitInfo_dwStartUpChecksStatus(tUnitInfo.dwStartUpChecksStatus) );
	CMNAPI::WriteLog( "                pUnitInfo->dwRefillWaterStatus      (␅)         = %s", GetString_UnitInfo_dwRefillWaterStatus(tUnitInfo.dwRefillWaterStatus) );
	CMNAPI::WriteLog( "                pUnitInfo->dwDailySetupStatus       (fC[)         = %s", GetString_UnitInfo_dwDailySetupStatus(tUnitInfo.dwDailySetupStatus) );
	CMNAPI::WriteLog( "                pUnitInfo->dwControlStripStatus     (Xgbv)   = %s", GetString_UnitInfo_dwControlStripStatus(tUnitInfo.dwControlStripStatus) );
	CMNAPI::WriteLog( "                pUnitInfo->dwMaintenanceStatus      (eL)       = %s", GetString_UnitInfo_dwMaintenanceStatus(tUnitInfo.dwMaintenanceStatus) );
	CMNAPI::WriteLog( "                pUnitInfo->dwFadStatus              (FAD)              = %s", GetString_UnitInfo_dwFadStatus(tUnitInfo.dwFadStatus) );
	return bResult;
}

//--------------------------------------------------------------------
bool CNpsLib::npsDevGetMagInfo( DWORD dwMaxCnt )
{
	WORD wIdx = 0;
	long nResult = 0;
	bool bResult = true;
	DWORD dwSize = 0;
	PNPS_MagInfo pMagInfo = NULL;

	CMNAPI::WriteLog( "a. npsDevGetMagInfo֐̌ĂяomF <ő擾=%u>", dwMaxCnt );
	dwSize = sizeof(NPS_MagInfo) * dwMaxCnt;
	if ( 0 < dwMaxCnt )
	{
		pMagInfo = new NPS_MagInfo[dwMaxCnt];
	}
	nResult = ::npsDevGetMagInfo( m_hPrinter, pMagInfo, &dwSize );
	CMNAPI::WriteLog( "  <API CALL> npsDevGetMagInfo( hPrinter=0x%08X, pMagInfo<ȉQ>, *pdwSize=%u ) = %s", m_hPrinter, dwSize, ConvResultNum2Str(nResult) );
	for ( wIdx=0 ; min( dwMaxCnt, dwSize/sizeof(NPS_MagInfo) ) > wIdx ; wIdx++ )
	{
		CMNAPI::WriteLog( "                pMagInfo[%d] = { dwWidth=%u, dwSurface=%u, dwRemain=%u, dwFeed=%u, dwPresence=%u, szName=%s }",
							wIdx, (pMagInfo+wIdx)->dwWidth, (pMagInfo+wIdx)->dwSurface, (pMagInfo+wIdx)->dwRemain, (pMagInfo+wIdx)->dwFeed, (pMagInfo+wIdx)->dwPresence, (pMagInfo+wIdx)->szName );
	}
	if ( NULL != pMagInfo )
	{
		delete [] pMagInfo;
	}

	return bResult;
}

//--------------------------------------------------------------------
bool CNpsLib::npsDevGetSetUpInfo()
{
	long nResult = 0;
	bool bResult = true;
	NPS_SetUpInfo tSetUpInfo = { 0 };

	CMNAPI::WriteLog( "a. npsDevGetSetUpInfo֐̌ĂяomF" );
	nResult = ::npsDevGetSetUpInfo( m_hPrinter, &tSetUpInfo );
	CMNAPI::WriteLog( "  <API CALL> npsDevGetSetUpInfo( hPrinter=0x%08X, pSetUpInfo<ȉQ> ) = %s", m_hPrinter, ConvResultNum2Str(nResult) );
	CMNAPI::WriteLog( "                pSetUpInfo->szMachineTypeName       = %s", tSetUpInfo.szMachineTypeName );
	CMNAPI::WriteLog( "                pSetUpInfo->szSoftName              = %s", tSetUpInfo.szSoftName );
	CMNAPI::WriteLog( "                pSetUpInfo->szSerialNumber          = %s", tSetUpInfo.szSerialNumber );
	CMNAPI::WriteLog( "                pSetUpInfo->wSupportResolutions     = { %u, %u, %u, %u, %u, %u, %u, %u }",
							tSetUpInfo.wSupportResolutions[0], tSetUpInfo.wSupportResolutions[1], tSetUpInfo.wSupportResolutions[2], tSetUpInfo.wSupportResolutions[3],
							tSetUpInfo.wSupportResolutions[4], tSetUpInfo.wSupportResolutions[5], tSetUpInfo.wSupportResolutions[6], tSetUpInfo.wSupportResolutions[7] );
	CMNAPI::WriteLog( "                pSetUpInfo->wNpsVersion             = 0x%04X(%d)", tSetUpInfo.wNpsVersion, tSetUpInfo.wNpsVersion );
	CMNAPI::WriteLog( "                pSetUpInfo->wMachineTypeID          = %u", tSetUpInfo.wMachineTypeID );
	CMNAPI::WriteLog( "                pSetUpInfo->dwTotalMemory           = %u", tSetUpInfo.dwTotalMemory );
	CMNAPI::WriteLog( "                pSetUpInfo->dwImageSizeMinWidth     = %u", tSetUpInfo.dwImageSizeMinWidth );
	CMNAPI::WriteLog( "                pSetUpInfo->dwImageSizeMinHeight    = %u", tSetUpInfo.dwImageSizeMinHeight );
	CMNAPI::WriteLog( "                pSetUpInfo->dwImageSizeMaxWidth     = %u", tSetUpInfo.dwImageSizeMaxWidth );
	CMNAPI::WriteLog( "                pSetUpInfo->dwImageSizeMaxHeight    = %u", tSetUpInfo.dwImageSizeMaxHeight );
	CMNAPI::WriteLog( "                pSetUpInfo->dwNumberOfMagazine      = %u", tSetUpInfo.dwNumberOfMagazine );
	CMNAPI::WriteLog( "                pSetUpInfo->PrinterTime             = %04d/%02d/%02d %02d:%02d:%02d'%03d",
							tSetUpInfo.PrinterTime.tDate.dwYear, tSetUpInfo.PrinterTime.tDate.dwMonth, tSetUpInfo.PrinterTime.tDate.dwDay,
							tSetUpInfo.PrinterTime.tTime.dwHour, tSetUpInfo.PrinterTime.tTime.dwMinute, tSetUpInfo.PrinterTime.tTime.dwSecond );
	CMNAPI::WriteLog( "                pSetUpInfo->dwRepeatCountMax        = %u", tSetUpInfo.dwRepeatCountMax );
	CMNAPI::WriteLog( "                pSetUpInfo->SupportImageFormat      = { %s }", ConvSupportImageFormat2Str(tSetUpInfo.SupportImageFormat) );
	CMNAPI::WriteLog( "                pSetUpInfo->wLaminatorUnitAttach    = %u", tSetUpInfo.wLaminatorUnitAttach );
	CMNAPI::WriteLog( "                pSetUpInfo->InstallationDate        = %04d/%02d/%02d",
							tSetUpInfo.InstallationDate.dwYear, tSetUpInfo.InstallationDate.dwMonth, tSetUpInfo.InstallationDate.dwDay );
	CMNAPI::WriteLog( "                pSetUpInfo->OperationStartDate      = %04d/%02d/%02d",
							tSetUpInfo.OperationStartDate.dwYear, tSetUpInfo.OperationStartDate.dwMonth, tSetUpInfo.OperationStartDate.dwDay );
	CMNAPI::WriteLog( "                pSetUpInfo->wProcessorType          = %u", tSetUpInfo.wProcessorType );
	CMNAPI::WriteLog( "                pSetUpInfo->wEmulsionNumber         = %u", tSetUpInfo.wEmulsionNumber );
	CMNAPI::WriteLog( "                pSetUpInfo->szPrinterNickname       = %s", tSetUpInfo.szPrinterNickname );
	CMNAPI::WriteLog( "                pSetUpInfo->wSupportAngle           = %u", tSetUpInfo.wSupportAngle );
	CMNAPI::WriteLog( "                pSetUpInfo->wSupportIntoPrinter     = %u", tSetUpInfo.wSupportIntoPrinter );
	CMNAPI::WriteLog( "                pSetUpInfo->wSorterStatus           = %u", tSetUpInfo.wSorterStatus );
	CMNAPI::WriteLog( "                pSetUpInfo->wCvpStatus              = %u", tSetUpInfo.wCvpStatus );
	CMNAPI::WriteLog( "                pSetUpInfo->wSupportPaperFitting    = %u", tSetUpInfo.wSupportPaperFitting );
	CMNAPI::WriteLog( "                pSetUpInfo->wSupportEdgeEnhancement = %u", tSetUpInfo.wSupportEdgeEnhancement );
	CMNAPI::WriteLog( "                pSetUpInfo->wSupportWithBorder      = %u", tSetUpInfo.wSupportWithBorder );
	CMNAPI::WriteLog( "                pSetUpInfo->wMachinTypeForProfile   = %u", tSetUpInfo.wMachinTypeForProfile );
	CMNAPI::WriteLog( "                pSetUpInfo->wPaperTypeCode          = { %u, %u, %u, %u, %u, %u }",
							tSetUpInfo.wPaperTypeCode[0], tSetUpInfo.wPaperTypeCode[1], tSetUpInfo.wPaperTypeCode[2],
							tSetUpInfo.wPaperTypeCode[3], tSetUpInfo.wPaperTypeCode[4], tSetUpInfo.wPaperTypeCode[5] );
	CMNAPI::WriteLog( "                pSetUpInfo->wSupportCMS             = %u", tSetUpInfo.wSupportCMS );
	CMNAPI::WriteLog( "                pSetUpInfo->wSetupAlgorithm         = %u", tSetUpInfo.wSetupAlgorithm );
	CMNAPI::WriteLog( "                pSetUpInfo->wSupportDuplex          = %u", tSetUpInfo.wSupportDuplex );
	CMNAPI::WriteLog( "                pSetUpInfo->dwFadAttachNo           = %u", tSetUpInfo.dwFadAttachNo );
	return bResult;
}

//--------------------------------------------------------------------
bool CNpsLib::npsDevResetEvent( DWORD dwErrHandle, DWORD dwActionId )
{
	bool bResult = true;

	return bResult;
}

//--------------------------------------------------------------------
bool CNpsLib::npsDevIsReady()
{
	long nResult = 0;
	bool bResult = true;

	CMNAPI::WriteLog( "a. npsDevIsReady֐̌ĂяomF" );
	nResult = ::npsDevIsReady( m_hPrinter );
	CMNAPI::WriteLog( "  <API CALL> npsDevIsReady( hPrinter=0x%08X ) = %s",
						m_hPrinter, ConvResultNum2Str(nResult) );

	return bResult;
}
long NPS_API npsDevIsReady( HPRINTER hPrinter );

//--------------------------------------------------------------------
bool CNpsLib::npsDevSetTime( SYSTEMTIME* pTime )
{
	long nResult = 0;
	bool bResult = true;
	NPS_DateTime tDateTime = { 0 };

	tDateTime.tDate.dwYear = pTime->wYear;
	tDateTime.tDate.dwMonth = pTime->wMonth;
	tDateTime.tDate.dwDay = pTime->wDay;
	tDateTime.tDate.dwDayofweek = pTime->wDayOfWeek;
	tDateTime.tTime.dwHour = pTime->wHour;
	tDateTime.tTime.dwMinute = pTime->wMinute;
	tDateTime.tTime.dwSecond = pTime->wSecond;

	CMNAPI::WriteLog( "a. npsDevSetTime֐̌ĂяomF" );
	nResult = ::npsDevSetTime( m_hPrinter, &tDateTime );
	CMNAPI::WriteLog( "  <API CALL> npsDevSetTime( hPrinter=0x%08X, pTime=%04d/%02d/%02d(%d) %02d:%02d:%02d ) = %s",
						m_hPrinter,
						tDateTime.tDate.dwYear, tDateTime.tDate.dwMonth, tDateTime.tDate.dwDay, tDateTime.tDate.dwDayofweek,
						tDateTime.tTime.dwHour, tDateTime.tTime.dwMinute, tDateTime.tTime.dwSecond,
						ConvResultNum2Str(nResult) );

	return bResult;
}

//--------------------------------------------------------------------
bool CNpsLib::npsDevGetTime()
{
	long nResult = 0;
	bool bResult = true;
	NPS_DateTime tDateTime = { 0 };

	CMNAPI::WriteLog( "a. npsDevGetTime֐̌ĂяomF" );
	nResult = ::npsDevGetTime( m_hPrinter, &tDateTime );
	CMNAPI::WriteLog( "  <API CALL> npsDevGetTime( hPrinter=0x%08X, pTime=%04d/%02d/%02d(%d) %02d:%02d:%02d ) = %s",
						m_hPrinter,
						tDateTime.tDate.dwYear, tDateTime.tDate.dwMonth, tDateTime.tDate.dwDay, tDateTime.tDate.dwDayofweek,
						tDateTime.tTime.dwHour, tDateTime.tTime.dwMinute, tDateTime.tTime.dwSecond,
						ConvResultNum2Str(nResult) );

	return bResult;
}

//--------------------------------------------------------------------
bool CNpsLib::npsDevCloseCheck()
{
	bool bResult = true;

	return bResult;
}

//--------------------------------------------------------------------
bool CNpsLib::npsDevGetAllMagInfo( DWORD dwMaxCnt )
{
	WORD wIdx = 0;
	long nResult = 0;
	bool bResult = true;
	DWORD dwSize = 0;
	PNPS_MagDetailInfo pMagDetailInfo = NULL;

	CMNAPI::WriteLog( "a. npsDevGetAllMagInfo֐̌ĂяomF <ő擾=%u>", dwMaxCnt );
	dwSize = sizeof(NPS_MagDetailInfo) * dwMaxCnt;
	if ( 0 < dwMaxCnt )
	{
		pMagDetailInfo = new NPS_MagDetailInfo[dwMaxCnt];
	}
	nResult = ::npsDevGetAllMagInfo( m_hPrinter, pMagDetailInfo, &dwSize );
	CMNAPI::WriteLog( "  <API CALL> npsDevGetAllMagInfo( hPrinter=0x%08X, pMagDetailInfo<ȉQ>, *pdwSize=%u ) = %s", m_hPrinter, dwSize, ConvResultNum2Str(nResult) );
	for ( wIdx=0 ; min( dwMaxCnt, dwSize/sizeof(NPS_MagDetailInfo) ) > wIdx ; wIdx++ )
	{
		CMNAPI::WriteLog( "                pMagDetailInfo[%d] = { dwWidth=%u, dwLengthMin=%u, dwLengthMax=%u, dwSurface=%u, dwResolution={ %u, %u, %u, %u, %u, %u, %u, %u }, nAllocationTop=%u, nAllocationBottom=%d, nAllocationLeft=%d, nAllocationRight=%d, dwSetupStatus=%u, dwFeed=%u, nWBAdjustLeft=%d, nWBAdjustRight=%d, szPaperName=\"%s\", wPaperTypeCode=%u, wDirection=%u, wPrintQuality=%u }",
							wIdx,
							(pMagDetailInfo+wIdx)->dwWidth, (pMagDetailInfo+wIdx)->dwLengthMin, (pMagDetailInfo+wIdx)->dwLengthMax, (pMagDetailInfo+wIdx)->dwSurface,
							(pMagDetailInfo+wIdx)->dwResolution[0], (pMagDetailInfo+wIdx)->dwResolution[1], (pMagDetailInfo+wIdx)->dwResolution[2], (pMagDetailInfo+wIdx)->dwResolution[3],
							(pMagDetailInfo+wIdx)->dwResolution[4], (pMagDetailInfo+wIdx)->dwResolution[5], (pMagDetailInfo+wIdx)->dwResolution[6], (pMagDetailInfo+wIdx)->dwResolution[7],
							(pMagDetailInfo+wIdx)->nAllocationTop, (pMagDetailInfo+wIdx)->nAllocationBottom, (pMagDetailInfo+wIdx)->nAllocationLeft, (pMagDetailInfo+wIdx)->nAllocationRight,
							(pMagDetailInfo+wIdx)->dwSetupStatus, (pMagDetailInfo+wIdx)->dwFeed, (pMagDetailInfo+wIdx)->nWBAdjustLeft, (pMagDetailInfo+wIdx)->nWBAdjustRight,
							(pMagDetailInfo+wIdx)->szPaperName, (pMagDetailInfo+wIdx)->wPaperTypeCode, (pMagDetailInfo+wIdx)->wDirection, (pMagDetailInfo+wIdx)->wPrintQuality );
	}
	if ( NULL != pMagDetailInfo )
	{
		delete [] pMagDetailInfo;
	}

	return bResult;
}

//--------------------------------------------------------------------
bool CNpsLib::npsDevCtrlPrint( DWORD dwCtrl )
{
	long nResult = 0;
	bool bResult = true;

	CMNAPI::WriteLog( "a. npsDevCtrlPrint֐̌ĂяomF" );
	nResult = ::npsDevCtrlPrint( m_hPrinter, dwCtrl );
	CMNAPI::WriteLog( "  <API CALL> npsDevCtrlPrint( hPrinter=0x%08X, dwCtrl=%s ) = %s",
						m_hPrinter, GetString_CtrlPrint(dwCtrl), ConvResultNum2Str(nResult) );

	return bResult;
}

//--------------------------------------------------------------------
bool CNpsLib::npsDevGetProfile()
{
	WORD wIdx = 0;
	long nResult = 0;
	bool bResult = true;
	DWORD dwMaxSize = 0;
	DWORD dwSize = 0;
	PNPS_MagDetailInfo pMagDetailInfo = NULL;
	CString strFileName;
	NPS_PaperInfo tPaperInfo = { 0 };

	CMNAPI::WriteLog( "a. npsDevGetAllMagInfo֐Ăяoă}KW擾" );
	nResult = ::npsDevGetAllMagInfo( m_hPrinter, pMagDetailInfo, &dwMaxSize );
	CMNAPI::WriteLog( "  <API CALL> npsDevGetMagInfo( hPrinter=0x%08X, pMagDetailInfo=0x%08X, *pdwSize=%u ) = %s", m_hPrinter, pMagDetailInfo, dwMaxSize, ConvResultNum2Str(nResult) );

	CMNAPI::WriteLog( "b. npsDevGetAllMagInfo֐Ăяoă}KW擾" );
	dwSize = dwMaxSize;
	pMagDetailInfo = new NPS_MagDetailInfo[dwMaxSize/sizeof(NPS_MagDetailInfo)];
	nResult = ::npsDevGetAllMagInfo( m_hPrinter, pMagDetailInfo, &dwSize );
	CMNAPI::WriteLog( "  <API CALL> npsDevGetMagInfo( hPrinter=0x%08X, pMagDetailInfo<ȉQ>, *pdwSize=%u ) = %s", m_hPrinter, dwSize, ConvResultNum2Str(nResult) );
	for ( wIdx=0 ; min( dwMaxSize/sizeof(NPS_MagDetailInfo), dwSize/sizeof(NPS_MagDetailInfo) ) > wIdx ; wIdx++ )
	{
		CMNAPI::WriteLog( "                pMagDetailInfo[%d] = { dwWidth=%u, dwLengthMin=%u, dwLengthMax=%u, dwSurface=%u, dwResolution={ %u, %u, %u, %u, %u, %u, %u, %u }, nAllocationTop=%u, nAllocationBottom=%d, nAllocationLeft=%d, nAllocationRight=%d, dwSetupStatus=%u, dwFeed=%u, nWBAdjustLeft=%d, nWBAdjustRight=%d, szPaperName=\"%s\", wPaperTypeCode=%u, wDirection=%u, wPrintQuality=%u }",
							wIdx,
							(pMagDetailInfo+wIdx)->dwWidth, (pMagDetailInfo+wIdx)->dwLengthMin, (pMagDetailInfo+wIdx)->dwLengthMax, (pMagDetailInfo+wIdx)->dwSurface,
							(pMagDetailInfo+wIdx)->dwResolution[0], (pMagDetailInfo+wIdx)->dwResolution[1], (pMagDetailInfo+wIdx)->dwResolution[2], (pMagDetailInfo+wIdx)->dwResolution[3],
							(pMagDetailInfo+wIdx)->dwResolution[4], (pMagDetailInfo+wIdx)->dwResolution[5], (pMagDetailInfo+wIdx)->dwResolution[6], (pMagDetailInfo+wIdx)->dwResolution[7],
							(pMagDetailInfo+wIdx)->nAllocationTop, (pMagDetailInfo+wIdx)->nAllocationBottom, (pMagDetailInfo+wIdx)->nAllocationLeft, (pMagDetailInfo+wIdx)->nAllocationRight,
							(pMagDetailInfo+wIdx)->dwSetupStatus, (pMagDetailInfo+wIdx)->dwFeed, (pMagDetailInfo+wIdx)->nWBAdjustLeft, (pMagDetailInfo+wIdx)->nWBAdjustRight,
							(pMagDetailInfo+wIdx)->szPaperName, (pMagDetailInfo+wIdx)->wPaperTypeCode, (pMagDetailInfo+wIdx)->wDirection, (pMagDetailInfo+wIdx)->wPrintQuality );

		tPaperInfo.dwWidth     = (pMagDetailInfo+wIdx)->dwWidth;
		tPaperInfo.dwSurface   = (pMagDetailInfo+wIdx)->dwSurface;
		tPaperInfo.dwFeed      = (pMagDetailInfo+wIdx)->dwFeed;
		strcpy( tPaperInfo.szPaperName, (pMagDetailInfo+wIdx)->szPaperName );
		strFileName.Format( "%snpsDevGetProfile_%u_%u_%s_%s.icc", CMNAPI::GetModuleFolder(), tPaperInfo.dwWidth, tPaperInfo.dwSurface, GetString_Feed(tPaperInfo.dwFeed), tPaperInfo.szPaperName );
		CMNAPI::WriteLog( "c. npsDevGetProfile֐Ăяoăvt@Cf[^擾" );
		nResult = ::npsDevGetProfile( m_hPrinter, strFileName, &tPaperInfo );
		CMNAPI::WriteLog( "  <API CALL> npsDevGetProfile( hPrinter=0x%08X, lpFileName=\"%s\", pPaperInfo={ dwWidth=%u, dwSurface=%u, dwFeed=%u, szPaperName=\"%s\" } ) = %s",
							m_hPrinter, strFileName,
							tPaperInfo.dwWidth, tPaperInfo.dwSurface, tPaperInfo.dwFeed, tPaperInfo.szPaperName,
							ConvResultNum2Str(nResult) );
	}

	if ( NULL != pMagDetailInfo )
	{
		delete [] pMagDetailInfo;
	}

	return bResult;
}

//--------------------------------------------------------------------
bool CNpsLib::npsSetConnectMode( DWORD dwMode )
{
	long nResult = 0;
	bool bResult = true;

	CMNAPI::WriteLog( "a. npsSetConnectMode֐̌ĂяomF" );
	nResult = ::npsSetConnectMode( dwMode );
	CMNAPI::WriteLog( "  <API CALL> npsSetConnectMode( dwMode=%u ) = %s",
						dwMode, ConvResultNum2Str(nResult) );

	return bResult;
}

//--------------------------------------------------------------------
bool CNpsLib::npsDevStartOrder( DWORD dwPriority, DWORD dwSorterNum, DWORD dwSortFrame )
{
	long nResult = 0;
	bool bResult = true;

	return bResult;
}

//--------------------------------------------------------------------
bool CNpsLib::npsDevEndOrder()
{
	long nResult = 0;
	bool bResult = true;

	return bResult;
}
