// DevPrintIccsXmlDlg.cpp : Cve[V t@C
//

#include "stdafx.h"
#include "npsclient.h"
#include "DevPrintIccsXmlDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CDevPrintIccsXmlDlg _CAO

stPriorityString	gPriorityString[] =
{
	{ -3,	"THREAD_PRIORITY_IDLE"			},
	{ -2,	"THREAD_PRIORITY_LOWEST"		},
	{ -1,	"THREAD_PRIORITY_BELOW_NORMAL"	},
	{  0,	"THREAD_PRIORITY_NORMAL"		},
	{  1,	"THREAD_PRIORITY_ABOVE_NORMAL"	},
	{  2,	"THREAD_PRIORITY_HIGHEST"		},
};

CDevPrintIccsXmlDlg::CDevPrintIccsXmlDlg(CWnd* pParent /*=NULL*/)
	: CDevPrintDlg(CDevPrintIccsXmlDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CDevPrintIccsXmlDlg)
	m_strIccsCmdFilePath = _T("");
	//}}AFX_DATA_INIT
}


void CDevPrintIccsXmlDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CDevPrintIccsXmlDlg)
	DDX_Control(pDX, IDC_COMBO_PRIORITY, m_ComboPriority);
	DDX_Text(pDX, IDC_EDIT_ICCS_CMD_FILE_PATH, m_strIccsCmdFilePath);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CDevPrintIccsXmlDlg, CDialog)
	//{{AFX_MSG_MAP(CDevPrintIccsXmlDlg)
	ON_BN_CLICKED(IDC_BUTTON_ICCS_CMD_FILE_PATH, OnButtonIccsCmdFilePath)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDevPrintIccsXmlDlg bZ[W nh

BOOL CDevPrintIccsXmlDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	// TODO: ̈ʒuɏ̕⑫ǉĂ
	for( int nCnt = 0; nCnt < COUNTOF(gPriorityString); nCnt++ )
	{
		m_ComboPriority.AddString( gPriorityString[nCnt].description );

		if( gPriorityString[nCnt].priority == m_pNpsPrintInfo->priority )
		{
			m_ComboPriority.SetCurSel( nCnt );
		}
	}

	m_strIccsCmdFilePath	= m_pNpsPrintInfo->IccsCmdFilePath;

	UpdateData( FALSE );
	
	return TRUE;  // Rg[ɃtH[JXݒ肵ȂƂA߂l TRUE ƂȂ܂
	              // O: OCX vpeB y[W̖߂l FALSE ƂȂ܂
}

void CDevPrintIccsXmlDlg::UpdateMemberData()
{
	UpdateData();

	m_pNpsPrintInfo->priority			= gPriorityString[m_ComboPriority.GetCurSel()].priority;
	strcpy( m_pNpsPrintInfo->IccsCmdFilePath, m_strIccsCmdFilePath );
}

void CDevPrintIccsXmlDlg::OnButtonIccsCmdFilePath() 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	UpdateData( TRUE );

	CFileDialog	wFileDlg( 
					TRUE,
					NULL,
					NULL, 
					OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT, 
					"XML (*.xml)|*.xml|",
					this );

	if( IDOK != wFileDlg.DoModal() )
	{
		return;
	}

	m_strIccsCmdFilePath	= wFileDlg.GetPathName();

	UpdateData( FALSE );
}
