// DevStartRetransmissionDlg.cpp: CDevStartRetransmissionDlg NX̃Cve[V
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "npsclient.h"
#include "OrderManager.h"
#include "DevStartRetransmissionDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CDevStartRetransmissionDlg _CAO


CDevStartRetransmissionDlg::CDevStartRetransmissionDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CDevStartRetransmissionDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CDevStartRetransmissionDlg)
	m_SuspendOrderId = 0;
	m_ResumeOrderId = 0;
	//}}AFX_DATA_INIT
}


void CDevStartRetransmissionDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CDevStartRetransmissionDlg)
	DDX_Control(pDX, IDC_LIST_SUSPEND_ORDER_ID, m_SuspendOrderList);
	DDX_Text(pDX, IDC_EDIT_RESUME_ORDER_ID, m_ResumeOrderId);
	DDV_MinMaxDWord(pDX, m_ResumeOrderId, 0, 4294967295);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CDevStartRetransmissionDlg, CDialog)
	//{{AFX_MSG_MAP(CDevStartRetransmissionDlg)
	ON_NOTIFY(LVN_ITEMCHANGED, IDC_LIST_SUSPEND_ORDER_ID, OnItemchangedListSuspendOrderId)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDevStartRetransmissionDlg bZ[W nh

BOOL CDevStartRetransmissionDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();

	// TODO: ̈ʒuɏ̕⑫ǉĂ
	if( m_SuspendOrderList.LockWindowUpdate() )
	{
		for( int ii = 0; ii < OrderManager::GetOrderSize(); ii++ )
		{
			OrderManager::COrder*	pOrder = OrderManager::GetOrder( ii );
			if( pOrder && pOrder->m_bInterrupted )
			{
				int	index = m_SuspendOrderList.GetItemCount();
				char	buffer[ 32 ];
				sprintf( buffer, "%u", pOrder->m_dwOrderId );
				m_SuspendOrderList.InsertItem( index, buffer );
				m_SuspendOrderList.SetItemData( index, pOrder->m_dwOrderId );

				if( 0 >= index )
				{
					m_SuspendOrderId = pOrder->m_dwOrderId;
				}
			}
		}
		m_SuspendOrderList.UnlockWindowUpdate();
	}

	return TRUE;  // Rg[ɃtH[JXݒ肵ȂƂA߂l TRUE ƂȂ܂
	              // O: OCX vpeB y[W̖߂l FALSE ƂȂ܂
}

void CDevStartRetransmissionDlg::OnItemchangedListSuspendOrderId(NMHDR* pNMHDR, LRESULT* pResult) 
{
	NM_LISTVIEW* pNMListView = (NM_LISTVIEW*)pNMHDR;
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	m_SuspendOrderId = ( DWORD )m_SuspendOrderList.GetItemData( pNMListView->iItem );

	*pResult = 0;
}
