// PrinterState.cpp: CPrinterState NX̃Cve[V
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "NpsServer.h"
#include "PrinterState.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// \z/
//////////////////////////////////////////////////////////////////////

CPrinterState::CPrinterState()
{
	// v^Ŝ̏ iv^S̏ԁj
	// ----------------------------------------
	// 1Fv^
	// @ieiXj
	// 2FACh
	// 3Fvg
	// 4FI
	// 5FPC̃CXg[

	m_nPrinterStatus = 2;

	// t
	// ----------------------------------------
	// 1Fts\
	// 2Ft\

	m_nAcceptStatus = 2;

	// v^L̏
	// ----------------------------------------
	// 1FL
	// 2FʏL
	// 3FLiʏĊJ҂j
	// 4F}[x1]L
	// 5FLi}[x1]ĊJ҂j
	// 6F}[x2]L
	// 7FLi}[x2]ĊJ҂j
	// 8F}[x3]L
	// 9FLi}[x3]ĊJ҂j
	// 10F}[x4]L
	// 11FLi}[x4]ĊJ҂j
	// 12F}[x5]L
	// 13FLi}[x5]ĊJ҂j

	m_nPrinterPossession = 1;

	// v^Ŝ̏ inŚj
	// ----------------------------------------
	// 0FԎ擾s\
	// 1F̗vts
	// 2F̗vt\
	// 3F쒆

	m_nAdvanceStatus = 2;

	// w[U[̏ iw[U[j
	// ----------------------------------------
	// 0FԎ擾s\
	// 1F
	// 2FJnij
	// 3F

	m_nLaserStatus = 3;

	// vZT[Ŝ̏ inŚj
	// ----------------------------------------
	// 0FԎ擾s\
	// 1F̗vts\
	// 2F̗vt\
	// 3F쒆

	m_nDevelopmentStatus = 2;

	// ̏ ij
	// ----------------------------------------
	// 0FԎ擾s\
	// 1F
	// 2Fq[gAbv
	// 3F
	// 4Fs

//	m_nProcessorStatus = 1;
	m_nProcessorStatus = 3;		// 2006.09.28 T.Mizushima

	// [Ŝ̏ i[j
	// ----------------------------------------
	// 0FԎ擾s\
	// 1Fʏ^]
	// 2F[
	// 3FՎU
	// 4FLbg[

	m_nReplenisherStatus = 1;

	// [J[gbW̌̉ i[J[gbWj
	// ----------------------------------------
	// 0FԎ擾s\
	// 1F\
	// 2F[ҋ@
	// 3FJ

	m_nReplaceCartridgeStatus = 1;

	// 2006.09.28 T.Mizushima
	// v^
	// ----------------------------------------
	// 1FfullłȂ
	// 2Ffull

	m_nMemoryStatus = 1;

	// nƓ_̎{
	// ----------------------------------------
	// 0FԎ擾s\
	// 1F{
	// 2F{ς
	m_nStartUpChecksStatus = 2;

	// I[gZbgAbvł̕␅̎{
	// ----------------------------------------
	// 0FԎ擾s\
	// 1F{
	// 2F{ς
	m_nRefillWaterStatus = 2;

	// I[gZbgAbvł̃fC[ZbgAbv̎{
	// ----------------------------------------
	// 0FԎ擾s\
	// 1F{
	// 2F{ς
	m_nDailySetupStatus = 2;

	// I[gZbgAbvł̃Rg[Xgbv̎{
	// ----------------------------------------
	// 0FԎ擾s\
	// 1F{
	// 2F{ς
	m_nControlStripStatus = 2;

	// FAD̏
	// ----------------------------------------
	// 0FԎ擾s\
	// 1FItC
	// 2FN
	// 3FACh
	// 4Fx
	// 5FeiX
	m_nFadStatus = 3;
}

CPrinterState::~CPrinterState()
{

}

// v^Ŝ̏ iv^S̏ԁj
void CPrinterState::SetPrinterStatus( UCHAR nStatus )
{
	if ( m_nPrinterStatus != nStatus ) {
		m_nPrinterStatus = nStatus;
		::GetServerTcpCmd()->OnNotifyPrinterState( 1, m_nPrinterStatus );
	}
}

UCHAR CPrinterState::GetPrinterStatus()
{
	return m_nPrinterStatus;
}

// t
void CPrinterState::SetAcceptStatus( UCHAR nStatus )
{
	if ( m_nAcceptStatus != nStatus ) {
		m_nAcceptStatus = nStatus;
		::GetServerTcpCmd()->OnNotifyPrinterState( 2, m_nAcceptStatus );
	}
}

UCHAR CPrinterState::GetAcceptStatus()
{
	return m_nAcceptStatus;
}

// v^L̏
void CPrinterState::SetPrinterPossession( UCHAR nStatus )
{
	if ( m_nPrinterPossession != nStatus ) {
		m_nPrinterPossession = nStatus;
		::GetServerTcpCmd()->OnNotifyPrinterState( 3, m_nPrinterPossession );
	}
}

UCHAR CPrinterState::GetPrinterPossession()
{
	return m_nPrinterPossession;
}

// v^Ŝ̏ inŚj
void CPrinterState::SetAdvanceStatus( UCHAR nStatus )
{
	if ( 1 == ::GetVirtualPrinter()->m_cPrinterInfo.GetMachineTypeID() )
	{
		// 1FCNWFbg^Cv̏ꍇ͒ʒmȂ
		return;
	}

	if ( m_nAdvanceStatus != nStatus ) {
		m_nAdvanceStatus = nStatus;
		::GetServerTcpCmd()->OnNotifyPrinterState( 5, m_nAdvanceStatus );
	}
}

UCHAR CPrinterState::GetAdvanceStatus()
{
	return m_nAdvanceStatus;
}

// w[U[̏ iw[U[j
void CPrinterState::SetLaserStatus( UCHAR nStatus )
{
	if ( 1 == ::GetVirtualPrinter()->m_cPrinterInfo.GetMachineTypeID() )
	{
		// 1FCNWFbg^Cv̏ꍇ͒ʒmȂ
		return;
	}

	if ( m_nLaserStatus != nStatus ) {
		m_nLaserStatus = nStatus;
		::GetServerTcpCmd()->OnNotifyPrinterState( 6, m_nLaserStatus );
	}
}

UCHAR CPrinterState::GetLaserStatus()
{
	return m_nLaserStatus;
}

// vZT[Ŝ̏ inŚj
void CPrinterState::SetDevelopmentStatus( UCHAR nStatus )
{
	if ( 1 == ::GetVirtualPrinter()->m_cPrinterInfo.GetMachineTypeID() )
	{
		// 1FCNWFbg^Cv̏ꍇ͒ʒmȂ
		return;
	}

	if ( m_nDevelopmentStatus != nStatus ) {
		m_nDevelopmentStatus = nStatus;
		::GetServerTcpCmd()->OnNotifyPrinterState( 7, m_nDevelopmentStatus );
	}
}

UCHAR CPrinterState::GetDevelopmentStatus()
{
	return m_nDevelopmentStatus;
}

// ̏ ij
void CPrinterState::SetProcessorStatus( UCHAR nStatus )
{
	if ( 1 == ::GetVirtualPrinter()->m_cPrinterInfo.GetMachineTypeID() )
	{
		// 1FCNWFbg^Cv̏ꍇ͒ʒmȂ
		return;
	}

	if ( m_nProcessorStatus != nStatus ) {
		m_nProcessorStatus = nStatus;
		::GetServerTcpCmd()->OnNotifyPrinterState( 8, m_nProcessorStatus );
	}
}

UCHAR CPrinterState::GetProcessorStatus()
{
	return m_nProcessorStatus;
}

// [Ŝ̏ i[j
void CPrinterState::SetReplenisherStatus( UCHAR nStatus )
{
	if ( 1 == ::GetVirtualPrinter()->m_cPrinterInfo.GetMachineTypeID() )
	{
		// 1FCNWFbg^Cv̏ꍇ͒ʒmȂ
		return;
	}

	if ( m_nReplenisherStatus != nStatus ) {
		m_nReplenisherStatus = nStatus;
		::GetServerTcpCmd()->OnNotifyPrinterState( 9, m_nReplenisherStatus );
	}
}

UCHAR CPrinterState::GetReplenisherStatus()
{
	return m_nReplenisherStatus;
}

// [J[gbW̌̉ i[J[gbWj
void CPrinterState::SetReplaceCartridgeStatus( UCHAR nStatus )
{
	if ( 1 == ::GetVirtualPrinter()->m_cPrinterInfo.GetMachineTypeID() )
	{
		// 1FCNWFbg^Cv̏ꍇ͒ʒmȂ
		return;
	}

	if ( m_nReplaceCartridgeStatus != nStatus ) {
		m_nReplaceCartridgeStatus = nStatus;
		::GetServerTcpCmd()->OnNotifyPrinterState( 10, m_nReplaceCartridgeStatus );
	}
}

UCHAR CPrinterState::GetReplaceCartridgeStatus()
{
	return m_nReplaceCartridgeStatus;
}

// nƓ_̎{
void CPrinterState::SetStartUpChecksStatus( UCHAR nStatus )
{
//	if ( 1 == ::GetVirtualPrinter()->m_cPrinterInfo.GetMachineTypeID() )	// Added by H.Yoshida	2007.02.21 CNWFbgłʒm
//	{
//		// 1FCNWFbg^Cv̏ꍇ͒ʒmȂ
//		return;
//	}

	if ( m_nStartUpChecksStatus != nStatus ) {
		m_nStartUpChecksStatus = nStatus;
		::GetServerTcpCmd()->OnNotifyPrinterState( 12, m_nStartUpChecksStatus );
	}
}

UCHAR CPrinterState::GetStartUpChecksStatus()
{
	return m_nStartUpChecksStatus;
}

// I[gZbgAbvł̕␅̎{
void CPrinterState::SetRefillWaterStatus( UCHAR nStatus )
{
	if ( 1 == ::GetVirtualPrinter()->m_cPrinterInfo.GetMachineTypeID() )
	{
		// 1FCNWFbg^Cv̏ꍇ͒ʒmȂ
		return;
	}

	if ( m_nRefillWaterStatus != nStatus ) {
		m_nRefillWaterStatus = nStatus;
		::GetServerTcpCmd()->OnNotifyPrinterState( 13, m_nRefillWaterStatus );
	}
}

UCHAR CPrinterState::GetRefillWaterStatus()
{
	return m_nRefillWaterStatus;
}

// I[gZbgAbvł̃fC[ZbgAbv̎{
void CPrinterState::SetDailySetupStatus( UCHAR nStatus )
{
	if ( 1 == ::GetVirtualPrinter()->m_cPrinterInfo.GetMachineTypeID() )
	{
		// 1FCNWFbg^Cv̏ꍇ͒ʒmȂ
		return;
	}

	if ( m_nDailySetupStatus != nStatus ) {
		m_nDailySetupStatus = nStatus;
		::GetServerTcpCmd()->OnNotifyPrinterState( 14, m_nDailySetupStatus );
	}
}

UCHAR CPrinterState::GetDailySetupStatus()
{
	return m_nDailySetupStatus;
}

// I[gZbgAbvł̃Rg[Xgbv̎{
void CPrinterState::SetControlStripStatus( UCHAR nStatus )
{
	if ( 1 == ::GetVirtualPrinter()->m_cPrinterInfo.GetMachineTypeID() )
	{
		// 1FCNWFbg^Cv̏ꍇ͒ʒmȂ
		return;
	}

	if ( m_nControlStripStatus != nStatus ) {
		m_nControlStripStatus = nStatus;
		::GetServerTcpCmd()->OnNotifyPrinterState( 15, m_nControlStripStatus );
	}
}

UCHAR CPrinterState::GetControlStripStatus()
{
	return m_nControlStripStatus;
}

// FAD̏
void CPrinterState::SetFadStatus( UCHAR nStatus )
{
	if ( 0 == ::GetVirtualPrinter()->m_cPrinterConfig.GetFadAttachNo() )
	{
		// FADڑ̏ꍇ͒ʒmȂ
		return;
	}

	if ( m_nFadStatus != nStatus ) {
		m_nFadStatus = nStatus;
		::GetServerTcpCmd()->OnNotifyPrinterState( 17, m_nFadStatus );
	}
}

UCHAR CPrinterState::GetFadStatus()
{
	return m_nFadStatus;
}

// /r
CPrinterState& CPrinterState::operator=(CPrinterState& src)
{
	SetPrinterStatus( src.GetPrinterStatus() );
	SetAcceptStatus( src.GetAcceptStatus() );
	SetPrinterPossession( src.GetPrinterPossession() );
	SetAdvanceStatus( src.GetAdvanceStatus() );
	SetLaserStatus( src.GetLaserStatus() );
	SetDevelopmentStatus( src.GetDevelopmentStatus() );
	SetProcessorStatus( src.GetProcessorStatus() );
	SetReplenisherStatus( src.GetReplenisherStatus() );
	SetReplaceCartridgeStatus( src.GetReplaceCartridgeStatus() );
	SetStartUpChecksStatus( src.GetStartUpChecksStatus() );
	SetRefillWaterStatus( src.GetRefillWaterStatus() );
	SetDailySetupStatus( src.GetDailySetupStatus() );
	SetControlStripStatus( src.GetControlStripStatus() );
	SetFadStatus( src.GetFadStatus() );

	return *this;
}

BOOL CPrinterState::operator==(CPrinterState& src)
{
	if ( m_nPrinterStatus			!= src.GetPrinterStatus() )				return FALSE;
	if ( m_nAcceptStatus			!= src.GetAcceptStatus() )				return FALSE;
	if ( m_nPrinterPossession		!= src.GetPrinterPossession() )			return FALSE;
	if ( m_nAdvanceStatus			!= src.GetAdvanceStatus() )				return FALSE;
	if ( m_nLaserStatus				!= src.GetLaserStatus() )				return FALSE;
	if ( m_nDevelopmentStatus		!= src.GetDevelopmentStatus() )			return FALSE;
	if ( m_nProcessorStatus			!= src.GetProcessorStatus() )			return FALSE;
	if ( m_nReplenisherStatus		!= src.GetReplenisherStatus() )			return FALSE;
	if ( m_nReplaceCartridgeStatus	!= src.GetReplaceCartridgeStatus() )	return FALSE;
	if ( m_nStartUpChecksStatus		!= src.GetStartUpChecksStatus() )		return FALSE;
	if ( m_nRefillWaterStatus		!= src.GetRefillWaterStatus() )			return FALSE;
	if ( m_nDailySetupStatus		!= src.GetDailySetupStatus() )			return FALSE;
	if ( m_nControlStripStatus		!= src.GetControlStripStatus() )		return FALSE;
	if ( m_nFadStatus				!= src.GetFadStatus() )					return FALSE;

	return TRUE;
}

BOOL CPrinterState::operator!=(CPrinterState& src)
{
	if ( m_nPrinterStatus			!= src.GetPrinterStatus() )				return TRUE;
	if ( m_nAcceptStatus			!= src.GetAcceptStatus() )				return TRUE;
	if ( m_nPrinterPossession		!= src.GetPrinterPossession() )			return TRUE;
	if ( m_nAdvanceStatus			!= src.GetAdvanceStatus() )				return TRUE;
	if ( m_nLaserStatus				!= src.GetLaserStatus() )				return TRUE;
	if ( m_nDevelopmentStatus		!= src.GetDevelopmentStatus() )			return TRUE;
	if ( m_nProcessorStatus			!= src.GetProcessorStatus() )			return TRUE;
	if ( m_nReplenisherStatus		!= src.GetReplenisherStatus() )			return TRUE;
	if ( m_nReplaceCartridgeStatus	!= src.GetReplaceCartridgeStatus() )	return TRUE;
	if ( m_nStartUpChecksStatus		!= src.GetStartUpChecksStatus() )		return TRUE;
	if ( m_nRefillWaterStatus		!= src.GetRefillWaterStatus() )			return TRUE;
	if ( m_nDailySetupStatus		!= src.GetDailySetupStatus() )			return TRUE;
	if ( m_nControlStripStatus		!= src.GetControlStripStatus() )		return TRUE;
	if ( m_nFadStatus				!= src.GetFadStatus() )					return TRUE;

	return FALSE;
}

// 2006.09.28 T.Mizushima
// v^
void CPrinterState::SetMemoryStatus( UCHAR nStatus )
{
	if ( m_nMemoryStatus != nStatus ) {
		m_nMemoryStatus = nStatus;

	}
}

UCHAR CPrinterState::GetMemoryStatus()
{
	return m_nMemoryStatus;
}
