//////////////////////////////////////////////////////////////////////////////
//	FILE NAME : PrinterState.h
//	ABSTRACT  : v^ԏǗNX
//	
//	CREATE    : Y.Yoshinobu	2006.10.20
//	UPDATE    : 
//	
//										(C)Copyright : Noritsu Koki CO.,LTD.
//////////////////////////////////////////////////////////////////////////////

#if !defined(AFX_PRINTERSTATE_H__F39E6766_CB96_48B8_A592_8062F51039C5__INCLUDED_)
#define AFX_PRINTERSTATE_H__F39E6766_CB96_48B8_A592_8062F51039C5__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

class CPrinterState  
{
public:
	CPrinterState();
	virtual ~CPrinterState();

	//////////////////////////////
	// o֐
	//////////////////////////////

	// v^Ŝ̏ iv^S̏ԁj
	void	SetPrinterStatus( UCHAR nStatus );
	UCHAR	GetPrinterStatus();

	// t
	void	SetAcceptStatus( UCHAR nStatus );
	UCHAR	GetAcceptStatus();

	// v^L̏
	void	SetPrinterPossession( UCHAR nStatus );
	UCHAR	GetPrinterPossession();

	// v^Ŝ̏ inŚj
	void	SetAdvanceStatus( UCHAR nStatus );
	UCHAR	GetAdvanceStatus();

	// w[U[̏ iw[U[j
	void	SetLaserStatus( UCHAR nStatus );
	UCHAR	GetLaserStatus();

	// vZT[Ŝ̏ inŚj
	void	SetDevelopmentStatus( UCHAR nStatus );
	UCHAR	GetDevelopmentStatus();

	// ̏ ij
	void	SetProcessorStatus( UCHAR nStatus );
	UCHAR	GetProcessorStatus();

	// [Ŝ̏ i[j
	void	SetReplenisherStatus( UCHAR nStatus );
	UCHAR	GetReplenisherStatus();

	// [J[gbW̌̉ i[J[gbWj
	void	SetReplaceCartridgeStatus( UCHAR nStatus );
	UCHAR	GetReplaceCartridgeStatus();

	// /r
	CPrinterState& operator=(CPrinterState& src);
	BOOL	operator==(CPrinterState& src);
	BOOL	operator!=(CPrinterState& src);

	// 2006.09.28 T.Mizushima
	// v^
	void	SetMemoryStatus( UCHAR nStatus );
	UCHAR	GetMemoryStatus();

	// nƓ_̎{
	void	SetStartUpChecksStatus( UCHAR nStatus );
	UCHAR	GetStartUpChecksStatus();

	// I[gZbgAbvł̕␅̎{
	void	SetRefillWaterStatus( UCHAR nStatus );
	UCHAR	GetRefillWaterStatus();

	// I[gZbgAbvł̃fC[ZbgAbv̎{
	void	SetDailySetupStatus( UCHAR nStatus );
	UCHAR	GetDailySetupStatus();

	// I[gZbgAbvł̃Rg[Xgbv̎{
	void	SetControlStripStatus( UCHAR nStatus );
	UCHAR	GetControlStripStatus();

	// FAD̏
	void	SetFadStatus( UCHAR nStatus );
	UCHAR	GetFadStatus();

private:

	//////////////////////////////
	// oϐ
	//////////////////////////////

	UCHAR	m_nPrinterStatus;			// v^Ŝ̏ iv^S̏ԁj
	UCHAR	m_nAcceptStatus;			// t
	UCHAR	m_nPrinterPossession;		// v^L̏
	UCHAR	m_nAdvanceStatus;			// v^Ŝ̏ inŚj
	UCHAR	m_nLaserStatus;				// w[U[̏ iw[U[j
	UCHAR	m_nDevelopmentStatus;		// vZT[Ŝ̏ inŚj
	UCHAR	m_nProcessorStatus;			// ̏ ij
	UCHAR	m_nReplenisherStatus;		// [Ŝ̏ i[j
	UCHAR	m_nReplaceCartridgeStatus;	// [J[gbW̌̉ i[J[gbWj
	UCHAR	m_nStartUpChecksStatus;		// nƓ_̎{
	UCHAR	m_nRefillWaterStatus;		// I[gZbgAbvł̕␅̎{
	UCHAR	m_nDailySetupStatus;		// I[gZbgAbvł̃fC[ZbgAbv̎{
	UCHAR	m_nControlStripStatus;		// I[gZbgAbvł̃Rg[Xgbv̎{
	UCHAR	m_nFadStatus;				// FAD̏

	// 2006.09.28 T.Mizushima
	UCHAR	m_nMemoryStatus;			// v^
};

#endif // !defined(AFX_PRINTERSTATE_H__F39E6766_CB96_48B8_A592_8062F51039C5__INCLUDED_)
