// Frame.h: CFrame NX̃C^[tFCX
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_FRAME_H__C3E1259E_91E4_4712_9AC7_97080925C80C__INCLUDED_)
#define AFX_FRAME_H__C3E1259E_91E4_4712_9AC7_97080925C80C__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

enum ENUM_DUPLEX_TYPE {
	SINGLE,			// Ж
	DUPLEX_FRONT,	// (\)
	DUPLEX_BACK,	// ()
};

enum ENUM_ACCURACY_TYPE {
	IMAGE_TYPE1,	// x摜^Cv1 (XP[)
	IMAGE_TYPE2,	// x摜^Cv2 (XP[ + Oghׂ)
};

typedef struct {
	DWORD	dwResolution;
	DWORD	dwPaperWidth;
	DWORD	dwPaperLength;
	DWORD	dwPrintNum;
	DWORD	dwSurface;
	DWORD	dwFeed;
	CHAR	szPaperName[32];
	RECT	tSpillOver;
	ENUM_ACCURACY_TYPE	eAccuracyType;		// vg摜^Cv
	ENUM_DUPLEX_TYPE	eDuplexType;		// Ж/ʃtO
} T_FRAME_PARAM;

typedef struct {
	DWORD	dwRepeat;
	DWORD	dwTransfer;
	DWORD	dwPrint;
	DWORD	dwOutput;
} T_FRAME_STATUS;

class CFrame  
{
public:
	CFrame() {
		m_dwPrintID = 0;
		m_bFrameEnd = FALSE;
		::ZeroMemory( &m_tFrameParam, sizeof(T_FRAME_PARAM) );
		::ZeroMemory( &m_tFrameStatus, sizeof(T_FRAME_STATUS) );
	};
	virtual ~CFrame() {
		if ( FALSE == m_strFileName.IsEmpty() )
		{
			::DeleteFile( m_strFileName );
		}
	};

	CString GetStatusString() {
		if ( TRUE == m_bFrameEnd )
		{
			if ( m_tFrameStatus.dwRepeat > m_tFrameStatus.dwOutput )
			{
				return CString( _T("rI") );
			}
			return CString( _T("I") );
		}
		return CString( _T("") );
	}

	CString GetDuplexTypeString() {
		CString str;
		switch ( m_tFrameParam.eDuplexType )
		{
		case SINGLE:		str = _T("");	break;
		case DUPLEX_FRONT:	str = _T("(\)");	break;
		case DUPLEX_BACK:	str = _T("()");	break;
		}
		return str;
	};

public:

	DWORD					m_dwPrintID;
	CString					m_strFileName;		// 摜t@Cւ̃tpX
	BOOL					m_bFrameEnd;		// ItO ( TRUE:I, FALSE: )

	T_FRAME_PARAM			m_tFrameParam;
	T_FRAME_STATUS			m_tFrameStatus;
};

#endif // !defined(AFX_FRAME_H__C3E1259E_91E4_4712_9AC7_97080925C80C__INCLUDED_)
