#ifndef NKC_IMAGE_FILE_BMP_L1_H
#define NKC_IMAGE_FILE_BMP_L1_H
#include "NKC_Image_File.h"

/*
	m[c|@p File I/O Interface: BMP Interface Level-1 Class

	Copyright(C) 2000 Ichikawa Soft Laboratory

	ClassBMPLevel-1Access邽߂Interface ClassłB

*/

// (NIFIO0005)
class NKC_Image_File_BMP_L1 : public NKC_Image_File {
public:
	virtual ~NKC_Image_File_BMP_L1() {};
public:
	// oR FileOpen ////////////////////////////////////////////////////////////////////
	virtual BOOL	OpenBuf( void** pbuf, int* size, UINT flags ) = 0;
	/*
	Input:	pbuf	Open File ̃C[Wւ̃|C^ւ̃|C^
			size	pbuf ̃oCgւ̃|C^
			flags	Ǎ/݂̎wȂ(̐ݒ\)
			  Open Mode: ȉ̂ÂꂩPI܂
			  NKC_Image_File::modeRead			t@CǂݏopŊJ܂
			  NKC_Image_File::modeWrite			t@CݐpŊJ܂		  
			  NKC_Image_File::modeThumbnailRead TlCǍ݂̏ꍇ
			  Format`Fȉ̂ÂꂩPI܂
	 (Default)NKC_Image_File::BGR24				24bitDIB`̉摜Datagp
			  NKC_Image_File::BGR32				32bitDIB`̉摜Datagp
			  NKC_Image_File::RGB24				24bitRGB`̉摜Datagp
			  NKC_Image_File::RGB32				32bitRGB`̉摜Datagp
	Return: ǂ
	*/

	// FileClose
	BOOL	Close() = 0;

	// Open(void**, int*, UINT modeWrite) ̏ꍇ̎ۃobt@̎QƂI
	virtual	BOOL CloseBuf() = 0;
	/*
	Return: ǂ
	*/
};
#endif	// NKC_IMAGE_FILE_BMP_L1_H