#ifndef NKC_IMAGE_FILE_JPG_L1_H
#define NKC_IMAGE_FILE_JPG_L1_H
#include "NKC_Image_File.h"

/*
	m[c|@p File I/O Interface: JPG(Jpeg File) Interface Level-1 Class

	Copyright(C) 2000 Ichikawa Soft Laboratory

	ClassJPG(Jpeg File)Level-1Access邽߂Interface ClassłB

*/

class NKC_Image_File_JPG_L1 : public NKC_Image_File {
public:
	// ۑ`̐ݒp萔̒` ////////////////////////////////////////////////////
	enum {
		Normal = 0,
		Progressive = 1,
		Exif = 2
	};
public:
	virtual ~NKC_Image_File_JPG_L1() {};
public:
	// iW̐ݒ(ݎ̋@\) ////////////////////////////////////////////////
	virtual void		SetQuality( int quality ) = 0;
	/*
	Input:	quality	iW(0`100)
	*/
	// ۑ`̐ݒ(ݎ̋@\) ////////////////////////////////////////////////
	virtual BOOL		SetWriteMode( UINT mode = Normal ) = 0;
	/*
	Input:  mode	ۑ`:ȉ̂ÂꂩPI܂
	(Default)	NKC_Image_File_JPG_L1::Normal			ʏJpeg`ŕۑ̏ꍇ
				NKC_Image_File_JPG_L1::Progressive		ProgressiveJpegŕۑ̏ꍇ
				NKC_Image_File_JPG_L1::Exif				Exif/DCF`ŕۑ̏ꍇ
	Return:	ۑ`̐ݒɐǂ
	*/
};
#endif	// NKC_IMAGE_FILE_JPG_L1_H
