//////////////////////////////////////////////////////////////////////////////
//   File Name   : NkcComApi.h
//   Contents    : ʊ֐
//					
//   Author/Date : Y.Yoshinobu	2006.07.05
//	                                    (C)Copyright : Noritsu Koki CO.,LTD.
//////////////////////////////////////////////////////////////////////////////
#ifndef _NKCCOMAPI_H_
#define _NKCCOMAPI_H_

#include <afxwin.h>         // MFC ̃RAѕWR|[lg
#include <afxext.h>         // MFC ̊g
#include <afxdtctl.h>		// MFC  Internet Explorer 4 R Rg[ T|[g

#include <afxpriv.h>

#include <winsock2.h>		// WinSock 2.0
#include <mswsock.h>		// Microsoft Windows Socket

#include <Shlwapi.h>

#include "Nps.h"

//ʃ}N
#if !defined(COUNTOF)
	#define COUNTOF(xxxx)		(sizeof(xxxx)/sizeof(xxxx[0]))
#endif

#define WIDTHBYTES(bits)	(((bits) + 31) / 32 * 4)

enum E_TempMode
{
	TEMP_TEMP	= 0,	// TEMPtH_
	TEMP_CURRENT,		// JgtH_
};

//======================================================================
// ʃNX
//======================================================================
class CUnduplicationCheckObject {
protected:
	HANDLE m_handle;
public:
	CUnduplicationCheckObject():m_handle(NULL){;}
	~CUnduplicationCheckObject()
	{
		if(m_handle != NULL) {
			::CloseHandle(m_handle);
		}
	}
	BOOL Regist(LPSTR exename)
	{
		if ( m_handle != NULL )
		{
			::CloseHandle(m_handle);
		}
		m_handle = ::CreateMutex(NULL,FALSE,exename);
		if ( ::WaitForSingleObject(m_handle,0) == WAIT_OBJECT_0 )
		{
			return TRUE;
		}
		return FALSE;
	}
};


//======================================================================
// ʊ֐
//======================================================================
namespace NkcComApi {

	//----------------------------------------
	// \PbgʐM֌W
	//----------------------------------------

	// hostent ^̃f[^AzXg̖O擾܂
	CString GetHostName( hostent* p );

	// hostent ^̃f[^AzXg̃AhX擾܂
	CString GetHostAddr( hostent* p );

	// lbg[NoCgI[_[zXgoCgI[_[ɕϊ܂
	unsigned short ntohs( unsigned short netshort );		// short^
	unsigned long ntohl( unsigned long netlong );			// long^
	unsigned __int64 ntohi64( unsigned __int64 netint64 );	// int64^
	float ntohf( float netfloat );							// float^

	// zXgoCgI[_[lbg[NoCgI[_[ɕϊ܂
	unsigned short htons( unsigned short hostshort );		// short^
	unsigned long htonl( unsigned long hostlong );			// long^
	unsigned __int64 htoni64( unsigned __int64 hostint64 );	// int64^
	float htonf( float hostfloat );							// float^

	// WinSock 2.2 gpł悤ɂ
	BOOL WinSockStartup();

	// WinSock 2.2 ̎gpJ܂
	BOOL WinSockCleanup();

	// Ping
	BOOL PingEx(LPCSTR pstrHost);

	//----------------------------------------
	// t@C֌W
	//----------------------------------------

	// t@CTCY擾܂
	unsigned long GetFileSize( LPCTSTR lpFilePath );

	// t@C̃f[^ǂݍŃփRs[܂
	BOOL ReadFileToMemory( LPCTSTR lpFilePath, unsigned long nOffset, unsigned long nReadSize, LPBYTE lpBuffer );

	// L̏t@Cɕۑ܂
	BOOL WriteFileByMmf( LPCTSTR lpFilePath, LPCTSTR lpMmfName, unsigned long nOffset, unsigned long nDataSize );

	// t@Cꕔ𔲂oāAʂ̃t@Cɕۑ܂
	BOOL CopyFileMid( LPCTSTR lpInFileName, LPCTSTR lpOutFileName, unsigned long nOffset, unsigned long nDataSize );

	// e|t@C̎擾
	CString GetTempFolderPath( E_TempMode eMode );
	CString GetTempFilePath( E_TempMode eMode );
	BOOL GetTempFilePath( E_TempMode eMode, LPCTSTR lpExt, LPTSTR lpFilePath );

	// tH_ƃt@CătpX쐬܂
	CString MakeFullPath( LPCTSTR lpFolderPath, LPCTSTR lpFileName );

	// w肳ꂽtH_쐬i΃pXwj
	BOOL CreateFolder( LPCTSTR lpFolder );

	// tH_̒Sč폜iw肳ꂽtH_͏Ȃj
	BOOL ClearFolder( LPCTSTR lpFolder );

	// 24bit Windows BMP ǂ̊mF
	BOOL IsBmp24( LPCTSTR lpFilePath );

	// BITMAP̉摜f[^1C̃f[^ʂZo
	DWORD DIBWidthBytes(DWORD dwWidth,int nBitCnt);

#if defined(NPS_CUSTOM_EDG)
	// tH[}bgϊi t@C ==> t@C j
	BOOL FileConvertJpgToRaw( HMODULE hInst, LPCTSTR lpInFilePath, LPCTSTR lpOutFilePath, SIZE* pImgSize );
	BOOL FileConvertBmpToRaw( HMODULE hInst, LPCTSTR lpInFilePath, LPCTSTR lpOutFilePath, SIZE* pImgSize );
	BOOL FileConvertTifToRaw( HMODULE hInst, LPCTSTR lpInFilePath, LPCTSTR lpOutFilePath, SIZE* pImgSize );
	BOOL FileConvertJpgToBmp( HMODULE hInst, LPCTSTR lpInFilePath, LPCTSTR lpOutFilePath, SIZE* pImgSize );
	BOOL FileConvertBmpToBmp( HMODULE hInst, LPCTSTR lpInFilePath, LPCTSTR lpOutFilePath, SIZE* pImgSize );
	BOOL FileConvertTifToBmp( HMODULE hInst, LPCTSTR lpInFilePath, LPCTSTR lpOutFilePath, SIZE* pImgSize );
	BOOL FileConvertJpgToBmp( LPCTSTR lpInFilePath, LPCTSTR lpOutFilePath, SIZE* pImgSize = NULL );
	BOOL FileConvertBmpToBmp( LPCTSTR lpInFilePath, LPCTSTR lpOutFilePath, SIZE* pImgSize = NULL );
	BOOL FileConvertTifToBmp( LPCTSTR lpInFilePath, LPCTSTR lpOutFilePath, SIZE* pImgSize = NULL );
	BOOL FileConvertJpgToRaw( LPCTSTR lpInFilePath, LPCTSTR lpOutFilePath, SIZE* pImgSize );
	BOOL FileConvertBmpToRaw( LPCTSTR lpInFilePath, LPCTSTR lpOutFilePath, SIZE* pImgSize );
	BOOL FileConvertTifToRaw( LPCTSTR lpInFilePath, LPCTSTR lpOutFilePath, SIZE* pImgSize );
	BOOL FileConvertBmpToJpg( LPCTSTR lpInFilePath, LPCTSTR lpOutFilePath, SIZE* pImgSize = NULL );

	BOOL GetBmpInfo( LPCTSTR lpFilePath, SIZE* pSize );

	BOOL ReadProcBmp( LPCTSTR lpFilePath, SIZE* pSize, LPVOID pImg );

	BOOL WriteProcJpg( LPCTSTR lpFilePath, SIZE* pSize, int nQuality, LPVOID pImg );
#endif // defined(NPS_CUSTOM_EDG)

	//----------------------------------------
	// Ԋ֌W
	//----------------------------------------

	// j	0ijj-6iyjj擾܂
	DWORD GetDayofweek(
						DWORD	dwYear,			// N	1980-2079
						DWORD	dwMonth,		// 	1-12
						DWORD	dwDay			// 	1-31
						);

	// UTCLocalTimeɕϊ܂
	SYSTEMTIME MyUTCToLocalTime( SYSTEMTIME utc );

	//----------------------------------------
	// NeBJZNV֌W
	//----------------------------------------

	// XR[v͈͂̃NeBJZNṼbNs܂
	class CCSScopeLock
	{
	private:
		CRITICAL_SECTION*	m_pCS;
	public:
		CCSScopeLock( CRITICAL_SECTION* pCS )	{ m_pCS	= pCS; ::EnterCriticalSection( m_pCS ); }
		~CCSScopeLock()	{ ::LeaveCriticalSection( m_pCS ); }
	};


	//----------------------------------------
	// 񑀍
	//----------------------------------------

	// ","J}ŋ؂ꂽ擾܂
	BOOL CommaFieldSeparate( int nPos, LPSTR lpSrc, LPSTR lpDest );

	//----------------------------------------
	// WXgANZX
	//----------------------------------------

	// WXg當擾܂
	BOOL GetRegString( HKEY hKey, LPCTSTR lpSubKey, LPCTSTR lpValueName, CString& string, CString* pstrErrMsg = NULL );

	//----------------------------------------
	// vZXN
	//----------------------------------------

	// vZXN
	BOOL StartProcess( LPCTSTR lpCommandLine, BOOL bInitWait = FALSE );

	// @햼ɂOEMv^[𒲂ׂ
	BOOL IsOemPrinterByName(LPCTSTR szName);

	// @햼ɂm[cv^[𒲂ׂ
	BOOL IsNoritsuPrinterByName(LPCTSTR szName);

	// @햼HUBXΉv^[𔻒f
	BOOL IsNotSupportHublessByName(LPCTSTR szName);

	// OEMR[hɂm[cv^[𒲂ׂ
	BOOL IsNoritsuPrinterByCode(const UCHAR Code);

	//----------------------------------------
	// rbg}bv
	//----------------------------------------
	
	// sNZɑ΂4oCgACgvZ
	int RowByte(int w);

}	// namespace NkcComApi


#endif // _NKCCOMAPI_H_
