// NpsBcThread.h: CNpsBcThread NX̃C^[tFCX
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_NPSBCTHREAD_H__F9DAD04D_BB56_4F18_9FC6_3724ACCA149C__INCLUDED_)
#define AFX_NPSBCTHREAD_H__F9DAD04D_BB56_4F18_9FC6_3724ACCA149C__INCLUDED_

#include <vector>
#include "NpsCommand.h"

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000


// v^[ƍNX							2008.10.24 S.Heya
class CNpsPrinterChecker;

//////////////////////////////////////////////////////////////////////
// \

// v^\
typedef struct
{
	TCHAR				szIP[16];		// IPAhX
	union
	{
		T_Nps000FH_0101H	Nps000FH_0101H;	// v^m
		T_Nps000FH_0201H	Nps000FH_0201H;	// v^m2
	};
	USHORT				wType;			// v^mʁi0:v^mA1:v^m2j

} T_NpsPrinterInfo;

//////////////////////////////////////////////////////////////////////
// ֐`

// M̃Xbh̃Gg
unsigned int WINAPI NpsBcThreadEntry( LPVOID pParam );

//////////////////////////////////////////////////////////////////////
// NX`

class CNpsBcThread  
{
public:
	CNpsBcThread(CNpsPrinterChecker* pNpsPrinterChecker = NULL); // 2008.10.24 S.Heya
	virtual ~CNpsBcThread();

	//----------------------------------------------------------------------------
	// ֌W
	//----------------------------------------------------------------------------

	//----------------------------------------------------------------------------
	// jLXgݒ
	//----------------------------------------------------------------------------
	void	SetUnicast() { m_bUnicast = TRUE; }

	void	SetMyPCAddr( DWORD dwInAddr );					// PC̃AhXZbg
	int		GetPrinterCount();								// v^̎擾
	BOOL	GetPrinterInfo( int nIdx, T_NpsPrinterInfo* pPrinterInfo );	// v^̎擾

	void	ThreadEnd();									// MXbhIv

	//----------------------------------------------------------------------------
	// MXbh֌W
	//----------------------------------------------------------------------------

	BOOL	ThreadInitInstance();							// MXbhJn

	void	ThreadExecProc();								// MXbh

	void	ThreadExitInstance();							// MXbhI


protected:

	//----------------------------------------------------------------------------
	// jLXgݒ
	//----------------------------------------------------------------------------
	BOOL	m_bUnicast;

	//----------------------------------------------------------------------------
	// u[hLXgR}h̑M
	//----------------------------------------------------------------------------

	BOOL	SendSearchCmd();								// v^mR}hM
	BOOL	SendSearchCmd2();								// v^m2R}hM

	//----------------------------------------------------------------------------
	// \Pbg֌W
	//----------------------------------------------------------------------------

	SOCKET	m_Socket;										// Mp\Pbg

	DWORD	m_dwInAddr;										// PCIPAhX

	//----------------------------------------------------------------------------
	// v^֌W
	//----------------------------------------------------------------------------

	std::vector<T_NpsPrinterInfo>	m_vPrinterInfo;			// v^̃Xg

	void	AddPrinterInfo( LPBYTE lpBuffer, DWORD dwHostAddress, TCHAR * szHostAddress );			// v^̒ǉ
	void	AddPrinterInfoOld( LPBYTE lpBuffer, DWORD dwHostAddress, TCHAR * szHostAddress );		// v^̒ǉ(000FH/0101Hp)
	void	AddPrinterInfoNew( LPBYTE lpBuffer, DWORD dwHostAddress, TCHAR * szHostAddress );		// v^̒ǉ(000FH/0201Hp)
	BOOL	ReadCmdHdr( LPBYTE lpBuffer, WORD &wInterfaceId, WORD &wCommandId );// NPSR}h̃wb_[擾

	// v^[ƍNX						2008.10.24 S.Heya
	CNpsPrinterChecker* m_pNpsPrinterChecker;

};

#endif // !defined(AFX_NPSBCTHREAD_H__F9DAD04D_BB56_4F18_9FC6_3724ACCA149C__INCLUDED_)
