//////////////////////////////////////////////////////////////////////////////
//	FILE NAME : NpsCallbackEvent.cpp
//	ABSTRACT  : CNpsCallbackEvent NX̃Cve[V
//	
//	CREATE    : T.Isogai	2006.7.10
//	UPDATE    : 
//	
//										(C)Copyright : Noritsu Koki CO.,LTD.
//////////////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "NpsCallbackEvent.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// \z/
//////////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////////////////////
//	MODULE   :CNpsCallbackEvent::CNpsCallbackEvent()
//	ABSTRACT : RXgN^
//	FUNCTION : RXgN^
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : T.Isogai	2006.7.10
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
CNpsCallbackEvent::CNpsCallbackEvent()
: CNpsCallback()
{
	m_pFunc	= NULL;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   :CNpsCallbackEvent::~CNpsCallbackEvent()
//	ABSTRACT : fXgN^
//	FUNCTION : fXgN^
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : T.Isogai	2006.7.10
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
CNpsCallbackEvent::~CNpsCallbackEvent()
{
	EndObject();
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CNpsCallbackEvent::AddNpsCALLBACKDATA()
//	ABSTRACT : CNpsCALLBACKDATA_EventIuWFNgXgɒǉ
//	FUNCTION : CNpsCALLBACKDATA_EventIuWFNgXgɒǉ
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : T.Isogai	2006.8.21
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
void CNpsCallbackEvent::AddNpsCALLBACKDATA( NPSEVENTINFO EventInfo )
{
	NkcComApi::CCSScopeLock	CSScopeLock( &m_CS );

	if( NULL == m_pFunc	)
	{
		return;
	}

	CNpsCALLBACKDATA_Event* pCALLBACKDATA;
	try
	{
		pCALLBACKDATA = new CNpsCALLBACKDATA_Event;
	}
	catch (CMemoryException* e)
	{
		{
			CString str;
			str.Format( "===Memory allocation error [CNpsCALLBACKDATA_Event]" );
			NPS_LOGOUT_FATAL( str );
		}
		e->Delete();
		return;
	}
	pCALLBACKDATA->m_EventInfo	= EventInfo;

	m_vectorCALLBACKDATA.push_back( pCALLBACKDATA );
	SetEvent();
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CNpsCallbackEvent::CallCallback()
//	ABSTRACT : R[obN֐Ăяo
//	FUNCTION : R[obN֐Ăяo
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : T.Isogai	2006.7.10
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
void CNpsCallbackEvent::CallCallback( CNpsCALLBACKDATA* pCALLBACKDATA )
{
	if( NULL == m_pFunc	)
	{
		return;
	}
	
	CNpsCALLBACKDATA_Event * pData	= ( CNpsCALLBACKDATA_Event * ) pCALLBACKDATA;

	{	// Oo
		CString str;
		in_addr tAddr;
		tAddr.S_un.S_addr = pData->m_EventInfo.dwIPAddress;
		str.Format( "<Callback> NPSEVENTPROC hPrinter=0x%08X, dwIPAddress=%d.%d.%d.%d, dwErrHandle=0x%08X, dwErrCode=%05d, dwOnOff=%d, alParams=(%d,%d,%d,%d)",
			pData->m_EventInfo.hPrinter,
			tAddr.S_un.S_un_b.s_b1,
			tAddr.S_un.S_un_b.s_b2,
			tAddr.S_un.S_un_b.s_b3,
			tAddr.S_un.S_un_b.s_b4,
			pData->m_EventInfo.dwErrHandle,
			pData->m_EventInfo.dwErrCode,
			pData->m_EventInfo.dwOnOff,
			pData->m_EventInfo.alParams[0],
			pData->m_EventInfo.alParams[1],
			pData->m_EventInfo.alParams[2],
			pData->m_EventInfo.alParams[3]
			);
		NPS_LOGOUT( str );
	}

	( ( NPSEVENTPROC )( m_pFunc ) )( &( pData->m_EventInfo ) );

	{	// Oo
		//NPS_LOGOUT( "<Callback return> NPSEVENTPROC" );
	}
}
