//////////////////////////////////////////////////////////////////////////////
//	FILE NAME : NpsControl.h
//	ABSTRACT  : CNpsControl NX̃C^[tFCX
//	
//	CREATE    : T.Isogai	2006.7.26
//	UPDATE    : 
//	
//										(C)Copyright : Noritsu Koki CO.,LTD.
//////////////////////////////////////////////////////////////////////////////

#if !defined(AFX_NPSCONTROL_H__DF78A258_8863_436D_9C63_F2A7837AD50D__INCLUDED_)
#define AFX_NPSCONTROL_H__DF78A258_8863_436D_9C63_F2A7837AD50D__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "Sdk.h"
#include <vector>

#include "NpsBc.h"

//////////////////////////////////////////////////////////////////////////////
//	CLASS    : CNpsControl
//	ABSTRACT : NPSO[oȊǗNX
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	CREATE	 : T.Isogai	2006.8.9
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
class CNpsControl  
{
public:
	CNpsControl();										// RXgN^
	virtual ~CNpsControl();								// fXgN^

	//////////////////////////////////////////////////////////////////////////////
	// SdkRg[

	void*	GetPrinterHandle();							// v^nh̔Ԃ擾

	BOOL AddSdk( CSdk * pSdk );							// CSdkIuWFNgXg֒ǉ
	
	BOOL DeleteSdk(										// CSdkIuWFNgXg폜
				HPRINTER	hPrinter					// v^̃nhw肷
				);

	CSdk * GetSdk(										// CSdkIuWFNgXg擾
				HPRINTER	hPrinter					// v^̃nhw肷
				);

	CSdk * GetSdk(										// CSdkIuWFNgXg擾
				DWORD		dwIPAddress,					// v^IPAhX
				USHORT		wNpsPortNo,					// v^NPSp|[gԍ̎擾
				USHORT		wImgPortNo					// v^NPS(摜f[^])p|[gԍ̎擾
				);

	int		GetSdkSize()		{ return (int)m_vectorSdk.size(); }	// o^ĂCSdkIuWFNǧ擾
	CSdk *	GetSdkNo( int i )	{ return m_vectorSdk[i]; }		// o^ĂCSdkIuWFNg̎擾
	void	DeleteSdkAll();										// o^ĂCSdkIuWFNgSč폜


	//////////////////////////////////////////////////////////////////////////////
	// v^m

	long SearchPrinter(									// v^̌
					BOOL			bEnableLoopBack,	// [vobNւ̌mLɂ
					LPWORD			pPrinterNum,		// v^̑䐔
					DWORD			dwWaitTime = 6000	// ҋ@(~b)
					);

	long GetPrinterList(								// ꂽv^̃Xg擾
					WORD				wBufferNum,		// pPrinterInfõobt@
					T_NpsPrinterInfo*	pPrinterInfo	// v^
					);

	BOOL ClearPrinterList();							// ꂽv^̃Xg폜

	//----------------------------------------------------------------------------
	// LibOpen ̗LmFpϐ
	//----------------------------------------------------------------------------

	BOOL	EnterLibOpen( LPCSTR lpLogFileName );		// LibOpen ł邩mF
	BOOL	LeaveLibOpen();								// LibCloseł邩mF
	BOOL	IsLibOpen();								// LibOpen Ă邩mF

	int		GetSdkCount()	{	return (int)m_vectorSdk.size();	}	// 2007.01.15 T.Mizushima

protected:

	//////////////////////////////////////////////////////////////////////////////
	// SdkRg[

	std::vector<CSdk*>				m_vectorSdk;			// CSdkXg
	DWORD							m_dwPrinter;			// ̔ԗpv^nh
	CRITICAL_SECTION				m_csSdk;				// m_vectorSdkp NeBJZNV

	//////////////////////////////////////////////////////////////////////////////
	// v^m

	std::vector<T_NpsPrinterInfo*>	m_vPrinterInfo;			// v^Xg

	//----------------------------------------------------------------------------
	// LibOpen ̗LmFpϐ
	//----------------------------------------------------------------------------

	BOOL							m_bLibOpen;			// LibOpen ̗LmFpϐ (TRUE:gp\, FALSE:gps\)
	CRITICAL_SECTION				m_csLibOpen;		// m_bLibOpenp NeBJZNV
};

#define NPS_LOGOUT_VALUE_HEX( n ) NpsLogValueHex( ""#n"", ##n )
void NpsLogValueHex( CString str1, DWORD val );

#define NPS_LOGOUT_VALUE_DEC( n ) NpsLogValueDec( ""#n"", ##n )
void NpsLogValueDec( CString str1, DWORD val );

#define NPS_LOGOUT_VALUE_STR( n ) NpsLogValueStr( ""#n"", ##n )
void NpsLogValueStr( CString str1, CString str2 );

#define NPS_LOGOUT_VALUE_PTR( n ) NpsLogValueHex( ""#n"", ##n )
void NpsLogValueHex( CString str1, void* ptr );

#endif // !defined(AFX_NPSCONTROL_H__DF78A258_8863_436D_9C63_F2A7837AD50D__INCLUDED_)
