//////////////////////////////////////////////////////////////////////////////
//	FILE NAME : PrintQue.cpp
//	ABSTRACT  : CPrintQue NX̃Cve[V
//	
//	CREATE    : T.Isogai	2006.9.21
//	UPDATE    : 
//	
//										(C)Copyright : Noritsu Koki CO.,LTD.
//////////////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "PrintQue.h"


extern DWORD g_dwCompProcMode;		// ʒm̓샂[h 2007.11.12 N.Nakashima

//////////////////////////////////////////////////////////////////////
// \z/
//////////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////////////////////
//	MODULE   :CPrintQue::CPrintQue()
//	ABSTRACT : 
//	FUNCTION : 
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : T.Isogai	2006.9.21
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
CPrintQue::CPrintQue()
{
	InitializeCriticalSection( &m_CS );

	NkcComApi::CCSScopeLock CSScopeLock( &m_CS );

	m_dwLatestOrderId			= MAKELONG( 0, LOWORD( ::GetCurrentProcessId() ) );	// _ 02580 ł̎bΉ j[NI[_[ԍZbg
	m_dwLatestPrintId			= 0;

	m_dwAcceptNormalOrderId		= 0;		// tOrderId@ʏ
	m_dwAcceptExpressOrderId	= 0;		// tOrderId@}(Level1)
	m_dwAcceptExpressL2OrderId	= 0;		// tOrderId@}(Level2)

	::ZeroMemory( &m_PossessionRelease, sizeof(T_PossessionRelease) );
	m_PossessionRelease.bPossessionRelease = FALSE;

	m_pCallbackCompletionOrderNG	= NULL;	// EZ Controller 6x6C` tHgubNΉ
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   :CPrintQue::~CPrintQue()
//	ABSTRACT : 
//	FUNCTION : 
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : T.Isogai	2006.9.21
//	UPDATE   : J.Fukumori(AVASYS) 2008.07.18 VS2005Ή for̔rLXg
//////////////////////////////////////////////////////////////////////////////
CPrintQue::~CPrintQue()
{
	{
		NkcComApi::CCSScopeLock CSScopeLock( &m_CS );

		// m_vOrderNormalXg폜
		for( int i =0; i < (int)m_vOrderNormal.size(); i++ )
		{
			COrderData * ptmpOrderData	= ( COrderData * ) m_vOrderNormal[i];
			delete ptmpOrderData;
		}

		m_vOrderNormal.clear();

		// m_vOrderExpressXg폜
		for( i =0; i < (int)m_vOrderExpress.size(); i++ )
		{
			COrderData * ptmpOrderData	= ( COrderData * ) m_vOrderExpress[i];
			delete ptmpOrderData;
		}

		m_vOrderExpress.clear();

		// m_vOrderExpressL2Xg폜
		for( i =0; i < (int)m_vOrderExpressL2.size(); i++ )
		{
			COrderData * ptmpOrderData	= ( COrderData * ) m_vOrderExpressL2[i];
			delete ptmpOrderData;
		}

		m_vOrderExpressL2.clear();

	}

	DeleteCriticalSection( &m_CS );
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CPrintQue::GetOrderData()
//	ABSTRACT : 
//	FUNCTION : 
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : T.Isogai	2006.9.21
//	UPDATE   : J.Fukumori(AVASYS) 2008.07.18 VS2005Ή for̔rLXg
//////////////////////////////////////////////////////////////////////////////
COrderData* CPrintQue::GetOrderData( DWORD dwOrderId )
{
	COrderData*	pOrderData	= NULL;
	int			nIdx;

	for( nIdx = 0; nIdx < (int)m_vOrderNormal.size(); nIdx++ )
	{
		COrderData* ptmpOrderData	= ( COrderData* ) m_vOrderNormal[nIdx];

		if( dwOrderId == ptmpOrderData->m_dwOrderId )
		{			
			pOrderData	= ptmpOrderData;
			return pOrderData;
		}
	}

	for( nIdx = 0; nIdx < (int)m_vOrderExpress.size(); nIdx++ )
	{
		COrderData* ptmpOrderData	= ( COrderData* ) m_vOrderExpress[nIdx];

		if( dwOrderId == ptmpOrderData->m_dwOrderId )
		{			
			pOrderData	= ptmpOrderData;
			return pOrderData;
		}
	}

	for( nIdx = 0; nIdx < (int)m_vOrderExpressL2.size(); nIdx++ )
	{
		COrderData* ptmpOrderData	= ( COrderData* ) m_vOrderExpressL2[nIdx];

		if( dwOrderId == ptmpOrderData->m_dwOrderId )
		{			
			pOrderData	= ptmpOrderData;
			return pOrderData;
		}
	}

	return pOrderData;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CPrintQue::GetOrderDataByReceiptNo()
//	ABSTRACT : 
//	FUNCTION : 
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : T.Isogai	2006.9.21
//	UPDATE   : J.Fukumori(AVASYS) 2008.07.18 VS2005Ή for̔rLXg
//////////////////////////////////////////////////////////////////////////////
COrderData* CPrintQue::GetOrderDataByReceiptNo( ULONG ReceiptNo )
{
	COrderData*	pOrderData	= NULL;
	int			nIdx1, nIdx2;

	for( nIdx1 = 0; nIdx1 < (int)m_vOrderNormal.size(); nIdx1++ )
	{
		COrderData* ptmpOrderData	= ( COrderData* ) m_vOrderNormal[nIdx1];

		for( nIdx2 = 0; nIdx2 < (int)ptmpOrderData->m_vFrame.size(); nIdx2++ )
		{
			CFrameData* ptmpFrameData	= ( CFrameData* ) ptmpOrderData->m_vFrame[nIdx2];

			if( CFrameData::TYPE_PRINT == ptmpFrameData->GetType() )
			{
				if( ReceiptNo == ( (CFrameDataPrint*)ptmpFrameData )->m_ReceiptNo )
				{
					pOrderData	= ptmpOrderData;
					return pOrderData;
				}
			}
		}
	}

	for( nIdx1 = 0; nIdx1 < (int)m_vOrderExpress.size(); nIdx1++ )
	{
		COrderData* ptmpOrderData	= ( COrderData* ) m_vOrderExpress[nIdx1];

		for( nIdx2 = 0; nIdx2 < (int)ptmpOrderData->m_vFrame.size(); nIdx2++ )
		{
			CFrameData* ptmpFrameData	= ( CFrameData* ) ptmpOrderData->m_vFrame[nIdx2];

			if( CFrameData::TYPE_PRINT == ptmpFrameData->GetType() )
			{
				if( ReceiptNo == ( (CFrameDataPrint*)ptmpFrameData )->m_ReceiptNo )
				{
					pOrderData	= ptmpOrderData;
					return pOrderData;
				}
			}
		}
	}

	for( nIdx1 = 0; nIdx1 < (int)m_vOrderExpressL2.size(); nIdx1++ )
	{
		COrderData* ptmpOrderData	= ( COrderData* ) m_vOrderExpressL2[nIdx1];

		for( nIdx2 = 0; nIdx2 < (int)ptmpOrderData->m_vFrame.size(); nIdx2++ )
		{
			CFrameData* ptmpFrameData	= ( CFrameData* ) ptmpOrderData->m_vFrame[nIdx2];

			if( CFrameData::TYPE_PRINT == ptmpFrameData->GetType() )
			{
				if( ReceiptNo == ( (CFrameDataPrint*)ptmpFrameData )->m_ReceiptNo )
				{
					pOrderData	= ptmpOrderData;
					return pOrderData;
				}
			}
		}
	}

	return pOrderData;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CPrintQue::GetOrderDataByReceiptNo2()
//	ABSTRACT : tԍ܂߂Č
//	FUNCTION : 
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : T.Mizushima	2006.12.07
//	UPDATE   : J.Fukumori(AVASYS) 2008.07.18 VS2005Ή for̔rLXg
//////////////////////////////////////////////////////////////////////////////
COrderData* CPrintQue::GetOrderDataByReceiptNo2( ULONG ReceiptNo )
{
	COrderData*	pOrderData	= NULL;
	int			nIdx1, nIdx2;

	for( nIdx1 = 0; nIdx1 < (int)m_vOrderNormal.size(); nIdx1++ )
	{
		COrderData* ptmpOrderData	= ( COrderData* ) m_vOrderNormal[nIdx1];

		for( nIdx2 = 0; nIdx2 < (int)ptmpOrderData->m_vFrame.size(); nIdx2++ )
		{
			CFrameData* ptmpFrameData	= ( CFrameData* ) ptmpOrderData->m_vFrame[nIdx2];

			if( CFrameData::TYPE_PRINT == ptmpFrameData->GetType() )
			{
				for( int i = (int)( (CFrameDataPrint*)ptmpFrameData )->m_ReceiptNoArray.GetSize() - 1; i >= 0; i-- )
				{
					if( ReceiptNo == ( (CFrameDataPrint*)ptmpFrameData )->m_ReceiptNoArray.GetAt( i ) )
					{
						pOrderData	= ptmpOrderData;
						return pOrderData;
					}
				}
			}
		}
	}

	for( nIdx1 = 0; nIdx1 < (int)m_vOrderExpress.size(); nIdx1++ )
	{
		COrderData* ptmpOrderData	= ( COrderData* ) m_vOrderExpress[nIdx1];

		for( nIdx2 = 0; nIdx2 < (int)ptmpOrderData->m_vFrame.size(); nIdx2++ )
		{
			CFrameData* ptmpFrameData	= ( CFrameData* ) ptmpOrderData->m_vFrame[nIdx2];

			if( CFrameData::TYPE_PRINT == ptmpFrameData->GetType() )
			{
				for( int i = (int)( (CFrameDataPrint*)ptmpFrameData )->m_ReceiptNoArray.GetSize() - 1; i >= 0; i-- )
				{
					if( ReceiptNo == ( (CFrameDataPrint*)ptmpFrameData )->m_ReceiptNoArray.GetAt( i ) )
					{
						pOrderData	= ptmpOrderData;
						return pOrderData;
					}
				}
			}
		}
	}

	for( nIdx1 = 0; nIdx1 < (int)m_vOrderExpressL2.size(); nIdx1++ )
	{
		COrderData* ptmpOrderData	= ( COrderData* ) m_vOrderExpressL2[nIdx1];

		for( nIdx2 = 0; nIdx2 < (int)ptmpOrderData->m_vFrame.size(); nIdx2++ )
		{
			CFrameData* ptmpFrameData	= ( CFrameData* ) ptmpOrderData->m_vFrame[nIdx2];

			if( CFrameData::TYPE_PRINT == ptmpFrameData->GetType() )
			{
				for( int i = (int)( (CFrameDataPrint*)ptmpFrameData )->m_ReceiptNoArray.GetSize() - 1; i >= 0; i-- )
				{
					if( ReceiptNo == ( (CFrameDataPrint*)ptmpFrameData )->m_ReceiptNoArray.GetAt( i ) )
					{
						pOrderData	= ptmpOrderData;
						return pOrderData;
					}
				}
			}
		}
	}

	return pOrderData;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CPrintQue::GetOrderDataByPrintId()
//	ABSTRACT : 
//	FUNCTION : 
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : Y.Yoshinobu	2006.10.18
//	UPDATE   : J.Fukumori(AVASYS) 2008.07.18 VS2005Ή for̔rLXg
//////////////////////////////////////////////////////////////////////////////
COrderData*	CPrintQue::GetOrderDataByPrintId( DWORD dwPrintId )
{
	COrderData*	pOrderData	= NULL;
	int			nIdx1, nIdx2;

	for( nIdx1 = 0; nIdx1 < (int)m_vOrderNormal.size(); nIdx1++ )
	{
		COrderData* ptmpOrderData	= ( COrderData* ) m_vOrderNormal[nIdx1];

		for( nIdx2 = 0; nIdx2 < (int)ptmpOrderData->m_vFrame.size(); nIdx2++ )
		{
			CFrameData* ptmpFrameData	= ( CFrameData* ) ptmpOrderData->m_vFrame[nIdx2];

			if( CFrameData::TYPE_PRINT == ptmpFrameData->GetType() )
			{
				if( dwPrintId == ( (CFrameDataPrint*)ptmpFrameData )->m_dwPrintId )
				{
					pOrderData	= ptmpOrderData;
					return pOrderData;
				}
			}
		}
	}

	for( nIdx1 = 0; nIdx1 < (int)m_vOrderExpress.size(); nIdx1++ )
	{
		COrderData* ptmpOrderData	= ( COrderData* ) m_vOrderExpress[nIdx1];

		for( nIdx2 = 0; nIdx2 < (int)ptmpOrderData->m_vFrame.size(); nIdx2++ )
		{
			CFrameData* ptmpFrameData	= ( CFrameData* ) ptmpOrderData->m_vFrame[nIdx2];

			if( CFrameData::TYPE_PRINT == ptmpFrameData->GetType() )
			{
				if( dwPrintId == ( (CFrameDataPrint*)ptmpFrameData )->m_dwPrintId )
				{
					pOrderData	= ptmpOrderData;
					return pOrderData;
				}
			}
		}
	}

	for( nIdx1 = 0; nIdx1 < (int)m_vOrderExpressL2.size(); nIdx1++ )
	{
		COrderData* ptmpOrderData	= ( COrderData* ) m_vOrderExpressL2[nIdx1];

		for( nIdx2 = 0; nIdx2 < (int)ptmpOrderData->m_vFrame.size(); nIdx2++ )
		{
			CFrameData* ptmpFrameData	= ( CFrameData* ) ptmpOrderData->m_vFrame[nIdx2];

			if( CFrameData::TYPE_PRINT == ptmpFrameData->GetType() )
			{
				if( dwPrintId == ( (CFrameDataPrint*)ptmpFrameData )->m_dwPrintId )
				{
					pOrderData	= ptmpOrderData;
					return pOrderData;
				}
			}
		}
	}

	return pOrderData;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   :COrderData*	CPrintQue::GetOrderDataByPrintId()
//	ABSTRACT : 
//	FUNCTION : 
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : T.Isogai	2006.9.22
//	UPDATE   : J.Fukumori(AVASYS) 2008.07.18 VS2005Ή for̔rLXg
//////////////////////////////////////////////////////////////////////////////
CFrameData*	CPrintQue::GetFrameDataByPrintId( DWORD dwPrintId )
{
	CFrameData*	pFrameData	= NULL;
	int			nIdx1, nIdx2;

	for( nIdx1 = 0; nIdx1 < (int)m_vOrderNormal.size(); nIdx1++ )
	{
		COrderData* ptmpOrderData	= ( COrderData* ) m_vOrderNormal[nIdx1];

		for( nIdx2 = 0; nIdx2 < (int)ptmpOrderData->m_vFrame.size(); nIdx2++ )
		{
			CFrameData* ptmpFrameData	= ( CFrameData* ) ptmpOrderData->m_vFrame[nIdx2];

			if( CFrameData::TYPE_PRINT == ptmpFrameData->GetType() )
			{
				if( dwPrintId == ( (CFrameDataPrint*)ptmpFrameData )->m_dwPrintId )
				{
					pFrameData	= ptmpFrameData;
					return pFrameData;
				}
			}
		}
	}

	for( nIdx1 = 0; nIdx1 < (int)m_vOrderExpress.size(); nIdx1++ )
	{
		COrderData* ptmpOrderData	= ( COrderData* ) m_vOrderExpress[nIdx1];

		for( nIdx2 = 0; nIdx2 < (int)ptmpOrderData->m_vFrame.size(); nIdx2++ )
		{
			CFrameData* ptmpFrameData	= ( CFrameData* ) ptmpOrderData->m_vFrame[nIdx2];

			if( CFrameData::TYPE_PRINT == ptmpFrameData->GetType() )
			{
				if( dwPrintId == ( (CFrameDataPrint*)ptmpFrameData )->m_dwPrintId )
				{
					pFrameData	= ptmpFrameData;
					return pFrameData;
				}
			}
		}
	}

	for( nIdx1 = 0; nIdx1 < (int)m_vOrderExpressL2.size(); nIdx1++ )
	{
		COrderData* ptmpOrderData	= ( COrderData* ) m_vOrderExpressL2[nIdx1];

		for( nIdx2 = 0; nIdx2 < (int)ptmpOrderData->m_vFrame.size(); nIdx2++ )
		{
			CFrameData* ptmpFrameData	= ( CFrameData* ) ptmpOrderData->m_vFrame[nIdx2];

			if( CFrameData::TYPE_PRINT == ptmpFrameData->GetType() )
			{
				if( dwPrintId == ( (CFrameDataPrint*)ptmpFrameData )->m_dwPrintId )
				{
					pFrameData	= ptmpFrameData;
					return pFrameData;
				}
			}
		}
	}

	return pFrameData;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CPrintQue::GetFrameDataByReceiptNo2()
//	ABSTRACT : R}f[^擾
//	FUNCTION : 
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : Y.Yoshinobu	2007.3.28
//	UPDATE   : J.Fukumori(AVASYS) 2008.07.18 VS2005Ή for̔rLXg
//////////////////////////////////////////////////////////////////////////////
CFrameData* CPrintQue::GetFrameDataByReceiptNo2( ULONG ReceiptNo )
{
	int nIdx1, nIdx2, nIdx3;
	CFrameData*	pFrameData = NULL;

	for( nIdx1 = 0; nIdx1 < (int)m_vOrderNormal.size(); nIdx1++ )
	{
		COrderData* ptmpOrderData	= ( COrderData* ) m_vOrderNormal[nIdx1];

		for( nIdx2 = 0; nIdx2 < (int)ptmpOrderData->m_vFrame.size(); nIdx2++ )
		{
			CFrameData* ptmpFrameData	= ( CFrameData* ) ptmpOrderData->m_vFrame[nIdx2];

			if( CFrameData::TYPE_PRINT == ptmpFrameData->GetType() )
			{
				for( nIdx3 = (int)( (CFrameDataPrint*)ptmpFrameData )->m_ReceiptNoArray.GetSize() - 1; nIdx3 >= 0; nIdx3-- )
				{
					if( ReceiptNo == ( (CFrameDataPrint*)ptmpFrameData )->m_ReceiptNoArray.GetAt( nIdx3 ) )
					{
						pFrameData = ptmpFrameData;
						return pFrameData;
					}
				}
			}
		}
	}

	for( nIdx1 = 0; nIdx1 < (int)m_vOrderExpress.size(); nIdx1++ )
	{
		COrderData* ptmpOrderData	= ( COrderData* ) m_vOrderExpress[nIdx1];

		for( nIdx2 = 0; nIdx2 < (int)ptmpOrderData->m_vFrame.size(); nIdx2++ )
		{
			CFrameData* ptmpFrameData	= ( CFrameData* ) ptmpOrderData->m_vFrame[nIdx2];

			if( CFrameData::TYPE_PRINT == ptmpFrameData->GetType() )
			{
				for( nIdx3 = (int)( (CFrameDataPrint*)ptmpFrameData )->m_ReceiptNoArray.GetSize() - 1; nIdx3 >= 0; nIdx3-- )
				{
					if( ReceiptNo == ( (CFrameDataPrint*)ptmpFrameData )->m_ReceiptNoArray.GetAt( nIdx3 ) )
					{
						pFrameData = ptmpFrameData;
						return pFrameData;
					}
				}
			}
		}
	}

	for( nIdx1 = 0; nIdx1 < (int)m_vOrderExpressL2.size(); nIdx1++ )
	{
		COrderData* ptmpOrderData	= ( COrderData* ) m_vOrderExpressL2[nIdx1];

		for( nIdx2 = 0; nIdx2 < (int)ptmpOrderData->m_vFrame.size(); nIdx2++ )
		{
			CFrameData* ptmpFrameData	= ( CFrameData* ) ptmpOrderData->m_vFrame[nIdx2];

			if( CFrameData::TYPE_PRINT == ptmpFrameData->GetType() )
			{
				for( nIdx3 = (int)( (CFrameDataPrint*)ptmpFrameData )->m_ReceiptNoArray.GetSize() - 1; nIdx3 >= 0; nIdx3-- )
				{
					if( ReceiptNo == ( (CFrameDataPrint*)ptmpFrameData )->m_ReceiptNoArray.GetAt( nIdx3 ) )
					{
						pFrameData = ptmpFrameData;
						return pFrameData;
					}
				}
			}
		}
	}

	return pFrameData;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : COrderData* CPrintQue::GetFrameDataByIndexNo()
//	ABSTRACT : 
//	FUNCTION : 
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : Y.Yoshinobu	2009.11.28
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
CFrameData*	CPrintQue::GetFrameDataByIndexNo( const DWORD dwOrderId, const DWORD dwIndexNo )
{
	int nIdx = 0;
	CFrameData* pFrameData = NULL;
	COrderData* pOrderData = GetOrderData( dwOrderId );

	if ( NULL != pOrderData )
	{
		for( nIdx=0 ; nIdx < (int)pOrderData->m_vFrame.size(); nIdx++ )
		{
			pFrameData = (CFrameData*)pOrderData->m_vFrame[nIdx];

			if( dwIndexNo == pFrameData->m_dwIndexNo )
			{
				return pFrameData;
			}
		}
	}

	return NULL;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CPrintQue::DeleteOrderData()
//	ABSTRACT : 
//	FUNCTION : 
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : T.Isogai	2006.9.21
//	UPDATE   : J.Fukumori(AVASYS) 2008.07.17 VS2005Ή
//////////////////////////////////////////////////////////////////////////////
BOOL CPrintQue::DeleteOrderData( DWORD dwOrderId )
{
	BOOL	bRet	= FALSE;
	int		nIdx;
	CFrameDataPrint* pFrame;
	std::vector<CFrameData*>::iterator	itFrame;

	for( nIdx = 0; nIdx < (int)m_vOrderNormal.size(); nIdx++ )
	{
		COrderData* ptmpOrderData	= ( COrderData* ) m_vOrderNormal[nIdx];

		if( dwOrderId == ptmpOrderData->m_dwOrderId )
		{			
				// v^[̐LĂȂꍇɂ́ALs
				if (( STEP1_ORDER_6000_0500 < ptmpOrderData->m_eOrderStep ) &&
					( STEP4_ORDER_6000_0600 > ptmpOrderData->m_eOrderStep ))
				{
					m_PossessionRelease.bPossessionRelease	= TRUE;
					if ( TRUE == ptmpOrderData->m_bIsMaintenance )
					{
						m_PossessionRelease.tNextCmd.eQueModeM	= QUE_MAINTENANCE;			// eiX
					}
					else
					{
						m_PossessionRelease.tNextCmd.eQueModeM	= QUE_PRINT;				// ʏvg
					}
					m_PossessionRelease.tNextCmd.eQueModeP			= QUE_NORMAL;					// ʏ
					m_PossessionRelease.tNextCmd.eCmdType			= CMD_ORDER_END;				// I[_[I
					m_PossessionRelease.tNextCmd.dwOrderId			= ptmpOrderData->m_dwOrderId;	// I[_[ID
					m_PossessionRelease.tNextCmd.dwPrintId			= 0;							// vgID (gpȂ̂0Zbg)
					m_PossessionRelease.tEndOrderData.eOrderStep	= ptmpOrderData->m_eOrderStep;	// vgv̔s
					m_PossessionRelease.tEndOrderData.wPossessionNo	= ptmpOrderData->m_nPossessionNo;// Lԍ
					// LMOɉ摜]p\Pbg 2007.01.06 T.Mizushima
					if ( 0 != ptmpOrderData->m_nNpsImgPort )
					{
						// ڑؒf
						m_pNpsImgMng->Delete( ptmpOrderData->m_nNpsImgPort );
						ptmpOrderData->m_nNpsImgPort = 0;
					}

					// tJnv(0700)sĂ摜MmFv(0800)MłĂȂƂ
					// LZvs
					for ( itFrame=ptmpOrderData->m_vFrame.begin() ; ptmpOrderData->m_vFrame.end() != itFrame ; itFrame++ )
					{
						if ( CFrameData::TYPE_PRINT == (*itFrame)->GetType() )
						{
							pFrame = (CFrameDataPrint*)(*itFrame);

							if (( STEPA_FRAME_6000_0700_13 <= pFrame->m_eFrameState ) &&
								( STEP4_FRAME_6000_0800 > pFrame->m_eFrameState ))
							{
								if ( 0 != pFrame->m_ReceiptNo )
								{
									m_PossessionRelease.nCancelReceiptNo = pFrame->m_ReceiptNo;
									break;
								}
							}
						}
					}
				}

			m_vOrderNormal.erase( m_vOrderNormal.begin() + nIdx );
			{
				CString	str;
				str.Format( "--DeleteOrderData ( Normal Order ) OrderId=%d", dwOrderId );
				NPS_LOGOUT( str );
			}
			delete ptmpOrderData;
			bRet	= TRUE;
//			return bRet;	// ɂ	2006.10.31 T.Mizushima	wE58
		}
	}

	if( bRet == FALSE )
	{
		for( nIdx = 0; nIdx < (int)m_vOrderExpress.size(); nIdx++ )
		{
			COrderData* ptmpOrderData	= ( COrderData* ) m_vOrderExpress[nIdx];

			if( dwOrderId == ptmpOrderData->m_dwOrderId )
			{			
					// v^[̐LĂȂꍇɂ́ALs
					if (( STEP1_ORDER_6000_0500 < ptmpOrderData->m_eOrderStep ) &&
						( STEP4_ORDER_6000_0600 > ptmpOrderData->m_eOrderStep ))
					{
						m_PossessionRelease.bPossessionRelease	= TRUE;
						if ( TRUE == ptmpOrderData->m_bIsMaintenance )
						{
							m_PossessionRelease.tNextCmd.eQueModeM	= QUE_MAINTENANCE;			// eiX
						}
						else
						{
							m_PossessionRelease.tNextCmd.eQueModeM	= QUE_PRINT;				// ʏvg
						}
						m_PossessionRelease.tNextCmd.eQueModeP			= QUE_EXPRESS1;					// }(Level1)
						m_PossessionRelease.tNextCmd.eCmdType			= CMD_ORDER_END;				// I[_[I
						m_PossessionRelease.tNextCmd.dwOrderId			= ptmpOrderData->m_dwOrderId;	// I[_[ID
						m_PossessionRelease.tNextCmd.dwPrintId			= 0;							// vgID (gpȂ̂0Zbg)
						m_PossessionRelease.tEndOrderData.eOrderStep	= ptmpOrderData->m_eOrderStep;	// vgv̔s
						m_PossessionRelease.tEndOrderData.wPossessionNo	= ptmpOrderData->m_nPossessionNo;// Lԍ
						// LMOɉ摜]p\Pbg 2007.01.06 T.Mizushima
						if ( 0 != ptmpOrderData->m_nNpsImgPort )
						{
							// ڑؒf
							m_pNpsImgMng->Delete( ptmpOrderData->m_nNpsImgPort );
							ptmpOrderData->m_nNpsImgPort = 0;
						}

						// tJnv(0700)sĂ摜MmFv(0800)MłĂȂƂ
						// LZvs
						for ( itFrame=ptmpOrderData->m_vFrame.begin() ; ptmpOrderData->m_vFrame.end() != itFrame ; itFrame++ )
						{
							if ( CFrameData::TYPE_PRINT == (*itFrame)->GetType() )
							{
								pFrame = (CFrameDataPrint*)(*itFrame);

								if (( STEPA_FRAME_6000_0700_13 <= pFrame->m_eFrameState ) &&
									( STEP4_FRAME_6000_0800 > pFrame->m_eFrameState ))
								{
									if ( 0 != pFrame->m_ReceiptNo )
									{
										m_PossessionRelease.nCancelReceiptNo = pFrame->m_ReceiptNo;
										break;
									}
								}
							}
						}
					}

				m_vOrderExpress.erase( m_vOrderExpress.begin() + nIdx );
				{
					CString	str;
					str.Format( "--DeleteOrderData ( Express Order ) OrderId=%d", dwOrderId );
					NPS_LOGOUT( str );
				}
				delete ptmpOrderData;
				bRet	= TRUE;
//				return bRet;	// ɂ	2006.10.31 T.Mizushima	wE58
			}
		}
	}

	if( bRet == FALSE )
	{
		for( nIdx = 0; nIdx < (int)m_vOrderExpressL2.size(); nIdx++ )
		{
			COrderData* ptmpOrderData	= ( COrderData* ) m_vOrderExpressL2[nIdx];

			if( dwOrderId == ptmpOrderData->m_dwOrderId )
			{
					// v^[̐LĂȂꍇɂ́ALs
					if (( STEP1_ORDER_6000_0500 < ptmpOrderData->m_eOrderStep ) &&
						( STEP4_ORDER_6000_0600 > ptmpOrderData->m_eOrderStep ))
					{
						m_PossessionRelease.bPossessionRelease	= TRUE;
						if ( TRUE == ptmpOrderData->m_bIsMaintenance )
						{
							m_PossessionRelease.tNextCmd.eQueModeM	= QUE_MAINTENANCE;			// eiX
						}
						else
						{
							m_PossessionRelease.tNextCmd.eQueModeM	= QUE_PRINT;				// ʏvg
						}
						m_PossessionRelease.tNextCmd.eQueModeP			= QUE_EXPRESS2;					// }(Level2)
						m_PossessionRelease.tNextCmd.eCmdType			= CMD_ORDER_END;				// I[_[I
						m_PossessionRelease.tNextCmd.dwOrderId			= ptmpOrderData->m_dwOrderId;	// I[_[ID
						m_PossessionRelease.tNextCmd.dwPrintId			= 0;							// vgID (gpȂ̂0Zbg)
						m_PossessionRelease.tEndOrderData.eOrderStep	= ptmpOrderData->m_eOrderStep;	// vgv̔s
						m_PossessionRelease.tEndOrderData.wPossessionNo	= ptmpOrderData->m_nPossessionNo;// Lԍ
						// LMOɉ摜]p\Pbg 2007.01.06 T.Mizushima
						if ( 0 != ptmpOrderData->m_nNpsImgPort )
						{
							// ڑؒf
							m_pNpsImgMng->Delete( ptmpOrderData->m_nNpsImgPort );
							ptmpOrderData->m_nNpsImgPort = 0;
						}

						// tJnv(0700)sĂ摜MmFv(0800)MłĂȂƂ
						// LZvs
						for ( itFrame=ptmpOrderData->m_vFrame.begin() ; ptmpOrderData->m_vFrame.end() != itFrame ; itFrame++ )
						{
							if ( CFrameData::TYPE_PRINT == (*itFrame)->GetType() )
							{
								pFrame = (CFrameDataPrint*)(*itFrame);

								if (( STEPA_FRAME_6000_0700_13 <= pFrame->m_eFrameState ) &&
									( STEP4_FRAME_6000_0800 > pFrame->m_eFrameState ))
								{
									if ( 0 != pFrame->m_ReceiptNo )
									{
										m_PossessionRelease.nCancelReceiptNo = pFrame->m_ReceiptNo;
										break;
									}
								}
							}
						}
					}

				m_vOrderExpressL2.erase( m_vOrderExpressL2.begin() + nIdx );
				{
					CString	str;
					str.Format( "--DeleteOrderData ( ExpressL2 Order ) OrderId=%d", dwOrderId );
					NPS_LOGOUT( str );
				}
				delete ptmpOrderData;
				bRet	= TRUE;
//				return bRet;	// ɂ	2006.10.31 T.Mizushima	wE58
			}
		}
	}


	return bRet;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CPrintQue::GetPriorityModeByReceiptNo()
//	ABSTRACT : tԍL̗D惂[h擾
//	FUNCTION : 
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : Y.Yoshinobu 2006.11.23
//	UPDATE   : J.Fukumori(AVASYS) 2008.07.18 VS2005Ή
//////////////////////////////////////////////////////////////////////////////
BOOL CPrintQue::GetPriorityModeByReceiptNo( const ULONG ReceiptNo, E_QueModeP& eQueModeP )
{
	int nIdx1;
	int nIdx2;
	COrderData*	pOrderData	= NULL;

	for( nIdx1 = 0; nIdx1 < (int)m_vOrderExpressL2.size(); nIdx1++ )
	{
		COrderData* ptmpOrderData	= ( COrderData* ) m_vOrderExpressL2[nIdx1];

		for( nIdx2 = 0; nIdx2 < (int)ptmpOrderData->m_vFrame.size(); nIdx2++ )
		{
			CFrameData* ptmpFrameData	= ( CFrameData* ) ptmpOrderData->m_vFrame[nIdx2];

			if( CFrameData::TYPE_PRINT == ptmpFrameData->GetType() )
			{
				if( ReceiptNo == ( (CFrameDataPrint*)ptmpFrameData )->m_ReceiptNo )
				{
					eQueModeP = QUE_EXPRESS2;
					return TRUE;
				}
			}
		}
	}

	for( nIdx1 = 0; nIdx1 < (int)m_vOrderExpress.size(); nIdx1++ )
	{
		COrderData* ptmpOrderData	= ( COrderData* ) m_vOrderExpress[nIdx1];

		for( nIdx2 = 0; nIdx2 < (int)ptmpOrderData->m_vFrame.size(); nIdx2++ )
		{
			CFrameData* ptmpFrameData	= ( CFrameData* ) ptmpOrderData->m_vFrame[nIdx2];

			if( CFrameData::TYPE_PRINT == ptmpFrameData->GetType() )
			{
				if( ReceiptNo == ( (CFrameDataPrint*)ptmpFrameData )->m_ReceiptNo )
				{
					eQueModeP = QUE_EXPRESS1;
					return TRUE;
				}
			}
		}
	}

	for( nIdx1 = 0; nIdx1 < (int)m_vOrderNormal.size(); nIdx1++ )
	{
		COrderData* ptmpOrderData	= ( COrderData* ) m_vOrderNormal[nIdx1];

		for( nIdx2 = 0; nIdx2 < (int)ptmpOrderData->m_vFrame.size(); nIdx2++ )
		{
			CFrameData* ptmpFrameData	= ( CFrameData* ) ptmpOrderData->m_vFrame[nIdx2];

			if( CFrameData::TYPE_PRINT == ptmpFrameData->GetType() )
			{
				if( ReceiptNo == ( (CFrameDataPrint*)ptmpFrameData )->m_ReceiptNo )
				{
					eQueModeP = QUE_NORMAL;
					return TRUE;
				}
			}
		}
	}

	return FALSE;
}

//----------------------------------------
// ~ĊJ
//----------------------------------------

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CPrintQue::InterruptReset()
//	ABSTRACT : v^ւ̑M̎
//	FUNCTION : }荞݂ɂ郊Zbg
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : Y.Yoshinobu 2006.10.17
//	UPDATE   : J.Fukumori(AVASYS) 2008.07.18 VS2005Ή 
//	UPDATE   : Y.Yoshinobu 2008.12.09	XgAR}̔ύX _Ή01409
//	UPDATE   : Y.Yoshinobu 2009.08.07	ʈ̓}ĊJǉ
//	
//////////////////////////////////////////////////////////////////////////////
BOOL CPrintQue::InterruptReset( ULONG ReceiptNumber, USHORT Repeat )
{
	// V^ݑΉ(RD-151)ł͍đݒ̕Kv͖Å֐̂
	//   Ă΂邱Ƃ͂Ȃ(6000H-F302HStatus=5,6MȂ)
	//   2012.05.08 T.Mizushima

	BOOL bExist = FALSE;
	COrderData*	pOrderData = NULL;
	CFrameDataPrint* pFrame = NULL;
	CFrameDataDuplex* pFrameDuplex = NULL;
	std::vector<COrderData*>::iterator	itOrder;
	std::vector<CFrameData*>::iterator	itFrame;
	std::vector<DWORD> vOrderId;
	std::vector<DWORD>::iterator itOrderId;

	// 2006.11.26 Y.Yoshinobu
	// ʏI[_[Ɠ}[x1]荞ݑΏۂƂȂ̂
	// UI[_[ID̃Xg쐬āA1I[_[s悤ɕύX
	for ( itOrder=m_vOrderExpress.begin() ; m_vOrderExpress.end() != itOrder ; itOrder++ )
	{
		vOrderId.push_back( (*itOrder)->m_dwOrderId );
	}
	for ( itOrder=m_vOrderNormal.begin() ; m_vOrderNormal.end() != itOrder ; itOrder++ )
	{
		vOrderId.push_back( (*itOrder)->m_dwOrderId );
	}

	// 擪珇ԂɊmF
	for ( itOrderId=vOrderId.begin() ; vOrderId.end() != itOrderId ; itOrderId++ )
	{
		pFrameDuplex = NULL;
		pOrderData = GetOrderData( *itOrderId );

		if( NULL != pOrderData )
		{
			if( TRUE == bExist )	// 2006.11.30 T.Mizushima
			{	// 荞ݒfꂽvgȍ~̃I[_[͑Sđ蒼
				pOrderData->m_eOrderStep = STEP0_ORDER_NONE;
				if ( 0 != pOrderData->m_nNpsImgPort )
				{
					// ڑؒf
					m_pNpsImgMng->Delete( pOrderData->m_nNpsImgPort );
					pOrderData->m_nNpsImgPort = 0;
				}
			}

			for ( itFrame=pOrderData->m_vFrame.begin() ; pOrderData->m_vFrame.end() != itFrame ; itFrame++ )
			{
				if ( CFrameData::TYPE_PRINT == (*itFrame)->GetType() )
				{
					pFrame = (CFrameDataPrint*)(*itFrame);
					if ( ReceiptNumber == pFrame->m_ReceiptNo )
					{
						if( pFrame->m_PrintNum.Transfer >= ( pFrame->m_PrintNum.Request - Repeat + 1 ) )
						{
							pFrame->m_PrintNum.Transfer -= pFrame->m_PrintNum.Request - Repeat + 1;		// rĊJ邱Ƃ̂Œ~ꂽ߂
						}
						else
						{
							pFrame->m_PrintNum.Transfer = 0;
						}

						{	// Oo
							CString str;
							str.Format( "---CPrintQue::InterruptReset() [RESTORE]F302   OrderId=%u, IndexNo=%u, PrintId=%u, Transfer=%u, Status=%u, Repeat=%u ( ReceiptNo=%u ) DuplexMode=%s",
										pOrderData->m_dwOrderId, pFrame->m_dwIndexNo, pFrame->m_dwPrintId, pFrame->m_PrintNum.Transfer, pFrame->m_eFrameState, Repeat, pFrame->m_ReceiptNo,
										( NULL == pFrameDuplex ) ? "FALSE" : "TRUE" );
							NPS_LOGOUT( str );
						}

						pFrame->m_eFrameState = STEP0_FRAME_NONE;
						pOrderData->m_eOrderStep = STEP0_ORDER_NONE;
						bExist = TRUE;
						pFrame->m_PrintNum.Request -= ( Repeat - 1 );

						// ʈ[h̎́AʈJnvđ
						if ( NULL != pFrameDuplex )
						{
							{	// Oo
								CString str;
								str.Format( "---CPrintQue::InterruptReset() [RESTORE]F302-A DUPLEX OrderId=%u, IndexNo=%u",
											pOrderData->m_dwOrderId, pFrameDuplex->m_dwIndexNo );
								NPS_LOGOUT( str );
							}

							pFrameDuplex->m_eFrameState = STEP0_FRAME_NONE;
						}

						// 摜M|[g̐ؒf
						if ( 0 != pOrderData->m_nNpsImgPort )
						{
							// ڑؒf
							m_pNpsImgMng->Delete( pOrderData->m_nNpsImgPort );
							pOrderData->m_nNpsImgPort = 0;
						}
						continue;
					}

					if ( TRUE == bExist )
					{
						if ( STEP0_FRAME_NONE < pFrame->m_eFrameState )
						{
							// v^փvgṽR}ɑ΂āAԂđOɖ߂

							if (( TRUE == pFrame->m_SendFlg.bPRINT ) ||
								( TRUE == pFrame->m_SendFlg.bUSER_CANCEL ) ||
								( TRUE == pFrame->m_SendFlg.bNG ))
							{
								// ς݁iIELZEG[ĵ߁Ađ͕sv
							}
							else
							{
								// ̃R}́AđԂɕύX

								if ( STEP4_FRAME_6000_0800 > pFrame->m_eFrameState )
								{
									// vgvMOȂ̂ŁAŏԂđOɕύX

									{	// Oo
										CString str;
										str.Format( "---CPrintQue::InterruptReset() [RESTORE]F302-A OrderId=%u, IndexNo=%u, PrintId=%u, Transfer=%u, Status=%u ( ReceiptNo=%u )",
													pOrderData->m_dwOrderId, pFrame->m_dwIndexNo, pFrame->m_dwPrintId, pFrame->m_PrintNum.Transfer, pFrame->m_eFrameState, pFrame->m_ReceiptNo );
										NPS_LOGOUT( str );
									}

									pFrame->m_eFrameState = STEP0_FRAME_NONE;
								}
								else
								{
									// vgvMȂ̂ŁAvg]ƏԂđOɕύX

									// d荞݂ŁAOr܂ňĂ\̂ōvsZ
									pFrame->m_PrintNum.Transfer -= pFrame->m_PrintNum.Request;

									{	// Oo
										CString str;
										str.Format( "---CPrintQue::InterruptReset() [RESTORE]F302-B OrderId=%u, IndexNo=%u, PrintId=%u, Transfer=%u, Status=%u ( ReceiptNo=%u )",
													pOrderData->m_dwOrderId, pFrame->m_dwIndexNo, pFrame->m_dwPrintId, pFrame->m_PrintNum.Transfer, pFrame->m_eFrameState, pFrame->m_ReceiptNo );
										NPS_LOGOUT( str );
									}

									pFrame->m_eFrameState = STEP0_FRAME_NONE;
								}
							}
						}
					}
				}
				else if ( CFrameData::TYPE_SORT == (*itFrame)->GetType() )
				{	// \[gv蒼	2006.12.14 T.Mizushima
					if ( TRUE == bExist )
					{
						{	// Oo
							CString str;
							str.Format( "---CPrintQue::InterruptReset() [RESTORE]F302-B SORT OrderId=%u, IndexNo=%u",
										pOrderData->m_dwOrderId, (*itFrame)->m_dwIndexNo );
							NPS_LOGOUT( str );
						}

						(*itFrame)->m_eFrameState = STEP0_FRAME_NONE;
					}
				}
				else if ( CFrameData::TYPE_DUPLEX == (*itFrame)->GetType() )
				{	// ʈv蒼
					switch (  ((CFrameDataDuplex*)(*itFrame))->m_eDuplexMode )
					{
					case CFrameDataDuplex::MODE_DUPLEX_START:
						// ʈJn
						pFrameDuplex = (CFrameDataDuplex*)(*itFrame);
						break;
					case CFrameDataDuplex::MODE_DUPLEX_END:
						// ʈI
						pFrameDuplex = NULL;
						break;
					}
					if ( TRUE == bExist )
					{
						{	// Oo
							CString str;
							str.Format( "---CPrintQue::InterruptReset() [RESTORE]F302-B DUPLEX OrderId=%u, IndexNo=%u",
										pOrderData->m_dwOrderId, (*itFrame)->m_dwIndexNo );
							NPS_LOGOUT( str );
						}

						(*itFrame)->m_eFrameState = STEP0_FRAME_NONE;
					}
				}
			}
		}
	}

	return TRUE;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CPrintQue::PrinterErrorReset()
//	ABSTRACT : v^G[ɂ郊Zbg
//	FUNCTION : v^ւ̑M̎
//	
//	NOTE     : < QSS System > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : Y.Yoshinobu	2006.10.17
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
BOOL CPrintQue::PrinterErrorReset( ULONG ReceiptNumber, USHORT Repeat )
{
	BOOL bExist = FALSE;
	COrderData*	pOrderData;
	CFrameDataPrint* pFrame;
	std::vector<COrderData*>::iterator	itOrder;
	std::vector<CFrameData*>::iterator	itFrame;
	std::vector<DWORD> vOrderId;
	std::vector<DWORD>::iterator itOrderId;

	// UpdateOrderStatus ĂяoƏĂI[_[̓L[폜̂
	// UI[_[ID̃Xg쐬āA1I[_[s

	for ( itOrder=m_vOrderExpressL2.begin() ; m_vOrderExpressL2.end() != itOrder ; itOrder++ )
	{
		vOrderId.push_back( (*itOrder)->m_dwOrderId );
	}
	for ( itOrder=m_vOrderExpress.begin() ; m_vOrderExpress.end() != itOrder ; itOrder++ )
	{
		vOrderId.push_back( (*itOrder)->m_dwOrderId );
	}
	for ( itOrder=m_vOrderNormal.begin() ; m_vOrderNormal.end() != itOrder ; itOrder++ )
	{
		vOrderId.push_back( (*itOrder)->m_dwOrderId );
	}

	// 擪I[_[珇Ԃɏ
	for ( itOrderId=vOrderId.begin() ; vOrderId.end() != itOrderId ; itOrderId++ )
	{
		pOrderData = GetOrderData( *itOrderId );
		
		if( NULL != pOrderData )
		{
			// NKCdlł́AG[ɂȂI[_[͑SĖŃG[Ƃď
			// AeiX[h͎tς݂ɂȂ
			if (( FALSE == pOrderData->m_bEndOrder ) && ( FALSE == pOrderData->m_bIsMaintenance ))
			{
				// EndOrdertς݂𖳏ŗL
				pOrderData->m_bEndOrder = TRUE;
				m_dwAcceptNormalOrderId		= 0;
				m_dwAcceptExpressOrderId	= 0;
				m_dwAcceptExpressL2OrderId	= 0;
			}
			// 擪R}珇Ԃɏ
			for ( itFrame=pOrderData->m_vFrame.begin() ; pOrderData->m_vFrame.end() != itFrame ; itFrame++ )
			{
				if ( CFrameData::TYPE_PRINT == (*itFrame)->GetType() )
				{
					pFrame = (CFrameDataPrint*)(*itFrame);
					if ( ReceiptNumber == pFrame->m_ReceiptNo )
					{

						// gC
						pFrame->m_PrintNum.NG += pFrame->m_PrintNum.Request - Repeat + 1;

						UpdatePrintStatus( pFrame->m_dwPrintId );

						bExist = TRUE;
						continue;
					}

					if ( TRUE == bExist )
					{
							// gC
							pFrame->m_PrintNum.NG = pFrame->m_PrintNum.Request;

							UpdatePrintStatus( pFrame->m_dwPrintId );

					}

				}
			}


		}

		UpdateOrderStatus( pOrderData->m_dwOrderId );

	}

	vOrderId.clear();

	return TRUE;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CPrintQue::FrameMemoryClearCancel()
//	ABSTRACT : t[NAɂLZ
//	FUNCTION : v^֑Mς݂̃R}̓LZ
//	
//	NOTE     : < QSS System > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : T.Mizushima	2007.01.23
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
BOOL CPrintQue::FrameMemoryClearCancel( ULONG ReceiptNumber, USHORT Repeat )
{
	BOOL bExist = FALSE;
	COrderData*	pOrderData;
	CFrameDataPrint* pFrame;
	std::vector<COrderData*>::iterator	itOrder;
	std::vector<CFrameData*>::iterator	itFrame;
	std::vector<DWORD> vOrderId;
	std::vector<DWORD>::iterator itOrderId;

	// UpdateOrderStatus ĂяoƏĂI[_[̓L[폜̂
	// UI[_[ID̃Xg쐬āA1I[_[s

	for ( itOrder=m_vOrderExpressL2.begin() ; m_vOrderExpressL2.end() != itOrder ; itOrder++ )
	{
		vOrderId.push_back( (*itOrder)->m_dwOrderId );
	}
	for ( itOrder=m_vOrderExpress.begin() ; m_vOrderExpress.end() != itOrder ; itOrder++ )
	{
		vOrderId.push_back( (*itOrder)->m_dwOrderId );
	}
	for ( itOrder=m_vOrderNormal.begin() ; m_vOrderNormal.end() != itOrder ; itOrder++ )
	{
		vOrderId.push_back( (*itOrder)->m_dwOrderId );
	}

	// 擪I[_[珇Ԃɏ
	for ( itOrderId=vOrderId.begin() ; vOrderId.end() != itOrderId ; itOrderId++ )
	{
		pOrderData = GetOrderData( *itOrderId );
		
		if( NULL != pOrderData )
		{
			// 擪R}珇Ԃɏ
			for ( itFrame=pOrderData->m_vFrame.begin() ; pOrderData->m_vFrame.end() != itFrame ; itFrame++ )
			{
				if ( CFrameData::TYPE_PRINT == (*itFrame)->GetType() )
				{
					pFrame = (CFrameDataPrint*)(*itFrame);
					if( ( ReceiptNumber == pFrame->m_ReceiptNo ) ||
						( bExist == TRUE ) )
					{
						if( pFrame->m_SendFlg.bTRANSFER	== TRUE )
						{	// Mς݂̃R}̂݃LZ
							pFrame->m_PrintNum.Cancel = pFrame->m_PrintNum.Request;
//							pFrame->m_SendFlg.bUSER_CANCEL = TRUE;
							pFrame->m_eFrameState = STEP6_DELETE;
							{
								CString	str;
								str.Format("--FrameMemoryClear Cancel( ReceiptNo=%d PrintId=%d )", pFrame->m_ReceiptNo, pFrame->m_dwPrintId );
								NPS_LOGOUT( str );
							}
							UpdatePrintStatus( pFrame->m_dwPrintId );
						}
						bExist = TRUE;
					}
				}
			}
		}

		UpdateOrderStatus( pOrderData->m_dwOrderId );

	}

	vOrderId.clear();

	return TRUE;
}

//----------------------------------------
// JE^Ǘ
//----------------------------------------

//////////////////////////////////////////////////////////////////////////////
// CNgvgIDCNgĎ擾
DWORD CPrintQue::GetLatestPrintIdInc()
{
	NkcComApi::CCSScopeLock CSScopeLock( &m_CS );
	return ++m_dwLatestPrintId;
}
//////////////////////////////////////////////////////////////////////////////
// tOrderId@ʏ 擾
DWORD CPrintQue::GetOrderIdNormal()	
{
	NkcComApi::CCSScopeLock CSScopeLock( &m_CS );
	return m_dwAcceptNormalOrderId;
}
//////////////////////////////////////////////////////////////////////////////
// tOrderId@} 擾(Level1)
DWORD CPrintQue::GetOrderIdExpress()
{
	NkcComApi::CCSScopeLock CSScopeLock( &m_CS );
	return m_dwAcceptExpressOrderId;
}
//////////////////////////////////////////////////////////////////////////////
// tOrderId@}(Level2) 擾
DWORD CPrintQue::GetOrderIdExpressL2()
{
	NkcComApi::CCSScopeLock CSScopeLock( &m_CS );
	return m_dwAcceptExpressL2OrderId;
}
//////////////////////////////////////////////////////////////////////////////
// tOrderId@ʏ ݒ
void CPrintQue::SetOrderIdNormal( DWORD OrderIdNormal )
{
	NkcComApi::CCSScopeLock CSScopeLock( &m_CS );
	m_dwAcceptNormalOrderId = OrderIdNormal;
}
//////////////////////////////////////////////////////////////////////////////
// tOrderId@}(Level1) ݒ
void CPrintQue::SetOrderIdExpress( DWORD OrderIdExpress )
{
	NkcComApi::CCSScopeLock CSScopeLock( &m_CS );
	m_dwAcceptExpressOrderId = OrderIdExpress;
}
//////////////////////////////////////////////////////////////////////////////
// tOrderId@}(Level2) ݒ
void CPrintQue::SetOrderIdExpressL2( DWORD OrderIdExpressL2 )
{
	NkcComApi::CCSScopeLock CSScopeLock( &m_CS );
	m_dwAcceptExpressL2OrderId = OrderIdExpressL2;
}

//----------------------------------------
// {̓o^
//----------------------------------------

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CPrintQue::Init()
//	ABSTRACT : 
//	FUNCTION : 
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : T.Isogai	2006.9.21
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
void CPrintQue::Init(
		DWORD						dwIPAddress,			// v^IPAhX
		USHORT						wNpsPortNo,				// v^NPSp|[gԍ
		HPRINTER					hPrinter,				// v^nh
		CNpsCallbackCompletion*		pCallbackCompletion,	// vg󋵒ʒmNX
		CNpsCmd*					pNpsCmd,				// R}hMNX̃|C^
		CNpsImgManager*				pNpsImgMng,				// \PbgʐMNXǗ(r)NX
		CDataManager*				pDataManager			// v^ǗNX
		)
{
	NkcComApi::CCSScopeLock CSScopeLock( &m_CS );

	m_dwIPAddress				= dwIPAddress;				// v^IPAhX
	m_wNpsPortNo				= wNpsPortNo;				// v^NPSp|[gԍ
	m_hPrinter					= hPrinter;					// v^nh
	m_pCallbackCompletion		= pCallbackCompletion;		// vg󋵒ʒmNX
	m_pNpsCmd					= pNpsCmd;					// R}hMNX̃|C^
	m_pNpsImgMng				= pNpsImgMng;				// \PbgʐMNXǗ(r)NX
	m_pDataManager				= pDataManager;				// v^ǗNX
}

//----------------------------------------
// I[_[̓o^
//----------------------------------------

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CPrintQue::AddStartOrder()
//	ABSTRACT : StartOrder̓o^
//	FUNCTION : StartOrder̓o^
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : T.Isogai	2006.9.21
//	UPDATE   : J.Fukumori 2008.07.22 VS2005Ή
//	UPDATE   : M.Yamamoto	2014.10.28	݃vg̏ԒZk@\ǉ(Pvg)
//////////////////////////////////////////////////////////////////////////////
BOOL CPrintQue::AddStartOrder(
						void *				pCompletionProc,
						BOOL				bOccupyStart,
						USHORT				nPossessionMode,
						USHORT				nInterruptMode,
						DWORD				dwOption,
						USHORT				PossessionNo,
						USHORT				nPort,
						USHORT				nSorterNum,
						DWORD				dwSortFrame,
						DWORD				*pOrderId,
						BOOL				bIsMaintenance,
						DWORD				dwExOptions	// gIvV(Pvg) 2014.10.28 M.Yamamoto
														// EX_OPTIONS_NONE        : gIvVȂ
														// EX_OPTIONS_SINGLE_LINE : Pvg
						)
{
	NkcComApi::CCSScopeLock CSScopeLock( &m_CS );

	DWORD dwOrderId;

	dwOrderId = ++m_dwLatestOrderId;

	COrderData*	pOrderData;
	try
	{
		pOrderData = new COrderData();
	}
	catch (CMemoryException* e)
	{
		{
			CString str;
			str.Format( "===Memory allocation error [COrderData]" );
			NPS_LOGOUT_FATAL( str );
		}
		e->Delete();
		return FALSE;
	}

	*pOrderId						= dwOrderId;
	pOrderData->m_dwOrderId			= dwOrderId;
	pOrderData->m_nNpsImgPort		= nPort;
	pOrderData->m_nSorterNum		= nSorterNum;
	pOrderData->m_pCompletionProc	= pCompletionProc;
	pOrderData->m_dwSortFrame		= dwSortFrame;
	pOrderData->m_nPossessionNo		= PossessionNo;
	pOrderData->m_nFirstPossessionNo= PossessionNo;
	pOrderData->m_nInterruptMode	= nInterruptMode;
	pOrderData->m_dwOption			= dwOption;
	pOrderData->m_bIsMaintenance	= bIsMaintenance;
	pOrderData->m_dwExOptions		= dwExOptions;	// gIvV(Pvg)

	if( FALSE == bOccupyStart )
	{
		pOrderData->m_eOrderStep	= STEP1_ORDER_6000_0500;	// STEP-1	v^LJnς
//		pOrderData->m_nPossessionNo	= PossessionNo;
	}

	switch ( nPossessionMode )
	{
	case 0:		// ʏ
		m_dwAcceptNormalOrderId = pOrderData->m_dwOrderId;
		m_vOrderNormal.push_back( pOrderData );
		break;
	case 2:		// }[x1]
		m_dwAcceptExpressOrderId = pOrderData->m_dwOrderId;
		m_vOrderExpress.push_back( pOrderData );
		break;
	case 4:		// }[x2]
		m_dwAcceptExpressL2OrderId = pOrderData->m_dwOrderId;
		m_vOrderExpressL2.push_back( pOrderData );
		break;
	}


	return TRUE;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CPrintQue::AddEndOrder()
//	ABSTRACT : EndOrder̓o^
//	FUNCTION : EndOrder̓o^
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : T.Isogai	2006.9.21
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
BOOL CPrintQue::AddEndOrder(
						DWORD				dwOrderId
						)
{
	NkcComApi::CCSScopeLock CSScopeLock( &m_CS );

	COrderData*	pOrderData	= GetOrderData( dwOrderId );

	if( NULL == pOrderData )
	{
		return FALSE;
	}

	pOrderData->m_bEndOrder = TRUE;

	return TRUE;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CPrintQue::AddPrint()
//	ABSTRACT : Print̓o^
//	FUNCTION : Print̓o^
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : T.Isogai	2006.9.21
//	UPDATE   : T.Isogai	2008.06.06 npsDevPrintIccsXml APIǉ
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
BOOL CPrintQue::AddPrint(
				DWORD				dwOrderId,		// I[_[ID
				DWORD				dwPrintId,		// vgID
				DWORD				dwSourceType,	// 摜f[^[̎󂯓n@
													// 0FLn
													// 1Ft@Cn
				DWORD				dwDataLength,	// 摜f[^̃oCgTCYiPʁFBytej
				DWORD				dwOffset,		// 摜f[^̊i[ĂItZbg
				CString				strName,		// t@C}bsOIuWFNg
				DWORD				dwProcessId,	// vZXID
				BOOL				bBlankPrint,	// 󔒃vgtO
				DWORD				dwClearInk,		// NACN ( 0:Ȃ, 1: )
				void*				pCompletionProc,// vg󋵒ʒmR[obN֐|C^
				NPS_PrintInfo*		pPrnParam,		// vgp[^iNPSpp[^j
				T_ICCSXML*			pIccsXml		// IccsXml
				)
{
	NkcComApi::CCSScopeLock CSScopeLock( &m_CS );

	COrderData*	pOrderData	= GetOrderData( dwOrderId );

	if( NULL == pOrderData )
	{
		return FALSE;
	}

	CFrameDataPrint* pFrameDataPrint;
	try
	{
		pFrameDataPrint	= new CFrameDataPrint();
	}
	catch (CMemoryException* e)
	{
		{
			CString str;
			str.Format( "===Memory allocation error [CFrameDataPrint]" );
			NPS_LOGOUT_FATAL( str );
		}
		e->Delete();
		return FALSE;
	}

	pFrameDataPrint->m_dwPrintId		= dwPrintId;				// vgID
	pFrameDataPrint->m_dwSourceType		= dwSourceType;				// 摜f[^[̎󂯓n@
	pFrameDataPrint->m_dwDataLength		= dwDataLength;				// 摜f[^̃oCgTCYiPʁFBytej
	pFrameDataPrint->m_dwOffset			= dwOffset;					// 摜f[^̊i[ĂItZbg
	pFrameDataPrint->m_strName			= strName;					// t@C}bsOIuWFNg
	pFrameDataPrint->m_dwProcessId		= dwProcessId;				// vZXID
	pFrameDataPrint->m_bBlankPrint		= bBlankPrint;				// 󔒃vgtO
	pFrameDataPrint->m_dwClearInk		= dwClearInk;				// NACN ( 0:Ȃ, 1: )
	pFrameDataPrint->m_pCompletionProc	= pCompletionProc;			// vg󋵒ʒmR[obN֐|C^
	
	if( pIccsXml )
	{
		pFrameDataPrint->m_bIccsXml	= TRUE;
		memcpy( &(pFrameDataPrint->m_tIccsXml), pIccsXml, sizeof( T_ICCSXML ) );
	}

	if ( NULL != pPrnParam )										// vgp[^iNPSpp[^j
	{
		::MoveMemory( &(pFrameDataPrint->m_PrnParam), pPrnParam, sizeof(NPS_PrintInfo) );
		pFrameDataPrint->m_PrintNum.Repeat	= pPrnParam->dwPrintNum;	// vgis[gj
		pFrameDataPrint->m_PrintNum.Request	= pPrnParam->dwPrintNum;	// vgṽs[g
	}
	else
	{
		::ZeroMemory( &(pFrameDataPrint->m_PrnParam), sizeof(NPS_PrintInfo) );
	}

	// CfbNXԍZbg
	pFrameDataPrint->m_dwIndexNo = pOrderData->GetLatestIndexNo();

	pOrderData->m_vFrame.push_back( (CFrameData*) pFrameDataPrint );

	return TRUE;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CPrintQue::AddSort()
//	ABSTRACT : Sort̓o^
//	FUNCTION : Sort̓o^
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : T.Isogai	2006.9.21
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
BOOL CPrintQue::AddSort( DWORD dwOrderId )
{
	NkcComApi::CCSScopeLock CSScopeLock( &m_CS );

	COrderData*	pOrderData = GetOrderData( dwOrderId );

	if( NULL == pOrderData )
	{
		return FALSE;
	}

	CFrameDataSort*	pFrameDataSort;
	try
	{
		pFrameDataSort = new CFrameDataSort();
	}
	catch (CMemoryException* e)
	{
		{
			CString str;
			str.Format( "===Memory allocation error [CFrameDataSort]" );
			NPS_LOGOUT_FATAL( str );
		}
		e->Delete();
		return FALSE;
	}

	// CfbNXԍZbg
	pFrameDataSort->m_dwIndexNo = pOrderData->GetLatestIndexNo();

	pOrderData->m_vFrame.push_back( ( CFrameData*) pFrameDataSort );

	return TRUE;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CPrintQue::AddDuplex()
//	ABSTRACT : ʈJn
//	FUNCTION : 
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : Y.Yoshinobu	2008.5.22
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
BOOL CPrintQue::AddDuplex( DWORD dwOrderId, CFrameDataDuplex::E_DuplexMode eDuplexMode )
{
	NkcComApi::CCSScopeLock CSScopeLock( &m_CS );

	COrderData*	pOrderData = GetOrderData( dwOrderId );

	if( NULL == pOrderData )
	{
		return FALSE;
	}

	CFrameDataDuplex*	pFrameDataDuplex;
	try
	{
		pFrameDataDuplex = new CFrameDataDuplex();
	}
	catch (CMemoryException* e)
	{
		{
			CString str;
			str.Format( "===Memory allocation error [CFrameDataDuplex]" );
			NPS_LOGOUT_FATAL( str );
		}
		e->Delete();
		return FALSE;
	}

	pFrameDataDuplex->m_eDuplexMode = eDuplexMode;

	// CfbNXԍZbg
	pFrameDataDuplex->m_dwIndexNo = pOrderData->GetLatestIndexNo();

	pOrderData->m_vFrame.push_back( ( CFrameData*) pFrameDataDuplex );

	return TRUE;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CPrintQue::AddRetransmission()
//	ABSTRACT : đJn/I
//	FUNCTION : 
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : A.Nagamatsu	2011.11.21
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
BOOL CPrintQue::AddRetransmission( 
				DWORD					dwOrderId,					// I[_[ID
				NPS_InterruptOrderInfo*	pInterruptOrderInfo,		// fLZ
				CFrameDataRetransmission::E_RetransmissionMode eRetransmissionMode )
{
	NkcComApi::CCSScopeLock CSScopeLock( &m_CS );

	// I[_[IDLԍ擾
	USHORT	PossessionNo = 0;
	PossessionNo = GetPossessionNo( dwOrderId );
	if ( 0 == PossessionNo )
	{
		NPS_LOGOUT_FATAL( "--BADPARAM GetPossessionNo() FAIL" );
		return NPSERR_SYSERR;
	}

	COrderData*	pOrderData = GetOrderData( dwOrderId );
	if( NULL == pOrderData )
	{
		return FALSE;
	}

	CFrameDataRetransmission*	pFrameDataRetransmission;
	try
	{
		pFrameDataRetransmission = new CFrameDataRetransmission();
	}
	catch (CMemoryException* e)
	{
		{
			CString str;
			str.Format( "===Memory allocation error [CFrameDataRetransmission]" );
			NPS_LOGOUT_FATAL( str );
		}
		e->Delete();
		return FALSE;
	}

	::ZeroMemory( &(pFrameDataRetransmission->m_InterruptOrderInfo), sizeof(NPS_InterruptOrderInfo) );
	if( CFrameDataRetransmission::MODE_RETRANSMISSION_START == eRetransmissionMode )
	{	// đJn
		pFrameDataRetransmission->m_InterruptOrderInfo.wOrderState		= pInterruptOrderInfo->wOrderState;			// f̃I[_[
		pFrameDataRetransmission->m_InterruptOrderInfo.wMainSideState	= pInterruptOrderInfo->wMainSideState;		// ʃvg̕\ʊJnm点
		pFrameDataRetransmission->m_InterruptOrderInfo.wBackSideState	= pInterruptOrderInfo->wBackSideState;		// ʃvg̗ʊJnm点
		pFrameDataRetransmission->m_InterruptOrderInfo.wPrintSide		= pInterruptOrderInfo->wPrintSide;			// ʃvg̃vg
	}
	else
	{	// đI
	}

	pFrameDataRetransmission->m_nPossessionNo		= PossessionNo;				// Lԍ
	pFrameDataRetransmission->m_eRetransmissionMode	= eRetransmissionMode;		// đ[h

	// CfbNXԍZbg
	pFrameDataRetransmission->m_dwIndexNo = pOrderData->GetLatestIndexNo();

	pOrderData->m_vFrame.push_back( ( CFrameData*) pFrameDataRetransmission );

	return TRUE;
}


//----------------------------------------
// L[̍XV
//----------------------------------------

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CPrintQue::UpdatePrintStatus()
//	ABSTRACT : vgR}̍XV
//	FUNCTION : vgR}XV
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : T.Isogai	2006.10.2
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
void CPrintQue::UpdatePrintStatus( DWORD dwPrintId )
{
	CFrameData*	pFrameData	= GetFrameDataByPrintId( dwPrintId );

	if( NULL == pFrameData )
	{
		return;
	}

	CFrameDataPrint*	pFrameDataPrint	= ( CFrameDataPrint* ) pFrameData;

	//////////////////////////////////////////////////////////////////////////////
	// ʒmivgj
	
	// RESULT_TRANSFER
	if( ( FALSE == pFrameDataPrint->m_SendFlg.bTRANSFER ) &&
		( pFrameDataPrint->m_PrintNum.Repeat <= ( pFrameDataPrint->m_PrintNum.Transfer + pFrameDataPrint->m_PrintNum.Cancel + pFrameDataPrint->m_PrintNum.NG ) ) )
	{
		CallbackCompletionPrint( pFrameDataPrint->m_pCompletionProc, pFrameDataPrint->m_dwProcessId,
				pFrameDataPrint->m_dwPrintId, RESULT_TRANSFER, pFrameDataPrint->m_PrintNum.Transfer );

		pFrameDataPrint->m_SendFlg.bTRANSFER	= TRUE;
		if ( 0 == pFrameDataPrint->m_PrintNum.Transfer )
		{
			pFrameDataPrint->m_SendFlg.bPRINT	= TRUE;
			pFrameDataPrint->m_SendFlg.bOK		= TRUE;
		}
	}
	
	// >>>>> 2011.11.24 A.Nagamatsu
	// vgAroʒmɒʒm
	// RESULT_OK_RETRANSMISSION
	if((( FALSE == pFrameDataPrint->m_SendFlg.bOK_RETRANSMISSION ) &&
		( pFrameDataPrint->m_PrintNum.Out_Retransmission != pFrameDataPrint->m_PrintNum.Out_Retransmission_Inform )) &&
		( pFrameDataPrint->m_PrintNum.Repeat <=	( pFrameDataPrint->m_PrintNum.Out_Retransmission + pFrameDataPrint->m_PrintNum.Cancel + pFrameDataPrint->m_PrintNum.NG ) ) )
	{
		CallbackCompletionPrint( pFrameDataPrint->m_pCompletionProc, pFrameDataPrint->m_dwProcessId,
				pFrameDataPrint->m_dwPrintId, RESULT_OK_RETRANSMISSION, pFrameDataPrint->m_PrintNum.Out_Retransmission );

		// ʒmςݖ XV 2011.12.13 A.Nagamatsu	isvɖʒm(0)ʒm邽߁Aωꍇɒʒm悤ɕύXj
		pFrameDataPrint->m_PrintNum.Out_Retransmission_Inform = pFrameDataPrint->m_PrintNum.Out_Retransmission;

		pFrameDataPrint->m_SendFlg.bOK_RETRANSMISSION	= TRUE;
	}
	// <<<<<

	// RESULT_PRINT_REPEAT
	if( pFrameDataPrint->m_PrintNum.End != pFrameDataPrint->m_PrintNum.End_Inform )
	{	// IXVꂽƂ
		if( g_dwCompProcMode  & NPS_PRINT_DETAIL_NOTIFY_ENABLE )
		{	// Ȉڍגʒm̂Ƃ
			// vgPʂ̘Iʒm
			CallbackCompletionPrint( pFrameDataPrint->m_pCompletionProc, pFrameDataPrint->m_dwProcessId,
					pFrameDataPrint->m_dwPrintId, RESULT_PRINT_REPEAT, pFrameDataPrint->m_PrintNum.End );
		}
		// ʒmςݖ XV
		pFrameDataPrint->m_PrintNum.End_Inform = pFrameDataPrint->m_PrintNum.End;
	}

	// RESULT_PRINT
	if( ( FALSE == pFrameDataPrint->m_SendFlg.bPRINT ) &&
		( pFrameDataPrint->m_PrintNum.Repeat <=	( pFrameDataPrint->m_PrintNum.End + pFrameDataPrint->m_PrintNum.Cancel + pFrameDataPrint->m_PrintNum.NG ) ) )
	{
		CallbackCompletionPrint( pFrameDataPrint->m_pCompletionProc, pFrameDataPrint->m_dwProcessId,
				pFrameDataPrint->m_dwPrintId, RESULT_PRINT, pFrameDataPrint->m_PrintNum.End );

		pFrameDataPrint->m_SendFlg.bPRINT	= TRUE;
		if ( 0 == pFrameDataPrint->m_PrintNum.End )
		{
			pFrameDataPrint->m_SendFlg.bOK		= TRUE;
		}
	}

	// RESULT_OK_REPEAT
	if( pFrameDataPrint->m_PrintNum.Out != pFrameDataPrint->m_PrintNum.Out_Inform )
	{	// vgroXVꂽƂ
		if( g_dwCompProcMode  & NPS_OUTPUT_DETAIL_NOTIFY_ENABLE )
		{	// rȍڍגʒm̂Ƃ
			// vgPʂ̔roʒm
			CallbackCompletionPrint( pFrameDataPrint->m_pCompletionProc, pFrameDataPrint->m_dwProcessId,
					pFrameDataPrint->m_dwPrintId, RESULT_OK_REPEAT, pFrameDataPrint->m_PrintNum.Out );
		}
		// ʒmςݖ XV
		pFrameDataPrint->m_PrintNum.Out_Inform = pFrameDataPrint->m_PrintNum.Out;
	}

	// RESULT_OK
	if( ( FALSE == pFrameDataPrint->m_SendFlg.bOK ) &&
		( pFrameDataPrint->m_PrintNum.Repeat <=	( pFrameDataPrint->m_PrintNum.Out + pFrameDataPrint->m_PrintNum.Cancel + pFrameDataPrint->m_PrintNum.NG ) ) )
	{
		CallbackCompletionPrint( pFrameDataPrint->m_pCompletionProc, pFrameDataPrint->m_dwProcessId,
				pFrameDataPrint->m_dwPrintId, RESULT_OK, pFrameDataPrint->m_PrintNum.Out );

		pFrameDataPrint->m_SendFlg.bOK	= TRUE;
	}

	// >>>>> 2011.11.17 A.Nagamatsu
	// RESULT_LOADING_REPEAT
	if( pFrameDataPrint->m_PrintNum.Loading != pFrameDataPrint->m_PrintNum.Loading_Inform )
	{	// [fBOJnXVꂽƂ
		if( g_dwCompProcMode  & NPS_LOADING_DETAIL_NOTIFY_ENABLE )
		{	// [fBOJn̏ڍגʒm̂Ƃ
			// s[gPʂ̃[fBOJnʒm
			CallbackCompletionPrint( pFrameDataPrint->m_pCompletionProc, pFrameDataPrint->m_dwProcessId,
					pFrameDataPrint->m_dwPrintId, RESULT_LOADING_REPEAT, pFrameDataPrint->m_PrintNum.Loading );
		}
		// ʒmςݖ XV
		pFrameDataPrint->m_PrintNum.Loading_Inform = pFrameDataPrint->m_PrintNum.Loading;
	}

	// RESULT_LOADING
	if( ( FALSE == pFrameDataPrint->m_SendFlg.bLOADING ) &&
		( pFrameDataPrint->m_PrintNum.Repeat <=	( pFrameDataPrint->m_PrintNum.Loading + pFrameDataPrint->m_PrintNum.Cancel + pFrameDataPrint->m_PrintNum.NG ) ) )
	{
		CallbackCompletionPrint( pFrameDataPrint->m_pCompletionProc, pFrameDataPrint->m_dwProcessId,
				pFrameDataPrint->m_dwPrintId, RESULT_LOADING, pFrameDataPrint->m_PrintNum.Loading );

		pFrameDataPrint->m_SendFlg.bLOADING	= TRUE;
	}
	// <<<<<
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CPrintQue::UpdateOrderStatus()
//	ABSTRACT : I[_[̍XV
//	FUNCTION : I[_[XV
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : T.Isogai	2006.10.2
//	UPDATE   : J.Fukumori(AVASYS) 2008.07.18 VS2005Ή
//////////////////////////////////////////////////////////////////////////////
void CPrintQue::UpdateOrderStatus( DWORD dwOrderId, E_UpdateOrderStatus eMode )
{
	COrderData*	pOrderData	= GetOrderData( dwOrderId );
	
	if( NULL == pOrderData )
	{
		return;
	}

	//////////////////////////////////////////////////////////////////////////////
	// I[_[
	if( FALSE == pOrderData->m_bEndOrder )
	{
		return;
	}

	int nIdx;
	ULONG nRepeat;
	ULONG nTotal;
	BOOL	bOrderEnd	= TRUE;
	BOOL	bCancel		= FALSE;
	BOOL	bNG			= FALSE;

	for ( nIdx=0 ; (int)pOrderData->m_vFrame.size() > nIdx ; nIdx++ )
	{
		CFrameData*	ptmpFrameData	= ( CFrameData* ) pOrderData->m_vFrame[nIdx];

		if ( CFrameData::TYPE_PRINT == ptmpFrameData->GetType() )
		{
			nRepeat = ((CFrameDataPrint*)ptmpFrameData)->m_PrintNum.Repeat;		// s[g
			nTotal	= ((CFrameDataPrint*)ptmpFrameData)->m_PrintNum.Out			// vgro
						+ ((CFrameDataPrint*)ptmpFrameData)->m_PrintNum.Cancel	//  + vgs
						+ ((CFrameDataPrint*)ptmpFrameData)->m_PrintNum.NG;		//  + vgLZ


			if ( nRepeat > nTotal )
			{
				bOrderEnd	= FALSE;
				break;
			}

			if ( 0 < ((CFrameDataPrint*)ptmpFrameData)->m_PrintNum.Cancel )
			{
				bCancel	= TRUE;
			}

			if ( 0 < ((CFrameDataPrint*)ptmpFrameData)->m_PrintNum.NG )
			{
				bNG		= TRUE;
			}
		}
		else if( CFrameData::TYPE_DUPLEX == ptmpFrameData->GetType() )
		{	// ʏIvMłI[_[폜Ă܂ꍇ̂C	2012.12.13 T.Mizushima
			if( ptmpFrameData->m_eFrameState < STEP5_SORT_COMPLETE )
			{	// M
				bOrderEnd	= FALSE;
				break;
			}
		}
	}

	if ( FALSE == bOrderEnd )
	{
		return;
	}

	DWORD dwStatus;

	// ʒmivgj
	if (( TRUE == bNG ) || ( UPDATE_OFFLINE == eMode ))
	{
		dwStatus = RESULT_NG;
	}
	else
	{
		if ( TRUE == bCancel )
		{
			dwStatus = RESULT_USER_CANCEL;
		}
		else
		{
			dwStatus = RESULT_OK;
		}
	}

	CallbackCompletionOrder( pOrderData->m_pCompletionProc,
		pOrderData->m_dwOrderId,
		dwStatus );

	// I[_[̍폜
	DeleteOrderData( pOrderData->m_dwOrderId );
}


//----------------------------------------
// I[_[̍XV
//----------------------------------------

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CPrintQue::RecvEventCompletion()
//	ABSTRACT : vgԕύXʒmM
//	FUNCTION : vg󋵕ύXʒmɉē̃Xe[^XύX
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : T.Isogai	2006.9.21
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
void CPrintQue::RecvEventCompletion( ULONG nReceipt, UCHAR nStatus, USHORT nRepeat )
{
	NkcComApi::CCSScopeLock CSScopeLock( &m_CS );

	if( INFO_SUPPORTINTNEW == m_pDataManager->GetPrinterSetupSupportInterrupt() )
	{	// V^荞ݑΉ		@@@RD-151Ή	2012.02.10	T.Mizushima
		if( ( nStatus == 5 ) || ( nStatus == 6 ) )
		{	// 5Fvg荞ݒfiĊJ҂j => [1F荞ݒf̍ĊJ]ŐLĊJ
			// 6Fvg荞ݒfiĊJ҂j => [0Fʏ]ŐLĊJ
			// ͎dlʒmȂAʒmĂ
			return;
		}
	}

#if 0	// 2006.12.07 T.Mizushima
	COrderData*	pOrderData	= GetOrderDataByReceiptNo( nReceipt );
#else
	COrderData*	pOrderData	= GetOrderDataByReceiptNo2( nReceipt );
#endif

	if( NULL == pOrderData )
	{
		return;
	}

#if 0	// 2006.12.07 T.Mizushima
	CFrameData*	pFrameData	= pOrderData->GetFrameDataByReceiptNo( nReceipt );
#else
	CFrameData*	pFrameData	= pOrderData->GetFrameDataByReceiptNo2( nReceipt );
#endif

	if( NULL == pFrameData )
	{
		return;
	}

	CFrameDataPrint* pFrameDataPrint	= (CFrameDataPrint*)pFrameData;

	//----------------------------------------------------------------------------
	// vgXV
	//----------------------------------------------------------------------------
	switch( nStatus )
	{
	// 1FvgJn
	case 1:
			{
				pFrameDataPrint->m_PrintNum.Start++;

				// >>>>> A.Nagamatsu 2011.11.22
				// vgMۂɃ[fBOJnZȂ
				//  G[̃vgĊJɂĐVKy[p[̃Zbg𔻒f邽߂
				//  [fBOJnǉĂ܂̂ŁAG[̖ʒmŌZĂ܂
				//  G[̃vgĊJɃZbgy[p[킩ȂȂ邽߁B
				// ̂߁AvgJnMꍇɁA[fBOJnƃvgJnȂ
				// [fBOJnMς݂ƔfČZ
				// ivgJn->vg͕̏ۏ؂Ă邽߁j
				if( pFrameDataPrint->m_PrintNum.Loading == pFrameDataPrint->m_PrintNum.Start )
				{	// [fBOJnʒmMς
					pFrameDataPrint->m_PrintNum.Loading--;
				}
				// <<<<<
			}	break;

	case 2: pFrameDataPrint->m_PrintNum.End++;		break;	// 2FvgiIj
	case 3: pFrameDataPrint->m_PrintNum.Out++;		break;	// 3Fvgro

	// 4Fvgs
	case 4:													
			{
				if ( pFrameDataPrint->m_PrintNum.End < nRepeat )
				{
					// IĂȂ̂ŃG[Ƃď

					// v^ւ̑M̎
					PrinterErrorReset( nReceipt, nRepeat );
				}
				else
				{
					// _Ή T1587 2007.09.06 Yoshinobu
					// IĂ̂ŃvgroƂď

					pFrameDataPrint->m_PrintNum.Out++;

				}

			} break;

	// 5Fvg荞ݒfiĊJ҂j => [1F荞ݒf̍ĊJ]ŐLĊJ
	// 6Fvg荞ݒfiĊJ҂j => [0Fʏ]ŐLĊJ
	case 5:
			{
				// [1F荞ݒf̍ĊJ(ʏ)]ŐLĊJ悤ɃtOZbg
				E_QueModeP eQueModeP;
				if ( TRUE == GetPriorityModeByReceiptNo( nReceipt, eQueModeP ) )
				{
					switch ( eQueModeP )
					{
					case QUE_NORMAL:		// ʏ
						{	// Oo
							CString str;
							str.Format( "-- ### WARIKOMI TYUDAN RECV ( NORMAL ReceiptNo=%d, Repeat=%d ) ###", nReceipt, nRepeat );
							NPS_LOGOUT_DEBUG( str );
						}
						m_pDataManager->SetRestartNormal( TRUE );
						break;
					case QUE_EXPRESS1:		// }(Level1)
						{	// Oo
							CString str;
							str.Format( "-- ### WARIKOMI TYUDAN RECV ( EXPRESS1 ReceiptNo=%d, Repeat=%d ) ###", nReceipt, nRepeat );
							NPS_LOGOUT_DEBUG( str );
						}
						m_pDataManager->SetRestartExpress( TRUE );
						break;
					}
				}
			}
	case 6:
			{
				// v^ւ̑M̎
				InterruptReset( nReceipt, nRepeat );
				if ( 0 != pOrderData->m_nNpsImgPort )
				{
					// ڑؒf
					m_pNpsImgMng->Delete( pOrderData->m_nNpsImgPort );
					pOrderData->m_nNpsImgPort = 0;
				}
			} break;

	// 7FvgLZ
	case 7:
			{
				// iLZƂȂj=ivgvj-iʒmRepeatCountj+ 1
				// ivgvj́A~ĊJlāAۂɂ̉ł̃vgvƂ

				// >>>>> yD502zLZR}̃G[̌㏈̑΍2ʒmz肷悤ɕύX (_02191,_02829) Y.Yoshinobu 2009.08.19
				//pFrameDataPrint->m_PrintNum.Cancel += ( pFrameDataPrint->m_PrintNum.Request - nRepeat + 1 );
				pFrameDataPrint->m_PrintNum.Cancel = ( pFrameDataPrint->m_PrintNum.Request - nRepeat + 1 );
				// <<<<<

			} break;

	// 8Fvg
	case 8:
			{
				// >>>>> 2011.11.24 A.Nagamatsu
				// [fBOJnƍđproȂAđproMς݂ƔfČZ
				// ivgJn->vg͕̏ۏ؂Ăj
				if( pFrameDataPrint->m_PrintNum.Out_Retransmission == pFrameDataPrint->m_PrintNum.Start )
				{	// đpro
					pFrameDataPrint->m_PrintNum.Out_Retransmission--;
					pFrameDataPrint->m_SendFlg.bOK_RETRANSMISSION	= FALSE;		// LZʒmɁAđproZŒʒmKv
				}
				// <<<<<
				
				pFrameDataPrint->m_PrintNum.Start--;
			}
			break;

	// 9Ft[NA	2007.01.23 T.Mizushima
	case 9:
			{
				// v^ւ̑M̎
				PrinterErrorReset( nReceipt, nRepeat );
			} break;

	// 10F[fBOJn				2011.11.1 A.Nagamatsu (D703/WG)
	case 10: pFrameDataPrint->m_PrintNum.Loading++;	break;	// 10: [fBOJn

	// 11Fđpro				2011.11.24 A.Nagamatsu (D703/WG)
	case 11:
			{
				pFrameDataPrint->m_PrintNum.Out_Retransmission++;
				
			} break;

	default:break;
	}

	// >>>>> _Ή V@tH[[ T1526	Y.Yoshinobu 2007.07.02
	// [4Fvgs]̏ꍇɁApOrderData, pFrameDataPrint ̃AhX
	// JėOsC܂B
	pOrderData	= GetOrderDataByReceiptNo2( nReceipt );
	if( NULL == pOrderData )
	{
		return;
	}
	pFrameData	= pOrderData->GetFrameDataByReceiptNo2( nReceipt );
	if( NULL == pFrameData )
	{
		return;
	}
	pFrameDataPrint = (CFrameDataPrint*)pFrameData;
	// <<<<< _Ή V@tH[[ T1526

	UpdatePrintStatus( pFrameDataPrint->m_dwPrintId );
	UpdateOrderStatus( pOrderData->m_dwOrderId );	
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CPrintQue::InsideProcError()
//	ABSTRACT : vg󋵕ύXiCuŔG[j
//	FUNCTION : 
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : Y.Yoshinobu	2006.10.18
//	UPDATE   : J.Fukumori(AVASYS) 2008.07.17 VS2005Ή
//////////////////////////////////////////////////////////////////////////////
void CPrintQue::InsideProcError( DWORD dwPrintId )
{
	NkcComApi::CCSScopeLock CSScopeLock( &m_CS );



	BOOL bExist = FALSE;
	COrderData*	pOrderData;
	COrderData*	pChkOrderData = NULL;
	CFrameDataPrint* pFrame;
	std::vector<COrderData*>::iterator	itOrder;
	std::vector<CFrameData*>::iterator	itFrame;
	std::vector<DWORD> vOrderId;
	std::vector<DWORD>::iterator itOrderId;

	// UpdateOrderStatus ĂяoƏĂI[_[̓L[폜̂
	// UI[_[ID̃Xg쐬āA1I[_[s

	for ( itOrder=m_vOrderExpressL2.begin() ; m_vOrderExpressL2.end() != itOrder ; itOrder++ )
	{
		vOrderId.push_back( (*itOrder)->m_dwOrderId );
	}
	for ( itOrder=m_vOrderExpress.begin() ; m_vOrderExpress.end() != itOrder ; itOrder++ )
	{
		vOrderId.push_back( (*itOrder)->m_dwOrderId );
	}
	for ( itOrder=m_vOrderNormal.begin() ; m_vOrderNormal.end() != itOrder ; itOrder++ )
	{
		vOrderId.push_back( (*itOrder)->m_dwOrderId );
	}

	// 擪I[_[珇Ԃɏ
	for ( itOrderId=vOrderId.begin() ; vOrderId.end() != itOrderId ; itOrderId++ )
	{
		pOrderData = GetOrderData( *itOrderId );

		if( NULL != pOrderData )
		{
			// NKCdlł́AG[ɂȂI[_[͑SĖŃG[Ƃď
			// AeiX[h͎tς݂ɂȂ
			if (( FALSE == pOrderData->m_bEndOrder ) && ( FALSE == pOrderData->m_bIsMaintenance ))
			{
				// EndOrdertς݂𖳏ŗL
				pOrderData->m_bEndOrder = TRUE;
				m_dwAcceptNormalOrderId		= 0;
				m_dwAcceptExpressOrderId	= 0;
				m_dwAcceptExpressL2OrderId	= 0;
			}
			// 擪R}珇Ԃɏ
			for ( itFrame=pOrderData->m_vFrame.begin() ; pOrderData->m_vFrame.end() != itFrame ; itFrame++ )
			{
				if ( CFrameData::TYPE_PRINT == (*itFrame)->GetType() )
				{

					pFrame = (CFrameDataPrint*)(*itFrame);

					if ( dwPrintId == pFrame->m_dwPrintId )
					{

						pFrame->m_PrintNum.NG += pFrame->m_PrintNum.Request;

						UpdatePrintStatus( pFrame->m_dwPrintId );

						bExist = TRUE;

						continue;

					}

					if ( TRUE == bExist )
					{

						pFrame->m_PrintNum.NG = pFrame->m_PrintNum.Request;

						UpdatePrintStatus( pFrame->m_dwPrintId );

					}

				}
			}

			UpdateOrderStatus( pOrderData->m_dwOrderId );

		}

	}

	vOrderId.clear();

}



//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CPrintQue::OfflineErrorReset()
//	ABSTRACT : vg󋵕ύXiItCɂȂ̏j
//	FUNCTION : 
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : Y.Yoshinobu	2006.10.18
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
void CPrintQue::OfflineErrorReset()
{
	NkcComApi::CCSScopeLock CSScopeLock( &m_CS );

	ULONG nStart;
	ULONG nEnd;
	COrderData*	pOrderData;
	CFrameDataPrint* pFrame;
	std::vector<COrderData*>::iterator	itOrder;
	std::vector<CFrameData*>::iterator	itFrame;
	std::vector<DWORD> vOrderId;
	std::vector<DWORD>::iterator itOrderId;

	// UpdateOrderStatus ĂяoƏĂI[_[̓L[폜̂
	// UI[_[ID̃Xg쐬āA1I[_[s

	for ( itOrder=m_vOrderExpressL2.begin() ; m_vOrderExpressL2.end() != itOrder ; itOrder++ )
	{
		vOrderId.push_back( (*itOrder)->m_dwOrderId );
	}
	for ( itOrder=m_vOrderExpress.begin() ; m_vOrderExpress.end() != itOrder ; itOrder++ )
	{
		vOrderId.push_back( (*itOrder)->m_dwOrderId );
	}
	for ( itOrder=m_vOrderNormal.begin() ; m_vOrderNormal.end() != itOrder ; itOrder++ )
	{
		vOrderId.push_back( (*itOrder)->m_dwOrderId );
	}

	// 擪珇Ԃɏ
	for ( itOrderId=vOrderId.begin() ; vOrderId.end() != itOrderId ; itOrderId++ )
	{
		pOrderData = GetOrderData( *itOrderId );
		
		if( NULL != pOrderData )
		{
			// NKCdlł́AItCɂȂI[_[͑SĖŃG[Ƃď
			if ( FALSE == pOrderData->m_bEndOrder )
			{
				// EndOrdertς݂𖳏ŗL
				pOrderData->m_bEndOrder = TRUE;
				m_dwAcceptNormalOrderId		= 0;
				m_dwAcceptExpressOrderId	= 0;
				m_dwAcceptExpressL2OrderId	= 0;
			}
			for ( itFrame=pOrderData->m_vFrame.begin() ; pOrderData->m_vFrame.end() != itFrame ; itFrame++ )
			{
				if ( CFrameData::TYPE_PRINT == (*itFrame)->GetType() )
				{
					if( (*itFrame)->m_eFrameState == STEP6_DELETE )	// 2006.11.16 T.Mizushima
					{	// LZꂽt[ȂƂ΂
						continue;
					}

					pFrame = (CFrameDataPrint*)(*itFrame);

					nStart		= pFrame->m_PrintNum.Start;
					nEnd		= pFrame->m_PrintNum.Out + pFrame->m_PrintNum.Cancel + pFrame->m_PrintNum.NG;

						// gC

						// vgroĂȂf[^͑Săvgsɂ
						pFrame->m_PrintNum.NG += pFrame->m_PrintNum.Request - nEnd;


					UpdatePrintStatus( pFrame->m_dwPrintId );

				}
			}

		}

		UpdateOrderStatus( *itOrderId, UPDATE_OFFLINE );

	}

	vOrderId.clear();

	// _ 01558 2006.12.22 Y.Yoshinobu
	// LɃItCɂȂLIȂĂǂ̂ŃZbg
	::ZeroMemory( &m_PossessionRelease, sizeof(T_PossessionRelease) );
	m_PossessionRelease.bPossessionRelease = FALSE;

	return;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CPrintQue::SetPossessionNo()
//	ABSTRACT : Lԍ̐ݒ
//	FUNCTION : Lԍ̐ݒ
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : T.Isogai	2006.9.22
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
BOOL CPrintQue::SetPossessionNo( DWORD dwOrderId, USHORT PossessionNo )
{
	NkcComApi::CCSScopeLock CSScopeLock( &m_CS );

	COrderData*	pOrderData = GetOrderData( dwOrderId );

	if( NULL == pOrderData )
	{
		return FALSE;
	}

	pOrderData->m_nPossessionNo		= PossessionNo;

	return TRUE;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CPrintQue::GetPossessionNo()
//	ABSTRACT : Lԍ̎擾
//	FUNCTION : Lԍ̎擾
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : T.Mizushima	2006.11.22
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
USHORT CPrintQue::GetPossessionNo( DWORD dwOrderId )
{
	NkcComApi::CCSScopeLock CSScopeLock( &m_CS );

	COrderData*	pOrderData = GetOrderData( dwOrderId );

	if( NULL == pOrderData )
	{
		return 0;
	}

	return pOrderData->m_nPossessionNo;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CPrintQue::SetPortNo()
//	ABSTRACT : |[gԍ̐ݒ
//	FUNCTION : |[gԍ̐ݒ
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : T.Mizushima	2006.10.11
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
BOOL CPrintQue::SetPortNo( DWORD dwOrderId, USHORT PortNo )
{
	NkcComApi::CCSScopeLock CSScopeLock( &m_CS );

	COrderData*	pOrderData = GetOrderData( dwOrderId );

	if( NULL == pOrderData )
	{
		return FALSE;
	}

	pOrderData->m_nNpsImgPort = PortNo;

	return TRUE;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CPrintQue::UpdateOrderStep()
//	ABSTRACT : vgv̔sԂ̍XViORDERj
//	FUNCTION : 
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : Y.Yoshinobu	2006.10.9
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
BOOL CPrintQue::UpdateOrderStep( DWORD dwOrderId, E_PrintOrderStep eStep )
{
	NkcComApi::CCSScopeLock CSScopeLock( &m_CS );


	if ( eStep == STEP4_ORDER_6000_0600 )
	{
		if ( TRUE == m_PossessionRelease.bPossessionRelease )
		{
			if ( dwOrderId == m_PossessionRelease.tNextCmd.dwOrderId )
			{
				// LĨZbg
				::ZeroMemory( &m_PossessionRelease, sizeof(T_PossessionRelease) );
				m_PossessionRelease.bPossessionRelease = FALSE;
			}
			return TRUE;
		}
	}


	COrderData*	pOrderData	= GetOrderData( dwOrderId );

	if( NULL == pOrderData )
	{
		return FALSE;
	}


	pOrderData->m_eOrderStep = eStep;

	return TRUE;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CPrintQue::UpdateFrameStep()
//	ABSTRACT : vgv̔sԂ̍XViFRAMEj
//	FUNCTION : 
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : Y.Yoshinobu	2006.10.9
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
BOOL CPrintQue::UpdateFrameStep(  DWORD dwOrderId, DWORD dwIndexNo, E_PrintFrameStep eStep, DWORD dwPrintId )
{
	NkcComApi::CCSScopeLock CSScopeLock( &m_CS );

	CFrameData*	pFrameData	= GetFrameDataByIndexNo( dwOrderId, dwIndexNo );

	if( NULL == pFrameData )
	{
		return FALSE;
	}

	// ԂXV
	pFrameData->m_eFrameState = eStep;

	if ( STEP4_FRAME_6000_0800 == eStep )
	{
		// CȗM
		((CFrameDataPrint*)pFrameData)->m_PrintNum.Transfer	+= ((CFrameDataPrint*)pFrameData)->m_PrintNum.Request;

		UpdatePrintStatus( ((CFrameDataPrint*)pFrameData)->m_dwPrintId );
	}

	return TRUE;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CPrintQue::SetReceiptNo()
//	ABSTRACT : tԍ̐ݒ
//	FUNCTION : tԍ̐ݒ
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : T.Isogai	2006.9.22
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
BOOL CPrintQue::SetReceiptNo( DWORD dwOrderId, DWORD dwPrintId, ULONG ReceiptNo )
{
	NkcComApi::CCSScopeLock CSScopeLock( &m_CS );

	COrderData*	pOrderData = GetOrderData( dwOrderId );

	if( NULL == pOrderData )
	{
		return FALSE;
	}

	CFrameData*	pFrameData = pOrderData->GetFrameData( dwPrintId );

	if( NULL == pFrameData )
	{
		return FALSE;
	}

	if( CFrameData::TYPE_PRINT != pFrameData->GetType() )
	{
		return FALSE;
	}

	( (CFrameDataPrint*) pFrameData )->m_ReceiptNo	= ReceiptNo;

	// s[gvgȂǂɓ}荞ݓꍇ́A荞ݏIɍđ邪
	// ̎ ReceiptNo ͕ςĂ܂BĊ荞ݑOɘIς݂vg
	// roʒm󂯎ĂA̒ʒm ReceiptNo ͍đ ReceiptNo ɏ㏑
	// ܂Ă邽߂ɁAvg̏IJEgꂸAʓIɍđI[_[̊
	// ołȂꍇBĔ̂߂ ReceiptNo ̗ƂĂB
	// JǗ_V[g00985	2006.12.07 T.Mizushima
	( (CFrameDataPrint*) pFrameData )->m_ReceiptNoArray.Add( ReceiptNo );

	return TRUE;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CPrintQue::RequestEndOrderEnd()
//	ABSTRACT : EndOrder̊
//	FUNCTION : EndOrder̊
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : T.Isogai	2006.9.22
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
BOOL CPrintQue::RequestEndOrderEnd( DWORD dwOrderId )
{
	NkcComApi::CCSScopeLock CSScopeLock( &m_CS );

	COrderData*	pOrderData	= GetOrderData( dwOrderId );

	if( NULL == pOrderData )
	{
		return FALSE;
	}

	// \PbgN[Y
	if ( 0 != pOrderData->m_nNpsImgPort )
	{
		// ڑؒf
		m_pNpsImgMng->Delete( pOrderData->m_nNpsImgPort );
		pOrderData->m_nNpsImgPort = 0;
	}

	UpdateOrderStatus( pOrderData->m_dwOrderId );

	return TRUE;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CPrintQue::CancelProc()
//	ABSTRACT : vgݒ
//	FUNCTION : vgݒ
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : T.Isogai	2006.9.22
//	UPDATE   : J.Fukumori(AVASYS) 2008.07.18 VS2005Ή
//////////////////////////////////////////////////////////////////////////////
BOOL CPrintQue::CancelProc( DWORD dwOrderId, DWORD dwPrintID, CList<ULONG,ULONG>* pList )
{
	NkcComApi::CCSScopeLock CSScopeLock( &m_CS );

	BOOL bRet = FALSE;

	COrderData * pOrderData	= GetOrderData( dwOrderId );

	//------------------------------------------------------------------
	// Ώۂ̑݃`FbN
	//------------------------------------------------------------------

	if( pOrderData )
	{
		if( 0 == dwPrintID )
		{
			bRet = TRUE;
		}
		else
		{
			CFrameData * pFrameData	= GetFrameDataByPrintId( dwPrintID );

			if( pFrameData )
			{
				if( ((CFrameDataPrint*)pFrameData)->m_SendFlg.bUSER_CANCEL == FALSE )
				{	// łɃLZς݂ȂΏۊOɂ		2006.12.25 T.Mizushima
					bRet = TRUE;
				}
			}
		}
	}

	if( pOrderData )
	{
		for( int i = 0; i < (int)pOrderData->m_vFrame.size(); i++ )
		{
			CFrameData*	pFrameData	= pOrderData->m_vFrame[i];

			if( CFrameData::TYPE_PRINT == pFrameData->GetType() )
			{

				if( ( dwPrintID != 0 ) && ( ((CFrameDataPrint*)pFrameData)->m_dwPrintId != dwPrintID ) )
				{
					continue;
				}

				if( ((CFrameDataPrint*)pFrameData)->m_SendFlg.bUSER_CANCEL == TRUE )
				{	// łɃLZς݂ȂΏۊOɂ		2006.12.25 T.Mizushima
					continue;
				}


				switch ( pFrameData->m_eFrameState )
				{
				case STEP0_FRAME_NONE:			// STEP-0	
					// 摜M
					((CFrameDataPrint*)pFrameData)->m_PrintNum.Cancel
						=	((CFrameDataPrint*)pFrameData)->m_PrintNum.Repeat - ((CFrameDataPrint*)pFrameData)->m_PrintNum.Transfer;
					// 摜𑗐MȂ悤ɍ폜
					pFrameData->m_eFrameState = STEP6_DELETE;
					break;
				case STEP1_FRAME_IMGPROC:		// STEP-1	摜쐬
				case STEPA_FRAME_6000_0700_13:	// STEP-A	tJnŃXv[t
				case STEP2_FRAME_6000_0700:		// STEP-2	tJnς
				case STEP3_FRAME_IMG_SEND:		// STEP-3	摜Mς
				case STEP4_FRAME_6000_0800:		// STEP-4	摜MmFς
				case STEP5_SORT_COMPLETE:		// STEP-5	\[gς
					if ( 0 != ((CFrameDataPrint*)pFrameData)->m_ReceiptNo )
					{
						// 摜Mς
						if ( ((CFrameDataPrint*)pFrameData)->m_PrintNum.Repeat > ((CFrameDataPrint*)pFrameData)->m_PrintNum.Start )
						{
							// vgőҋ@̂̂Xgɓ
							pList->AddTail( ((CFrameDataPrint*)pFrameData)->m_ReceiptNo );
						}
						else
						{
							// ʈ̍ŏIR}̏ꍇ́A摜Mς݂łXgɓ
							if ( TRUE == IsDuplexLastOdd( dwOrderId, ((CFrameDataPrint*)pFrameData)->m_dwPrintId ) )
							{
								pList->AddTail( ((CFrameDataPrint*)pFrameData)->m_ReceiptNo );
							}
						}
					}
					break;
				case STEP6_DELETE:				// STEP-6	폜
				default:
					break;
				}

				UpdatePrintStatus( ((CFrameDataPrint*)pFrameData)->m_dwPrintId );
			}
		}
	}

	return bRet;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CPrintQue::IsEnableExpressOrder()
//	ABSTRACT : }DɕύX\ȃI[_[݂邩mF
//	FUNCTION : v^őҋ@Ătԍ̈ꗗLZpɎ擾
//	
//	NOTE     : < QSS System > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : Y.Yoshinobu	2006.10.17
//	UPDATE   : J.Fukumori(AVASYS) 2008.07.18 VS2005Ή
//////////////////////////////////////////////////////////////////////////////
BOOL CPrintQue::IsEnableExpressOrder( DWORD dwOrderId, CList<ULONG,ULONG>* pReceiptNoList )
{
	NkcComApi::CCSScopeLock CSScopeLock( &m_CS );

	int nIdx;
	BOOL bResult=TRUE;
	COrderData*	pOrderData = NULL;
	CFrameDataPrint* pFrameData = NULL;

	pOrderData = GetOrderData( dwOrderId );

	if ( NULL != pOrderData )
	{
		for ( nIdx=0 ; (int)pOrderData->m_vFrame.size() > nIdx ; nIdx++ )
		{
			pFrameData = (CFrameDataPrint*)pOrderData->m_vFrame[nIdx];

			if( CFrameData::TYPE_PRINT == pFrameData->GetType() )
			{
				if ( 0 < pFrameData->m_PrintNum.Start )
				{
					// vgJnĂ̂œ}D̃LZ͕KvȂ
					bResult = FALSE;
					break;
				}
				if( pFrameData->m_SendFlg.bUSER_CANCEL == TRUE )
				{	// łɃLZς݂ȂΏۊOɂ		2007.01.06 T.Mizushima
					continue;
				}
				if ( 0 < pFrameData->m_PrintNum.Transfer )
				{
					pReceiptNoList->AddTail( pFrameData->m_ReceiptNo );
				}
			}
		}
	}
	else
	{
		bResult = FALSE;
	}

	if ( FALSE == bResult )
	{
		pReceiptNoList->RemoveAll();
	}
	else
	{
		ULONG nReceipt;
		POSITION pos = pReceiptNoList->GetHeadPosition();

		for ( nIdx=0 ; pReceiptNoList->GetCount() > nIdx ; nIdx++ )
		{
			nReceipt = pReceiptNoList->GetNext( pos );
			pOrderData = GetOrderDataByReceiptNo( nReceipt );

			if( NULL != pOrderData )
			{
				// JǗ_01401	2006.12.25 T.Mizushima	
				// v^[̐LĂȂꍇɂ́ALs
				if (( STEP1_ORDER_6000_0500 < pOrderData->m_eOrderStep ) &&
					( STEP4_ORDER_6000_0600 > pOrderData->m_eOrderStep ))
				{
					m_PossessionRelease.bPossessionRelease	= TRUE;
					if ( TRUE == pOrderData->m_bIsMaintenance )
					{
						m_PossessionRelease.tNextCmd.eQueModeM	= QUE_MAINTENANCE;			// eiX
					}
					else
					{
						m_PossessionRelease.tNextCmd.eQueModeM	= QUE_PRINT;				// ʏvg
					}
					m_PossessionRelease.tNextCmd.eQueModeP			= QUE_NORMAL;					// ʏ
					m_PossessionRelease.tNextCmd.eCmdType			= CMD_ORDER_END;				// I[_[I
					m_PossessionRelease.tNextCmd.dwOrderId			= pOrderData->m_dwOrderId;		// I[_[ID
					m_PossessionRelease.tNextCmd.dwPrintId			= 0;							// vgID (gpȂ̂0Zbg)
					m_PossessionRelease.tEndOrderData.eOrderStep	= pOrderData->m_eOrderStep;		// vgv̔s
					m_PossessionRelease.tEndOrderData.wPossessionNo	= pOrderData->m_nPossessionNo;	// Lԍ
					if ( 0 != pOrderData->m_nNpsImgPort )
					{
						// ڑؒf
						m_pNpsImgMng->Delete( pOrderData->m_nNpsImgPort );
						pOrderData->m_nNpsImgPort = 0;
					}
				}
				// JǗ_01401	2006.12.25 T.Mizushima	܂

				// MvZbg
				pOrderData->m_eOrderStep = STEP0_ORDER_NONE;
				if ( 0 != pOrderData->m_nNpsImgPort )
				{
					// ڑؒf
					m_pNpsImgMng->Delete( pOrderData->m_nNpsImgPort );
					pOrderData->m_nNpsImgPort = 0;
				}

				pFrameData = (CFrameDataPrint*)pOrderData->GetFrameDataByReceiptNo( nReceipt );

				if ( NULL != pFrameData )
				{
					// tԍZbg
					pFrameData->m_ReceiptNo = 0;
					pFrameData->m_eFrameState = STEP0_FRAME_NONE;
					pFrameData->m_PrintNum.Transfer	= 0;
					pFrameData->m_PrintNum.Start	= 0;
					pFrameData->m_PrintNum.End		= 0;
					pFrameData->m_PrintNum.Out		= 0;
					pFrameData->m_PrintNum.Cancel	= 0;
					pFrameData->m_PrintNum.NG		= 0;
					pFrameData->m_ReceiptNoArray.RemoveAll();	// tԍ폜		2006.12.21 T.Mizushima
				}

			}
		}
	}

	return bResult;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CPrintQue::ChangeNormalToExpress()
//	ABSTRACT : ʏI[_[}I[_[ɕύX
//	FUNCTION : 
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : Y.Yoshinobu	2006.10.17
//	UPDATE   : J.Fukumori(AVASYS) 2008.07.18 VS2005Ή
//////////////////////////////////////////////////////////////////////////////
BOOL CPrintQue::ChangeNormalToExpress( DWORD dwOrderId )
{
	NkcComApi::CCSScopeLock CSScopeLock( &m_CS );

	int nIdx;
	BOOL bResult = FALSE;
	COrderData* pOrderData;

	for( nIdx=0 ; (int)m_vOrderNormal.size() > nIdx ; nIdx++ )
	{
		pOrderData = (COrderData*)m_vOrderNormal[nIdx];

		if( dwOrderId == pOrderData->m_dwOrderId )
		{			
			m_vOrderNormal.erase( m_vOrderNormal.begin() + nIdx );

#if 0
			// JǗ_01401	2006.12.18 T.Mizushima	
			if ( TRUE == pOrderData->m_pNpsImg->IsOpenSocket() )
			{
				// ڑؒf
				pOrderData->m_pNpsImg->Close();
			}
			// JǗ_01401	2006.12.18 T.Mizushima	܂

			// Ô߃I[_[f[^
			ResetOrderFrameData( pOrderData );
#endif
			pOrderData->m_nInterruptMode = 1;
			m_vOrderExpress.push_back( pOrderData );
			bResult = TRUE;
			break;
		}
	}

	return bResult;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CPrintQue::ResetOrderFrameData()
//	ABSTRACT : }I[_[ɕύXI[_[f[^
//	FUNCTION : Ôߏ
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : T.Mizushima	2006.12.20
//	UPDATE   : J.Fukumori(AVASYS) 2008.07.18 VS2005Ή
//////////////////////////////////////////////////////////////////////////////
void CPrintQue::ResetOrderFrameData( COrderData* pOrderData )
{
	CFrameData* pFrameData;

	pOrderData->m_eOrderStep	= STEP0_ORDER_NONE;
//	pOrderData->m_bEndOrder		= FALSE;

	for( int nIdx = 0; nIdx < (int)pOrderData->m_vFrame.size(); nIdx++ )
	{
		pFrameData	= ( CFrameData* ) pOrderData->m_vFrame[nIdx];

		pFrameData->m_eFrameState = STEP0_FRAME_NONE;

		if( CFrameData::TYPE_PRINT == pFrameData->GetType() )
		{
			( (CFrameDataPrint*)pFrameData )->m_ReceiptNo					= 0;

			( (CFrameDataPrint*)pFrameData )->m_PrintNum.Transfer			= 0;	// vg]
			( (CFrameDataPrint*)pFrameData )->m_PrintNum.Start				= 0;	// 1:vgJn
			( (CFrameDataPrint*)pFrameData )->m_PrintNum.End				= 0;	// 2:vgiIj
			( (CFrameDataPrint*)pFrameData )->m_PrintNum.Out				= 0;	// 3:vgro
			( (CFrameDataPrint*)pFrameData )->m_PrintNum.Cancel				= 0;	// 4:vgs
			( (CFrameDataPrint*)pFrameData )->m_PrintNum.NG					= 0;	// 7:vgLZ
			( (CFrameDataPrint*)pFrameData )->m_PrintNum.Loading			= 0;	// 10:[fBOJn				2011.11.17 A.Nagamatsu
			( (CFrameDataPrint*)pFrameData )->m_PrintNum.Out_Retransmission	= 0;	// 11:đpro				2011.11.24 A.Nagamatsu

			( (CFrameDataPrint*)pFrameData )->m_SendFlg.bTRANSFER			= FALSE;	// RESULT_TRANSFER
			( (CFrameDataPrint*)pFrameData )->m_SendFlg.bPRINT				= FALSE;	// RESULT_PRINT
			( (CFrameDataPrint*)pFrameData )->m_SendFlg.bOK					= FALSE;	// RESULT_OK
			( (CFrameDataPrint*)pFrameData )->m_SendFlg.bUSER_CANCEL		= FALSE;	// RESULT_USER_CANCEL
			( (CFrameDataPrint*)pFrameData )->m_SendFlg.bNG					= FALSE;	// RESULT_NG
			( (CFrameDataPrint*)pFrameData )->m_SendFlg.bLOADING			= FALSE;	// RESULT_LOADING					2011.11.17 A.Nagamatsu
			( (CFrameDataPrint*)pFrameData )->m_SendFlg.bOK_RETRANSMISSION	= FALSE;	// RESULT_OK_RETRANSMISSION			2011.11.24 A.Nagamatsu

			( (CFrameDataPrint*)pFrameData )->m_ReceiptNoArray.RemoveAll();
		}
	}
}

//----------------------------------------
// I[_[̎擾
//----------------------------------------


//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CPrintQue::IsOrderRemain()
//	ABSTRACT : ݏI[_[cĂ邩擾
//	FUNCTION : ݏI[_[cĂ邩擾
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : T.Isogai	2006.9.22
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
BOOL CPrintQue::IsOrderRemain()
{
	NkcComApi::CCSScopeLock CSScopeLock( &m_CS );

	if( ( 0 == m_vOrderNormal.size() ) && ( 0 == m_vOrderExpress.size() ) && ( 0 == m_vOrderExpressL2.size() ) )
	{
		return FALSE;
	}
	else
	{

		return TRUE;
	}
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CPrintQue::IsOccupy()
//	ABSTRACT : v^LĂ邩擾
//	FUNCTION : 
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : Y.Yoshinobu 2007.02.20
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
BOOL CPrintQue::IsOccupy( DWORD dwPriority )
{
	NkcComApi::CCSScopeLock CSScopeLock( &m_CS );

	std::vector<COrderData*>::iterator itOrder;

	if ( PRTY_NORMAL & dwPriority )
	{
		if ( 0 < m_vOrderNormal.size() )
		{
			for ( itOrder=m_vOrderNormal.begin() ; m_vOrderNormal.end() != itOrder ; itOrder++ )
			{
				if ( STEP4_ORDER_6000_0600 >  (*itOrder)->m_eOrderStep )		// v^LIςݖ܂
				{
					return TRUE;
				}
			}
		}
	}

	if ( PRTY_EXPRESS1 & dwPriority )
	{
		if ( 0 < m_vOrderExpress.size() )
		{
			for ( itOrder=m_vOrderExpress.begin() ; m_vOrderExpress.end() != itOrder ; itOrder++ )
			{
				if ( STEP4_ORDER_6000_0600 >  (*itOrder)->m_eOrderStep )		// v^LIςݖ܂
				{
					return TRUE;
				}
			}
		}
	}

	if ( PRTY_EXPRESS2 & dwPriority )
	{
		if ( 0 < m_vOrderExpressL2.size() )
		{
			for ( itOrder=m_vOrderExpressL2.begin() ; m_vOrderExpressL2.end() != itOrder ; itOrder++ )
			{
				if ( STEP4_ORDER_6000_0600 >  (*itOrder)->m_eOrderStep )		// v^LIςݖ܂
				{
					return TRUE;
				}
			}
		}
	}

	return FALSE;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CPrintQue::GetNextProcData()
//	ABSTRACT : ɏ擾
//	FUNCTION : 
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : Y.Yoshinobu	2006.10.8
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
BOOL CPrintQue::GetNextProcData( T_NextCmd* pNextCmd )
{
	NkcComApi::CCSScopeLock CSScopeLock( &m_CS );

	int nIdx1;
	int nIdx2;
	int nCnt1;
	int nCnt2;


	//----------------------------------------------------------------------
	// LIiv^̃G[AvgLZȂǁj
	//----------------------------------------------------------------------
	// LIKvȏꍇɂ́ADIɐLIs

	if ( TRUE == m_PossessionRelease.bPossessionRelease )
	{
		::MoveMemory( pNextCmd, &m_PossessionRelease.tNextCmd, sizeof(T_NextCmd) );
		return TRUE;
	}


	//----------------------------------------------------------------------
	// }I[_[iLevel2j
	//----------------------------------------------------------------------
	// }ꍇɂ́AD悷

	nCnt1 = (int)m_vOrderExpressL2.size();
	for( nIdx1=0 ; nCnt1 > nIdx1 ; nIdx1++ )
	{
		COrderData* ptmpOrderData = (COrderData*)m_vOrderExpressL2[nIdx1];

		if( STEP3_ORDER_6000_1200 > ptmpOrderData->m_eOrderStep )
		{
			// CMD_ORDER_START
			if ( TRUE == ptmpOrderData->m_bIsMaintenance )
			{
				pNextCmd->eQueModeM	= QUE_MAINTENANCE;			// eiX
			}
			else
			{
				pNextCmd->eQueModeM	= QUE_PRINT;				// ʏvg
			}
			pNextCmd->eQueModeP	= QUE_EXPRESS2;					// }(Level2)
			pNextCmd->dwOption	= ptmpOrderData->m_dwOption;	// ꏈIvV
			pNextCmd->eCmdType	= CMD_ORDER_START;				// I[_[Jn
			pNextCmd->dwOrderId	= ptmpOrderData->m_dwOrderId;	// I[_[ID
			pNextCmd->dwIndexNo	= 0;							// CfbNXԍ
			pNextCmd->wNpsImgPort = ptmpOrderData->m_nNpsImgPort;// 摜Mp̃|[gԍ
			return TRUE;
		}

		else if( STEP3_ORDER_6000_1200 == ptmpOrderData->m_eOrderStep )
		{
			// vg(StartOrderς݁j

			CFrameData*	pFrameData	= NULL;

			nCnt2 = (int)ptmpOrderData->m_vFrame.size();
			for ( nIdx2=0 ; nCnt2 > nIdx2 ; nIdx2++ )
			{
				CFrameData*	ptmpFrameData	= (CFrameData*)ptmpOrderData->m_vFrame[nIdx2];

				if( STEP0_FRAME_NONE == ptmpFrameData->m_eFrameState )
				{
					switch ( ptmpFrameData->GetType() )
					{
					case CFrameData::TYPE_PRINT:
					{
						CFrameDataPrint* pFramePrint	= (CFrameDataPrint*)ptmpFrameData;

						if( pFramePrint->m_SendFlg.bUSER_CANCEL == TRUE )
						{	// łɃLZς݂ȂΏۊOɂ		2006.12.29 T.Mizushima
							continue;
						}

						// R}vgv
						if ( TRUE == ptmpOrderData->m_bIsMaintenance )
						{
							pNextCmd->eQueModeM	= QUE_MAINTENANCE;			// eiX
						}
						else
						{
							pNextCmd->eQueModeM	= QUE_PRINT;				// ʏvg
						}
						pNextCmd->eQueModeP	= QUE_EXPRESS2;					// }(Level2)
						pNextCmd->dwOption	= ptmpOrderData->m_dwOption;	// ꏈIvV
						if ( FALSE == pFramePrint->m_bBlankPrint )
						{
							pNextCmd->eCmdType	= CMD_FRAME;				// R}
						}
						else
						{
							pNextCmd->eCmdType	= CMD_BLANK_FRAME;			// 󔒃R}
						}
						pNextCmd->dwOrderId	= ptmpOrderData->m_dwOrderId;	// I[_[ID
						pNextCmd->dwIndexNo	= pFramePrint->m_dwIndexNo;		// CfbNXԍ
						pNextCmd->dwPrintId	= pFramePrint->m_dwPrintId;		// vgID
						pNextCmd->wNpsImgPort = ptmpOrderData->m_nNpsImgPort;// 摜Mp̃|[gԍ
						return TRUE;
					}
					case CFrameData::TYPE_SORT:
					{
						CFrameDataSort* pFrameSort	= (CFrameDataSort*)ptmpFrameData;

						// \[^[v
						if ( TRUE == ptmpOrderData->m_bIsMaintenance )
						{
							pNextCmd->eQueModeM	= QUE_MAINTENANCE;			// eiX
						}
						else
						{
							pNextCmd->eQueModeM	= QUE_PRINT;				// ʏvg
						}
						pNextCmd->eQueModeP	= QUE_EXPRESS2;					// }(Level2)
						pNextCmd->dwOption	= ptmpOrderData->m_dwOption;	// ꏈIvV
						pNextCmd->eCmdType	= CMD_SORTER;					// \[^[
						pNextCmd->dwOrderId	= ptmpOrderData->m_dwOrderId;	// I[_[ID
						pNextCmd->dwIndexNo	= pFrameSort->m_dwIndexNo;		// CfbNXԍ
						pNextCmd->wNpsImgPort = ptmpOrderData->m_nNpsImgPort;// 摜Mp̃|[gԍ

						return TRUE;
					}
					case CFrameData::TYPE_DUPLEX:
					{
						CFrameDataDuplex* pFrameDuplex = (CFrameDataDuplex*)ptmpFrameData;

						// ʈv
						if ( TRUE == ptmpOrderData->m_bIsMaintenance )
						{
							pNextCmd->eQueModeM	= QUE_MAINTENANCE;			// eiX
						}
						else
						{
							pNextCmd->eQueModeM	= QUE_PRINT;				// ʏvg
						}
						pNextCmd->eQueModeP	= QUE_EXPRESS2;					// }(Level2)
						pNextCmd->dwOption	= ptmpOrderData->m_dwOption;	// ꏈIvV
						switch ( pFrameDuplex->m_eDuplexMode )
						{
						case CFrameDataDuplex::MODE_DUPLEX_START:
							pNextCmd->eCmdType	= CMD_DUPLEX_START;				// ʈJn
							break;
						case CFrameDataDuplex::MODE_DUPLEX_END:
							pNextCmd->eCmdType	= CMD_DUPLEX_END;				// ʈI
							break;
						}
						pNextCmd->dwOrderId	= ptmpOrderData->m_dwOrderId;	// I[_[ID
						pNextCmd->dwIndexNo	= pFrameDuplex->m_dwIndexNo;	// CfbNXԍ
						pNextCmd->wNpsImgPort = ptmpOrderData->m_nNpsImgPort;// 摜Mp̃|[gԍ

						return TRUE;
					}
					}
				}
			}

			if( TRUE == ptmpOrderData->m_bEndOrder )
			{
				// EndOrderv
				if ( TRUE == ptmpOrderData->m_bIsMaintenance )
				{
					pNextCmd->eQueModeM	= QUE_MAINTENANCE;			// eiX
				}
				else
				{
					pNextCmd->eQueModeM	= QUE_PRINT;				// ʏvg
				}
				pNextCmd->eQueModeP	= QUE_EXPRESS2;					// }(Level2)
				pNextCmd->dwOption	= ptmpOrderData->m_dwOption;	// ꏈIvV
				pNextCmd->eCmdType	= CMD_ORDER_END;				// I[_[I
				pNextCmd->dwOrderId	= ptmpOrderData->m_dwOrderId;	// I[_[ID
				pNextCmd->dwIndexNo	= 0;							// CfbNXԍ
				pNextCmd->wNpsImgPort = ptmpOrderData->m_nNpsImgPort;// 摜Mp̃|[gԍ
				return TRUE;
			}

		}
	}

	// }iLevel2ĵ߂̗vꍇłAEndOrder҂ꍇ͓}iLevel1jȂ
	nCnt1 = (int)m_vOrderExpressL2.size();
	for( nIdx1 = 0; nCnt1 > nIdx1 ; nIdx1++ )
	{
		COrderData* ptmpOrderData = (COrderData*)m_vOrderExpressL2[nIdx1];
		
		if( FALSE == ptmpOrderData->m_bEndOrder )
		{
			return FALSE;
		}
	}

	//----------------------------------------------------------------------
	// }I[_[iLevel1j
	//----------------------------------------------------------------------
	// }ꍇɂ́AD悷

	nCnt1 = (int)m_vOrderExpress.size();
	for( nIdx1=0 ; nCnt1 > nIdx1 ; nIdx1++ )
	{
		COrderData* ptmpOrderData = (COrderData*)m_vOrderExpress[nIdx1];

		if( STEP3_ORDER_6000_1200 > ptmpOrderData->m_eOrderStep )
		{
			// CMD_ORDER_START
			if ( TRUE == ptmpOrderData->m_bIsMaintenance )
			{
				pNextCmd->eQueModeM	= QUE_MAINTENANCE;			// eiX
			}
			else
			{
				pNextCmd->eQueModeM	= QUE_PRINT;				// ʏvg
			}
			pNextCmd->eQueModeP	= QUE_EXPRESS1;					// }(Level1)
			pNextCmd->dwOption	= ptmpOrderData->m_dwOption;	// ꏈIvV
			pNextCmd->eCmdType	= CMD_ORDER_START;				// I[_[Jn
			pNextCmd->dwOrderId	= ptmpOrderData->m_dwOrderId;	// I[_[ID
			pNextCmd->dwIndexNo	= 0;							// CfbNXԍ
			pNextCmd->wNpsImgPort = ptmpOrderData->m_nNpsImgPort;// 摜Mp̃|[gԍ
			return TRUE;
		}

		else if( STEP3_ORDER_6000_1200 == ptmpOrderData->m_eOrderStep )
		{
			// vg(StartOrderς݁j

			CFrameData*	pFrameData	= NULL;

			nCnt2 = (int)ptmpOrderData->m_vFrame.size();
			for ( nIdx2=0 ; nCnt2 > nIdx2 ; nIdx2++ )
			{
				CFrameData*	ptmpFrameData	= (CFrameData*)ptmpOrderData->m_vFrame[nIdx2];

				if( STEP0_FRAME_NONE == ptmpFrameData->m_eFrameState )
				{

					switch ( ptmpFrameData->GetType() )
					{
					case CFrameData::TYPE_PRINT:
					{
						CFrameDataPrint* pFramePrint	= (CFrameDataPrint*)ptmpFrameData;

						if( pFramePrint->m_SendFlg.bUSER_CANCEL == TRUE )
						{	// łɃLZς݂ȂΏۊOɂ		2006.12.29 T.Mizushima
							continue;
						}

						// R}vgv
						if ( TRUE == ptmpOrderData->m_bIsMaintenance )
						{
							pNextCmd->eQueModeM	= QUE_MAINTENANCE;			// eiX
						}
						else
						{
							pNextCmd->eQueModeM	= QUE_PRINT;				// ʏvg
						}
						pNextCmd->eQueModeP	= QUE_EXPRESS1;					// }(Level1)
						pNextCmd->dwOption	= ptmpOrderData->m_dwOption;	// ꏈIvV
						if ( FALSE == pFramePrint->m_bBlankPrint )
						{
							pNextCmd->eCmdType	= CMD_FRAME;				// R}
						}
						else
						{
							pNextCmd->eCmdType	= CMD_BLANK_FRAME;			// 󔒃R}
						}
						pNextCmd->dwOrderId	= ptmpOrderData->m_dwOrderId;	// I[_[ID
						pNextCmd->dwIndexNo	= pFramePrint->m_dwIndexNo;		// CfbNXԍ
						pNextCmd->dwPrintId	= pFramePrint->m_dwPrintId;		// vgID
						pNextCmd->wNpsImgPort = ptmpOrderData->m_nNpsImgPort;// 摜Mp̃|[gԍ
						return TRUE;
					}
					case CFrameData::TYPE_SORT:
					{
						CFrameDataSort* pFrameSort	= (CFrameDataSort*)ptmpFrameData;

						// \[^[v
						if ( TRUE == ptmpOrderData->m_bIsMaintenance )
						{
							pNextCmd->eQueModeM	= QUE_MAINTENANCE;			// eiX
						}
						else
						{
							pNextCmd->eQueModeM	= QUE_PRINT;				// ʏvg
						}
						pNextCmd->eQueModeP	= QUE_EXPRESS1;					// }(Level1)
						pNextCmd->dwOption	= ptmpOrderData->m_dwOption;	// ꏈIvV
						pNextCmd->eCmdType	= CMD_SORTER;					// \[^[
						pNextCmd->dwOrderId	= ptmpOrderData->m_dwOrderId;	// I[_[ID
						pNextCmd->dwIndexNo	= pFrameSort->m_dwIndexNo;		// CfbNXԍ
						pNextCmd->wNpsImgPort = ptmpOrderData->m_nNpsImgPort;// 摜Mp̃|[gԍ

						return TRUE;
					}
					case CFrameData::TYPE_DUPLEX:
					{
						CFrameDataDuplex* pFrameDuplex = (CFrameDataDuplex*)ptmpFrameData;

						// ʈv
						if ( TRUE == ptmpOrderData->m_bIsMaintenance )
						{
							pNextCmd->eQueModeM	= QUE_MAINTENANCE;			// eiX
						}
						else
						{
							pNextCmd->eQueModeM	= QUE_PRINT;				// ʏvg
						}
						pNextCmd->eQueModeP	= QUE_EXPRESS1;					// }(Level1)
						pNextCmd->dwOption	= ptmpOrderData->m_dwOption;	// ꏈIvV
						switch ( pFrameDuplex->m_eDuplexMode )
						{
						case CFrameDataDuplex::MODE_DUPLEX_START:
							pNextCmd->eCmdType	= CMD_DUPLEX_START;				// ʈJn
							break;
						case CFrameDataDuplex::MODE_DUPLEX_END:
							pNextCmd->eCmdType	= CMD_DUPLEX_END;				// ʈI
							break;
						}
						pNextCmd->dwOrderId	= ptmpOrderData->m_dwOrderId;	// I[_[ID
						pNextCmd->dwIndexNo	= pFrameDuplex->m_dwIndexNo;	// CfbNXԍ
						pNextCmd->wNpsImgPort = ptmpOrderData->m_nNpsImgPort;// 摜Mp̃|[gԍ

						return TRUE;
					}
					}
				}
			}

			if( TRUE == ptmpOrderData->m_bEndOrder )
			{
				// EndOrderv
				if ( TRUE == ptmpOrderData->m_bIsMaintenance )
				{
					pNextCmd->eQueModeM	= QUE_MAINTENANCE;			// eiX
				}
				else
				{
					pNextCmd->eQueModeM	= QUE_PRINT;				// ʏvg
				}
				pNextCmd->eQueModeP	= QUE_EXPRESS1;					// }(Level1)
				pNextCmd->dwOption	= ptmpOrderData->m_dwOption;	// ꏈIvV
				pNextCmd->eCmdType	= CMD_ORDER_END;				// I[_[I
				pNextCmd->dwOrderId	= ptmpOrderData->m_dwOrderId;	// I[_[ID
				pNextCmd->dwIndexNo	= 0;							// CfbNXԍ
				pNextCmd->wNpsImgPort = ptmpOrderData->m_nNpsImgPort;// 摜Mp̃|[gԍ
				return TRUE;
			}

		}
	}

	// }̂߂̗vꍇłAEndOrder҂ꍇ͒ʏȂ
	nCnt1 = (int)m_vOrderExpress.size();
	for( nIdx1 = 0; nCnt1 > nIdx1 ; nIdx1++ )
	{
		COrderData* ptmpOrderData = (COrderData*)m_vOrderExpress[nIdx1];
		
		if( FALSE == ptmpOrderData->m_bEndOrder )
		{
			return FALSE;
		}
	}

	//----------------------------------------------------------------------
	// ʏ폈
	//----------------------------------------------------------------------
	nCnt1 = (int)m_vOrderNormal.size();
	for( nIdx1=0 ; nCnt1 > nIdx1 ; nIdx1++ )
	{
		COrderData* ptmpOrderData = (COrderData*)m_vOrderNormal[nIdx1];

		if( STEP3_ORDER_6000_1200 > ptmpOrderData->m_eOrderStep )
		{
			// CMD_ORDER_START
			if ( TRUE == ptmpOrderData->m_bIsMaintenance )
			{
				pNextCmd->eQueModeM	= QUE_MAINTENANCE;			// eiX
			}
			else
			{
				pNextCmd->eQueModeM	= QUE_PRINT;				// ʏvg
			}
			pNextCmd->eQueModeP	= QUE_NORMAL;					// ʏ
			pNextCmd->dwOption	= ptmpOrderData->m_dwOption;	// ꏈIvV
			pNextCmd->eCmdType	= CMD_ORDER_START;				// I[_[Jn
			pNextCmd->dwOrderId	= ptmpOrderData->m_dwOrderId;	// I[_[ID
			pNextCmd->dwIndexNo	= 0;							// CfbNXԍ
			pNextCmd->wNpsImgPort = ptmpOrderData->m_nNpsImgPort;// 摜Mp̃|[gԍ
			return TRUE;
		}

		else if( STEP3_ORDER_6000_1200 == ptmpOrderData->m_eOrderStep )
		{
			// vg(StartOrderς݁j

			CFrameData*	pFrameData	= NULL;

			nCnt2 = (int)ptmpOrderData->m_vFrame.size();
			for ( nIdx2=0 ; nCnt2 > nIdx2 ; nIdx2++ )
			{
				CFrameData*	ptmpFrameData	= (CFrameData*)ptmpOrderData->m_vFrame[nIdx2];

				BOOL	bStep = FALSE;
				if( INFO_SUPPORTINTNEW == m_pDataManager->GetPrinterSetupSupportInterrupt() )
				{	// V^荞ݑΉ		@@@RD-151Ή	2012.02.20	T.Mizushima
					if( ptmpFrameData->m_eFrameState < STEP4_FRAME_6000_0800 )
					{	// R}f[^MĂȂ
						bStep = TRUE;
					}
				}
				else
				{
					if( STEP0_FRAME_NONE == ptmpFrameData->m_eFrameState )
					{	// ̃R}f[^
						bStep = TRUE;
					}
				}

				if( bStep )
				{
					switch ( ptmpFrameData->GetType() )
					{
					case CFrameData::TYPE_PRINT:
					{
						CFrameDataPrint* pFramePrint	= (CFrameDataPrint*)ptmpFrameData;

						if( pFramePrint->m_SendFlg.bUSER_CANCEL == TRUE )
						{	// łɃLZς݂ȂΏۊOɂ		2006.12.29 T.Mizushima
							continue;
						}

						// R}vgv
						if ( TRUE == ptmpOrderData->m_bIsMaintenance )
						{
							pNextCmd->eQueModeM	= QUE_MAINTENANCE;			// eiX
						}
						else
						{
							pNextCmd->eQueModeM	= QUE_PRINT;				// ʏvg
						}
						pNextCmd->eQueModeP	= QUE_NORMAL;					// ʏ
						pNextCmd->dwOption	= ptmpOrderData->m_dwOption;	// ꏈIvV
						if ( FALSE == pFramePrint->m_bBlankPrint )
						{
							pNextCmd->eCmdType	= CMD_FRAME;				// R}
						}
						else
						{
							pNextCmd->eCmdType	= CMD_BLANK_FRAME;			// 󔒃R}
						}
						pNextCmd->dwOrderId	= ptmpOrderData->m_dwOrderId;	// I[_[ID
						pNextCmd->dwIndexNo	= pFramePrint->m_dwIndexNo;		// CfbNXԍ
						pNextCmd->dwPrintId	= pFramePrint->m_dwPrintId;		// vgID
						pNextCmd->wNpsImgPort = ptmpOrderData->m_nNpsImgPort;// 摜Mp̃|[gԍ
						return TRUE;
					}
					case CFrameData::TYPE_SORT:
					{
						CFrameDataSort* pFrameSort	= (CFrameDataSort*)ptmpFrameData;

						// \[^[v
						if ( TRUE == ptmpOrderData->m_bIsMaintenance )
						{
							pNextCmd->eQueModeM	= QUE_MAINTENANCE;			// eiX
						}
						else
						{
							pNextCmd->eQueModeM	= QUE_PRINT;				// ʏvg
						}
						pNextCmd->eQueModeP	= QUE_NORMAL;					// ʏ
						pNextCmd->dwOption	= ptmpOrderData->m_dwOption;	// ꏈIvV
						pNextCmd->eCmdType	= CMD_SORTER;					// \[^[
						pNextCmd->dwOrderId	= ptmpOrderData->m_dwOrderId;	// I[_[ID
						pNextCmd->dwIndexNo	= pFrameSort->m_dwIndexNo;		// CfbNXԍ
						pNextCmd->wNpsImgPort = ptmpOrderData->m_nNpsImgPort;// 摜Mp̃|[gԍ

						return TRUE;
					}
					case CFrameData::TYPE_DUPLEX:
					{
						CFrameDataDuplex* pFrameDuplex = (CFrameDataDuplex*)ptmpFrameData;

						// ʈv
						if ( TRUE == ptmpOrderData->m_bIsMaintenance )
						{
							pNextCmd->eQueModeM	= QUE_MAINTENANCE;			// eiX
						}
						else
						{
							pNextCmd->eQueModeM	= QUE_PRINT;				// ʏvg
						}
						pNextCmd->eQueModeP	= QUE_NORMAL;					// ʏ
						pNextCmd->dwOption	= ptmpOrderData->m_dwOption;	// ꏈIvV
						switch ( pFrameDuplex->m_eDuplexMode )
						{
						case CFrameDataDuplex::MODE_DUPLEX_START:
							pNextCmd->eCmdType	= CMD_DUPLEX_START;				// ʈJn
							break;
						case CFrameDataDuplex::MODE_DUPLEX_END:
							pNextCmd->eCmdType	= CMD_DUPLEX_END;				// ʈI
							break;
						}
						pNextCmd->dwOrderId	= ptmpOrderData->m_dwOrderId;	// I[_[ID
						pNextCmd->dwIndexNo	= pFrameDuplex->m_dwIndexNo;	// CfbNXԍ
						pNextCmd->wNpsImgPort = ptmpOrderData->m_nNpsImgPort;// 摜Mp̃|[gԍ

						return TRUE;
					}
					// >>>>> 2011.11.21 A.Nagamatsu
					case CFrameData::TYPE_RETRANSMISSION:
					{
						CFrameDataRetransmission* pFrameDataRetransmission = (CFrameDataRetransmission*)ptmpFrameData;

						if ( TRUE == ptmpOrderData->m_bIsMaintenance )
						{
							pNextCmd->eQueModeM	= QUE_MAINTENANCE;			// eiX
						}
						else
						{
							pNextCmd->eQueModeM	= QUE_PRINT;				// ʏvg
						}
						pNextCmd->eQueModeP	= QUE_NORMAL;								// ʏ
						pNextCmd->dwOption	= ptmpOrderData->m_dwOption;				// ꏈIvV
						switch ( pFrameDataRetransmission->m_eRetransmissionMode )
						{
						case CFrameDataRetransmission::MODE_RETRANSMISSION_START:
							pNextCmd->eCmdType	= CMD_RETRANSMISSION_START;				// đJn
							break;
						case CFrameDataRetransmission::MODE_RETRANSMISSION_END:
							pNextCmd->eCmdType	= CMD_RETRANSMISSION_END;				// đI
							break;
						}

						pNextCmd->dwOrderId			= ptmpOrderData->m_dwOrderId;				// I[_[ID
						pNextCmd->dwIndexNo			= pFrameDataRetransmission->m_dwIndexNo;	// CfbNXԍ
						pNextCmd->wNpsImgPort		= ptmpOrderData->m_nNpsImgPort;				// 摜Mp̃|[gԍ

						pNextCmd->wOrderState		= pFrameDataRetransmission->m_InterruptOrderInfo.wOrderState;		// f̃I[_[
						pNextCmd->wMainSideState	= pFrameDataRetransmission->m_InterruptOrderInfo.wMainSideState;	// ʃvg̕\ʊJnm点
						pNextCmd->wBackSideState	= pFrameDataRetransmission->m_InterruptOrderInfo.wBackSideState;	// ʃvg̗ʊJnm点
						pNextCmd->wPrintSide		= pFrameDataRetransmission->m_InterruptOrderInfo.wPrintSide;		// ʃvg̃vg

						return TRUE;
					}
					// <<<<<
					}
				}
			}

			if( TRUE == ptmpOrderData->m_bEndOrder )
			{
				// EndOrderv
				if ( TRUE == ptmpOrderData->m_bIsMaintenance )
				{
					pNextCmd->eQueModeM	= QUE_MAINTENANCE;			// eiX
				}
				else
				{
					pNextCmd->eQueModeM	= QUE_PRINT;				// ʏvg
				}
				pNextCmd->eQueModeP	= QUE_NORMAL;					// ʏ
				pNextCmd->dwOption	= ptmpOrderData->m_dwOption;	// ꏈIvV
				pNextCmd->eCmdType	= CMD_ORDER_END;				// I[_[I
				pNextCmd->dwOrderId	= ptmpOrderData->m_dwOrderId;	// I[_[ID
				pNextCmd->dwIndexNo	= 0;							// CfbNXԍ
				pNextCmd->wNpsImgPort = ptmpOrderData->m_nNpsImgPort;// 摜Mp̃|[gԍ
				return TRUE;
			}

		}
	}

	return FALSE;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CPrintQue::GetStartOrderData()
//	ABSTRACT : I[_[JnvɕKvȃf[^擾
//	FUNCTION : 
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : Y.Yoshinobu	2006.10.8
//	UPDATE   : M.Yamamoto	2014.10.28	݃vg̏ԒZk@\ǉ(Pvg)
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
BOOL CPrintQue::GetStartOrderData( T_NextCmd* pNextCmd, T_StartOrderData* pStartOrderData )
{
	NkcComApi::CCSScopeLock CSScopeLock( &m_CS );

	if ( CMD_ORDER_START != pNextCmd->eCmdType )
	{
		return FALSE;
	}

	COrderData*	pOrder = GetOrderData( pNextCmd->dwOrderId );

	if ( NULL != pOrder )
	{
		pStartOrderData->eOrderStep		= pOrder->m_eOrderStep;		// vgv̔s
		pStartOrderData->wPossessionNo	= pOrder->m_nPossessionNo;	// Lԍ
		pStartOrderData->wSorterNum		= pOrder->m_nSorterNum;		// vg̎d
		pStartOrderData->wInterruptMode	= pOrder->m_nInterruptMode;	// 荞݃[h
		pStartOrderData->bReOccupy		= pOrder->m_bReOccupy;		// }ݏI̍ĐLǂ(V^(RD-151)ɂĎgp)		@@@RD-151Ή 2012.05.08 T.Mizushima
		pStartOrderData->dwExOptions	= pOrder->m_dwExOptions;	// gIvV(Pvg) 2014.10.28 M.Yamamoto

		return TRUE;
	}

	return FALSE;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CPrintQue::GetFrameData()
//	ABSTRACT : vgvɕKvȃf[^擾
//	FUNCTION : 
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : Y.Yoshinobu	2006.10.8
//	UPDATE   : T.Isogai		2008.06.06 npsDevPrintIccsXml APIǉ
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
BOOL CPrintQue::GetFrameData( T_NextCmd* pNextCmd, T_FrameData* pFrameData )
{
	NkcComApi::CCSScopeLock CSScopeLock( &m_CS );

#if 0
	if( INFO_SUPPORTINTNEW == m_pDataManager->GetPrinterSetupSupportInterrupt() )
	{	// V^荞ݑΉ		@@@RD-151Ή	2012.02.20	T.Mizushima
		if( CDataManager::OCCUPY_STATE_NONE == m_pDataManager->GetOccupyState() )
		{	// ɐLĂ珈Ȃ
			return FALSE;
		}
	}
#endif

	if (( CMD_FRAME != pNextCmd->eCmdType ) &&
		( CMD_BLANK_FRAME != pNextCmd->eCmdType ))
	{
		return FALSE;
	}

	COrderData*	pOrder = GetOrderData( pNextCmd->dwOrderId );
	CFrameData*	pFrame = GetFrameDataByPrintId( pNextCmd->dwPrintId );

	if (( NULL != pOrder ) && ( NULL != pFrame ))
	{
		CFrameDataPrint* pFramePrint = (CFrameDataPrint*)(pFrame);

		pFrameData->eFrameStep							= pFramePrint->m_eFrameState;		// vgv̔s
		pFrameData->dwPrintId							= pFramePrint->m_dwPrintId;			// vgID
		pFrameData->nReceiptNo							= pFramePrint->m_ReceiptNo;			// tԍ
		pFrameData->dwSortFrame							= pOrder->m_dwSortFrame;			// R}̃\[g@\
		pFrameData->dwSourceType						= pFramePrint->m_dwSourceType;		// 摜f[^[̎󂯓n@i 0:Ln, 1:t@Cn j
		pFrameData->dwDataLength						= pFramePrint->m_dwDataLength;		// 摜f[^̃oCgTCYiPʁFBytej
		pFrameData->dwOffset							= pFramePrint->m_dwOffset;			// 摜f[^̊i[ĂItZbg
		::lstrcpy( pFrameData->szName, pFramePrint->m_strName.GetBuffer(1) );				// t@C}bsOIuWFNg̓t@C
		pFrameData->wPossessionNo						= pOrder->m_nPossessionNo;			// Lԍ
		pFrameData->pCompletionProc						= pFramePrint->m_pCompletionProc;	// vg󋵒ʒmR[obN֐|C^
		// tJnvݒ
		::MoveMemory( &(pFrameData->tPrnParam), &(pFramePrint->m_PrnParam), sizeof(NPS_PrintInfo) );
		pFrameData->tPrnParam.dwPrintNum			= pFramePrint->m_PrintNum.Request;		// ɑMς݂͈̕Z
		pFrameData->tPrnParam.dwCvpInitialValue1	+= pFramePrint->m_PrintNum.Transfer;	// ɑMς݂͑̕Z
		pFrameData->tPrnParam.dwCvpInitialValue2	+= pFramePrint->m_PrintNum.Transfer;	// ɑMς݂͑̕Z
		pFrameData->eOrderStep							= pOrder->m_eOrderStep;				// I[_[Ŝ̏	2007.01.10 T.Mizushima
		pFrameData->dwClearInk							= pFramePrint->m_dwClearInk;		// NACN ( 0:Ȃ, 1: )
		pFrameData->wFirstPossessionNo					= pOrder->m_nFirstPossessionNo;		// Lԍi tJnv(6000H-0700)̃I[_[ʎqɎgp j

		pFrameData->bIccsXml							= pFramePrint->m_bIccsXml;
		::memcpy( &(pFrameData->tIccsXml), &(pFramePrint->m_tIccsXml), sizeof(T_ICCSXML) );

		return TRUE;

	}

	return FALSE;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CPrintQue::GetSortData()
//	ABSTRACT : \[gvɕKvȃf[^擾
//	FUNCTION : 
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : Y.Yoshinobu	2006.10.8
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
BOOL CPrintQue::GetSortData( T_NextCmd* pNextCmd, T_SortData* pSortData )
{
	NkcComApi::CCSScopeLock CSScopeLock( &m_CS );

	if ( CMD_SORTER != pNextCmd->eCmdType )
	{
		return FALSE;
	}

	COrderData*	pOrder = GetOrderData( pNextCmd->dwOrderId );

	if ( NULL != pOrder )
	{
		pSortData->wPossessionNo = pOrder->m_nPossessionNo;	// Lԍ

		return TRUE;
	}

	return FALSE;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CPrintQue::GetStartDuplexData()
//	ABSTRACT : ʈJnvɕKvȃf[^擾
//	FUNCTION : 
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : Y.Yoshinobu	2008.5.23
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
BOOL CPrintQue::GetStartDuplexData( T_NextCmd* pNextCmd, T_StartDuplexData* pStartDuplexData )
{
	NkcComApi::CCSScopeLock CSScopeLock( &m_CS );

	if ( CMD_DUPLEX_START != pNextCmd->eCmdType )
	{
		return FALSE;
	}

	COrderData*	pOrder = GetOrderData( pNextCmd->dwOrderId );

	if ( NULL != pOrder )
	{
		pStartDuplexData->wPossessionNo = pOrder->m_nPossessionNo;	// Lԍ

		return TRUE;
	}

	return FALSE;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CPrintQue::GetEndDuplexData()
//	ABSTRACT : ʈIvɕKvȃf[^擾
//	FUNCTION : 
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : Y.Yoshinobu	2008.5.23
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
BOOL CPrintQue::GetEndDuplexData( T_NextCmd* pNextCmd, T_EndDuplexData* pEndDuplexData )
{
	NkcComApi::CCSScopeLock CSScopeLock( &m_CS );

	if ( CMD_DUPLEX_END != pNextCmd->eCmdType )
	{
		return FALSE;
	}

	COrderData*	pOrder = GetOrderData( pNextCmd->dwOrderId );

	if ( NULL != pOrder )
	{
		pEndDuplexData->wPossessionNo = pOrder->m_nPossessionNo;	// Lԍ

		return TRUE;
	}

	return FALSE;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CPrintQue::GetEndOrderDataCancelReceiptNo()
//	ABSTRACT : v^LIOɃLZKvȃf[^擾
//	FUNCTION : 
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : Y.Yoshinobu	2007.4.10
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
BOOL CPrintQue::GetEndOrderDataCancelReceiptNo( ULONG* pReceiptNo )
{
	NkcComApi::CCSScopeLock CSScopeLock( &m_CS );

	if ( TRUE == m_PossessionRelease.bPossessionRelease )
	{
		if ( 0 != m_PossessionRelease.nCancelReceiptNo )
		{
			*pReceiptNo = m_PossessionRelease.nCancelReceiptNo;
			m_PossessionRelease.nCancelReceiptNo = 0;
			return TRUE;
		}
	}

	return FALSE;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CPrintQue::GetEndOrderData()
//	ABSTRACT : v^LIɕKvȃf[^擾
//	FUNCTION : 
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : Y.Yoshinobu	2006.10.8
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
BOOL CPrintQue::GetEndOrderData( T_NextCmd* pNextCmd, T_EndOrderData* pEndOrderData )
{
	NkcComApi::CCSScopeLock CSScopeLock( &m_CS );

	if ( CMD_ORDER_END != pNextCmd->eCmdType )
	{
		return FALSE;
	}


	if ( TRUE == m_PossessionRelease.bPossessionRelease )
	{
		// LI
		if ( pNextCmd->dwOrderId == m_PossessionRelease.tNextCmd.dwOrderId )
		{
			::MoveMemory( pEndOrderData, &m_PossessionRelease.tEndOrderData, sizeof(T_EndOrderData) );
		}
		return TRUE;
	}


	COrderData*	pOrder = GetOrderData( pNextCmd->dwOrderId );

	if ( NULL != pOrder )
	{
		pEndOrderData->eOrderStep		= pOrder->m_eOrderStep;		// vgv̔s
		pEndOrderData->wPossessionNo	= pOrder->m_nPossessionNo;	// Lԍ

		return TRUE;
	}

	return FALSE;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CPrintQue::GetCreditOrderData()
//	ABSTRACT : NWbgJnEIɕKvȃf[^擾
//	FUNCTION : 
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : Y.Yoshinobu	2007.03.07
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
BOOL CPrintQue::GetCreditOrderData( T_NextCmd* pNextCmd, T_CreditOrderData* pCreditOrderData )
{
	NkcComApi::CCSScopeLock CSScopeLock( &m_CS );

	COrderData*	pOrder = GetOrderData( pNextCmd->dwOrderId );

	if ( NULL != pOrder )
	{
		pCreditOrderData->wPossessionNo = pOrder->m_nPossessionNo;	// Lԍ

		return TRUE;
	}

	return FALSE;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CPrintQue::GetStartInterruptOrderInfoData()
//	ABSTRACT : đJnvɕKvȃf[^擾
//	FUNCTION : 
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : A.Nagamatsu	2011.11.22
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
BOOL CPrintQue::GetStartInterruptOrderInfoData( T_NextCmd* pNextCmd, T_InterruptOrderInfoData* pInterruptOrderInfoData )
{
	NkcComApi::CCSScopeLock CSScopeLock( &m_CS );

	if ( CMD_RETRANSMISSION_START != pNextCmd->eCmdType )
	{
		return FALSE;
	}

	COrderData*	pOrder = GetOrderData( pNextCmd->dwOrderId );
	if ( NULL != pOrder )
	{
		pInterruptOrderInfoData->wPossessionNo							= pOrder->m_nPossessionNo;	// Lԍ
		pInterruptOrderInfoData->tInterruptOrderParam.wOrderState		= pNextCmd->wOrderState;	// f̃I[_[
		pInterruptOrderInfoData->tInterruptOrderParam.wMainSideState	= pNextCmd->wMainSideState;	// ʃvg̕\ʊJnm点
		pInterruptOrderInfoData->tInterruptOrderParam.wBackSideState	= pNextCmd->wBackSideState;	// ʃvg̗ʊJnm点
		pInterruptOrderInfoData->tInterruptOrderParam.wPrintSide		= pNextCmd->wPrintSide;		// ʃvg̃vg

		return TRUE;
	}

	return FALSE;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CPrintQue::GetEndInterruptOrderInfoData()
//	ABSTRACT : đIvɕKvȃf[^擾
//	FUNCTION : 
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : A.Nagamatsu	2011.11.22
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
BOOL CPrintQue::GetEndInterruptOrderInfoData( T_NextCmd* pNextCmd, T_InterruptOrderInfoData* pInterruptOrderInfoData )
{
	NkcComApi::CCSScopeLock CSScopeLock( &m_CS );

	if ( CMD_RETRANSMISSION_END != pNextCmd->eCmdType )
	{
		return FALSE;
	}

	COrderData*	pOrder = GetOrderData( pNextCmd->dwOrderId );
	if ( NULL != pOrder )
	{
		pInterruptOrderInfoData->wPossessionNo	= pOrder->m_nPossessionNo;	// Lԍ

		return TRUE;
	}

	return FALSE;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CPrintQue::GetReserverCount()
//	ABSTRACT : SDK̖vg擾
//	FUNCTION : SDK̖vg擾
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : T.Isogai	2006.9.21
//	UPDATE   : J.Fukumori(AVASYS) 2008.07.18 VS2005Ή for̔rLXg
//////////////////////////////////////////////////////////////////////////////
DWORD CPrintQue::GetReserverCount()
{
	NkcComApi::CCSScopeLock CSScopeLock( &m_CS );

	int nIdx1;
	int nIdx2;
	DWORD dwCount = 0;

	for( nIdx1 = 0; nIdx1 < (int)m_vOrderNormal.size(); nIdx1++ )
	{
		COrderData* ptmpOrderData	= ( COrderData* ) m_vOrderNormal[nIdx1];

		for( nIdx2 = 0; nIdx2 < (int)ptmpOrderData->m_vFrame.size(); nIdx2++ )
		{
			CFrameData* ptmpFrameData	= ( CFrameData* ) ptmpOrderData->m_vFrame[nIdx2];

			if( ptmpFrameData->m_eFrameState != STEP6_DELETE )	// 2006.11.16 T.Mizushima
			{
				if(( CFrameData::TYPE_PRINT == ptmpFrameData->GetType() ) &&
				   ( 0 == ((CFrameDataPrint*)ptmpFrameData)->m_PrintNum.Transfer ))
				{
					dwCount += ((CFrameDataPrint*)ptmpFrameData)->m_PrintNum.Repeat;
				}
			}
		}
	}

	for( nIdx1 = 0; nIdx1 < (int)m_vOrderExpress.size(); nIdx1++ )
	{
		COrderData* ptmpOrderData	= ( COrderData* ) m_vOrderExpress[nIdx1];

		for( nIdx2 = 0; nIdx2 < (int)ptmpOrderData->m_vFrame.size(); nIdx2++ )
		{
			CFrameData* ptmpFrameData	= ( CFrameData* ) ptmpOrderData->m_vFrame[nIdx2];

			if( ptmpFrameData->m_eFrameState != STEP6_DELETE )	// 2006.11.16 T.Mizushima
			{
				if(( CFrameData::TYPE_PRINT == ptmpFrameData->GetType() ) &&
				   ( 0 == ((CFrameDataPrint*)ptmpFrameData)->m_PrintNum.Transfer ))
				{
					dwCount += ((CFrameDataPrint*)ptmpFrameData)->m_PrintNum.Repeat;
				}
			}
		}
	}

	for( nIdx1 = 0; nIdx1 < (int)m_vOrderExpressL2.size(); nIdx1++ )
	{
		COrderData* ptmpOrderData	= ( COrderData* ) m_vOrderExpressL2[nIdx1];

		for( nIdx2 = 0; nIdx2 < (int)ptmpOrderData->m_vFrame.size(); nIdx2++ )
		{
			CFrameData* ptmpFrameData	= ( CFrameData* ) ptmpOrderData->m_vFrame[nIdx2];

			if( ptmpFrameData->m_eFrameState != STEP6_DELETE )	// 2006.11.16 T.Mizushima
			{
				if(( CFrameData::TYPE_PRINT == ptmpFrameData->GetType() ) &&
				   ( 0 == ((CFrameDataPrint*)ptmpFrameData)->m_PrintNum.Transfer ))
				{
					dwCount += ((CFrameDataPrint*)ptmpFrameData)->m_PrintNum.Repeat;
				}
			}
		}
	}

	return dwCount;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CPrintQue::GetTotalCount()
//	ABSTRACT : SDKSĂ̑擾
//	FUNCTION : SDKSĂ̑擾
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : T.Isogai	2006.9.21
//	UPDATE   : J.Fukumori(AVASYS) 2008.07.18 VS2005Ή for̔rLXg
//////////////////////////////////////////////////////////////////////////////
DWORD CPrintQue::GetTotalCount()
{
	NkcComApi::CCSScopeLock CSScopeLock( &m_CS );

	int nIdx1;
	int nIdx2;
	DWORD dwCount = 0;

	for ( nIdx1 = 0; nIdx1 < (int)m_vOrderNormal.size(); nIdx1++ )
	{
		COrderData* ptmpOrderData	= ( COrderData* ) m_vOrderNormal[nIdx1];

		for ( nIdx2 = 0; nIdx2 < (int)ptmpOrderData->m_vFrame.size(); nIdx2++ )
		{
			CFrameData* ptmpFrameData	= ( CFrameData* ) ptmpOrderData->m_vFrame[nIdx2];

			if ( CFrameData::TYPE_PRINT == ptmpFrameData->GetType() )
			{
				dwCount += ( ((CFrameDataPrint*)ptmpFrameData)->m_PrintNum.Repeat
								- ((CFrameDataPrint*)ptmpFrameData)->m_PrintNum.Out
								- ((CFrameDataPrint*)ptmpFrameData)->m_PrintNum.Cancel
								- ((CFrameDataPrint*)ptmpFrameData)->m_PrintNum.NG );
			}
		}
	}

	for ( nIdx1 = 0; nIdx1 < (int)m_vOrderExpress.size(); nIdx1++ )
	{
		COrderData* ptmpOrderData	= ( COrderData* ) m_vOrderExpress[nIdx1];

		for ( nIdx2 = 0; nIdx2 < (int)ptmpOrderData->m_vFrame.size(); nIdx2++ )
		{
			CFrameData* ptmpFrameData	= ( CFrameData* ) ptmpOrderData->m_vFrame[nIdx2];

			if ( CFrameData::TYPE_PRINT == ptmpFrameData->GetType() )
			{
				dwCount += ( ((CFrameDataPrint*)ptmpFrameData)->m_PrintNum.Repeat
								- ((CFrameDataPrint*)ptmpFrameData)->m_PrintNum.Out
								- ((CFrameDataPrint*)ptmpFrameData)->m_PrintNum.Cancel
								- ((CFrameDataPrint*)ptmpFrameData)->m_PrintNum.NG );
			}
		}
	}

	for ( nIdx1 = 0; nIdx1 < (int)m_vOrderExpressL2.size(); nIdx1++ )
	{
		COrderData* ptmpOrderData	= ( COrderData* ) m_vOrderExpressL2[nIdx1];

		for ( nIdx2 = 0; nIdx2 < (int)ptmpOrderData->m_vFrame.size(); nIdx2++ )
		{
			CFrameData* ptmpFrameData	= ( CFrameData* ) ptmpOrderData->m_vFrame[nIdx2];

			if ( CFrameData::TYPE_PRINT == ptmpFrameData->GetType() )
			{
				dwCount += ( ((CFrameDataPrint*)ptmpFrameData)->m_PrintNum.Repeat
								- ((CFrameDataPrint*)ptmpFrameData)->m_PrintNum.Out
								- ((CFrameDataPrint*)ptmpFrameData)->m_PrintNum.Cancel
								- ((CFrameDataPrint*)ptmpFrameData)->m_PrintNum.NG );
			}
		}
	}

	return dwCount;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CPrintQue::GetPrintStatus()
//	ABSTRACT : vgԂ̎擾
//	FUNCTION : vgԂ̎擾
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : T.Isogai	2006.9.21
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
DWORD CPrintQue::GetPrintStatus( DWORD dwPrintId )
{
	NkcComApi::CCSScopeLock CSScopeLock( &m_CS );

	DWORD	PrintStatus	= REQSTS_UNKNOWN;

	CFrameData*	pFrameData	= GetFrameDataByPrintId( dwPrintId );

	if( NULL == pFrameData )
	{
		PrintStatus	= REQSTS_UNKNOWN;
	}
	else if( STEP0_FRAME_NONE == ((CFrameDataPrint*)pFrameData)->m_eFrameState )
	{
		PrintStatus	= REQSTS_WAIT;
	}
	else
	{
		if (( STEP0_FRAME_NONE < ((CFrameDataPrint*)pFrameData)->m_eFrameState ) &&
			( STEP4_FRAME_6000_0800 > ((CFrameDataPrint*)pFrameData)->m_eFrameState ))
		{
			PrintStatus	= REQSTS_REQUEST;
		}
		else if ( STEP4_FRAME_6000_0800 == ((CFrameDataPrint*)pFrameData)->m_eFrameState )
		{
			ULONG nRepeat	= ((CFrameDataPrint*)pFrameData)->m_PrintNum.Repeat;		// s[g
			ULONG nTotal	= ((CFrameDataPrint*)pFrameData)->m_PrintNum.Out			// vgro
								+ ((CFrameDataPrint*)pFrameData)->m_PrintNum.Cancel		//  + vgs
								+ ((CFrameDataPrint*)pFrameData)->m_PrintNum.NG;		//  + vgLZ
			if ( nRepeat > nTotal )
			{
				PrintStatus = REQSTS_EXEC;
			}
		};
	}

	return PrintStatus;
}

//----------------------------------------
// I[_[̍폜
//----------------------------------------

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CPrintQue::RemoveOrder()
//	ABSTRACT : I[_[̍폜
//	FUNCTION : I[_[̍폜
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : T.Isogai	2006.9.21
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
BOOL CPrintQue::RemoveOrder( DWORD dwOrderId )
{
	NkcComApi::CCSScopeLock CSScopeLock( &m_CS );

	BOOL	bRet;

	bRet	= DeleteOrderData( dwOrderId );

	return bRet;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CPrintQue::RemoveFrame()
//	ABSTRACT : R}̍폜
//	FUNCTION : R}̍폜
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : T.Isogai	2006.9.21
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
BOOL CPrintQue::RemoveFrame( DWORD dwOrderId, DWORD dwPrintId )
{
	NkcComApi::CCSScopeLock CSScopeLock( &m_CS );

	COrderData*	pOrderData;

	pOrderData	= GetOrderData( dwOrderId );

	if( NULL == pOrderData )
	{
		return FALSE;
	}

	BOOL	bRet	= pOrderData->DeleteFrameData( dwPrintId );

	return bRet;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CPrintQue::CallbackCompletionPrint()
//	ABSTRACT : 
//	FUNCTION : 
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : T.Isogai	2006.9.22
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
void CPrintQue::CallbackCompletionPrint( void* pCompletionProc, DWORD dwProcessId, DWORD dwPrintId, DWORD dwStatus, DWORD dwFinishNum )
{
	// R[obN]
	SYSTEMTIME	localtime;
	GetLocalTime( &localtime );

		DWORD	dwCompletionCode	= COMPLETION_PRINT;

		NPSPRINTINFO	wPrintInfo;
		NPSORDERINFO	wOrderInfo;

		ZeroMemory( &wPrintInfo, sizeof( NPSPRINTINFO ) );
		ZeroMemory( &wOrderInfo, sizeof( NPSORDERINFO ) );

		wPrintInfo.hPrinter			= m_hPrinter;			// Cxg̔v^̃nh	wPrintInfo.hPrinter			= GetPrinterHandle();		// Cxg̔v^̃nh
		wPrintInfo.dwIPAddress		= m_dwIPAddress;		// Cxg̔v^IPAhX
		wPrintInfo.sysTime			= localtime;			// Cxg
		wPrintInfo.dwPrintId		= dwPrintId;			// vgʎq
		wPrintInfo.dwStatus			= dwStatus;				// 
		wPrintInfo.dwFinishNum		= dwFinishNum;			// I
		wPrintInfo.wPortNo			= m_wNpsPortNo;			// Cxg̔v^NPSp|[gԍ

		if ( pCompletionProc )
		{
			if ( NULL != m_pCallbackCompletion )
			{
				m_pCallbackCompletion->AddNpsCALLBACKDATA( pCompletionProc, dwCompletionCode, wPrintInfo, wOrderInfo );
			}
		}
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CPrintQue::CallbackCompletionOrder()
//	ABSTRACT : 
//	FUNCTION : 
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : T.Isogai	2006.9.22
//	UPDATE   : T.Isogai 2010.01.06	EZ Controller 6x6C` tHgubNΉ
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
void CPrintQue::CallbackCompletionOrder( void* pCompletionProc, DWORD dwOrderId, DWORD dwStatus )
{
	SYSTEMTIME	localtime;
	GetLocalTime( &localtime );

		DWORD	dwCompletionCode	= COMPLETION_ORDER;

		NPSPRINTINFO	wPrintInfo;
		NPSORDERINFO	wOrderInfo;

		ZeroMemory( &wPrintInfo, sizeof( NPSPRINTINFO ) );
		ZeroMemory( &wOrderInfo, sizeof( NPSORDERINFO ) );

		wOrderInfo.hPrinter			= m_hPrinter;			// Cxg̔v^̃nh
		wOrderInfo.dwIPAddress		= m_dwIPAddress;		// Cxg̔v^IPAhX
		wOrderInfo.sysTime			= localtime;			// Cxg
		wOrderInfo.dwOrderId		= dwOrderId;			// I[_[ʎq
		wOrderInfo.dwStatus			= dwStatus;				// 
		wOrderInfo.wPortNo			= m_wNpsPortNo;			// Cxg̔v^NPSp|[gԍ

		//--------------------------------------------------------------------------------
		// EZ Controller 6x6C` tHgubNΉ
		//--------------------------------------------------------------------------------
		if( RESULT_NG == dwStatus )
		{
			if( NULL != m_pCallbackCompletionOrderNG)
			{
				m_pCallbackCompletion->AddNpsCALLBACKDATA( m_pCallbackCompletionOrderNG, dwCompletionCode, wPrintInfo, wOrderInfo );
			}
		}
		//--------------------------------------------------------------------------------

		if ( pCompletionProc )
		{
			if ( NULL != m_pCallbackCompletion )
			{
				m_pCallbackCompletion->AddNpsCALLBACKDATA( pCompletionProc, dwCompletionCode, wPrintInfo, wOrderInfo );
			}
		}
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CPrintQue::IsExistOrder()
//	ABSTRACT : CuɃI[_[邩mF
//	FUNCTION : 
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : Y.Yoshinobu	2006.10.17
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
BOOL CPrintQue::IsExistOrder( DWORD dwOrderId )
{
	NkcComApi::CCSScopeLock CSScopeLock( &m_CS );

	COrderData*	pOrderData = GetOrderData( dwOrderId );

	if( NULL == pOrderData )
	{
		return FALSE;
	}

	return TRUE;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CPrintQue::IsEmptyOrder()
//	ABSTRACT : I[_[ł邩mF
//	FUNCTION : 
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : Y.Yoshinobu	2008.12.24
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
BOOL CPrintQue::IsEmptyOrder( DWORD dwOrderId )
{
	NkcComApi::CCSScopeLock CSScopeLock( &m_CS );

	COrderData*	pOrderData = GetOrderData( dwOrderId );

	if( NULL == pOrderData )
	{
		return FALSE;
	}

	if ( 0 == pOrderData->m_vFrame.size() )
	{
		return TRUE;
	}

	return FALSE;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CPrintQue::IsExistFrame()
//	ABSTRACT : CuɃR}邩mF
//	FUNCTION : 
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : Y.Yoshinobu	2006.10.24
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
BOOL CPrintQue::IsExistFrame( DWORD dwPrintId )
{
	NkcComApi::CCSScopeLock CSScopeLock( &m_CS );

	COrderData*	pOrderData = GetOrderDataByPrintId( dwPrintId );

	if( NULL == pOrderData )
	{
		return FALSE;
	}

	return TRUE;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CPrintQue::IsMaintenance()
//	ABSTRACT : eiXI[_[mF
//	FUNCTION : 
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : Y.Yoshinobu	2006.12.26
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
BOOL CPrintQue::IsMaintenance( DWORD dwOrderId )
{
	NkcComApi::CCSScopeLock CSScopeLock( &m_CS );

	COrderData*	pOrderData = GetOrderData( dwOrderId );

	if( NULL != pOrderData )
	{
		if ( TRUE == pOrderData->m_bIsMaintenance )
		{
			return TRUE;
		}
	}

	return FALSE;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CPrintQue::IsDuplexMode()
//	ABSTRACT : ʈt[hmF
//	FUNCTION : 
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	ARGUMENT : dwOrderId        : I[_[ID
//	           pDuplexMode      : ʈt[htO ( TRUE:ʎt[h, FALSE:ʔt[h )
//	           pDuplexFrameCnt  : ʎtĂR} ( npsDevStartDuplex琔A܂npsDevSortŃZbg  )
//	           pDuplexPaperInfo : ʎtŌ̃R}̃y[p[ ( OR}Ƃ̃y[p[`FbNɎgp )
//	           
//	RETURN   : TRUE  : I[_[݂
//	           FALSE : I[_[݂Ȃ
//	
//	CREATE	 : Y.Yoshinobu	2008.5.23
//	UPDATE   : J.Fukumori(AVASYS) 2008.07.18 VS2005Ή
//	UPDATE   : Y.Yoshinobu	2008.9.25	͉𑜓xA}KWwA@擾ɒǉ
//////////////////////////////////////////////////////////////////////////////
BOOL CPrintQue::IsDuplexMode( const DWORD dwOrderId, BOOL* pDuplexMode, LPDWORD pDuplexFrameCnt, T_DuplexPaperInfo* pDuplexPaperInfo )
{
	NkcComApi::CCSScopeLock CSScopeLock( &m_CS );

	DWORD dwCount=0;
	COrderData*	pOrderData = GetOrderData( dwOrderId );

	if( NULL != pOrderData )
	{
		int nIdx;
		CFrameData* pFrameData;
		CFrameDataPrint* pFramePrint;
		CFrameDataDuplex* pFrameDuplex;

		*pDuplexMode = FALSE;

		for( nIdx = 0; nIdx < (int)pOrderData->m_vFrame.size(); nIdx++ )
		{
			pFrameData = ( CFrameData* ) pOrderData->m_vFrame[nIdx];

			switch ( pFrameData->GetType() )
			{
			case CFrameData::TYPE_DUPLEX:

				pFrameDuplex = (CFrameDataDuplex*)pFrameData;

				switch ( pFrameDuplex->m_eDuplexMode )
				{
				case CFrameDataDuplex::MODE_DUPLEX_START:
					*pDuplexMode = TRUE;
					// ʂ̑gݍ킹Zbĝ0ɖ߂
					dwCount = 0;
					break;
				case CFrameDataDuplex::MODE_DUPLEX_END:
					*pDuplexMode = FALSE;
					break;
				}
				break;

			case CFrameData::TYPE_PRINT:

				pFramePrint = (CFrameDataPrint*)pFrameData;

				if ( TRUE == *pDuplexMode )
				{
					dwCount ++;
					if ( NULL != pDuplexPaperInfo )
					{
						pDuplexPaperInfo->dwPaperWidth	= pFramePrint->m_PrnParam.dwPaperWidth;
						pDuplexPaperInfo->dwSurface		= pFramePrint->m_PrnParam.dwSurface;
						pDuplexPaperInfo->dwPaperLength	= pFramePrint->m_PrnParam.dwPaperLength;
						pDuplexPaperInfo->dwFeed		= pFramePrint->m_PrnParam.dwFeed;
						pDuplexPaperInfo->dwPrintNum	= pFramePrint->m_PrnParam.dwPrintNum;
						strncpy( pDuplexPaperInfo->szPaperName, pFramePrint->m_PrnParam.szPaperName, 32 );
						pDuplexPaperInfo->dwResolution	= pFramePrint->m_PrnParam.dwResolution;
						pDuplexPaperInfo->dwPaperPresence	= pFramePrint->m_PrnParam.dwPaperPresence;
						pDuplexPaperInfo->wPrintQuality	= pFramePrint->m_PrnParam.wPrintQuality;
					}
				}
				break;

			case CFrameData::TYPE_SORT:
				if ( TRUE == *pDuplexMode )
				{
					// ʂ̑gݍ킹Zbĝ0ɖ߂
					dwCount = 0;
				}
				break;

			}
		}
	}
	else
	{
		return FALSE;
	}

	if ( NULL != pDuplexFrameCnt )
	{
		*pDuplexFrameCnt = dwCount;
	}

	return TRUE;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CPrintQue::IsDuplexLastOdd()
//	ABSTRACT : ʈ̍ŏIR}ŊmF
//	FUNCTION : 
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	ARGUMENT : dwOrderId        : I[_[ID
//	           dwPrintID        : vgID
//	           
//	RETURN   : TRUE  : ʈ̍ŏIR}Ŋł
//	           FALSE : ʈ̍ŏIR}ŊłȂ
//	
//	CREATE	 : Y.Yoshinobu	2009.11.10
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
BOOL CPrintQue::IsDuplexLastOdd( const DWORD dwOrderId, const DWORD dwPrintID )
{
	BOOL bLastOne=FALSE;
	BOOL bDuplexMode=FALSE;
	DWORD dwDuplexCount=0;
	COrderData*	pOrderData = GetOrderData( dwOrderId );

	if( NULL != pOrderData )
	{
		int nIdx;
		CFrameData* pFrameData;
		CFrameDataPrint* pFramePrint;
		CFrameDataDuplex* pFrameDuplex;

		for( nIdx = 0; nIdx < (int)pOrderData->m_vFrame.size(); nIdx++ )
		{
			pFrameData = ( CFrameData* ) pOrderData->m_vFrame[nIdx];

			switch ( pFrameData->GetType() )
			{
			case CFrameData::TYPE_DUPLEX:

				pFrameDuplex = (CFrameDataDuplex*)pFrameData;

				switch ( pFrameDuplex->m_eDuplexMode )
				{
				case CFrameDataDuplex::MODE_DUPLEX_START:

					bLastOne = FALSE;
					bDuplexMode = TRUE;
					// ʂ̑gݍ킹Zbĝ0ɖ߂
					dwDuplexCount = 0;
					break;

				case CFrameDataDuplex::MODE_DUPLEX_END:

					if ( TRUE == bLastOne )
					{
						return TRUE;
					}

					bDuplexMode = FALSE;
					break;
				}
				break;

			case CFrameData::TYPE_PRINT:

				bLastOne = FALSE;

				pFramePrint = (CFrameDataPrint*)pFrameData;

				if ( TRUE == bDuplexMode )
				{
					dwDuplexCount ++;
					if ( dwPrintID == pFramePrint->m_dwPrintId )
					{
						if ( 1 == dwDuplexCount % 2 )
						{
							bLastOne = TRUE;
						}
					}
				}
				break;

			case CFrameData::TYPE_SORT:

				if ( TRUE == bLastOne )
				{
					return TRUE;
				}

				if ( TRUE == bDuplexMode )
				{
					// ʂ̑gݍ킹Zbĝ0ɖ߂
					dwDuplexCount = 0;
				}
				break;

			}
		}
	}
	else
	{
		return FALSE;
	}

	if ( TRUE == bLastOne )
	{
		return TRUE;
	}

	return FALSE;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CPrintQue::IsDuplexOrder()
//	ABSTRACT : ʈI[_[mF
//	FUNCTION : 
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : TRUE  : ʈI[_[ł
//	           FALSE : ʈI[_[łȂ
//	
//	CREATE	 : Y.Yoshinobu	2008.5.23
//	UPDATE   : J.Fukumori(AVASYS) 2008.07.18 VS2005Ή for̔rLXg
//////////////////////////////////////////////////////////////////////////////
BOOL CPrintQue::IsDuplexOrder( const DWORD dwOrderId )
{
	NkcComApi::CCSScopeLock CSScopeLock( &m_CS );

	COrderData*	pOrderData = GetOrderData( dwOrderId );

	if( NULL != pOrderData )
	{
		int nIdx;
		CFrameData* pFrameData;

		for( nIdx = 0; nIdx < (int)pOrderData->m_vFrame.size(); nIdx++ )
		{
			pFrameData = ( CFrameData* ) pOrderData->m_vFrame[nIdx];

			if( CFrameData::TYPE_DUPLEX == pFrameData->GetType() )
			{
				return TRUE;
			}
		}
	}

	return FALSE;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CPrintQue::ResetOrderStep()
//	ABSTRACT : I[_[Ԃɖ߂
//	FUNCTION : I[_[Ԃɖ߂
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : T.Mizushima	2006.10.31
//	UPDATE   : Y.Yoshinobu	2009.11.28	ʈ̏Ԃ߂ǉ
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
void CPrintQue::ResetOrderStep( const DWORD dwOrderId, const DWORD dwIndexNo )
{
	NkcComApi::CCSScopeLock CSScopeLock( &m_CS );

	{	// Oo
		CString str;
		str.Format( "---CPrintQue::ResetOrderStep() [RESTORE]CHECK START OrderId=%u IndexNo=%u", dwOrderId, dwIndexNo );
		NPS_LOGOUT( str );
	}

	COrderData* pOrderData;
	pOrderData = GetOrderData( dwOrderId );

	if( pOrderData != NULL )
	{
		// LJn̍đ(MZbg)
		if ( STEP0_ORDER_NONE != pOrderData->m_eOrderStep )
		{
			pOrderData->m_eOrderStep = STEP0_ORDER_NONE;
			if( 0 != pOrderData->m_nNpsImgPort )
			{
				// ڑؒf
				m_pNpsImgMng->Delete( pOrderData->m_nNpsImgPort );
				pOrderData->m_nNpsImgPort = 0;
			}

			{	// Oo
				CString str;
				str.Format( "---CPrintQue::ResetOrderStep() [RESTORE]ORDER OrderId=%u", dwOrderId );
				NPS_LOGOUT( str );
			}

			if( INFO_SUPPORTINTNEW == m_pDataManager->GetPrinterSetupSupportInterrupt() )
			{	// V^荞ݑΉ		@@@RD-151Ή	2012.05.08	T.Mizushima
				pOrderData->m_bReOccupy = TRUE;		// }ݏI̍ĐLZbg
			}
		}

		std::vector<CFrameData*>::iterator itFrame;

		// gCύXv̍đ(MZbg)
		if( INFO_SUPPORTINTNEW == m_pDataManager->GetPrinterSetupSupportInterrupt() )
		{	// V^荞ݑΉȂđȂ̂ŉȂ		@@@RD-151Ή	2012.05.08	T.Mizushima
		}
		else
		{
			CFrameData* pFrameDataSort = NULL;
			if ( 0 == dwIndexNo )
			{
				// v^ԕύXʒmŁAL荞݂mƂ̏
				for ( itFrame=pOrderData->m_vFrame.begin() ; pOrderData->m_vFrame.end() != itFrame ; itFrame++ )
				{
					if ( STEP0_FRAME_NONE == (*itFrame)->m_eFrameState )
					{
						break;
					}
					// R}ԂuIv́uvgIorrovΏۂɂ
					switch ( (*itFrame)->GetType() )
					{
					case CFrameData::TYPE_PRINT:
						pFrameDataSort = NULL;
						break;
					case CFrameData::TYPE_SORT:
						pFrameDataSort = *itFrame;
						break;
					case CFrameData::TYPE_DUPLEX:
						break;
					}
				}
			}
			else
			{
				// 荞݉(NPS_ERROR_27)󂯂̏
				for ( itFrame=pOrderData->m_vFrame.begin() ; pOrderData->m_vFrame.end() != itFrame ; itFrame++ )
				{
					if ( dwIndexNo <= (*itFrame)->m_dwIndexNo )
					{
						break;
					}
					// R}ԂuIv́uvgIorrovΏۂɂ
					switch ( (*itFrame)->GetType() )
					{
					case CFrameData::TYPE_PRINT:
						pFrameDataSort = NULL;
						break;
					case CFrameData::TYPE_SORT:
						pFrameDataSort = *itFrame;
						break;
					case CFrameData::TYPE_DUPLEX:
						break;
					}
				}
			}
			if ( NULL != pFrameDataSort )
			{
				pFrameDataSort->m_eFrameState = STEP0_FRAME_NONE;

				{	// Oo
					CString str;
					str.Format( "---CPrintQue::ResetOrderStep() [RESTORE]SORT OrderId=%u IndexNo=%u Type=%u",
									pOrderData->m_dwOrderId, pFrameDataSort->m_dwIndexNo, pFrameDataSort->GetType() );
					NPS_LOGOUT( str );
				}
			}

			// ʊJnEIv̍đ(MZbg)
			for ( itFrame=pOrderData->m_vFrame.begin() ; pOrderData->m_vFrame.end() != itFrame ; itFrame++ )
			{
				if ( CFrameData::TYPE_DUPLEX == (*itFrame)->GetType() )
				{
					// Mς݂̗ʊJnEIv͖ŖMɖ߂
					// ʊJnvƗʏIv̊ԂɃvgv΃v^[͉Ȃ̂
					//   PɑSĖMɖ߂
					if ( STEP0_FRAME_NONE != (*itFrame)->m_eFrameState )
					{
						(*itFrame)->m_eFrameState = STEP0_FRAME_NONE;

						{	// Oo
							CString str;
							str.Format( "---CPrintQue::ResetOrderStep() [RESTORE]DUPLEX OrderId=%u IndexNo=%u Type=%u",
											pOrderData->m_dwOrderId, (*itFrame)->m_dwIndexNo, (*itFrame)->GetType() );
							NPS_LOGOUT( str );
						}
					}
				}
			}

			// >>>>> 2011.11.22 A.Nagamatsu
			// đJnEIv̍đ(MZbg)
			for ( itFrame=pOrderData->m_vFrame.begin() ; pOrderData->m_vFrame.end() != itFrame ; itFrame++ )
			{
				if ( CFrameData::TYPE_RETRANSMISSION == (*itFrame)->GetType() )
				{
					// Mς݂̍đJnEIv͖ŖMɖ߂
					// đJnvƍđIv̊ԂɃvgv΃v^[͉Ȃ̂
					//   PɑSĖMɖ߂
					if ( STEP0_FRAME_NONE != (*itFrame)->m_eFrameState )
					{
						(*itFrame)->m_eFrameState = STEP0_FRAME_NONE;

						{	// Oo
							CString str;
							str.Format( "---CPrintQue::ResetOrderStep() [RESTORE]RETRANSMISSION OrderId=%u IndexNo=%u Type=%u",
											pOrderData->m_dwOrderId, (*itFrame)->m_dwIndexNo, (*itFrame)->GetType() );
							NPS_LOGOUT( str );
						}
					}
				}
			}
			// <<<<<
		}

#if 0
		// ʈ̊JnEIƃ\[g̃R}h𖢑Mɖ߂ǉ		2009.11.30 Y.Yoshinobu
		if ( 0 == dwIndexNo )
		{
			// v^ԕύXʒmŁAL荞݂mƂ̏
			//------------------------------------------------------------------------------------------------
			// vg󋵒ʒmȂ̂ŁAōđs
			// ) [1]R}(vg), [2]R}(vg), [3]\[g ,[4]ʈJn
			//     ̂悤ȃP[Xł[3]\[g[4]ʈJn𖢑Mɂ

			DWORD dwResumeStart = 0;	// đJnԍ( 0:YȂ, 1ȏ:đJnԍ )
			DWORD dwResumeEnd = 0;		// đIԍ( 0:YȂ, 1ȏ:đIԍ )
			std::vector<CFrameData*>::iterator itFrame;

			// R}̃vgvsŃvgIĂȂƂɁAʈJnđ邽߂̏
			for ( itFrame=pOrderData->m_vFrame.begin() ; pOrderData->m_vFrame.end() != itFrame ; itFrame++ )
			{
				if ( STEP0_FRAME_NONE != (*itFrame)->m_eFrameState )
				{
					switch ( (*itFrame)->GetType() )
					{
					case CFrameData::TYPE_PRINT:
						dwResumeStart = 0;
						dwResumeEnd = 0;
						if (( FALSE == ((CFrameDataPrint*)(*itFrame))->m_SendFlg.bPRINT ) &&
							( FALSE == ((CFrameDataPrint*)(*itFrame))->m_SendFlg.bUSER_CANCEL ) &&
							( FALSE == ((CFrameDataPrint*)(*itFrame))->m_SendFlg.bNG ))
						{
							// vg󋵒ʒmŊ荞ݒfԂ̂ŁAł͏Ȃ
							// [vI
						}
						else
						{
							// vg󋵒ʒmŊ荞ݒfԂȂ̂ŏp
							continue;
						}
						break;
					case CFrameData::TYPE_SORT:
						if ( 0 == dwResumeStart )
						{
							dwResumeStart = (*itFrame)->m_dwIndexNo;
						}
						dwResumeEnd = (*itFrame)->m_dwIndexNo;
						continue;
						break;
					case CFrameData::TYPE_DUPLEX:
						if ( CFrameDataDuplex::MODE_DUPLEX_START == ((CFrameDataDuplex*)(*itFrame))->m_eDuplexMode )
						{
							if ( 0 == dwResumeStart )
							{
								dwResumeStart = (*itFrame)->m_dwIndexNo;
							}
							dwResumeEnd = (*itFrame)->m_dwIndexNo;
						}
						else
						{
							dwResumeStart = 0;
							dwResumeEnd = 0;
						}
						continue;
						break;
					}

					// [vI
					break;
				}

				// [vI
				break;
			}

			for ( itFrame=pOrderData->m_vFrame.begin() ; pOrderData->m_vFrame.end() != itFrame ; itFrame++ )
			{
				if (( dwResumeStart <= (*itFrame)->m_dwIndexNo ) &&
					( dwResumeEnd >= (*itFrame)->m_dwIndexNo ))
				{
					(*itFrame)->m_eFrameState = STEP0_FRAME_NONE;
					{	// Oo
						CString str;
						str.Format( "---CPrintQue::ResetOrderStep() [RESTORE]F102 OrderId=%u IndexNo=%u Type=%u",
										pOrderData->m_dwOrderId, (*itFrame)->m_dwIndexNo, (*itFrame)->GetType() );
						NPS_LOGOUT( str );
					}
				}
			}
		}
		else
		{
			// ʈJn𑗐Mς݂ŁA̗ʂ̍ŏ̃R}Ŋ荞݉(NPS_ERROR_27)󂯂
			// vg󋵒ʒmȂ̂ŁAōđs
			// I[_[ɗʈJnEI݂邱Ƃl
			//------------------------------------------------------------------------------------------------
			// ) [1]ʈJn, [2]ʈI, [3]\[g ,[4]ʈJn, [5]R}(tJn̉27)
			//     ̂悤ȃP[Xł[3]\[g[4]ʈJn𖢑Mɖ߂

			std::vector<CFrameData*>::reverse_iterator ritFrame;

			for ( ritFrame=pOrderData->m_vFrame.rbegin() ; pOrderData->m_vFrame.rend() != ritFrame ; ritFrame++ )
			{
				if ( dwIndexNo > (*ritFrame)->m_dwIndexNo )
				{
					if ( STEP0_FRAME_NONE != (*ritFrame)->m_eFrameState )
					{

						switch ( (*ritFrame)->GetType() )
						{
						case CFrameData::TYPE_PRINT:
							// 荞ݍĊJł̍đΏۊOȂ̂Ń[v𔲂
							break;
						case CFrameData::TYPE_SORT:
							// 荞ݍĊJł̍đΏ
							(*ritFrame)->m_eFrameState = STEP0_FRAME_NONE;
							{	// Oo
								CString str;
								str.Format( "---CPrintQue::ResetOrderStep() [RESTORE]NPS_ERROR_27 OrderId=%u IndexNo=%u Type=SORT",
												pOrderData->m_dwOrderId, (*ritFrame)->m_dwIndexNo );
								NPS_LOGOUT( str );
							}
							continue;
							break;
						case CFrameData::TYPE_DUPLEX:
							if ( CFrameDataDuplex::MODE_DUPLEX_START == ((CFrameDataDuplex*)(*ritFrame))->m_eDuplexMode )
							{
								// 荞ݍĊJł̍đΏ
								(*ritFrame)->m_eFrameState = STEP0_FRAME_NONE;
								{	// Oo
									CString str;
									str.Format( "---CPrintQue::ResetOrderStep() [RESTORE]NPS_ERROR_27 OrderId=%u IndexNo=%u Type=DUPLEX_START",
													pOrderData->m_dwOrderId, (*ritFrame)->m_dwIndexNo );
									NPS_LOGOUT( str );
								}
								continue;
							}
							else
							{
								// 荞ݍĊJł̍đΏۊOȂ̂Ń[v𔲂
							}
							break;
						}

					}

					// [vI
					break;
				}
			}
		}
#endif
	}

	{	// Oo
		CString str;
		str.Format( "---CPrintQue::ResetOrderStep() [RESTORE]CHECK END   OrderId=%u IndexNo=%u", dwOrderId, dwIndexNo );
		NPS_LOGOUT( str );
	}
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CPrintQue::GetPortNo()
//	ABSTRACT : 摜f[^Mp\Pbg̃|[gԍ擾
//	FUNCTION : 摜f[^Mp\Pbg̃|[gԍ擾
//	
//	NOTE     : < RD-111 > [FPS]
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : T.Mizushima	2007.01.12
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
USHORT CPrintQue::GetPortNo( DWORD dwOrderId )
{
	NkcComApi::CCSScopeLock CSScopeLock( &m_CS );

	COrderData*	pOrder = GetOrderData( dwOrderId );

	if ( NULL != pOrder )
	{
		return pOrder->m_nNpsImgPort;
	}

	return 0;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CPrintQue::DeleteFrame_6000_0700_13()
//	ABSTRACT : 摜f[^Mp\Pbg̃|[gԍ擾
//	FUNCTION : 
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	           QSS̎dlsΉ
//	              vgv𔭍sȂ悤ɃR}̏ԂDELETEԂɂ
//	              QSS̏ꍇ 6000_0700 ŃXv[tԂĂĂtς݂ƂȂ̂
//	              vgv~ꍇɂ́A6000_0900(LZv)𔭍s邽
//	
//	RETURN   : 
//	
//	CREATE	 : Y.Yoshinobu	2007.03.28
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
BOOL CPrintQue::DeleteFrame_6000_0700_13( ULONG ReceiptNo )
{
	NkcComApi::CCSScopeLock CSScopeLock( &m_CS );

	BOOL bRet = FALSE;

	COrderData* pOrderData = GetOrderDataByReceiptNo2( ReceiptNo );

	if( pOrderData )
	{
		CFrameData* pFrameData = GetFrameDataByReceiptNo2( ReceiptNo );

		if ( NULL != pFrameData )
		{

			if ( STEPA_FRAME_6000_0700_13 == pFrameData->m_eFrameState )
			{
				// 摜M
				((CFrameDataPrint*)pFrameData)->m_PrintNum.Cancel
					=	((CFrameDataPrint*)pFrameData)->m_PrintNum.Repeat - ((CFrameDataPrint*)pFrameData)->m_PrintNum.Transfer;
				// 摜𑗐MȂ悤ɍ폜
				pFrameData->m_eFrameState = STEP6_DELETE;

				UpdatePrintStatus( ((CFrameDataPrint*)pFrameData)->m_dwPrintId );

				bRet = TRUE;
			}

		}
	}

	return bRet;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CPrintQue::GetPrintIdByReceiptNo()
//	ABSTRACT : vgID擾
//	FUNCTION : 
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : A.Nagamatsu		2011.11.15
//	UPDATE   :
//////////////////////////////////////////////////////////////////////////////
DWORD CPrintQue::GetPrintIdByReceiptNo( ULONG ReceiptNo )
{
	NkcComApi::CCSScopeLock CSScopeLock( &m_CS );

	DWORD	dwPrintID = 0;

	// tԍ  vgID
	COrderData*	pOrderData = GetOrderDataByReceiptNo2( ReceiptNo );
	if( NULL == pOrderData )
	{
		return dwPrintID;
	}
	CFrameData*	pFrameData = pOrderData->GetFrameDataByReceiptNo2( ReceiptNo );
	if( NULL == pFrameData )
	{
		return dwPrintID;
	}

	CFrameDataPrint* pFrameDataPrint = (CFrameDataPrint*)pFrameData;

	// vgID
	dwPrintID = pFrameDataPrint->m_dwPrintId;


	return dwPrintID;
}
