//////////////////////////////////////////////////////////////////////////////
//	FILE NAME : PrinterWatchThread.h
//	ABSTRACT  : CPrinterWatchThread NX̃C^[tFCX
//	
//	CREATE    : Y.Yoshinobu	2006.10.11
//	UPDATE    : 
//	
//										(C)Copyright : Noritsu Koki CO.,LTD.
//////////////////////////////////////////////////////////////////////////////

#if !defined(AFX_PRINTERWATCHTHREAD_H__B62943BE_BDF4_49CF_91FA_4A54E7A4D215__INCLUDED_)
#define AFX_PRINTERWATCHTHREAD_H__B62943BE_BDF4_49CF_91FA_4A54E7A4D215__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "NpsBc.h"
#include "VersionCheck.h"

#define	CONNECT_INTERVAL_TIME	30		// ItC̎ɐڑmFsԊu

// o[W`FbN֐ `FbN
#define	PTVERCHK_NORMAL			0x00000000	// 
#define	PTVERCHK_VERSIONUP		0x00000001	// o[WAbvKv
#define	PTVERCHK_CAUTION		0x00000002	// m点\Kv

// v^Ď̃Xbh̃Gg
unsigned int WINAPI PrinterWatchThreadEntry( LPVOID pParam );

class CSdk;
//////////////////////////////////////////////////////////////////////////////
//	CLASS    : CPrinterWatchThread
//	ABSTRACT : v^ĎNX
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	CREATE	 : Y.Yoshinobu 2006.10.11
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
class CPrinterWatchThread  
{
public:
	CPrinterWatchThread();
	virtual ~CPrinterWatchThread();

	//----------------------------------------------------------------------------
	// XbhǗ
	//----------------------------------------------------------------------------

		// XbhJn
	BOOL	InitInstance();
		// Xbh
	void	ExecProc();
		// XbhI
	BOOL	ExitInstance();
		// XbhIv
	void	EndThread();

		// vgJnCxg쓮
	void	SetWatchEvent();

		// vgXbhAhXݒ		2006.11.08 T.Mizushima
	void	SetPrintThreadAddress(CPrintThread*	pThread)	{ m_pPrintThread = pThread; }

	//----------------------------------------------------------------------------
	// ʐM֌W
	//----------------------------------------------------------------------------

		// v^IPAhX̓o^
	void	SetIPAddress( DWORD dwIPAddress );
		// v^NPSp|[gԍ̓o^
	void	SetNpsPortNo( USHORT wNpsPortNo );
		// v^ʂǗIuWFNg̓o^
	void	SetSdk( CSdk* pSdk );
		// ڑmFpCxg̎擾
	HANDLE	GetStartEventHandle();
		// XbhImFpCxg擾	2006.11.06 T.Mizushima
	HANDLE	GetFinishEventHandle();

	// o[W`FbN֌W	2006.12.01 T.Mizushima
	long	ptVersionCheck( TPtVersionInf* ptVerInf );
	int		IsProcessorType(USHORT _ProcessorType);
	USHORT	GetMachineSubInfo(void);
	BOOL	GetUnitVersionInfo(int _Unit, int _iCmp, UCHAR* UnitVer, int* count, TPtVersionInf* ptVerInf);
	BOOL	GetSysFileVersionInfo(LPCTSTR lpSysFilePath, int _Unit, int _iCmp, UCHAR* sysVersion, USHORT _MachineTypeID, USHORT ProcessorType, USHORT MachineSubInfo);
	BOOL	PrinterStateCheck();
	void	ErrorNoticeON_1804( BOOL bAutoVerUp );
	void	ErrorNoticeON_1805();
		// o[W`FbNc[̎s	2011.06.14 Y.Atoji
	int		ExecVerupChecker( LPCTSTR lpCheckerPath, LPCTSTR lpHostAddress );


private:

		// v^Ď
	void	PrinterWatch();

		// v^ڑmF
	void	PrinterCheck();

		// v^ڑ
	void	PrinterConnect();

		// vt@Co[W̊mF
	void	ProfileVersionCheck();

		// G[ʒm No.1750
	void	ErrorNoticeON_1750();

		// G[ʒm No.1751
	void	ErrorNoticeON_1751();

		// G[ʒm No.1754
	void	ErrorNoticeON_1754();

		// G[ʒm No.1755
	void	ErrorNoticeON_1755();

		// G[ʒm No.1756
	void	ErrorNoticeON_1756();

		// G[ʒm No.1750
	void	ErrorNoticeOFF_1750();

private:

	//----------------------------------------------------------------------------
	// XbhǗ
	//----------------------------------------------------------------------------

	enum
	{	// m_hEvent
		EVENT_STOP = 0,						// XbhIpCxgnh
		EVENT_WATCH,						// v^ĎJnCxgnh
		EVENT_TIMER,						// ^C}[Cxg
		EVENT_FINISH,						// XbhImFpCxg	2006.11.06 T.Mizushima
		EVENT_CNT
	};

	HANDLE				m_hEvent[EVENT_CNT];	// Cxgvz

	HANDLE				m_hStartEvent;			// ڑmFpCxgi CSdk::DevOpen, CSdk::DevOpen_G ̑ҋ@p j

	//----------------------------------------------------------------------------
	// ʐM֌W
	//----------------------------------------------------------------------------

	DWORD				m_dwIPAddress;			// v^IPAhX

	USHORT				m_wNpsPortNo;			// v^NPSp|[gԍ

	CSdk*				m_pSdk;					// v^ʂǗNX̃|C^

	CPrintThread*		m_pPrintThread;			// vgXbh		2006.11.08 T.Mizushima

	enum
	{	// o[WAbv`FbNc[̏IR[h
		EXITCODE_VERUP = 0,						// o[WAbvKv
		EXITCODE_NORMAL,						// o[WAbvsv
		EXITCODE_CAUTION,						// o[WAbvKv(m点mF)
		EXITCODE_INVARID = 100,					// s
		EXITCODE_FAILED,						// o[W`FbNs
		EXITCODE_STARTED,						// ɋNĂ
		EXITCODE_UNDEFINED = 999				// ̑̃G[
	};

	//----------------------------------------------------------------------------
	// ڑmF
	//----------------------------------------------------------------------------

	DWORD				m_dwConnectChkCnt;		// ڑmFsǂ̃JE^[
};

#endif // !defined(AFX_PRINTERWATCHTHREAD_H__B62943BE_BDF4_49CF_91FA_4A54E7A4D215__INCLUDED_)
