//////////////////////////////////////////////////////////////////////////////
//	FILE NAME : Sdk.h
//	ABSTRACT  : CSdk NX̃C^[tFCX
//	
//	CREATE    : T.Isogai	2006.7.21
//	UPDATE    : 
//	
//										(C)Copyright : Noritsu Koki CO.,LTD.
//////////////////////////////////////////////////////////////////////////////

#if !defined(AFX_SDK_H__1A65EF86_7CF0_48D1_9B76_E9EFC3C4463F__INCLUDED_)
#define AFX_SDK_H__1A65EF86_7CF0_48D1_9B76_E9EFC3C4463F__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "Nps.h"

#include "NkcComApi.h"

#include "NpsCmd.h"
#include "NpsImg.h"
#include "DataManager.h"

#include "NpsCallbackUnit.h"
#include "NpsCallbackEvent.h"
#include "NpsCallbackCompletion.h"

#include "PrintThread.h"
#include "PrinterWatchThread.h"

//////////////////////////////////////////////////////////////////////////////
//	CLASS    : CSdk
//	ABSTRACT : v^ʂǗNX
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	CREATE	 : T.Isogai	2006.8.9
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
class CSdk  
{
public:
	CSdk();											// RXgN^
	virtual ~CSdk();								// fXgN^

	void		SetPrinterHandle( HPRINTER hPrinter )	{ m_hPrinter = hPrinter; }		// v^nh̐ݒ
	HPRINTER	GetPrinterHandle()	{ return m_hPrinter; }								// v^nh̎擾
	DWORD		GetIPAddress()		{ return m_dwIPAddress; }							// v^IPAhX̎擾
	USHORT		GetNpsPortNo()		{ return m_wNpsPortNo; }							// v^NPSp|[gԍ̎擾
	USHORT		GetImgPortNo()		{ return m_wImgPortNo; }							// v^NPS(摜f[^])p|[gԍ̎擾

	//////////////////////////////////////////////////////////////////////////////
	//	MODULE   : CSdk::DevOpen ()
	//	ABSTRACT : v^I[v
	//	FUNCTION : v^𗘗p\ɂ
	virtual long DevOpen (
		DWORD			dwIPAddress,	// v^IPAhX
		USHORT			wNpsPortNo,		// NPSp|[gԍ
		USHORT			wImgPortNo,		// NPS(摜f[^])p|[gԍ
		HPRINTER*		phPrinter,		// 擾nh̊i[
		NPSEVENTPROC	pEventProc,		// Cxgʒm֐
		NPSUNITPROC		pUnitProc		// jbgԕύXʒm֐
	);

	//////////////////////////////////////////////////////////////////////////////
	//	MODULE   : CSdk::DevClose ()
	//	ABSTRACT : v^N[Y
	//	FUNCTION : v^𗘗p֎~ɂ
	virtual long DevClose (
	);

	//////////////////////////////////////////////////////////////////////////////
	//	MODULE   : CSdk::DevGetUnitInfo ()
	//	ABSTRACT : jbgԎ擾
	//	FUNCTION : v^̃jbgԏ擾
	virtual long DevGetUnitInfo (
		PNPS_UnitInfo	pUnitInfo	// jbgԍ\̂ւ̃AhX
	);

	//////////////////////////////////////////////////////////////////////////////
	//	MODULE   : CSdk::DevGetMagInfo ()
	//	ABSTRACT : }KW擾
	//	FUNCTION : v^ɑĂ}KW̏擾
	virtual long DevGetMagInfo (
		PNPS_MagInfo	pMagInfo,	// }KW󂯎obt@
		DWORD*			pdwSize		// obt@̃TCY
	);

	//////////////////////////////////////////////////////////////////////////////
	//	MODULE   : CSdk::DevGetSetUpInfo ()
	//	ABSTRACT : ݒu擾
	//	FUNCTION : v^̐ݒu擾
	virtual long DevGetSetUpInfo (
		PNPS_SetUpInfo	pSetUpInfo	// ݒu\̂ւ̃AhX
	);

	//////////////////////////////////////////////////////////////////////////////
	//	MODULE   : CSdk::DevGetPrintNumInfo ()
	//	ABSTRACT : vg擾
	//	FUNCTION : vg̖擾
	virtual long DevGetPrintNumInfo (
		PNPS_PrintNumInfo	pPrintNumInfo	// vg\̂ւ̃AhX
	);

	//////////////////////////////////////////////////////////////////////////////
	//	MODULE   : CSdk::DevResetEvent ()
	//	ABSTRACT : v^CxgNA
	//	FUNCTION : v^ŔCxgNA
	virtual long DevResetEvent (
		DWORD		dwErrHandle,	// NACxgnh
		DWORD		dwActionId		// Cxg̃ANVw肷
	);

	//////////////////////////////////////////////////////////////////////////////
	//	MODULE   : CSdk::DevIsReady ()
	//	ABSTRACT : vg`FbN
	//	FUNCTION : vg\`FbN
	virtual long DevIsReady (
	);

	//////////////////////////////////////////////////////////////////////////////
	//	MODULE   : CSdk::DevStartOrder ()
	//	ABSTRACT : I[_[Jn
	//	FUNCTION : I[_[Jnw
	virtual long DevStartOrder (
		DWORD*				pdwOrderId,	// 擾I[_[IDi[
		NPSCOMPLETIONPROC	pEventProc,	// ʒmpR[obN֐ւ̃AhX
		DWORD				dwPriority,	// Dxw
		DWORD				dwSorterNum,// vg̎d
		DWORD				dwSortFrame,// R}̃\[g@\
		DWORD				dwExOptions	// gIvV(Pvg) 2014.10.28 M.Yamamoto
										// EX_OPTIONS_NONE        : gIvVȂ
										// EX_OPTIONS_SINGLE_LINE : Pvg
	);

	//////////////////////////////////////////////////////////////////////////////
	//	MODULE   : CSdk::DevEndOrder ()
	//	ABSTRACT : I[_[I
	//	FUNCTION : I[_[Iw
	virtual long DevEndOrder (
		DWORD		dwOrderId	// II[_[IDw肷
	);

	//////////////////////////////////////////////////////////////////////////////
	//	MODULE   : CSdk::DevPrint ()
	//	ABSTRACT : vgv
	//	FUNCTION : vgv󂯕t
	virtual long DevPrint (
		DWORD				dwOrderId,	// vgI[_[IDw肷
		LPDWORD				pPrintID,	// vgʎq
		NPSCOMPLETIONPROC	pEventProc,	// CxgʒmpR[obN֐ւ
										// AhX
		PNPS_PrintInfo		pPrintInfo,	// vgvp[^
		T_ICCSXML*			pIccsXml	// IccsXml
	);

	//////////////////////////////////////////////////////////////////////////////
	//	MODULE   : CSdk::DevSort ()
	//	ABSTRACT : \[gv
	//	FUNCTION : \[gw
	virtual long DevSort (
		DWORD		dwOrderId	// 擾I[_[IDw肷
	);

	//////////////////////////////////////////////////////////////////////////////
	//	MODULE   : CSdk::DevCancelPrintOrder ()
	//	ABSTRACT : vgI[_[LZ
	//	FUNCTION : 󂯕tĂvg1I[_[LZ
	virtual long DevCancelPrintOrder (
		DWORD		dwOrderId,	// LZI[_[IDw肷
		DWORD		dwPrintID	// vgʎq
	);

	//////////////////////////////////////////////////////////////////////////////
	//	MODULE   : CSdk::DevGetPrintStatus ()
	//	ABSTRACT : vgԎ擾
	//	FUNCTION : vgԂ擾
	virtual long DevGetPrintStatus (
		DWORD		dwPrintID,		// vgʎq
		LPDWORD		pPrintStatus	// vg
	);

	//////////////////////////////////////////////////////////////////////////////
	//	MODULE   : CSdk::DevSetTime ()
	//	ABSTRACT : ݒ
	//	FUNCTION : ݒ肷
	virtual long DevSetTime (
		PNPS_DateTime	pTime		// ݒ肷
	);

	//////////////////////////////////////////////////////////////////////////////
	//	MODULE   : CSdk::DevGetTime ()
	//	ABSTRACT : 擾
	//	FUNCTION : 擾
	virtual long DevGetTime (
		PNPS_DateTime	pTime		// 擾̊i[
	);

	//////////////////////////////////////////////////////////////////////////////
	//	MODULE   : CSdk::DevCloseCheck ()
	//	ABSTRACT : v^N[Y`FbN
	//	FUNCTION : v^̎gp֎~(npsDevClose)\ł邩`FbN
	virtual long DevCloseCheck (
	);

	//////////////////////////////////////////////////////////////////////////////
	//	MODULE   : CSdk::DevOccupyCheck()
	//	ABSTRACT : v^[LmF
	//	FUNCTION : npsDevStartOrder APIŐLv^̐LImF
	virtual long DevOccupyCheck();

	//////////////////////////////////////////////////////////////////////////////
	//	MODULE   : CSdk::DevGetAllMagInfo ()
	//	ABSTRACT : S}KW擾
	//	FUNCTION : v^ɓo^ĂŎgpłSẴ}KW̏擾
	virtual long DevGetAllMagInfo (
		PNPS_MagDetailInfo	pMagDetailInfo,	// }KWڍ׏󂯎obt@
		DWORD*				pdwSize			// obt@̃TCY
	);

	//////////////////////////////////////////////////////////////////////////////
	//	MODULE   : CSdk::DevCtrlPrint ()
	//	ABSTRACT : vg
	//	FUNCTION : vg𐧌䂷ivg~/vg~j
	virtual long DevCtrlPrint (
		DWORD		dwCtrl		// ew肷
	);

	//////////////////////////////////////////////////////////////////////////////
	//	MODULE   : CSdk::DevExpressOrder ()
	//	ABSTRACT : I[_[DxύX
	//	FUNCTION : I[_[̗Dx}wɕύX
	virtual long DevExpressOrder (
		DWORD		dwOrderId	// Dx}wɂI[_[IDw肷
	);

	//////////////////////////////////////////////////////////////////////////////
	//	MODULE   : CSdk::DevGetProfile ()
	//	ABSTRACT : v^vt@C擾
	//	FUNCTION : y[p[Ƀvt@C擾
	virtual long DevGetProfile (
		LPCSTR			lpFileName,	// vt@Cf[^ot@Cw肷
		PNPS_PaperInfo	pPaperInfo	// vt@C擾y[p[̏w肷
	);

	//////////////////////////////////////////////////////////////////////////////
	//	MODULE   : CSdk::DevStartDuplex ()
	//	ABSTRACT : ʈJn
	//	FUNCTION : ʈ̊Jnw
	virtual long DevStartDuplex(
		DWORD			dwOrderId	// 擾I[_[IDw肷
	);

	//////////////////////////////////////////////////////////////////////////////
	//	MODULE   : CSdk::DevEndDuplex ()
	//	ABSTRACT : ʈI
	//	FUNCTION : ʈ̏Iw
	virtual long DevEndDuplex(
		DWORD			dwOrderId	// 擾I[_[IDw肷
	);

	//////////////////////////////////////////////////////////////////////////////
	//	MODULE   : CSdk::DevBlankPrint ()
	//	ABSTRACT : 󔒃y[W̃vgv
	//	FUNCTION : 󔒃y[W̃vgw
	virtual long DevBlankPrint(
		DWORD			dwOrderId,				// vgI[_[IDw肷
		LPDWORD			pPrintID,				// vgʎq
		NPSCOMPLETIONPROC pEventProc,			// CxgʒmpR[obN֐ւ̃AhX
		PNPS_BlankPrintInfo	pBlankPrintInfo		// 󔒃vgvp[^
	);

	//////////////////////////////////////////////////////////////////////////////
	//	MODULE   : CSdk::DevNpsCommand1 ()
	//	ABSTRACT : NPSʐMi^Cv1jiJj
	//	FUNCTION : Cӂ̃C^[tF[XIDƃR}h̓ʐM
	virtual long DevNpsCommand1 (
		WORD		wIfId,			// C^[tFCXID
		WORD		wSendCmdId,		// vp̃R}hID
		WORD		wSendBufLen,	// vp̃R}h̃obt@TCY
		LPVOID		lpSendBuf,		// vp̃R}h̃obt@
		WORD		wRecvCmdId,		// p̃R}hID
		LPWORD		pwRecvBufLen,	// p̃R}h̃obt@TCY
		LPVOID		lpRecvBuf,		// p̃R}h̃obt@
		DWORD		dwTimeOut		// ^CAEg(~b)
	);

	//////////////////////////////////////////////////////////////////////////////
	//	MODULE   : CSdk::DevNpsCommand2 ()
	//	ABSTRACT : NPSʐMi^Cv2jiJj
	//	FUNCTION : Cӂ̃C^[tF[XIDƃR}h̓ʐM
	//				R[obN֐ŕԂ
	virtual long DevNpsCommand2 (
		WORD		wIfId,			// C^[tFCXID
		WORD		wSendCmdId,		// vp̃R}hID
		WORD		wSendBufLen,	// vp̃R}h̃obt@TCY
		LPVOID		lpSendBuf,		// vp̃R}h̃obt@
		WORD		wRecvCmdId,		// p̃R}hID
		LPWORD		pwRecvBufLen,	// p̃R}h̃obt@TCY
		RECVPROC	pRecvProc,		// ɌĂяo֐
		DWORD		dwTimeOut		// ^CAEg(~b)
	);

	//////////////////////////////////////////////////////////////////////////////
	//	MODULE   : CSdk::DevNpsNotice ()
	//	ABSTRACT : NPS񓯊ʐMiJj
	//	FUNCTION : v^̔񓯊ʐMM߂̃R[obN֐o^
	virtual long DevNpsNotice (
		WORD			wIfId,			// C^[tFCXID
		WORD			wCmdId,			// R}hID
		NOTICEPROC		pNoticeProc		// ɌĂяo֐
	);

	//////////////////////////////////////////////////////////////////////////////
	//	MODULE   : CSdk::DevCancelPrintAll ()
	//	ABSTRACT : vgI[_[SLZiJj
	//	FUNCTION : vgI[_[SăLZ
	virtual long DevCancelPrintAll (
	);

	//////////////////////////////////////////////////////////////////////////////
	//	MODULE   : CSdk::DevGetTransmitTime ()
	//	ABSTRACT : 摜]Ԃ̎擾iJj
	//	FUNCTION : Ōɓ]R}̉摜]Ԃ擾
	virtual long DevGetTransmitTime (
		LPDWORD pOrderId,				// I[_[ID
		LPDWORD pPrintID,				// vgʎq
		LPDWORD pTime					// 摜M
	);

	//////////////////////////////////////////////////////////////////////////////
	//	MODULE   : CSdk::DevStartFAD ()
	//	ABSTRACT : FADgpJniJj
	//	FUNCTION : FADւ̔row
	virtual long DevStartFAD (
		DWORD dwOrderId,				// I[_[ID
		LPCSTR lpOrderKey,				// I[_[ʎq
		LPDWORD lpdwResult,				// FAD
		WORD wFadOut,					// ro̎w
		LPCSTR lpFadFileName			// FADrot@C
	);

	//////////////////////////////////////////////////////////////////////////////
	//	MODULE   : CSdk::DevStartFAD ()
	//	ABSTRACT : vgJniJj
	//	FUNCTION : vgs߂̒Jn
	virtual long DevAdjustForPrint (
	);

	LONG	GetSubNum( LPCTSTR, LPCTSTR, ULONG,  LONG );	// Ԃ擾

	//////////////////////////////////////////////////////////////////////////////
	//	MODULE   : CSdk::DevStartRetransmission ()
	//	ABSTRACT : đJniJj
	//	FUNCTION : fI[_[̍đJnw
	virtual long DevStartRetransmission (
		DWORD dwOrderId,									// I[_[ID
		PNPS_InterruptOrderInfo pInterruptOrderInfo			// fLZ
	);

	//////////////////////////////////////////////////////////////////////////////
	//	MODULE   : CSdk::DevEndRetransmission ()
	//	ABSTRACT : đIiJj
	//	FUNCTION : fI[_[̍đIw
	virtual long DevEndRetransmission (
		DWORD dwOrderId					// I[_[ID
	);

	//////////////////////////////////////////////////////////////////////////////
	//	MODULE   : CSdk::DevInterruptPrintOrder ()
	//	ABSTRACT : fLZiJj
	//	FUNCTION : 󂯕tĂvg1I[_[f
	virtual long DevInterruptPrintOrder (
		DWORD dwOrderId,									// I[_[ID
		PNPS_InterruptOrderInfo pInterruptOrderInfo			// fLZ
	);

	//////////////////////////////////////////////////////////////////////////////
	//	MODULE   : CSdk::DevNpsNoticeEventProcEx ()
	//	ABSTRACT : NPS񓯊ʐMiv^Cxggʒmo^j
	//	FUNCTION : v^̔񓯊ʐMM邽߂̃R[obN֐o^܂
	virtual long DevNpsNoticeEventProcEx (
		NPSEVENTPROCEX	pEventProcEx		// v^Cxggʒm֐
	);

	//////////////////////////////////////////////////////////////////////////////
	// R[obN
	void CALLBACK CallbackEvent(
		T_Nps6000H_F202H *	pInfo
		);

	void CALLBACK CallbackEventEx(
		T_Nps6001H_F102H *	pInfo
		);
	
	void SocketCloseProc();

	// sW[Ăяo
	BOOL CallbackFunction( T_Nps6000H_F502H * pInfo );

protected:

	//////////////////////////////////////////////////////////////////////////////
	// R[obN

	// lbg[Nؒfʒm
	static void CALLBACK CallbackSocketCloseStatic( LPVOID pParam );
	void CALLBACK CallbackSocketClose( BOOL bErrorNotice );

	// v^ԕύXʒm
	CNpsCallbackUnit* m_pCallbackUnit;
	CRITICAL_SECTION m_csCallbackUnit;			// NeBJZNV

	static void CALLBACK CallbackUnitStatic( T_Nps6000H_F102H *pInfo, LPVOID pParam );
	void CALLBACK CallbackUnit( T_Nps6000H_F102H *pInfo );

	// v^Cxgʒm
	CNpsCallbackEvent* m_pCallbackEvent;
	CRITICAL_SECTION m_csCallbackEvent;			// NeBJZNV

	static void CALLBACK CallbackEventStatic( T_Nps6000H_F202H * pInfo, LPVOID pParam );
	void CALLBACK CallbackEventNps( T_Nps6000H_F202H * pInfo );

	// vg󋵒ʒm
	CNpsCallbackCompletion* m_pCallbackCompletion;
	CRITICAL_SECTION m_csCallbackCompletion;	// NeBJZNV

	static void CALLBACK CallbackCompletionStatic( T_Nps6000H_F302H * pInfo, LPVOID pParam );
	void CALLBACK CallbackCompletion( T_Nps6000H_F302H * pInfo );

	// sW[Ăяo
	static void CALLBACK CallbackFunctionStatic( T_Nps6000H_F502H * pInfo, LPVOID pParam );

	// vg쓮
	static void CALLBACK CallbackPrintRequestSetEvent( LPVOID pParam )
	{
		( (CSdk*) pParam )->m_PrintThread.SetPrintEvent();
	}

	// v^Cxggʒm
	void *	m_pCallbackEventEx;	

	static void CALLBACK CallbackEventExStatic( T_Nps6001H_F102H * pInfo, LPVOID pParam );
	void CALLBACK CallbackEventExNps( T_Nps6001H_F102H * pInfo );

protected:

	// lbg[NʐMG[
	void ErrorNoticeON_6681( LONG nSubNo );

	// G[e[uv^CxgActionIdɐݒ肷ׂl擾
	BOOL GetActionId( LPCTSTR lpSoftName, LPCTSTR lpValueName, ULONG EventCodeMain, DWORD dwButtonKey, UCHAR* pdwActionId );

	// ItCɔ̃G[/m点SĎ
	void ErrorNoticeAllClear( BOOL bAllClear );

	// p[^`FbN
	long ParamChkOfDevPrint( PNPS_PrintInfo pPrintInfo );
	long ParamChkOfDevPrintDuplex( PNPS_PrintInfo pPrintInfo, T_DuplexPaperInfo* pDuplexPaperInfo );
	long ParamChkOfDevBlankPrint( PNPS_BlankPrintInfo pBlankPrintInfo );
	long ParamChkOfDevBlankPrintDuplex( PNPS_BlankPrintInfo pPrintInfo, T_DuplexPaperInfo* pDuplexPaperInfo );
	long ParamChkOfDevPrintIccsXml( PNPS_PrintInfo pPrintInfo, T_ICCSXML* pIccsXml );

public:
	CDataManager			m_DataManager;			// vgǗNX
	CNpsCmd					m_NpsCmd;				// \PbgR}hMpNX
	CNpsImgManager			m_NpsImgMng;			// \PbgʐMNXǗ(r)NX

	CRITICAL_SECTION		m_csExpress;			// 07000800̏0500𑗐MȂ悤ɔrs
													// _V[g7320	2007.02.06 Y.Yoshinobu

protected:

	DWORD					m_dwIPAddress;				// v^IPAhX
	USHORT					m_wNpsPortNo;				// NPSp|[gԍ
	USHORT					m_wImgPortNo;				// NPS(摜f[^])p|[gԍ
	HPRINTER				m_hPrinter;					// v^nh

	CPrintThread			m_PrintThread;			// vgXbhNX
	CWinThread*				m_pPrintThread;			// vgXbh̃|C^
	CPrinterWatchThread		m_PrinterWatchThread;	// v^ĎXbhNX
	CWinThread*				m_pPrinterWatchThread;	// v^ĎXbh̃|C^
	CPrintQue				m_PrintQue;				// vgL[

};

#endif // !defined(AFX_SDK_H__1A65EF86_7CF0_48D1_9B76_E9EFC3C4463F__INCLUDED_)
