// SendCmdBuffer.h: CSendCmdBuffer NX̃C^[tFCX
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_SENDCMDBUFFER_H__6208BE54_1F8D_4062_A637_503B1E76AA49__INCLUDED_)
#define AFX_SENDCMDBUFFER_H__6208BE54_1F8D_4062_A637_503B1E76AA49__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

class CSendCmdBuffer  
{
public:
	CSendCmdBuffer();
	virtual ~CSendCmdBuffer();

	BOOL Create( int nMaxBufferLen );
	void Empty();

	int AddHeader( WORD wInterfaceId, WORD wCommandId );
	int AddTagChar ( WORD wTag, char nValue );
	int AddTagChar ( WORD wTag, char* pValue, int nCount );
	int AddTagShort( WORD wTag, short nValue );
	int AddTagShort( WORD wTag, short* pValue, int nCount );
	int AddTagLong ( WORD wTag, long nValue );
	int AddTagLong ( WORD wTag, long* pValue, int nCount );
	int AddTagFloat( WORD wTag, float nValue );
	int AddTagFloat( WORD wTag, float* pValue, int nCount );
	int AddTagFooter();

	LPBYTE GetBuffer();
	int GetBufferLen();

private:
	int		m_nBufferLen;
	int		m_nMaxBufferLen;
	LPBYTE	m_pBuffer;
};

#endif // !defined(AFX_SENDCMDBUFFER_H__6208BE54_1F8D_4062_A637_503B1E76AA49__INCLUDED_)
