//////////////////////////////////////////////////////////////////////////////
//   FILE NAME   : WS2Tcp.h
//   ABSTRACT    : \PbgʐMNX (WinSock2.0Ή)
//
//                                     (C)Copyright : Noritsu Koki CO.,LTD.
//////////////////////////////////////////////////////////////////////////////
#if !defined(_WS2TCP_H_)
#define _WS2TCP_H_

#include <afxpriv.h>

#include <winsock2.h>		// WinSock 2.0
#include <mswsock.h>		// Microsoft Windows Socket

//////////////////////////////////////////////////////////////////////////////
// e}N`Lq܂
// ڂ̌߂`
#if !defined(COUNTOF)
	#define COUNTOF(xxxx)		(sizeof(xxxx)/sizeof(xxxx[0]))
#endif


class CWS2Tcp
{
public:
	//////////////////////////////////////////////////////////////////////
	//	@\F	NX̍\zs܂(Server(1)/Client(1))
	//	F	Ȃ
	//	ߒlF	Ȃ
	CWS2Tcp();

	//////////////////////////////////////////////////////////////////////
	//	@\F	NX̊Js܂
	//	F	Ȃ
	//	ߒlF	Ȃ
	virtual ~CWS2Tcp();

	//////////////////////////////////////////////////////////////////////
	//	@\F	\Pbg쐬܂(Server(2)/Client(2))
	//	F	int					nAddressFamily		AhX`
	//			int					nSocketType			\Pbg^Cv
	//			int					nProtocol			vgR
	//			LPWSAPROTOCOL_INFO	lpProtocolInfo		쐬
	//	ߒlF	\Pbg쐬 TRUE Ԃ܂
	BOOL Create( int nAddressFamily = AF_INET ,
				 int nSocketType    = SOCK_STREAM ,
				 int nProtocol      = IPPROTO_TCP );
	BOOL Create( LPWSAPROTOCOL_INFO lpProtocolInfo ,
				 int nAddressFamily = FROM_PROTOCOL_INFO ,
				 int nSocketType    = FROM_PROTOCOL_INFO ,
				 int nProtocol      = FROM_PROTOCOL_INFO );

	BOOL CreateBlock( int nAddressFamily = AF_INET ,
				 int nSocketType    = SOCK_STREAM ,
				 int nProtocol      = IPPROTO_TCP );

	UINT GetSocketPortNo();

	////////////////////////////////////////////////////////////////////////////
	//	@\F	\PbgɖOt܂(Server(3))
	//	F	UINT				nSocketPort			|[gԍ
	//			LPCTSTR				lpszSocketAddress	\Pbg̃AhX
	//			SOCKADDR			lpSockAddr			\Pbg
	//			int					nSockAddrLen	\Pbg̒
	//	ߒlF	Ot̐ TRUE Ԃ܂
	BOOL Bind( UINT nSocketPort , LPCTSTR lpszSocketAddress = NULL );
	BOOL Bind( const SOCKADDR* lpSockAddr, int nSockAddrLen );

	////////////////////////////////////////////////////////////////////////////
	//	@\F	NCAgڑv󂯓鏀܂(Server(4))
	//	F	int					nBackLog			BackLog ̌ ( MSDN QƂ̂ )
	//	ߒlF	ꍇ TRUE Ԃ܂
	BOOL Listen( int nBackLog = 5 );

	////////////////////////////////////////////////////////////////////////////
	//	@\F	ڑv󂯓܂(Server(5))
	//	F	CSocket2&			sock				ڑv󂯕t\PbgNX
	//			sockaddr*			pAddr				ڑv󂯕tAhX
	//			int*				pAddrLen			pAddr ̒(Byte)
	//	ߒlF	ꍇ TRUE Ԃ܂
	BOOL Accept( CWS2Tcp& sock , struct sockaddr *pAddr = NULL , int *pAddrLen = NULL );

	////////////////////////////////////////////////////////////////////////////
	//	@\F	T[o[ɐڑvs܂(Client(3))
	//	F	LPCTSTR				lpszHostAddress		ڑAhX
	//			UINT				nHostPort			ڑ|[g
	//			SOCKADDR*			lpSockAddr			ڑ
	//			int					nSockAddrLen		lpSockAddr ̒(Byte)
	//	ߒlF	ꍇ TRUE Ԃ܂
	BOOL Connect( LPCTSTR lpszHostAddress, UINT nHostPort );
	BOOL Connect( const SOCKADDR* lpSockAddr, int nSockAddrLen );

	////////////////////////////////////////////////////////////////////////////
	//	@\F	f[^̑Ms܂(TCP)
	//	F	void*				lpBuf				Mf[^
	//			int					nBufLen				lpBuf ̒(Byte)
	//			DWORD				dwFlags				MtO
	//			WSABUF*				pBuf				Mf[^
	//			int					nCount				pBuf ̌
	//	ߒlF	ꍇ TRUE Ԃ܂
	BOOL Send( const void* lpBuf, int nBufLen, DWORD dwFlags = 0 );
	BOOL Send( WSABUF* pBuf , int nCount , DWORD dwFlags = 0 );

	////////////////////////////////////////////////////////////////////////////
	//	@\F	f[^̎Ms܂(TCP)
	//	F	void*				lpBuf				Mobt@
	//			int					nBufLen				lpBuf ̒(Byte)
	//			DWORD				dwFlags				MtO
	//	ߒlF	ꍇ M(Byte) Ԃ܂
	//				s -1 Ԃ܂
	int Receive( void* lpBuf, int nBufLen, DWORD dwFlags = 0 );

	////////////////////////////////////////////////////////////////////////////
	//	@\F	f[^̎MTCY擾܂
	//	F	Ȃ
	//	ߒlF	f[^̎MTCY(BYTE)
	DWORD GetReceiveSize();

	////////////////////////////////////////////////////////////////////////////
	//	@\F	MI錾
	//	F	Ȃ
	//	ߒlF	ꍇ TRUE Ԃ܂
	BOOL SendDisconnect();

	////////////////////////////////////////////////////////////////////////////
	//	@\F	MI錾
	//	F	Ȃ
	//	ߒlF	ꍇ TRUE Ԃ܂
	BOOL ReceiveDisconnect();

	////////////////////////////////////////////////////////////////////////////
	//	@\F	܂
	//	F	Ȃ
	//	ߒlF	ꍇ TRUE Ԃ܂
	BOOL Close();

	////////////////////////////////////////////////////////////////////////////
	//	@\F	w\PbgƃNXѕt܂
	//	F	SOCKET				sock			Ǘ\Pbg
	//			int					nAddressFamily	AhX`
	//	ߒlF	ꍇ TRUE Ԃ܂
	BOOL Attach( SOCKET sock , int nAddressFamily = AF_INET );

	////////////////////////////////////////////////////////////////////////////
	//	@\F	\Pbg̎Mobt@TCY̐ݒs܂
	//	F	int					nSize			Mobt@̃TCY
	//												-1 ̂Ƃ͐ݒ肹Ɏ擾̂
	//	ߒlF	O̎Mobt@̃TCY
	//			-1 ̂Ƃ͎擾/ݒ莸s
	//	 ̊֐ɂĎMTCY𑝉AOnReceive ֐ŁÅ
	//     Sleep sقAxɂ̃f[^Mł̂ CPU
	//     ̎gpAbvB
	//     1Byte M OnReceive ĂяôŁA܂Ă̂ق
	//     悢
	int SetRecvBufferSize( int nSize );

	////////////////////////////////////////////////////////////////////////////
	//	@\F	G[擾܂
	//	F	Ȃ
	//	ߒlF	G[R[hԂ܂
	static int GetLastError();

	////////////////////////////////////////////////////////////////////////////
	//	@\F	\Pbg^vꂽƂ̓\Pbgf[^Ԃ܂
	//	F	Ȃ
	//	ߒlF	\Pbg
	operator SOCKET () const { return m_Socket; }

	////////////////////////////////////////////////////////////////////////////
	//	@\F	\PbgؒfꂽƂɎIɃNX̍폜邩ǂݒ肵܂
	//	F	BOOL				bAutoDelete		= TRUE  : 폜
	//												= FALSE : 폜Ȃ
	//	ߒlF	Ȃ
	void	SetAutoDelete( BOOL bAutoDelete = TRUE );

	BOOL	IsOpenSocket()	{ return ( m_Socket != INVALID_SOCKET ); }

	//////////////////////////////////////////////////////////////////////////////
	//   MODULE   : CWS2Tcp::GetSendBufSize
	//   ABSTRACT : f[^Mp̃obt@̃TCY擾܂
	//   FUNCTION : f[^Mp̃obt@̃TCY擾܂
	//////////////////////////////////////////////////////////////////////////////
	BOOL	GetSendBufSize( int* pSendBufSize );

	//////////////////////////////////////////////////////////////////////////////
	//   MODULE   : CWS2Tcp::SetSendBufSize
	//   ABSTRACT : f[^Mp̃obt@̃TCYݒ肵܂
	//   FUNCTION : f[^Mp̃obt@̃TCYݒ肵܂
	//////////////////////////////////////////////////////////////////////////////
	BOOL	SetSendBufSize( const int nSendBufSize );

	//////////////////////////////////////////////////////////////////////////////
	//   MODULE   : CWS2Tcp::GetNoDelay
	//   ABSTRACT : NagleASY̗L擾܂
	//   FUNCTION : NagleASY̗L擾܂
	//////////////////////////////////////////////////////////////////////////////
	BOOL	GetNoDelay( BOOL* pEnable );

	//////////////////////////////////////////////////////////////////////////////
	//   MODULE   : CWS2Tcp::SetNoDelay
	//   ABSTRACT : NagleASY̗Lݒ肵܂
	//   FUNCTION : NagleASY̗Lݒ肵܂
	//////////////////////////////////////////////////////////////////////////////
	BOOL	SetNoDelay( const BOOL bEnable );

protected:
	////////////////////////////////////////////////////////////////////////////
	// eCxgƂɌĂяo֐ł
	// ʂ̃XbhŌĂяo󂯂邽߁ACXbhȂǂŏsꍇ
	// r䂪KvƂȂ܂B
	// ܂ACXbhɒʒmKvł΁ACXbh̃XbhID
	// ݒ肷邱ƂɂA PostThreadMessage() ŌĂяos܂
	virtual void OnAccept( int nErrorCode );	// Accept  󂯎Ƃ
	virtual void OnClose( int nErrorCode );		// Close   󂯎Ƃ
	virtual void OnConnect( int nErrorCode );	// Connect 󂯎Ƃ
	virtual void OnOOB( int nErrorCode );		// OOB     󂯎Ƃ
	virtual void OnQOS( int nErrorCode );		// QOS     󂯎Ƃ
	virtual void OnReceive( int nErrorCode );	// Receive 󂯎Ƃ
	virtual void OnSend( int nErrorCode );		// Send    󂯎Ƃ
	virtual void OnAttach() {}					// \Pbg쐬(ĂяoXbh)
												// NXƃ\Pbg̊֘A
												// Create / Attach ֐Ăяo

private:
	////////////////////////////////////////////////////////////////////////////
	// eCxgs߂̃Xbh𓮍삳邽߂̊֐ł
	// 㑤̊֐́AAfxBeginThread() ɗ^邽߂ static KvŁAł
	// NXϐɃANZX̂ʓ|Ȃ̂ŁANX֐̉֐Ăяo
	// sĂ܂
	static UINT SocketEventThread( LPVOID pParam );
	UINT SocketEvent();

private:
	SOCKET		m_Socket;			// Ǘ\Pbg
	int			m_nAddressFamily;	// AhXt@~[
	WSAEVENT	m_ExitEvent;		// IpCxg
	WSAEVENT	m_NetworkEvent;		// lbg[NpCxg
	CWinThread* m_pWinThread;		// Xbhnh
	BOOL		m_bAutoDelete;		// \PbgN[YɎIɃNX폜?
	BOOL		m_ConnectState;		// ڑ
	HANDLE		m_hConnectEvent;
};

#endif // _CWS2TCP_H_
