// NpsLib.h: CNpsLib NX̃C^[tFCX
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_NPSLIB_H__34E2DC94_CBE7_498F_8F62_E8F4DF67243E__INCLUDED_)
#define AFX_NPSLIB_H__34E2DC94_CBE7_498F_8F62_E8F4DF67243E__INCLUDED_

#include "Nps.h"

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

class CNpsLib  
{
	public: CNpsLib( DWORD dwSeqNo );
	public: virtual ~CNpsLib();

	public: bool npsLibOpen( bool bEnableLogOut );
	public: bool npsLibClose();
	public: bool npsGetNpsVersion();
	public: bool npsSearchPrinter();
	public: bool npsDevOpen( DWORD dwIPAddress );
	public: bool npsDevClose();
	public: bool npsDevGetUnitInfo();
	public: bool npsDevGetMagInfo( DWORD dwMaxCnt );
	public: bool npsDevGetSetUpInfo();
	public: bool npsDevResetEvent( DWORD dwErrHandle, DWORD dwActionId );
	public: bool npsDevIsReady();
	public: bool npsDevSetTime( SYSTEMTIME* pTime );
	public: bool npsDevGetTime();
	public: bool npsDevCloseCheck();
	public: bool npsDevGetAllMagInfo( DWORD dwMaxCnt );
	public: bool npsDevCtrlPrint( DWORD dwCtrl );
	public: bool npsDevGetProfile();
	public: bool npsSetConnectMode( DWORD dwMode );
	public: bool npsDevStartOrder( DWORD dwPriority, DWORD dwSorterNum, DWORD dwSortFrame );
	public: bool npsDevEndOrder();
/*
	public: bool npsSetCompletionProcMode( DWORD dwMode );
	public: bool npsDevGetPrintNumInfo( PNPS_PrintNumInfo pPrintNumInfo );
	public: bool npsDevExpressOrder( DWORD dwOrderId );
	public: bool npsDevGetPrintStatus( DWORD dwPrintID, LPDWORD pPrintStatus );
	public: bool npsDevPrint( DWORD dwOrderId, LPDWORD pPrintID, NPSCOMPLETIONPROC pEventProc, PNPS_PrintInfo pPrintInfo );
	public: bool npsDevSort( DWORD dwOrderId );
	public: bool npsDevCancelPrintOrder( DWORD dwOrderId, DWORD dwPrintID );
	public: bool npsDevStartDuplex( DWORD dwOrderId );
	public: bool npsDevEndDuplex( DWORD dwOrderId );
	public: bool npsDevBlankPrint( DWORD dwOrderId, LPDWORD pPrintID, NPSCOMPLETIONPROC pEventProc, PNPS_BlankPrintInfo pBlankPrintInfo );

long NPS_API npsSearchPrinter2( LPWORD pPrinterNum, DWORD dwWaitTime=6000 );
long NPS_API npsDevCancelPrintAll( HPRINTER hPrinter );
long NPS_API npsDevOccupyCheck( HPRINTER hPrinter );
long NPS_API npsSetLanguage( LPCSTR lpLangName );
long NPS_API npsSetCustomMode( DWORD dwMode );
long NPS_API npsSetConnectMode( DWORD dwMode );
long NPS_API npsDevGetTransmitTime( HPRINTER hPrinter, LPDWORD pOrderId, LPDWORD pPrintID, LPDWORD pTime );
long NPS_API npsSetTempFolder( LPCSTR lpFolderName );
long NPS_API npsDevPrintIccsXml ( HPRINTER hPrinter, DWORD dwOrderId, LPDWORD pPrintID, NPSCOMPLETIONPROC pEventProc, short priority, PNPS_PrintInfoIccsXml pPrintInfo );
long NPS_API npsDevStartFAD( HPRINTER hPrinter, DWORD dwOrderId, LPCSTR lpOrderKey, LPDWORD lpdwResult, WORD wFadOut, LPCSTR lpFadFileName );
long NPS_API npsDevAdjustForPrint( HPRINTER hPrinter );
*/
	private: CString ConvResultNum2Str( long nResultNum );

	private: HPRINTER m_hPrinter;
	private: DWORD m_dwSeqNo;
	private: DWORD m_dwOrderId;
};

#endif // !defined(AFX_NPSLIB_H__34E2DC94_CBE7_498F_8F62_E8F4DF67243E__INCLUDED_)
