// DevCancelPrintOrderDlg.cpp : Cve[V t@C
//

#include "stdafx.h"
#include "NpsClient.h"
#include "OrderManager.h"
#include "DevCancelPrintOrderDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CDevCancelPrintOrderDlg _CAO


CDevCancelPrintOrderDlg::CDevCancelPrintOrderDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CDevCancelPrintOrderDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CDevCancelPrintOrderDlg)
	m_OrderId = 0;
	m_PrintId = 0;
	//}}AFX_DATA_INIT
}


void CDevCancelPrintOrderDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CDevCancelPrintOrderDlg)
	DDX_Control(pDX, IDC_LIST_PRINT_ID, m_PrintList);
	DDX_Control(pDX, IDC_LIST_ORDER_ID, m_OrderList);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CDevCancelPrintOrderDlg, CDialog)
	//{{AFX_MSG_MAP(CDevCancelPrintOrderDlg)
	ON_NOTIFY(LVN_ITEMCHANGED, IDC_LIST_ORDER_ID, OnItemchangedListOrderId)
	ON_NOTIFY(LVN_ITEMCHANGED, IDC_LIST_PRINT_ID, OnItemchangedListPrintId)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDevCancelPrintOrderDlg bZ[W nh

BOOL CDevCancelPrintOrderDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// TODO: ̈ʒuɏ̕⑫ǉĂ
	if( m_OrderList.LockWindowUpdate() )
	{
		for( int ii = 0; ii < OrderManager::GetOrderSize(); ii++ )
		{
			OrderManager::COrder*	pOrder = OrderManager::GetOrder( ii );
			if( pOrder )
			{
				int	index = m_OrderList.GetItemCount();
				char	buffer[ 32 ];
				sprintf( buffer, "%u", pOrder->m_dwOrderId );
				m_OrderList.InsertItem( index, buffer );
				m_OrderList.SetItemData( index, pOrder->m_dwOrderId );

				if( 0 >= index )
				{
					m_OrderId = pOrder->m_dwOrderId;
				}
			}
		}
		m_OrderList.UnlockWindowUpdate();
	}

	m_PrintList.DeleteAllItems();

	OrderManager::COrder*	pOrder = OrderManager::FindOrder( m_OrderId );
	if( pOrder && m_PrintList.LockWindowUpdate() )
	{
		m_PrintId = 0;
		for( int ii = 0; ii < pOrder->GetFrameSize(); ii++ )
		{
			OrderManager::CFrame*	pFrame = pOrder->GetFrame( ii );
			if( pFrame )
			{
				int	index = m_PrintList.GetItemCount();
				char	buffer[ 32 ];
				sprintf( buffer, "%u", pFrame->m_dwPrintId );
				m_PrintList.InsertItem( index, buffer );
				m_PrintList.SetItemData( index, pFrame->m_dwPrintId );

				m_PrintList.SetItemState( index, LVIS_FOCUSED | LVIS_SELECTED, LVIS_FOCUSED | LVIS_SELECTED);
			}
		}
		m_PrintList.UnlockWindowUpdate();
	}

	return TRUE;  // Rg[ɃtH[JXݒ肵ȂƂA߂l TRUE ƂȂ܂
	              // O: OCX vpeB y[W̖߂l FALSE ƂȂ܂
}

void CDevCancelPrintOrderDlg::OnItemchangedListOrderId(NMHDR* pNMHDR, LRESULT* pResult) 
{
	NM_LISTVIEW* pNMListView = (NM_LISTVIEW*)pNMHDR;
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	m_OrderId = ( DWORD )m_OrderList.GetItemData( pNMListView->iItem );

	m_PrintList.DeleteAllItems();

	OrderManager::COrder*	pOrder = OrderManager::FindOrder( m_OrderId );
	if( pOrder && m_PrintList.LockWindowUpdate() )
	{
		for( int ii = 0; ii < pOrder->GetFrameSize(); ii++ )
		{
			OrderManager::CFrame*	pFrame = pOrder->GetFrame( ii );
			if( pFrame )
			{
				int	index = m_PrintList.GetItemCount();
				char	buffer[ 32 ];
				sprintf( buffer, "%u", pFrame->m_dwPrintId );
				m_PrintList.InsertItem( index, buffer );
				m_PrintList.SetItemData( index, pFrame->m_dwPrintId );

				m_PrintList.SetItemState( index, LVIS_FOCUSED | LVIS_SELECTED, LVIS_FOCUSED | LVIS_SELECTED);
			}
		}
		m_PrintList.UnlockWindowUpdate();
	}

	*pResult = 0;
}

void CDevCancelPrintOrderDlg::OnItemchangedListPrintId(NMHDR* pNMHDR, LRESULT* pResult) 
{
	NM_LISTVIEW* pNMListView = (NM_LISTVIEW*)pNMHDR;
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	DWORD	SelPrintId = 0;
	DWORD	NoSelPrintId = 0;

	for( int index = 0; index < m_PrintList.GetItemCount(); index++ )
	{
		if( m_PrintList.GetItemState( index, LVIS_SELECTED ) & LVIS_SELECTED )
		{
			if( !SelPrintId )
				SelPrintId = m_PrintList.GetItemData( index );
		}
		else
		{
			if( !NoSelPrintId )
				NoSelPrintId = m_PrintList.GetItemData( index );
		}
	}

	// PsȏIĂԂőSsIłȂꍇ
	// 擪R}̂݃LZ
	if( SelPrintId && NoSelPrintId )
	{
		m_PrintId = SelPrintId;
	}
	else
	{
		m_PrintId = 0;
	}

	*pResult = 0;
}
