// OrderManager.h: OrderManager NX̃C^[tFCX
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_ORDERMANAGER_H__B4FF5814_AF67_4207_B625_74466CDA8B84__INCLUDED_)
#define AFX_ORDERMANAGER_H__B4FF5814_AF67_4207_B625_74466CDA8B84__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include <vector>

namespace OrderManager
{
	class CFrame
	{
	public:
								CFrame(
											DWORD				dwOrderId,				// I[_[ID
											NPS_PrintInfo*		pPrintInfo,				// vg
											int					eType,					// vg
											short				nPriority,				// 
											char*				pIccsCmdFilePath );		// 
								CFrame(
											CFrame*				pFrame );
		virtual					~CFrame();

	public:
		DWORD					m_dwOrderId;											// I[_[ID
		DWORD					m_dwPrintId;											// vgID
		NPS_PrintInfo			m_tPrintInfo;											// vg
		int						m_eType;												// vg
		short					m_nPriority;											// 
		char					m_cIccsCmdFilePath[ MAX_PATH ];							// 
		char					m_cNameBuffer[ 512 ];									// NPS_PrintInfo::pNameGA
		BOOL					m_bTransfered;											// ]ς݃tO
	};

	class COrder
	{
	public:
								COrder(
											DWORD				dwOrderId,				// I[_[ID
											DWORD				dwPriority,				// Dxw
											DWORD				dwSorterNum,			// vg̎d
											DWORD				dwSortFrame,			// R}̃\[g@\
											DWORD				dwExOptions );			// gIvV(Pvg)	2014.10.30 M.Yamamoto
								COrder(
											COrder*				pOrder );
		virtual					~COrder();
		CFrame*					AppendFrame(
											CFrame*				pFrame );
		void					RemoveFrame(
											CFrame*&			pFrame );
		CFrame*					FindFrame(
											DWORD				dwPrintId );
		CFrame*					GetFrame(
											int					nIndex );
		int						GetFrameSize();

	public:
		BOOL					m_bInterrupted;											// fI[_[H
		DWORD					m_dwOrderId;											// I[_[ID
		DWORD					m_dwPriority;											// Dxw
		DWORD					m_dwSorterNum;											// vg̎d
		DWORD					m_dwSortFrame;											// R}̃\[g@\
		DWORD					m_dwExOptinons;											// gIvV(Pvg)	2014.10.30 M.Yamamoto
		NPS_InterruptOrderInfo	m_tOrderInfo;											// fI[_[
		std::vector<CFrame*>	m_Frames;												// t[Xg
	};

	void						Initialize();
	COrder*						AppendOrder(
											COrder*				pOrder );
	void						RemoveOrder(
											COrder*&			pOrder );
	COrder*						FindOrder(
											DWORD				dwOrderId );
	COrder*						GetOrder(
											int					nIndex );
	int							GetOrderSize();
	void						UpdateOrder(
											PNPSORDERINFO		pInfo );
	void						UpdateFrame(
											PNPSPRINTINFO		pInfo );
	void						UpdateFrame(
											PNPSEVENTINFOEX		pInfo );
}
#endif // !defined(AFX_ORDERMANAGER_H__B4FF5814_AF67_4207_B625_74466CDA8B84__INCLUDED_)
