//////////////////////////////////////////////////////////////////////////////
//   File Name   : NkcComApi.h
//   Contents    : ʊ֐
//					
//   Author/Date : Y.Yoshinobu	2006.07.05
//	                                    (C)Copyright : Noritsu Koki CO.,LTD.
//////////////////////////////////////////////////////////////////////////////
#ifndef _NKCCOMAPI_H_
#define _NKCCOMAPI_H_

#include <afxwin.h>         // MFC ̃RAѕWR|[lg
#include <afxext.h>         // MFC ̊g
#include <afxdtctl.h>		// MFC  Internet Explorer 4 R Rg[ T|[g

#include <afxpriv.h>

#include <winsock2.h>		// WinSock 2.0
#include <mswsock.h>		// Microsoft Windows Socket

//ʊ֐
namespace NkcComApi {

	// hostent ^̃f[^AzXg̖O擾܂
	CString GetHostName( hostent* p );

	// hostent ^̃f[^AzXg̃AhX擾܂
	CString GetHostAddr( hostent* p );

	// lbg[NoCgI[_[zXgoCgI[_[ɕϊ܂
	unsigned short ntohs( unsigned short netshort );		// short^
	unsigned long ntohl( unsigned long netlong );			// long^
	unsigned __int64 ntohi64( unsigned __int64 netint64 );	// int64^

	// zXgoCgI[_[lbg[NoCgI[_[ɕϊ܂
	unsigned short htons( unsigned short hostshort );		// short^
	unsigned long htonl( unsigned long hostlong );			// long^
	unsigned __int64 htoni64( unsigned __int64 hostint64 );	// int64^

	// WinSock 2.2 gpł悤ɂ
	BOOL WinSockStartup();

	// WinSock 2.2 ̎gpJ܂
	BOOL WinSockCleanup();

	// t@CTCY擾܂
	unsigned long GetFileSize( LPCTSTR lpFilePath );

	// pXvZs܂
	CString MakeFullPath( const CString szFileName );
	CString MakeFullPath( LPCTSTR lpFolderPath, LPCTSTR lpFileName );

	// t@C/tH_ 
	BOOL CreateFolder( LPCTSTR lpFolder );
	BOOL DeleteFolder( LPCTSTR lpFolder );
	BOOL ClearFolder( LPCTSTR lpFolder );

	BOOL ReadMyVersion( DWORD* pdwFileVersionMS, DWORD* pdwFileVersionLS );

	// XR[v͈͂̃NeBJZNṼbNs܂
	//--------------------------------------------------------------------------------
	class CCSScopeLock
	{
	private:
		CRITICAL_SECTION*	m_pCS;
	public:
		CCSScopeLock( CRITICAL_SECTION* pCS )	{ m_pCS	= pCS; ::EnterCriticalSection( m_pCS ); }
		~CCSScopeLock()	{ ::LeaveCriticalSection( m_pCS ); }
	};

}	// namespace NkcComApi


#endif // _NKCCOMAPI_H_
