//////////////////////////////////////////////////////////////////////////////
//   FILE NAME   : WS2TcpListen.cpp
//   ABSTRACT    : \PbgʐMNX (WinSock2.0Ή)
//
//                                     (C)Copyright : Noritsu Koki CO.,LTD.
//////////////////////////////////////////////////////////////////////////////
#include "stdafx.h"

#include "WS2TcpListen.h"

//////////////////////////////////////////////////////////////////////////////
//   MODULE   : CWS2TcpListen::CWS2TcpListen
//   ABSTRACT : RXgN^
//   FUNCTION : T[o[\PbgNX̐s܂
//////////////////////////////////////////////////////////////////////////////
CWS2TcpListen::CWS2TcpListen( pfnSockCreate pfnSockCreateFunc )
{
	TRACE( "[%08X] CWS2TcpListen::CWS2TcpListen()\n", GetCurrentThreadId() );

	m_pfnSockCreate = pfnSockCreateFunc;		// \Pbg쐬֐|C^[
}

//////////////////////////////////////////////////////////////////////////////
//   MODULE   : CWS2TcpListen::~CWS2TcpListen
//   ABSTRACT : fXgN^
//   FUNCTION : T[o[\PbgNX̊Js܂
//////////////////////////////////////////////////////////////////////////////
CWS2TcpListen::~CWS2TcpListen()
{
	TRACE( "[%08X] CWS2TcpListen::~CWS2TcpListen()\n", GetCurrentThreadId() );

}

//////////////////////////////////////////////////////////////////////////////
//   MODULE   : CWS2TcpListen::Create
//   ABSTRACT : T[o[\Pbg쐬܂
//   FUNCTION : T[o[\Pbg쐬܂
//////////////////////////////////////////////////////////////////////////////
BOOL CWS2TcpListen::Create( UINT nSocketPort , LPCTSTR lpszSocketAddress )
{
	TRACE( "[%08X] CWS2TcpListen::Create()\n", GetCurrentThreadId() );

	// \Pbg̍쐬
	if( !CWS2Tcp::Create() )
		return FALSE;
	// \PbgɖOt܂
	if( !Bind( nSocketPort , lpszSocketAddress ) )
		return FALSE;
	if( !Listen() )
		return FALSE;

	return TRUE;
}

//////////////////////////////////////////////////////////////////////////////
//   MODULE   : CWS2TcpListen::OnAccept
//   ABSTRACT : ڑvM
//   FUNCTION : ڑvM
//////////////////////////////////////////////////////////////////////////////
void CWS2TcpListen::OnAccept( int nErrorCode )
{
	TRACE( "[%08X] CWS2TcpListen::OnAccept()\n", GetCurrentThreadId() );

	// \Pbg̍쐬
	CWS2Tcp*	pSock = OnAcceptSockCreate();
	if( pSock == NULL )
		return;			// \PbgNXԂĂ炦Ȃ
	
	// \Pbǧ
	if( !Accept( *pSock ) )
		delete pSock;		// \Pbǧs

}

//////////////////////////////////////////////////////////////////////////////
//   MODULE   : CWS2TcpListen::OnAcceptSockCreate
//   ABSTRACT : ڑvM
//   FUNCTION : ڑvM
//////////////////////////////////////////////////////////////////////////////
CWS2Tcp* CWS2TcpListen::OnAcceptSockCreate()
{
	TRACE( "[%08X] CWS2TcpListen::OnAcceptSockCreate()\n", GetCurrentThreadId() );

	if( m_pfnSockCreate )
		return (*m_pfnSockCreate)();
	ASSERT(0);		// {̃NXł͐łȂ̂ ASSERT() s
	CWS2Tcp*	pSock = new CWS2Tcp;	// Ƃ肠삷悤Ƀ\Pbg쐬
	pSock->SetAutoDelete( TRUE );		// Close 폜
	return pSock;
}

