// WS2TcpListenCmd.cpp: CWS2TcpListenCmd NX̃Cve[V
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "NpsServer.h"
#include "WS2TcpListenCmd.h"
#include "ServerTcpCmd.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif


//////////////////////////////////////////////////////////////////////////////
//   MODULE   : CWS2TcpListenCmd::CWS2TcpListenCmd
//   ABSTRACT : RXgN^
//   FUNCTION : T[o[\PbgNX̐s܂
//////////////////////////////////////////////////////////////////////////////
CWS2TcpListenCmd::CWS2TcpListenCmd( pfnSockCreate pfnSockCreateFunc )
{
	TRACE( "[%08X] CWS2TcpListenCmd::CWS2TcpListenCmd()\n", GetCurrentThreadId() );

	m_pfnSockCreate = pfnSockCreateFunc;		// \Pbg쐬֐|C^[
}

//////////////////////////////////////////////////////////////////////////////
//   MODULE   : CWS2TcpListenCmd::~CWS2TcpListenCmd
//   ABSTRACT : fXgN^
//   FUNCTION : T[o[\PbgNX̊Js܂
//////////////////////////////////////////////////////////////////////////////
CWS2TcpListenCmd::~CWS2TcpListenCmd()
{
	TRACE( "[%08X] CWS2TcpListenCmd::~CWS2TcpListenCmd()\n", GetCurrentThreadId() );
}

//////////////////////////////////////////////////////////////////////////////
//   MODULE   : CWS2TcpListenCmd::Create
//   ABSTRACT : T[o[\Pbg쐬܂
//   FUNCTION : T[o[\Pbg쐬܂
//////////////////////////////////////////////////////////////////////////////
BOOL CWS2TcpListenCmd::Create( UINT nSocketPort , LPCTSTR lpszSocketAddress )
{
	TRACE( "[%08X] CWS2TcpListenCmd::Create()\n", GetCurrentThreadId() );

	// \Pbg̍쐬
	if( !CWS2Tcp::Create() )
		return FALSE;
	// \PbgɖOt܂
	if( !Bind( nSocketPort , lpszSocketAddress ) )
		return FALSE;
	if( !Listen( LISTEN_CMD_NUM ) )
		return FALSE;

	return TRUE;
}

//////////////////////////////////////////////////////////////////////////////
//   MODULE   : CWS2TcpListenCmd::OnAccept
//   ABSTRACT : ڑvM
//   FUNCTION : ڑvM
//////////////////////////////////////////////////////////////////////////////
void CWS2TcpListenCmd::OnAccept( int nErrorCode )
{
	TRACE( "[%08X] CWS2TcpListenCmd::OnAccept()\n", GetCurrentThreadId() );

	// \Pbg̍쐬
	CWS2Tcp*	pSock = OnAcceptSockCreate();
	if( pSock == NULL )
		return;			// \PbgNXԂĂ炦Ȃ
	
	// \Pbǧ
	if( !Accept( *pSock ) )
		delete pSock;		// \Pbǧs
	
	{	// Oo
		CString str;
		str.Format( "Connect [CMD]" );
		NPS_LOGOUT( str );
	}
	// Ǘ̈ɊǗNXǉ
	::GetServerTcpCmd()->AddServerSock( pSock );
}

//////////////////////////////////////////////////////////////////////////////
//   MODULE   : CWS2TcpListenCmd::OnAcceptSockCreate
//   ABSTRACT : ڑvM
//   FUNCTION : ڑvM
//////////////////////////////////////////////////////////////////////////////
CWS2Tcp* CWS2TcpListenCmd::OnAcceptSockCreate()
{
	TRACE( "[%08X] CWS2TcpListenCmd::OnAcceptSockCreate()\n", GetCurrentThreadId() );

	if( m_pfnSockCreate )
		return (*m_pfnSockCreate)();
	ASSERT(0);		// {̃NXł͐łȂ̂ ASSERT() s
	CWS2Tcp*	pSock = new CWS2Tcp;	// Ƃ肠삷悤Ƀ\Pbg쐬
	pSock->SetAutoDelete( TRUE );		// Close 폜
	return pSock;
}
