//////////////////////////////////////////////////////////////////////////////
//   FILE NAME   : WS2Udp.h
//   ABSTRACT    : \Pbg񓯊ʐMNX (WinSock2.0Ή)
//
//                                     (C)Copyright : Noritsu Koki CO.,LTD.
//////////////////////////////////////////////////////////////////////////////
#if !defined(_WS2UDP_H_)
#define _WS2UDP_H_

#include <afxpriv.h>

#include <winsock2.h>		// WinSock 2.0
#include <mswsock.h>		// Microsoft Windows Socket

//////////////////////////////////////////////////////////////////////////////
// e}N`Lq܂
// ڂ̌߂`
#if !defined(COUNTOF)
	#define COUNTOF(xxxx)		(sizeof(xxxx)/sizeof(xxxx[0]))
#endif

class CWS2Udp
{
public:

	CWS2Udp();
	virtual ~CWS2Udp();

	//////////////////////////////////////////////////////////////////////
	//	@\F	\Pbg쐬܂(Server(2)/Client(2))
	//	F	int					nAddressFamily		AhX`
	//			int					nSocketType			\Pbg^Cv
	//			int					nProtocol			vgR
	//			LPWSAPROTOCOL_INFO	lpProtocolInfo		쐬
	//	ߒlF	\Pbg쐬 TRUE Ԃ܂
	BOOL Create( int nAddressFamily = AF_INET,
				 int nSocketType    = SOCK_DGRAM,	
				 int nProtocol      = IPPROTO_UDP );
	BOOL Create( LPWSAPROTOCOL_INFO lpProtocolInfo,
				 int nAddressFamily = FROM_PROTOCOL_INFO,
				 int nSocketType    = FROM_PROTOCOL_INFO,
				 int nProtocol      = FROM_PROTOCOL_INFO );

	////////////////////////////////////////////////////////////////////////////
	//	@\F	\PbgɖOt܂(Server(3))
	//	F	UINT				nSocketPort			|[gԍ
	//			LPCTSTR				lpszSocketAddress	\Pbg̃AhX
	//			SOCKADDR			lpSockAddr			\Pbg
	//			int					nSockAddrLen	\Pbg̒
	//	ߒlF	Ot̐ TRUE Ԃ܂
	BOOL Bind( UINT nSocketPort , LPCTSTR lpszSocketAddress = NULL );
	BOOL Bind( const SOCKADDR* lpSockAddr, int nSockAddrLen );

	////////////////////////////////////////////////////////////////////////////
	//	@\F	܂
	//	F	Ȃ
	//	ߒlF	ꍇ TRUE Ԃ܂
	BOOL Close();

	////////////////////////////////////////////////////////////////////////////
	//	@\F	G[擾܂
	//	F	Ȃ
	//	ߒlF	G[R[hԂ܂
	static int GetLastError();

	////////////////////////////////////////////////////////////////////////////
	//	@\F	\Pbg^vꂽƂ̓\Pbgf[^Ԃ܂
	//	F	Ȃ
	//	ߒlF	\Pbg
	operator SOCKET () const { return m_Socket; }

	////////////////////////////////////////////////////////////////////////////
	//	@\F	\PbgؒfꂽƂɎIɃNX̍폜邩ǂݒ肵܂
	//	F	BOOL				bAutoDelete		= TRUE  : 폜
	//												= FALSE : 폜Ȃ
	//	ߒlF	Ȃ
	void SetAutoDelete( BOOL bAutoDelete = TRUE );

	////////////////////////////////////////////////////////////////////////////
	//	@\F	w\PbgƃNXѕt܂
	//	F	SOCKET				sock			Ǘ\Pbg
	//			int					nAddressFamily	AhX`
	//	ߒlF	ꍇ TRUE Ԃ܂
	BOOL Attach( SOCKET sock , int nAddressFamily = AF_INET );

	//////////////////////////////////////////////////////////////////////
	//	@\F	u[hLXgMݒs
	//	F	BOOL				bFlag
	//	ߒlF	ꍇ TRUE Ԃ܂
	virtual BOOL SetOptBroadCast(BOOL bFlag = TRUE);

	////////////////////////////////////////////////////////////////////////////
	//	@\F	f[^̑Ms܂(UDP)
	//	F	LPCTSTR				lpszHostAddress		ڑAhX
	//			UINT				nHostPort			ڑ|[g
	//			void*				lpBuf				Mf[^
	//			int					nBufLen				lpBuf ̒(Byte)
	//			DWORD				dwFlags				MtO
	//			WSABUF*				pBuf				Mf[^
	//			int					nCount				pBuf ̌
	//	ߒlF	ꍇ TRUE Ԃ܂
	virtual BOOL SendTo( LPCTSTR lpszHostAddress,
						UINT nHostPort,
						const void* lpBuf,
						 int nBufLen,
						DWORD dwFlags = 0 );
	virtual BOOL SendTo( const SOCKADDR* lpSockAddr,
						int nSockAddrLen,
						WSABUF* pBuf,
						int nCount,
						DWORD dwFlags = 0 );

	////////////////////////////////////////////////////////////////////////////
	//	@\F	f[^̎Ms܂(UDP)
	//	F	void*				lpBuf				Mobt@
	//			int					nBufLen				lpBuf ̒(Byte)
	//			LPTSTR				lpszHostAddress		MAhX
	//			int					nHostAddressBufLen	lpszHostAddress̒
	//			UINT*				pnHostPort			M|[g
	//			DWORD				dwFlags				MtO
	//	ߒlF	ꍇ M(Byte) Ԃ܂
	//				s -1 Ԃ܂
	virtual int ReceiveFrom( void* lpBuf,							// f[^̎Ms܂
						int nBufLen,
						LPTSTR lpszHostAddress,
						int nHostAddressBufLen,
						UINT* pnHostPort,
						DWORD dwFlags = 0 );


protected:
	////////////////////////////////////////////////////////////////////////////
	// eCxgƂɌĂяo֐ł
	// ʂ̃XbhŌĂяo󂯂邽߁ACXbhȂǂŏsꍇ
	// r䂪KvƂȂ܂B
	// ܂ACXbhɒʒmKvł΁ACXbh̃XbhID
	// ݒ肷邱ƂɂA PostThreadMessage() ŌĂяos܂
	virtual void OnAccept( int nErrorCode );		// Accept 󂯎Ƃ
	virtual void OnClose( int nErrorCode );			// Close 󂯎Ƃ
	virtual void OnConnect( int nErrorCode );		// Connect 󂯎Ƃ
	virtual void OnOOB( int nErrorCode );			// OOB 󂯎Ƃ
	virtual void OnQOS( int nErrorCode );			// QOS 󂯎Ƃ
	virtual void OnReceive( int nErrorCode );		// Receive 󂯎Ƃ
	virtual void OnSend( int nErrorCode );			// Send 󂯎Ƃ
	virtual void OnAttach() {}						// \Pbg쐬(ĂяoXbh)
													// NXƃ\Pbg̊֘A
													// Create / Attach ֐Ăяo

	////////////////////////////////////////////////////////////////////////////
	// eCxgs߂̃Xbh𓮍삳邽߂̊֐ł
	// 㑤̊֐́AAfxBeginThread() ɗ^邽߂ static KvŁAł
	// NXϐɃANZX̂ʓ|Ȃ̂ŁANX֐̉֐Ăяo
	// sĂ܂
	static UINT SocketEventThread( LPVOID pParam );
	UINT SocketEvent();

protected:

	SOCKET m_Socket;								// Ǘ\Pbg
	int m_nAddressFamily;							// AhXt@~[
	WSAEVENT m_ExitEvent;							// IpCxg
	WSAEVENT m_NetworkEvent;						// lbg[NpCxg
	CWinThread* m_pWinThread;						// Xbhnh
	BOOL m_bAutoDelete;								// \PbgN[YɎIɃNX폜?

};

#endif // _CWS2UDP_H_
