// ErrTable.cpp: CErrTable NX̃Cve[V
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "npstester.h"
#include "ErrTable.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// \z/
//////////////////////////////////////////////////////////////////////

CErrTable::CErrTable()
{
	EmptyTablePath();
	EmptyValue();
}

CErrTable::~CErrTable()
{
	EmptyTablePath();
	EmptyValue();
}

void CErrTable::EmptyTablePath()
{
	m_strErrorTablePath.Empty();
	m_strMessageTablePath.Empty();
}

void CErrTable::EmptyValue()
{
	m_dwErrMainCode	= 0;
	m_dwErrSubCode	= 0;
	m_dwErrParam[0]	= 0;
	m_dwErrParam[1]	= 0;
	m_dwErrParam[2]	= 0;
	m_strErrCode.Empty();
	m_strLevel.Empty();
	m_strLogSave.Empty();
	m_strButton1.Empty();
	m_strButton2.Empty();
	m_strButton3.Empty();
	m_strButton4.Empty();
	m_strButton5.Empty();
	m_strSoundPath.Empty();
	m_strSubNumType.Empty();

	int nIdx = 0;
	for ( nIdx=0 ; INSERT_CHARACTER_NUM > nIdx  ; nIdx++ )
	{
		m_strMessage[nIdx].Empty();
	}
}

BOOL CErrTable::SetSoftName( LPCTSTR lpSoftName )
{
	CString strSubKey;

	strSubKey.Format( PRINTER_REG_KEY_ROOT_FMT, lpSoftName );

	// G[e[ũpX擾
	if ( FALSE == COMAPI::GetRegString( HKEY_LOCAL_MACHINE, strSubKey, _T("NkcErrorTable"), m_strErrorTablePath ) )
	{
		AfxMessageBox( _T("ERROR : G[e[uCXg[ĂȂ߁Aڍ׏\ł܂B") );
		EmptyTablePath();
		return FALSE;
	}

	// bZ[We[ũpX擾
	if ( FALSE == COMAPI::GetRegString( HKEY_LOCAL_MACHINE, strSubKey, _T("MessageTable"), m_strMessageTablePath ) )
	{
		AfxMessageBox( _T("ERROR : G[e[uCXg[ĂȂ߁Aڍ׏\ł܂B") );
		EmptyTablePath();
		return FALSE;
	}

	// p => {
	m_strMessageTablePath.Replace( _T("ENGLISH"), _T("JAPANESE") );

	return TRUE;
}

BOOL CErrTable::SetErrCode( DWORD dwMainCode, DWORD dwSubCode, DWORD dwParam1, DWORD dwParam2, DWORD dwParam3 )
{
	if ( m_strErrorTablePath.IsEmpty() || m_strMessageTablePath.IsEmpty() )
	{
		return FALSE;
	}

	EmptyValue();
	m_dwErrMainCode	= dwMainCode;
	m_dwErrSubCode	= dwSubCode;
	m_dwErrParam[0]	= dwParam1;
	m_dwErrParam[1]	= dwParam2;
	m_dwErrParam[2]	= dwParam3;

	// G[ԍ̕\
	// --------------------------------------------------
	m_strErrCode.Format( _T("%05u-%05u"), dwMainCode, dwSubCode );

	CString str;
	CString strAppName;
	strAppName.Format( _T("%u"), dwMainCode );
	m_strLevel		= COMAPI::GetPrivateProfileString( strAppName, _T("Level"), _T(""), m_strErrorTablePath );
	m_strLogSave	= COMAPI::GetPrivateProfileString( strAppName, _T("LogSave"), _T(""), m_strErrorTablePath );
	m_strSoundPath	= COMAPI::GetPrivateProfileString( strAppName, _T("SoundPath"), _T(""), m_strErrorTablePath );
	m_strSubNumType	= COMAPI::GetPrivateProfileString( strAppName, _T("SubNumType"), _T(""), m_strErrorTablePath );

	str	= COMAPI::GetPrivateProfileString( strAppName, _T("ButtonString1"), _T(""), m_strErrorTablePath );	m_strButton1 = COMAPI::GetPrivateProfileString( _T("Message"), str, _T(""), m_strMessageTablePath );
	str	= COMAPI::GetPrivateProfileString( strAppName, _T("ButtonString2"), _T(""), m_strErrorTablePath );	m_strButton2 = COMAPI::GetPrivateProfileString( _T("Message"), str, _T(""), m_strMessageTablePath );
	str	= COMAPI::GetPrivateProfileString( strAppName, _T("ButtonString3"), _T(""), m_strErrorTablePath );	m_strButton3 = COMAPI::GetPrivateProfileString( _T("Message"), str, _T(""), m_strMessageTablePath );
	str	= COMAPI::GetPrivateProfileString( strAppName, _T("ButtonString4"), _T(""), m_strErrorTablePath );	m_strButton4 = COMAPI::GetPrivateProfileString( _T("Message"), str, _T(""), m_strMessageTablePath );
	str	= COMAPI::GetPrivateProfileString( strAppName, _T("ButtonString5"), _T(""), m_strErrorTablePath );	m_strButton5 = COMAPI::GetPrivateProfileString( _T("Message"), str, _T(""), m_strMessageTablePath );
	str = COMAPI::GetPrivateProfileString( strAppName, _T("Message1"), _T(""), m_strErrorTablePath );	m_strMessage[MESSAGE]	= COMAPI::GetPrivateProfileString( _T("Message"), str, _T(""), m_strMessageTablePath );		m_strMessage[MESSAGE] += _T("\r\n");
	str = COMAPI::GetPrivateProfileString( strAppName, _T("Message2"), _T(""), m_strErrorTablePath );	m_strMessage[MESSAGE]	+= COMAPI::GetPrivateProfileString( _T("Message"), str, _T(""), m_strMessageTablePath );	m_strMessage[MESSAGE] += _T("\r\n");
	str = COMAPI::GetPrivateProfileString( strAppName, _T("Message3"), _T(""), m_strErrorTablePath );	m_strMessage[MESSAGE]	+= COMAPI::GetPrivateProfileString( _T("Message"), str, _T(""), m_strMessageTablePath );	m_strMessage[MESSAGE] += _T("\r\n");
	str = COMAPI::GetPrivateProfileString( strAppName, _T("Message4"), _T(""), m_strErrorTablePath );	m_strMessage[MESSAGE]	+= COMAPI::GetPrivateProfileString( _T("Message"), str, _T(""), m_strMessageTablePath );	m_strMessage[MESSAGE] += _T("\r\n");
	str = COMAPI::GetPrivateProfileString( strAppName, _T("Message5"), _T(""), m_strErrorTablePath );	m_strMessage[MESSAGE]	+= COMAPI::GetPrivateProfileString( _T("Message"), str, _T(""), m_strMessageTablePath );	m_strMessage[MESSAGE] += _T("\r\n");
	str = COMAPI::GetPrivateProfileString( strAppName, _T("Message6"), _T(""), m_strErrorTablePath );	m_strMessage[MESSAGE]	+= COMAPI::GetPrivateProfileString( _T("Message"), str, _T(""), m_strMessageTablePath );
	str = COMAPI::GetPrivateProfileString( strAppName, _T("Action"), _T(""), m_strErrorTablePath );		m_strMessage[ACTION]	+= COMAPI::GetPrivateProfileString( _T("Message"), str, _T(""), m_strMessageTablePath );

	// ͂ߍݕ̏
	int nIndex = 0;
	int nStartPos = 0;
	int nEndPos = 0;
	int nElementNo = 0;
	CString strCharacterSet;

	int nIdx = 0;
	for ( nIdx=0 ; INSERT_CHARACTER_NUM > nIdx  ; nIdx++ )
	{
		nIndex = 0;
		nStartPos = 0;
		nEndPos = 0;
		for ( nIndex=m_strMessage[nIdx].FindOneOf( _T("%") ) ; -1 != nIndex ; nIndex=m_strMessage[nIdx].Find( _T("%"), nIndex ) )
		{
			nStartPos = nIndex;
			nEndPos = m_strMessage[nIdx].Find( _T("%"), nStartPos + 1 );
			if ( 0 < nEndPos )
			{
				strCharacterSet = m_strMessage[nIdx].Mid( nStartPos + 1, nEndPos - nStartPos - 1 );
				if ( 0 == strCharacterSet.Compare( _T("NUM") ) )
				{
					CString strNum;
					strNum.Format( "%u", m_dwErrParam[nElementNo] );
					nElementNo++;

					m_strMessage[nIdx].Delete( nStartPos, strCharacterSet.GetLength() + 2 );
					m_strMessage[nIdx].Insert( nStartPos, strNum );
					nEndPos = nStartPos + strNum.GetLength() - 1;
				}
				else if ( 0 == strCharacterSet.Left(5).Compare( _T("STD__") ) )
				{
					CString strKeyName;
					strKeyName.Format( "%u", m_dwErrParam[nElementNo] );
					CString strMessageId = COMAPI::GetPrivateProfileString( strCharacterSet, strKeyName, _T(""), m_strErrorTablePath );
					CString strString = COMAPI::GetPrivateProfileString( _T("Message"), strMessageId, _T(""), m_strMessageTablePath );
					nElementNo++;

					m_strMessage[nIdx].Delete( nStartPos, strCharacterSet.GetLength() + 2 );
					m_strMessage[nIdx].Insert( nStartPos, strString );
					nEndPos = nStartPos + strString.GetLength() - 1;
				}
				else if ( 0 == strCharacterSet.Left(5).Compare( _T("BIT__") ) )
				{
					int nBit = 0;
					CString strString;
					CString strKeyName;
					CString strMessageId;
					for ( nBit=0 ; 32 > nBit ; nBit++ )
					{
						if ( m_dwErrParam[nElementNo] & ( 0x00000001 << nBit ) )
						{
							strKeyName.Format( "%u", nBit );
							strMessageId = COMAPI::GetPrivateProfileString( strCharacterSet, strKeyName, _T(""), m_strErrorTablePath );
							strString += COMAPI::GetPrivateProfileString( _T("Message"), strMessageId, _T(""), m_strMessageTablePath );
							strString += _T(" ");
						}
					}
					nElementNo++;

					m_strMessage[nIdx].Delete( nStartPos, strCharacterSet.GetLength() + 2 );
					m_strMessage[nIdx].Insert( nStartPos, strString );
					nEndPos = nStartPos + strString.GetLength() - 1;
				}
				nIndex = nEndPos + 1;
				continue;
			}

			nIndex++;
			continue;
		}
		// s̒u "\n" -> "\r\n"
		m_strMessage[nIdx].Replace( _T("\\n"), _T("\r\n") );
	}

	return TRUE;
}
