// ErrorDlg.cpp : Cve[V t@C
//

#include "stdafx.h"
#include "npstester.h"
#include "ErrorDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CErrorDlg _CAO


CErrorDlg::CErrorDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CErrorDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CErrorDlg)
		//  - ClassWizard ͂̈ʒuɃ}bsOp̃}Nǉ܂͍폜܂B
	//}}AFX_DATA_INIT

	m_nIdx = 0;
	m_dwErrHandle = 0;
}


void CErrorDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CErrorDlg)
		//  - ClassWizard ͂̈ʒuɃ}bsOp̃}Nǉ܂͍폜܂B
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CErrorDlg, CDialog)
	//{{AFX_MSG_MAP(CErrorDlg)
	ON_BN_CLICKED(IDC_BUTTON1, OnButton1)
	ON_BN_CLICKED(IDC_BUTTON2, OnButton2)
	ON_BN_CLICKED(IDC_BUTTON3, OnButton3)
	ON_BN_CLICKED(IDC_BUTTON4, OnButton4)
	ON_BN_CLICKED(IDC_BUTTON5, OnButton5)
	ON_BN_CLICKED(IDC_RESERVE_BUTTON, OnReserveButton)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CErrorDlg bZ[W nh

BOOL CErrorDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	// TODO: ̈ʒuɏ̕⑫ǉĂ
	//#################################################################################################

	NPS_SetUpInfo tSetUpInfo = { 0 };
	NPSEVENTINFO tEventInfo = { 0 };

	CString str;
	CErrTable objErrTable;

	// \tgEFA̎擾
	if ( FALSE == GetNpsLib()->GetMemberDataOfSetUpInfo( &tSetUpInfo ) )
	{
		AfxMessageBox( _T("GetNpsLib()->GetMemberDataOfSetUpInfo() ֐Ăяos") );
		return TRUE;
	}

	// G[̎擾
	if ( FALSE == GetNpsLib()->GetMemberDataOfEventInfo( m_nIdx, &tEventInfo ) )
	{
		AfxMessageBox( _T("GetNpsLib()->GetMemberDataOfEventInfo() ֐Ăяos") );
		return TRUE;
	}

	m_dwErrHandle = tEventInfo.dwErrHandle;

	objErrTable.SetSoftName( tSetUpInfo.szSoftName );
	objErrTable.SetErrCode( tEventInfo.dwErrCode, tEventInfo.alParams[0],
							tEventInfo.alParams[1], tEventInfo.alParams[2], tEventInfo.alParams[3] );

	// e[u̐ݒ
	if ( FALSE == objErrTable.SetSoftName( tSetUpInfo.szSoftName ) )
	{
		AfxMessageBox( _T("ERROR : G[e[uCXg[ĂȂ߁Aڍ׏\ł܂B") );
		return TRUE;
	}

	// G[ԍ̕\
	// --------------------------------------------------
	GetDlgItem(IDC_ERROR_NO_STATIC)->SetWindowText( objErrTable.GetErrCode() );

	// G[e/Ώ@̕\
	// --------------------------------------------------
	CString strNote;
	strNote = objErrTable.GetMessage();
	strNote += _T("\r\n");
	strNote += _T("----------------------------------------------------------------------------------");
	strNote += _T("\r\n");
	strNote += objErrTable.GetAction();
	GetDlgItem(IDC_NOTE_EDIT)->SetWindowText( strNote );

	// {^\
	// --------------------------------------------------
	CString strButton;
	CButton* pobjButton = (CButton*)GetDlgItem(IDC_BUTTON1);
	strButton = objErrTable.GetButton1();
	if ( FALSE == strButton.IsEmpty() )
	{
		pobjButton->SetWindowText( strButton );
	}
	else
	{
		pobjButton->ShowWindow( SW_HIDE );
	}

	pobjButton = (CButton*)GetDlgItem(IDC_BUTTON2);
	strButton = objErrTable.GetButton2();
	if ( FALSE == strButton.IsEmpty() )
	{
		pobjButton->SetWindowText( strButton );
	}
	else
	{
		pobjButton->ShowWindow( SW_HIDE );
	}

	pobjButton = (CButton*)GetDlgItem(IDC_BUTTON3);
	strButton = objErrTable.GetButton3();
	if ( FALSE == strButton.IsEmpty() )
	{
		pobjButton->SetWindowText( strButton );
	}
	else
	{
		pobjButton->ShowWindow( SW_HIDE );
	}

	pobjButton = (CButton*)GetDlgItem(IDC_BUTTON4);
	strButton = objErrTable.GetButton4();
	if ( FALSE == strButton.IsEmpty() )
	{
		pobjButton->SetWindowText( strButton );
	}
	else
	{
		pobjButton->ShowWindow( SW_HIDE );
	}

	pobjButton = (CButton*)GetDlgItem(IDC_BUTTON5);
	strButton = objErrTable.GetButton5();
	if ( FALSE == strButton.IsEmpty() )
	{
		pobjButton->SetWindowText( strButton );
	}
	else
	{
		pobjButton->ShowWindow( SW_HIDE );
	}
	//#################################################################################################
	return TRUE;  // Rg[ɃtH[JXݒ肵ȂƂA߂l TRUE ƂȂ܂
	              // O: OCX vpeB y[W̖߂l FALSE ƂȂ܂
}

// --------------------------------------------------
void CErrorDlg::OnButton1() 
{
	ButtonCloseAction( PRESS_BUTTON01 );
}

// --------------------------------------------------
void CErrorDlg::OnButton2() 
{
	ButtonCloseAction( PRESS_BUTTON02 );
}

// --------------------------------------------------
void CErrorDlg::OnButton3() 
{
	ButtonCloseAction( PRESS_BUTTON03 );
}

// --------------------------------------------------
void CErrorDlg::OnButton4() 
{
	ButtonCloseAction( PRESS_BUTTON04 );
}

// --------------------------------------------------
void CErrorDlg::OnButton5() 
{
	ButtonCloseAction( PRESS_BUTTON05 );
}

// --------------------------------------------------
void CErrorDlg::ButtonCloseAction(DWORD dwActionId)
{
	if ( FALSE == ::GetNpsLib()->npsDevResetEvent( m_dwErrHandle, dwActionId ) )
	{
		AfxMessageBox( _T("CErrorDlg::ButtonCloseAction() : GetNpsLib()->npsDevResetEvent() ֐Ăяos") );
	}

	CDialog::OnOK();
}

// --------------------------------------------------
void CErrorDlg::OnReserveButton() 
{
	CDialog::OnCancel();
}
