// PaperListDlg.cpp : Cve[V t@C
//

#include "stdafx.h"
#include "npstester.h"
#include "PaperListDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CPaperListDlg _CAO


CPaperListDlg::CPaperListDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CPaperListDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CPaperListDlg)
		//  - ClassWizard ͂̈ʒuɃ}bsOp̃}Nǉ܂͍폜܂B
	//}}AFX_DATA_INIT
}


void CPaperListDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CPaperListDlg)
		//  - ClassWizard ͂̈ʒuɃ}bsOp̃}Nǉ܂͍폜܂B
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CPaperListDlg, CDialog)
	//{{AFX_MSG_MAP(CPaperListDlg)
	ON_WM_SIZE()
	ON_BN_CLICKED(IDC_EXIT_BUTTON, OnExitButton)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CPaperListDlg bZ[W nh

BOOL CPaperListDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();

	// TODO: ̈ʒuɏ̕⑫ǉĂ
	//#################################################################################################
	int nColumn = 0;
	CListCtrl* pobjListCtrl = (CListCtrl*)GetDlgItem(IDC_PAPER_LIST);

	pobjListCtrl->InsertColumn( nColumn, "y[p[",				LVCFMT_LEFT, -1, -1 );	pobjListCtrl->SetColumnWidth( nColumn, 100 );		nColumn++;
	pobjListCtrl->InsertColumn( nColumn, "ŏ",				LVCFMT_LEFT, -1, -1 );	pobjListCtrl->SetColumnWidth( nColumn, 80 );		nColumn++;
	pobjListCtrl->InsertColumn( nColumn, "ő",				LVCFMT_LEFT, -1, -1 );	pobjListCtrl->SetColumnWidth( nColumn, 80 );		nColumn++;
	pobjListCtrl->InsertColumn( nColumn, "ʎ",					LVCFMT_LEFT, -1, -1 );	pobjListCtrl->SetColumnWidth( nColumn, 80 );		nColumn++;
	pobjListCtrl->InsertColumn( nColumn, "͉𑜓x",				LVCFMT_LEFT, -1, -1 );	pobjListCtrl->SetColumnWidth( nColumn, 80 );		nColumn++;
	pobjListCtrl->InsertColumn( nColumn, "t",				LVCFMT_LEFT, -1, -1 );	pobjListCtrl->SetColumnWidth( nColumn, 80 );		nColumn++;
	pobjListCtrl->InsertColumn( nColumn, "ZbgAbv",		LVCFMT_LEFT, -1, -1 );	pobjListCtrl->SetColumnWidth( nColumn, 80 );		nColumn++;
	pobjListCtrl->InsertColumn( nColumn, "@",				LVCFMT_LEFT, -1, -1 );	pobjListCtrl->SetColumnWidth( nColumn, 80 );		nColumn++;
	pobjListCtrl->InsertColumn( nColumn, "WB␳l",				LVCFMT_LEFT, -1, -1 );	pobjListCtrl->SetColumnWidth( nColumn, 80 );		nColumn++;
	pobjListCtrl->InsertColumn( nColumn, "y[p[",				LVCFMT_LEFT, -1, -1 );	pobjListCtrl->SetColumnWidth( nColumn, 80 );		nColumn++;
	pobjListCtrl->InsertColumn( nColumn, "y[p[^CvR[h",	LVCFMT_LEFT, -1, -1 );	pobjListCtrl->SetColumnWidth( nColumn, 80 );		nColumn++;
	pobjListCtrl->InsertColumn( nColumn, "Direction",				LVCFMT_LEFT, -1, -1 );	pobjListCtrl->SetColumnWidth( nColumn, 80 );		nColumn++;
	pobjListCtrl->InsertColumn( nColumn, "PrintQuality",			LVCFMT_LEFT, -1, -1 );	pobjListCtrl->SetColumnWidth( nColumn, 80 );		nColumn++;

	pobjListCtrl->ModifyStyle(0, LVS_SHOWSELALWAYS);
	pobjListCtrl->SetExtendedStyle( LVS_EX_FULLROWSELECT | LVS_EX_GRIDLINES );

	// --------------------------------------------------
	int nIdx = 0;
	int nLine = 0;
	CString str;
	NPS_MagDetailInfo tMagDetailInfo = { 0 };

	for ( nIdx=0 ; GetNpsLib()->GetMemberDataOfMagDetailInfo( nIdx, &tMagDetailInfo ) ; nIdx++ )
	{
		nColumn = 0;
		str.Format( "%d", tMagDetailInfo.dwWidth );				pobjListCtrl->InsertItem( nLine, str, nColumn );	nColumn++;
		str.Format( "%d", tMagDetailInfo.dwLengthMin );			pobjListCtrl->SetItemText( nLine, nColumn, str );	nColumn++;
		str.Format( "%d", tMagDetailInfo.dwLengthMax );			pobjListCtrl->SetItemText( nLine, nColumn, str );	nColumn++;
		str.Format( "%d", tMagDetailInfo.dwSurface );			pobjListCtrl->SetItemText( nLine, nColumn, str );	nColumn++;
		str.Format( "%d", tMagDetailInfo.dwResolution[0] );		pobjListCtrl->SetItemText( nLine, nColumn, str );	nColumn++;
		str.Format( "%d, %d, %d, %d", tMagDetailInfo.nAllocationTop,
						  tMagDetailInfo.nAllocationBottom,
						  tMagDetailInfo.nAllocationLeft,
						  tMagDetailInfo.nAllocationRight );	pobjListCtrl->SetItemText( nLine, nColumn, str );	nColumn++;
		str.Format( "%d", tMagDetailInfo.dwSetupStatus );		pobjListCtrl->SetItemText( nLine, nColumn, str );	nColumn++;
		str.Format( "%d", tMagDetailInfo.dwFeed );				pobjListCtrl->SetItemText( nLine, nColumn, str );	nColumn++;
		str.Format( "%d, %d", tMagDetailInfo.nWBAdjustLeft,
						  tMagDetailInfo.nWBAdjustRight );		pobjListCtrl->SetItemText( nLine, nColumn, str );	nColumn++;
		str.Format( "%s", tMagDetailInfo.szPaperName );			pobjListCtrl->SetItemText( nLine, nColumn, str );	nColumn++;
		str.Format( "%d", tMagDetailInfo.wPaperTypeCode );		pobjListCtrl->SetItemText( nLine, nColumn, str );	nColumn++;
		str.Format( "%d", tMagDetailInfo.wDirection );			pobjListCtrl->SetItemText( nLine, nColumn, str );	nColumn++;
		str.Format( "%d", tMagDetailInfo.wPrintQuality );		pobjListCtrl->SetItemText( nLine, nColumn, str );	nColumn++;
		nLine++;
	}

	//#################################################################################################

	return TRUE;  // Rg[ɃtH[JXݒ肵ȂƂA߂l TRUE ƂȂ܂
	              // O: OCX vpeB y[W̖߂l FALSE ƂȂ܂
}

// --------------------------------------------------
void CPaperListDlg::OnSize(UINT nType, int cx, int cy) 
{
	CDialog::OnSize(nType, cx, cy);

	// TODO: ̈ʒuɃbZ[W nhp̃R[hǉĂ
	if ( FALSE == this->IsWindowVisible() )
	{
		return;
	}

	CButton* pobjButton = (CButton*)GetDlgItem(IDC_EXIT_BUTTON);
	CListCtrl* pobjListCtrl = (CListCtrl*)GetDlgItem(IDC_PAPER_LIST);

	RECT rtClient = { 0 };
	RECT rtList = { 0 };
	RECT rtButton = { 0 };

	this->GetClientRect( &rtClient );
	pobjButton->GetClientRect( &rtButton );

	rtList.left		= 10;
	rtList.right	= rtClient.right - 10;
	rtList.top		= 10;
	rtList.bottom	= rtClient.bottom - 30 - 10;
	pobjListCtrl->MoveWindow( &rtList, TRUE );

	rtButton.left	= rtButton.left		+ rtClient.right - 100;
	rtButton.right	= rtButton.right	+ rtClient.right - 100;
	rtButton.top	= rtButton.top		+ rtClient.bottom - 30;
	rtButton.bottom	= rtButton.bottom	+ rtClient.bottom - 30;
	pobjButton->MoveWindow( &rtButton, TRUE );
}

// --------------------------------------------------
void CPaperListDlg::OnExitButton() 
{
	CDialog::OnOK();
}
