// SearchDlg.cpp : Cve[V t@C
//

#include "stdafx.h"
#include "npstester.h"
#include "SearchDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CSearchDlg _CAO


CSearchDlg::CSearchDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CSearchDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CSearchDlg)
		//  - ClassWizard ͂̈ʒuɃ}bsOp̃}Nǉ܂͍폜܂B
	//}}AFX_DATA_INIT
}


void CSearchDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CSearchDlg)
		//  - ClassWizard ͂̈ʒuɃ}bsOp̃}Nǉ܂͍폜܂B
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CSearchDlg, CDialog)
	//{{AFX_MSG_MAP(CSearchDlg)
	ON_NOTIFY(NM_DBLCLK, IDC_SEARCH_LIST, OnDblclkSearchList)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CSearchDlg bZ[W nh

BOOL CSearchDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	// TODO: ̈ʒuɏ̕⑫ǉĂ
	//#################################################################################################
	int nColumn = 0;
	CListCtrl* pobjListCtrl = (CListCtrl*)GetDlgItem(IDC_SEARCH_LIST);

	pobjListCtrl->InsertColumn( nColumn, "IPAhX",			LVCFMT_LEFT, -1, -1 );	pobjListCtrl->SetColumnWidth( nColumn, 100 );		nColumn++;
	pobjListCtrl->InsertColumn( nColumn, "@햼",				LVCFMT_LEFT, -1, -1 );	pobjListCtrl->SetColumnWidth( nColumn, 100 );		nColumn++;
	pobjListCtrl->InsertColumn( nColumn, "\tgEFA",	LVCFMT_LEFT, -1, -1 );	pobjListCtrl->SetColumnWidth( nColumn, 80 );		nColumn++;
	pobjListCtrl->InsertColumn( nColumn, "VAԍ",		LVCFMT_LEFT, -1, -1 );	pobjListCtrl->SetColumnWidth( nColumn, 80 );		nColumn++;
	pobjListCtrl->InsertColumn( nColumn, "𑜓x",				LVCFMT_LEFT, -1, -1 );	pobjListCtrl->SetColumnWidth( nColumn, 80 );		nColumn++;
	pobjListCtrl->InsertColumn( nColumn, "I/Fo[W",		LVCFMT_LEFT, -1, -1 );	pobjListCtrl->SetColumnWidth( nColumn, 80 );		nColumn++;
	pobjListCtrl->InsertColumn( nColumn, "MacAhX",			LVCFMT_LEFT, -1, -1 );	pobjListCtrl->SetColumnWidth( nColumn, 80 );		nColumn++;

	pobjListCtrl->ModifyStyle(0, LVS_SHOWSELALWAYS);
	pobjListCtrl->SetExtendedStyle( LVS_EX_FULLROWSELECT | LVS_EX_GRIDLINES );

	// --------------------------------------------------
	int nIdx = 0;
	int nLine = 0;
	CString str;
	WORD wPrinterNum = 0;
	NPS_PRINTER_ENUM* pPrinterEnum = NULL;

	if ( TRUE == GetNpsLib()->npsSearchPrinter2( &wPrinterNum, 1000 ) )
	{
		try {
			pPrinterEnum = new NPS_PRINTER_ENUM[wPrinterNum];
		}
		catch (CMemoryException* e) {
			e->Delete();
			AfxMessageBox( _T("CSearchDlg::OnInitDialog() : ̈̊mۂɎs܂B") );
			return FALSE;
		}

		if ( TRUE == GetNpsLib()->npsGetPrinter( wPrinterNum, pPrinterEnum ) )
		{
			for ( nIdx=0 ; wPrinterNum > nIdx ; nIdx++ )
			{
				nColumn = 0;
				str.Format( "%u.%u.%u.%u",
								((pPrinterEnum+nIdx)->dwIPAddress & 0x000000FF),
								((pPrinterEnum+nIdx)->dwIPAddress & 0x0000FF00) >> 8,
								((pPrinterEnum+nIdx)->dwIPAddress & 0x00FF0000) >> 16,
								((pPrinterEnum+nIdx)->dwIPAddress & 0xFF000000) >> 24 );
																					pobjListCtrl->InsertItem( nLine, str, nColumn );	nColumn++;
				str.Format( "%s",	(pPrinterEnum+nIdx)->szMachineTypeName );		pobjListCtrl->SetItemText( nLine, nColumn, str );	nColumn++;
				str.Format( "%s",	(pPrinterEnum+nIdx)->szSoftName );				pobjListCtrl->SetItemText( nLine, nColumn, str );	nColumn++;
				str.Format( "%s",	(pPrinterEnum+nIdx)->szSerialNumber );			pobjListCtrl->SetItemText( nLine, nColumn, str );	nColumn++;
				str.Format( "%d",	(pPrinterEnum+nIdx)->wSupportResolutions[0] );	pobjListCtrl->SetItemText( nLine, nColumn, str );	nColumn++;
				str.Format( "%04X",	(pPrinterEnum+nIdx)->wNpsVersion );				pobjListCtrl->SetItemText( nLine, nColumn, str );	nColumn++;
				str.Format( "%02X-%02X-%02X-%02X-%02X-%02X",
								(pPrinterEnum+nIdx)->MacAddress[0], (pPrinterEnum+nIdx)->MacAddress[1],
								(pPrinterEnum+nIdx)->MacAddress[2], (pPrinterEnum+nIdx)->MacAddress[3],
								(pPrinterEnum+nIdx)->MacAddress[3], (pPrinterEnum+nIdx)->MacAddress[5] );
																					pobjListCtrl->SetItemText( nLine, nColumn, str );	nColumn++;
				pobjListCtrl->SetItemData( nLine, (pPrinterEnum+nIdx)->dwIPAddress );
				nLine++;
			}
		}

		delete [] pPrinterEnum;
	}

	//#################################################################################################

	return TRUE;  // Rg[ɃtH[JXݒ肵ȂƂA߂l TRUE ƂȂ܂
	              // O: OCX vpeB y[W̖߂l FALSE ƂȂ܂
}

void CSearchDlg::OnCancel() 
{
	// TODO: ̈ʒuɓʂȌ㏈ǉĂB
	
	CDialog::OnCancel();
}

void CSearchDlg::OnOK() 
{
	// TODO: ̈ʒuɂ̑̌ؗp̃R[hǉĂ
	CListCtrl* pobjListCtrl = (CListCtrl*)GetDlgItem(IDC_SEARCH_LIST);
	int nIdx;

	nIdx = pobjListCtrl->GetNextItem( -1, LVNI_SELECTED | LVNI_ALL );
	if ( 0 <= nIdx )
	{
		m_dwIPAddress = (DWORD)pobjListCtrl->GetItemData( nIdx );
	}

	CDialog::OnOK();
}

// XgŃ_uNbNꂽƂ
void CSearchDlg::OnDblclkSearchList(NMHDR* pNMHDR, LRESULT* pResult) 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	CListCtrl* pobjListCtrl = (CListCtrl*)GetDlgItem(IDC_SEARCH_LIST);
	int nIdx;

	nIdx = pobjListCtrl->GetNextItem( -1, LVNI_SELECTED | LVNI_ALL );
	if ( 0 <= nIdx )
	{
		m_dwIPAddress = (DWORD)pobjListCtrl->GetItemData( nIdx );
	}

	*pResult = 0;

	EndDialog( IDOK );
}
